// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(_) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function t(e) {
        return e.split("");
    }
    function In(e, n) {
        return n.indexOf(e) >= 0;
    }
    function Hn(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function r(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function i(e, n) {
        this.message = e;
        this.defs = n;
    }
    i.prototype = Object.create(Error.prototype);
    i.prototype.constructor = i;
    i.prototype.name = "DefaultsError";
    r(i);
    function be(e, n, t) {
        if (t) for (var r in e) {
            if (Jn(e, r) && !Jn(n, r)) throw new i("`" + r + "` is not a supported option", n);
        }
        for (var r in e) {
            if (Jn(e, r)) n[r] = e[r];
        }
        return n;
    }
    function Yn() {}
    function an() {
        return false;
    }
    function Rn() {
        return true;
    }
    function Ln() {
        return this;
    }
    function Bn() {
        return null;
    }
    var Un = function() {
        function e(e, n) {
            var t = [];
            for (var r = 0; r < e.length; r++) {
                var i = n(e[r], r);
                if (i === a) continue;
                if (i instanceof o) {
                    t.push.apply(t, i.v);
                } else {
                    t.push(i);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function Vn(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function Wn(e, r) {
        return e.replace(/\{([^{}]+)\}/g, function(e, n) {
            var t = r[n];
            return t instanceof un ? t.print_to_string() : t;
        });
    }
    function Gn(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function on(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function sn(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function fn() {
        this.values = Object.create(null);
    }
    fn.prototype = {
        set: function(e, n) {
            if (e == "__proto__") {
                this.proto_value = n;
            } else {
                this.values[e] = n;
            }
            return this;
        },
        add: function(e, n) {
            var t = this.get(e);
            if (t) {
                t.push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return e == "__proto__" ? this.proto_value : this.values[e];
        },
        del: function(e) {
            if (e == "__proto__") {
                delete this.proto_value;
            } else {
                delete this.values[e];
            }
            return this;
        },
        has: function(e) {
            return e == "__proto__" ? "proto_value" in this : e in this.values;
        },
        all: function(e) {
            for (var n in this.values) if (!e(this.values[n], n)) return false;
            if ("proto_value" in this && !e(this.proto_value, "__proto__")) return false;
            return true;
        },
        each: function(e) {
            for (var n in this.values) e(this.values[n], n);
            if ("proto_value" in this) e(this.proto_value, "__proto__");
        },
        size: function() {
            return Object.keys(this.values).length + ("proto_value" in this);
        },
        map: function(e) {
            var n = [];
            for (var t in this.values) n.push(e(this.values[t], t));
            if ("proto_value" in this) n.push(e(this.proto_value, "__proto__"));
            return n;
        },
        clone: function() {
            var t = new fn();
            this.each(function(e, n) {
                t.set(n, e);
            });
            return t;
        },
        toObject: function() {
            var t = {};
            this.each(function(e, n) {
                t["$" + n] = e;
            });
            return t;
        }
    };
    fn.fromObject = function(e) {
        var n = new fn();
        for (var t in e) if (Jn(e, t)) n.set(t.slice(1), e[t]);
        return n;
    };
    function Jn(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function Xn(e, n, t) {
        var r = e.parent(-1);
        for (var i = 0, a; a = e.parent(i++); r = a) {
            if (_t(a)) {
                return n && a.value === r;
            } else if (a instanceof Tn) {
                if (a.left === r) continue;
            } else if (a.TYPE == "Call") {
                if (a.expression === r) continue;
            } else if (a instanceof An) {
                if (a.condition === r) continue;
            } else if (a instanceof tr) {
                return t;
            } else if (a instanceof wn) {
                if (a.expression === r) continue;
            } else if (a instanceof yn) {
                if (a.expressions[0] === r) continue;
            } else if (a instanceof ln) {
                return true;
            } else if (a instanceof Cr) {
                if (a.tag === r) continue;
            } else if (a instanceof fr) {
                if (a.expression === r) continue;
            }
            return false;
        }
    }
    function a(r, e) {
        if (e.length > 31) throw new Error("Too many properties: " + e.length + "\n" + e.join(", "));
        e.forEach(function(e, n) {
            var t = 1 << n;
            Object.defineProperty(r.prototype, e, {
                get: function() {
                    return !!(this._bits & t);
                },
                set: function(e) {
                    if (e) this._bits |= t; else this._bits &= ~t;
                }
            });
        });
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e, n, t, r) {
        if (typeof r === "undefined") r = un;
        n = n ? n.split(/\s+/) : [];
        var i = n;
        if (r && r.PROPS) n = n.concat(r.PROPS);
        var a = [ "return function AST_", e, "(props){", "this._bits=0;", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        a.push("}");
        var o = Object.create(r && r.prototype);
        if (t.initialize || o.initialize) a.push("this.initialize();");
        a.push("};");
        var s = new Function(a.join(""))();
        s.prototype = o;
        s.prototype.CTOR = s;
        s.prototype.TYPE = s.TYPE = e;
        if (r) {
            s.BASE = r;
            r.SUBCLASSES.push(s);
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        s.PROPS = n;
        s.SELF_PROPS = i;
        s.SUBCLASSES = [];
        for (var f in t) if (Jn(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.DEFMETHOD(f, t[f]);
            }
        }
        if (typeof _ !== "undefined") _["AST_" + e] = s;
        return s;
    }
    var ne = e("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var un = e("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Br(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: function() {
            if (this.TYPE == "Node") throw new Error("should not instantiate AST_Node");
        },
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Nn(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(Wn("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    a(un, [ "_optimized", "_squeezed", "call_only", "collapse_scanning", "defined", "evaluating", "falsy", "in_arg", "in_bool", "is_undefined", "inlined", "length_read", "nested", "new", "optional", "private", "pure", "redundant", "static", "terminal", "truthy", "uses_eval", "uses_with" ]);
    (un.log_function = function(n, e) {
        if (typeof n != "function") {
            un.info = un.warn = Yn;
            return;
        }
        var t = Object.create(null);
        un.info = e ? function(e, n) {
            r("INFO: " + Wn(e, n));
        } : Yn;
        un.warn = function(e, n) {
            r("WARN: " + Wn(e, n));
        };
        function r(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var o = [];
    un.enable_validation = function() {
        un.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!Jn(n.prototype, "transform")) return;
            var r = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = r.call(this, e, n);
                if (t instanceof un) {
                    t.validate();
                } else if (!(t === null || n && Un.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            o.push(function() {
                n.prototype.transform = r;
            });
        })(this);
    };
    un.disable_validation = function() {
        var e;
        while (e = o.pop()) e();
    };
    var Kn = e("Statement", null, {
        $documentation: "Base class of all statements",
        _validate: function() {
            if (this.TYPE == "Statement") throw new Error("should not instantiate AST_Statement");
        }
    });
    var Qn = e("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, Kn);
    var Zn = e("Directive", "quote value", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Kn);
    var cn = e("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, Kn);
    function et(e) {
        return e instanceof Kn && !(e instanceof Mt) && !(e instanceof mt);
    }
    function s(e, n, t, r, i) {
        t = t ? "contain" : "be";
        if (!(e instanceof un)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof gn) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof $n) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Ir && !i) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof kn && !r) throw new Error(n + " cannot " + t + " AST_Spread");
        if (et(e)) throw new Error(n + " cannot " + t + " AST_Statement");
        if (e instanceof zn) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function n(e, n) {
        s(e[n], n);
    }
    var ln = e("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            n(this, "body");
        }
    }, Kn);
    var nt = e("BlockScope", "_var_names enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Dictionary/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Dictionary/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.TYPE == "BlockScope") throw new Error("should not instantiate AST_BlockScope");
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof nt)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof dn)) throw new Error("must be contained within AST_Scope");
        }
    }, Kn);
    function tt(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var rt = e("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                tt(n, e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Block") throw new Error("should not instantiate AST_Block");
            this.body.forEach(function(e) {
                if (!et(e)) throw new Error("body must contain AST_Statement");
            });
        }
    }, nt);
    var pn = e("BlockStatement", null, {
        $documentation: "A block statement"
    }, rt);
    var j = e("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (this.TYPE == "StatementWithBody") throw new Error("should not instantiate AST_StatementWithBody");
            if (!et(this.body)) throw new Error("body must be AST_Statement");
        }
    }, nt);
    var it = e("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var r = this.label;
                n.walk(new Nn(function(e) {
                    if (e instanceof Yt) {
                        if (!e.label || e.label.thedef !== r) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof dn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof Se)) throw new Error("label must be AST_Label");
        }
    }, j);
    var at = e("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it.",
        _validate: function() {
            if (this.TYPE == "IterationStatement") throw new Error("should not instantiate AST_IterationStatement");
        }
    }, j);
    var ot = e("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            if (this.TYPE == "DWLoop") throw new Error("should not instantiate AST_DWLoop");
            n(this, "condition");
        }
    }, at);
    var st = e("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, ot);
    var ft = e("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, ot);
    var ut = e("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof un)) throw new Error("init must be AST_Node");
                if (et(this.init) && !(this.init instanceof Kt)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) n(this, "condition");
            if (this.step != null) n(this, "step");
        }
    }, at);
    var ct = e("ForEnumeration", "init object", {
        $documentation: "Base class for enumeration loops, i.e. `for ... in`, `for ... of` & `for await ... of`",
        $propdoc: {
            init: "[AST_Node] the assignment target during iteration",
            object: "[AST_Node] the object to iterate over"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ForEnumeration") throw new Error("should not instantiate AST_ForEnumeration");
            if (this.init instanceof Kt) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                u(this.init, function(e) {
                    if (!(e instanceof wn || e instanceof Mn)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            n(this, "object");
        }
    }, at);
    var lt = e("ForIn", null, {
        $documentation: "A `for ... in` statement"
    }, ct);
    var ye = e("ForOf", null, {
        $documentation: "A `for ... of` statement"
    }, ct);
    var pt = e("ForAwaitOf", null, {
        $documentation: "A `for await ... of` statement"
    }, ye);
    var dt = e("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            n(this, "expression");
        }
    }, j);
    var dn = e("Scope", "fn_defs may_call_this uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: Ln,
        _validate: function() {
            if (this.TYPE == "Scope") throw new Error("should not instantiate AST_Scope");
        }
    }, rt);
    var ht = e("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Dictionary/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return Xr([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Br(function(e) {
                if (e instanceof Zn && e.value == "$ORIG") {
                    return Un.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return Xr([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Br(function(e) {
                if (e instanceof Zn && e.value == "$ORIG") {
                    return Un.splice(t);
                }
            }));
        }
    }, dn);
    var hn = e("Lambda", "argnames length_read rest safe_ids uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            length_read: "[boolean/S] whether length property of this function is accessed",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean|number/S] whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Nn(function(e) {
                if (e instanceof gn) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof pr) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof Cn) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                tt(e, n);
            });
        },
        _validate: function() {
            if (this.TYPE == "Lambda") throw new Error("should not instantiate AST_Lambda");
            this.argnames.forEach(function(e) {
                u(e, function(e) {
                    if (!(e instanceof Cn)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) u(this.rest, function(e) {
                if (!(e instanceof Cn)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, dn);
    var vt = e("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, hn);
    var mt = e("LambdaExpression", "inlined", {
        $documentation: "Base class for function expressions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined"
        },
        _validate: function() {
            if (this.TYPE == "LambdaExpression") throw new Error("should not instantiate AST_LambdaExpression");
        }
    }, hn);
    function _t(e) {
        return e instanceof wt || e instanceof xt;
    }
    function gt(e) {
        return e instanceof xt || e instanceof Dt || e instanceof kt || e instanceof Ot || e instanceof Et;
    }
    function bt(e) {
        return e instanceof Ot || e instanceof Et || e instanceof qt || e instanceof Tt;
    }
    function yt(e, n) {
        if (_t(e) && e.value) {
            e.value.walk(n);
        } else {
            tt(e, n);
        }
    }
    var wt = e("Arrow", "value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    tt(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                n(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, mt);
    var xt = e("AsyncArrow", "value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    tt(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                n(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, mt);
    var kt = e("AsyncFunction", "name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Sr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, mt);
    var Et = e("AsyncGeneratorFunction", "name", {
        $documentation: "An asynchronous generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Sr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, mt);
    var St = e("Function", "name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Sr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, mt);
    var Tt = e("GeneratorFunction", "name", {
        $documentation: "A generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Sr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, mt);
    var At = e("LambdaDefinition", "inlined name", {
        $documentation: "Base class for function definitions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined",
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (this.TYPE == "LambdaDefinition") throw new Error("should not instantiate AST_LambdaDefinition");
            if (!(this.name instanceof Er)) throw new Error("name must be AST_SymbolDefun");
        }
    }, hn);
    var Dt = e("AsyncDefun", null, {
        $documentation: "An asynchronous function definition"
    }, At);
    var Ot = e("AsyncGeneratorDefun", null, {
        $documentation: "An asynchronous generator function definition"
    }, At);
    var $t = e("Defun", null, {
        $documentation: "A function definition"
    }, At);
    var qt = e("GeneratorDefun", null, {
        $documentation: "A generator function definition"
    }, At);
    var zt = e("Class", "extends name properties", {
        $documentation: "Base class for class literals",
        $propdoc: {
            extends: "[AST_Node?] the super class, or null if not specified",
            properties: "[AST_ClassProperty*] array of class properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                if (e.extends) e.extends.walk(n);
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Class") throw new Error("should not instantiate AST_Class");
            if (this.extends != null) n(this, "extends");
            this.properties.forEach(function(e) {
                if (!(e instanceof Ft)) throw new Error("properties must contain AST_ClassProperty");
            });
        }
    }, nt);
    var Ct = e("DefClass", null, {
        $documentation: "A class definition",
        $propdoc: {
            name: "[AST_SymbolDefClass] the name of this class"
        },
        _validate: function() {
            if (!(this.name instanceof Ee)) throw new Error("name must be AST_SymbolDefClass");
        }
    }, zt);
    var Mt = e("ClassExpression", null, {
        $documentation: "A class expression",
        $propdoc: {
            name: "[AST_SymbolClass?] the name of this class, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Tr)) throw new Error("name must be AST_SymbolClass");
            }
        }
    }, zt);
    var Ft = e("ClassProperty", "key private static value", {
        $documentation: "Base class for `class` properties",
        $propdoc: {
            key: "[string|AST_Node] property name (AST_Node for computed property)",
            private: "[boolean] whether this is a private property",
            static: "[boolean] whether this is a static property",
            value: "[AST_Node?] property value (AST_Accessor for getters/setters, AST_LambdaExpression for methods, null if not specified for fields)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof un) n.key.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ClassProperty") throw new Error("should not instantiate AST_ClassProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof un)) throw new Error("key must be string or AST_Node");
                n(this, "key");
            }
            if (this.value != null) {
                if (!(this.value instanceof un)) throw new Error("value must be AST_Node");
            }
        }
    });
    var Pt = e("ClassField", null, {
        $documentation: "A `class` field",
        _validate: function() {
            if (this.value != null) n(this, "value");
        }
    }, Ft);
    var we = e("ClassGetter", null, {
        $documentation: "A `class` getter",
        _validate: function() {
            if (!(this.value instanceof vt)) throw new Error("value must be AST_Accessor");
        }
    }, Ft);
    var xe = e("ClassSetter", null, {
        $documentation: "A `class` setter",
        _validate: function() {
            if (!(this.value instanceof vt)) throw new Error("value must be AST_Accessor");
        }
    }, Ft);
    var jt = e("ClassMethod", null, {
        $documentation: "A `class` method",
        _validate: function() {
            if (!(this.value instanceof mt)) throw new Error("value must be AST_LambdaExpression");
            if (_t(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, Ft);
    var Nt = e("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)",
        _validate: function() {
            if (this.TYPE == "Jump") throw new Error("should not instantiate AST_Jump");
        }
    }, Kn);
    var It = e("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Exit") throw new Error("should not instantiate AST_Exit");
        }
    }, Nt);
    var vn = e("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) n(this, "value");
        }
    }, It);
    var Ht = e("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            n(this, "value");
        }
    }, It);
    var Yt = e("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "LoopControl") throw new Error("should not instantiate AST_LoopControl");
            if (this.label != null) {
                if (!(this.label instanceof Te)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, Nt);
    var Rt = e("Break", null, {
        $documentation: "A `break` statement"
    }, Yt);
    var Lt = e("Continue", null, {
        $documentation: "A `continue` statement"
    }, Yt);
    var mn = e("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            n(this, "condition");
            if (this.alternative != null) {
                if (!et(this.alternative)) throw new Error("alternative must be AST_Statement");
            }
        }
    }, j);
    var Bt = e("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                tt(n, e);
            });
        },
        _validate: function() {
            n(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof Ut)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, rt);
    var Ut = e("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches",
        _validate: function() {
            if (this.TYPE == "SwitchBranch") throw new Error("should not instantiate AST_SwitchBranch");
        }
    }, rt);
    var Vt = e("Default", null, {
        $documentation: "A `default` switch branch"
    }, Ut);
    var Wt = e("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                tt(n, e);
            });
        },
        _validate: function() {
            n(this, "expression");
        }
    }, Ut);
    var Gt = e("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                tt(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof Jt)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof Xt)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, rt);
    var Jt = e("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                tt(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) u(this.argname, function(e) {
                if (!(e instanceof Ar)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, rt);
    var Xt = e("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, rt);
    var Kt = e("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Definitions") throw new Error("should not instantiate AST_Definitions");
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, Kn);
    var Qt = e("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof _n)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof yr)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, Kt);
    var Zt = e("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof _n)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof xr)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, Kt);
    var er = e("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof _n)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof kr)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, Kt);
    var _n = e("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) n(this, "value");
        }
    });
    var nr = e("ExportDeclaration", "body", {
        $documentation: "An `export` statement",
        $propdoc: {
            body: "[AST_DefClass|AST_Definitions|AST_LambdaDefinition] the statement to export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof Ct || this.body instanceof Kt || this.body instanceof At)) {
                throw new Error("body must be AST_DefClass, AST_Definitions or AST_LambdaDefinition");
            }
        }
    }, Kn);
    var tr = e("ExportDefault", "body", {
        $documentation: "An `export default` statement",
        $propdoc: {
            body: "[AST_Node] the default export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof Ct || this.body instanceof At)) {
                n(this, "body");
            }
        }
    }, Kn);
    var ke = e("ExportForeign", "aliases keys path quote", {
        $documentation: "An `export ... from '...'` statement",
        $propdoc: {
            aliases: "[string*] array of aliases to export",
            keys: "[string*] array of keys to import",
            path: "[string] the path to import module",
            quote: "[string?] the original quote character"
        },
        _validate: function() {
            if (this.aliases.length != this.keys.length) {
                throw new Error("aliases:key length mismatch: " + this.aliases.length + " != " + this.keys.length);
            }
            this.aliases.forEach(function(e) {
                if (typeof e != "string") throw new Error("aliases must contain string");
            });
            this.keys.forEach(function(e) {
                if (typeof e != "string") throw new Error("keys must contain string");
            });
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, Kn);
    var rr = e("ExportReferences", "properties", {
        $documentation: "An `export { ... }` statement",
        $propdoc: {
            properties: "[AST_SymbolExport*] array of aliases to export"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Dr)) throw new Error("properties must contain AST_SymbolExport");
            });
        }
    }, Kn);
    var ir = e("Import", "all default path properties quote", {
        $documentation: "An `import` statement",
        $propdoc: {
            all: "[AST_SymbolImport?] the imported namespace, or null if not specified",
            default: "[AST_SymbolImport?] the alias for default `export`, or null if not specified",
            path: "[string] the path to import module",
            properties: "[(AST_SymbolImport*)?] array of aliases, or null if not specified",
            quote: "[string?] the original quote character"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.all) e.all.walk(n);
                if (e.default) e.default.walk(n);
                if (e.properties) e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.all != null) {
                if (!(this.all instanceof wr)) throw new Error("all must be AST_SymbolImport");
                if (this.properties != null) throw new Error("cannot import both * and {} in the same statement");
            }
            if (this.default != null) {
                if (!(this.default instanceof wr)) throw new Error("default must be AST_SymbolImport");
                if (this.default.key !== "") throw new Error("invalid default key: " + this.default.key);
            }
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.properties != null) this.properties.forEach(function(e) {
                if (!(e instanceof wr)) throw new Error("properties must contain AST_SymbolImport");
            });
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, Kn);
    var gn = e("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            n(this, "value");
        }
    });
    function f(e, n, t, r) {
        e[n].forEach(function(e) {
            s(e, n, true, t, r);
        });
    }
    var bn = e("Call", "args expression optional pure terminal", {
        $documentation: "A function call expression",
        $propdoc: {
            args: "[AST_Node*] array of arguments",
            expression: "[AST_Node] expression to invoke as function",
            optional: "[boolean] whether the expression is optional chaining",
            pure: "[boolean/S] marker for side-effect-free call expression",
            terminal: "[boolean] whether the chain has ended"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            n(this, "expression");
            f(this, "args", true);
        }
    });
    var ar = e("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties",
        _validate: function() {
            if (this.optional) throw new Error("optional must be false");
            if (this.terminal) throw new Error("terminal must be false");
        }
    }, bn);
    var yn = e("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            f(this, "expressions");
        }
    });
    function or(e) {
        while (e instanceof wn) e = e.expression;
        return e;
    }
    var wn = e("PropAccess", "expression optional property terminal", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            optional: "[boolean] whether the expression is optional chaining",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node",
            terminal: "[boolean] whether the chain has ended"
        },
        get_property: function() {
            var e = this.property;
            if (e instanceof Fn) return e.value;
            if (e instanceof Sn && e.operator == "void" && e.expression instanceof Fn) return;
            return e;
        },
        _validate: function() {
            if (this.TYPE == "PropAccess") throw new Error("should not instantiate AST_PropAccess");
            n(this, "expression");
        }
    });
    var xn = e("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, wn);
    var sr = e("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            n(this, "property");
        }
    }, wn);
    var kn = e("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            n(this, "expression");
        }
    });
    var En = e("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Unary") throw new Error("should not instantiate AST_Unary");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            n(this, "expression");
        }
    });
    var Sn = e("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, En);
    var fr = e("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, En);
    var Tn = e("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof Dn)) n(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            n(this, "right");
        }
    });
    var An = e("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            n(this, "condition");
            n(this, "consequent");
            n(this, "alternative");
        }
    });
    var Dn = e("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof $n) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                u(this.left, function(e) {
                    if (!(e instanceof wn || e instanceof Mn)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            } else if (!(this.left instanceof Hr || this.left instanceof jr || this.left instanceof wn && !this.left.optional || this.left instanceof Mn || this.left instanceof Nr)) {
                throw new Error("left must be assignable");
            }
        }
    }, Tn);
    var ur = e("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            n(this, "expression");
        }
    });
    var cr = e("Yield", "expression nested", {
        $documentation: "A yield expression",
        $propdoc: {
            expression: "[AST_Node?] return value for iterator, or null if undefined",
            nested: "[boolean] whether to iterate over expression as generator"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.expression) n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.expression != null) {
                n(this, "expression");
            } else if (this.nested) {
                throw new Error("yield* must contain expression");
            }
        }
    });
    var On = e("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            f(this, "elements", true, true);
        }
    });
    var $n = e("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        },
        _validate: function() {
            if (this.TYPE == "Destructured") throw new Error("should not instantiate AST_Destructured");
        }
    });
    function u(e, n, t) {
        if (e instanceof gn && t) return u(e.name, n);
        if (e instanceof $n) {
            if (e.rest != null) u(e.rest, n);
            if (e instanceof lr) return e.elements.forEach(function(e) {
                if (!(e instanceof Ir)) u(e, n, true);
            });
            if (e instanceof dr) return e.properties.forEach(function(e) {
                u(e.value, n, true);
            });
        }
        n(e);
    }
    var lr = e("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, $n);
    var pr = e("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof un) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof un)) throw new Error("key must be string or AST_Node");
                n(this, "key");
            }
            if (!(this.value instanceof un)) throw new Error("value must be AST_Node");
        }
    });
    var dr = e("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof pr)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, $n);
    var qn = e("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof hr || e instanceof kn)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var hr = e("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof un) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ObjectProperty") throw new Error("should not instantiate AST_ObjectProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof un)) throw new Error("key must be string or AST_Node");
                n(this, "key");
            }
            if (!(this.value instanceof un)) throw new Error("value must be AST_Node");
        }
    });
    var vr = e("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            n(this, "value");
        }
    }, hr);
    var mr = e("ObjectMethod", null, {
        $documentation: "A key(){} object property",
        _validate: function() {
            if (!(this.value instanceof mt)) throw new Error("value must be AST_LambdaExpression");
            if (_t(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of object method's lambda must be null");
        }
    }, vr);
    var _r = e("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof vt)) throw new Error("value must be AST_Accessor");
        }
    }, hr);
    var gr = e("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof vt)) throw new Error("value must be AST_Accessor");
        }
    }, hr);
    var br = e("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (this.TYPE == "Symbol") throw new Error("should not instantiate AST_Symbol");
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var zn = e("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, br);
    var yr = e("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, zn);
    var wr = e("SymbolImport", "key", {
        $documentation: "Symbol defined by an `import` statement",
        $propdoc: {
            key: "[string] the original `export` name"
        },
        _validate: function() {
            if (typeof this.key != "string") throw new Error("key must be string");
        }
    }, yr);
    var xr = e("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, zn);
    var kr = e("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, zn);
    var Cn = e("SymbolFunarg", "unused", {
        $documentation: "Symbol naming a function argument"
    }, kr);
    var Er = e("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, zn);
    var Sr = e("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, zn);
    var Ee = e("SymbolDefClass", null, {
        $documentation: "Symbol defining a class"
    }, yr);
    var Tr = e("SymbolClass", null, {
        $documentation: "Symbol naming a class expression"
    }, yr);
    var Ar = e("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, zn);
    var Se = e("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, br);
    var Mn = e("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, br);
    var Dr = e("SymbolExport", "alias", {
        $documentation: "Reference in an `export` statement",
        $propdoc: {
            alias: "[string] the `export` alias"
        },
        _validate: function() {
            if (typeof this.alias != "string") throw new Error("alias must be string");
        }
    }, Mn);
    var Te = e("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, br);
    var Or = e("ObjectIdentity", null, {
        $documentation: "Base class for `super` & `this`",
        _validate: function() {
            if (this.TYPE == "ObjectIdentity") throw new Error("should not instantiate AST_ObjectIdentity");
        }
    }, br);
    var $r = e("Super", null, {
        $documentation: "The `super` symbol",
        _validate: function() {
            if (this.name !== "super") throw new Error('name must be "super"');
        }
    }, Or);
    var qr = e("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.TYPE == "This" && this.name !== "this") throw new Error('name must be "this"');
        }
    }, Or);
    var zr = e("NewTarget", null, {
        $documentation: "The `new.target` symbol",
        initialize: function() {
            this.name = "new.target";
        },
        _validate: function() {
            if (this.name !== "new.target") throw new Error('name must be "new.target": ' + this.name);
        }
    }, qr);
    var Cr = e("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node] tag function, or null if absent"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            f(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) n(this, "tag");
        }
    });
    var Fn = e("Constant", null, {
        $documentation: "Base class for all constants",
        _validate: function() {
            if (this.TYPE == "Constant") throw new Error("should not instantiate AST_Constant");
        }
    });
    var Pn = e("String", "quote value", {
        $documentation: "A string literal",
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] the contents of this string"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Fn);
    var jn = e("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, Fn);
    var Mr = e("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, Fn);
    var Fr = e("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, Fn);
    var g = e("Atom", null, {
        $documentation: "Base class for atoms",
        _validate: function() {
            if (this.TYPE == "Atom") throw new Error("should not instantiate AST_Atom");
        }
    }, Fn);
    var Pr = e("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, g);
    var jr = e("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, g);
    var Nr = e("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, g);
    var Ir = e("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, g);
    var Hr = e("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, g);
    var Yr = e("Boolean", null, {
        $documentation: "Base class for booleans",
        _validate: function() {
            if (this.TYPE == "Boolean") throw new Error("should not instantiate AST_Boolean");
        }
    }, g);
    var Rr = e("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Yr);
    var Lr = e("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Yr);
    function Nn(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Nn.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Yn);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof hn) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof Zn && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            var e = this.stack.pop();
            if (e instanceof hn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length - 1; --t >= 0; ) {
                var r = n[t];
                if (r instanceof e) return r;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof dn) {
                for (var r = 0; r < t.body.length; ++r) {
                    var i = t.body[r];
                    if (!(i instanceof Zn)) break;
                    if (i.value == e) return i;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof it && r.label.name == e.label.name) return r.body;
            } else for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof at || e instanceof Rt && r instanceof Bt) return r;
            }
        },
        in_boolean_context: function() {
            for (var e = true, n = 0, t, r = this.self(); t = this.parent(n++); r = t) {
                if (t instanceof Tn) switch (t.operator) {
                  case "&&":
                  case "||":
                    if (t.left === r) e = false;
                    continue;

                  default:
                    return false;
                }
                if (t instanceof An) {
                    if (t.condition === r) return true;
                    continue;
                }
                if (t instanceof ot) return t.condition === r;
                if (t instanceof ut) return t.condition === r;
                if (t instanceof mn) return t.condition === r;
                if (t instanceof vn) {
                    if (t.in_bool) return true;
                    while (t = this.parent(n++)) {
                        if (t instanceof hn) {
                            if (t.name) return false;
                            t = this.parent(n++);
                            if (t.TYPE != "Call") return false;
                            break;
                        }
                    }
                }
                if (t instanceof yn) {
                    if (t.tail_node() === r) continue;
                    return e ? "d" : true;
                }
                if (t instanceof ln) return e ? "d" : true;
                if (t instanceof Sn) return t.operator == "!";
                return false;
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Br(e, n) {
        Nn.call(this);
        this.before = e;
        this.after = n;
    }
    Br.prototype = new Nn();
    (function(e) {
        function t(e, n) {
            return Un(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(un, Yn);
        e(it, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(ln, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(rt, function(e, n) {
            e.body = t(e.body, n);
        });
        e(st, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(ft, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(ut, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(ct, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(dt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(It, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(Yt, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(mn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(Bt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Wt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Gt, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(Jt, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(Kt, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(_n, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(gn, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(hn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(wt, n);
        e(xt, n);
        e(zt, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            if (e.extends) e.extends = e.extends.transform(n);
            e.properties = t(e.properties, n);
        });
        e(Ft, function(e, n) {
            if (e.key instanceof un) e.key = e.key.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(bn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(yn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(ur, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(cr, function(e, n) {
            if (e.expression) e.expression = e.expression.transform(n);
        });
        e(xn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(sr, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(kn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(En, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Tn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(An, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(On, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(lr, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(pr, function(e, n) {
            if (e.key instanceof un) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(dr, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(qn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(hr, function(e, n) {
            if (e.key instanceof un) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(nr, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(tr, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(rr, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(ir, function(e, n) {
            if (e.all) e.all = e.all.transform(n);
            if (e.default) e.default = e.default.transform(n);
            if (e.properties) e.properties = t(e.properties, n);
        });
        e(Cr, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, i) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, r;
            e.push(this);
            if (e.before) t = e.before(this, i, n);
            if (typeof t === "undefined") {
                t = this;
                i(t, e);
                if (e.after) {
                    r = e.after(t, n);
                    if (typeof r !== "undefined") t = r;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var Ae = "break case catch class const continue debugger default delete do else extends finally for function if in instanceof new return switch throw try typeof var void while with";
    var C = "false null true";
    var N = [ "abstract async await boolean byte char double enum export final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield", C, Ae ].join(" ");
    var M = "return new delete throw else case";
    Ae = on(Ae);
    N = on(N);
    M = on(M);
    C = on(C);
    var c = /^0b([01]+)$/i;
    var l = /^0x([0-9a-f]+)$/i;
    var p = /^0o?([0-7]+)$/i;
    var F = on([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", "**=", ">>=", "<<=", ">>>=", "&=", "|=", "^=", "&&", "||", "??", "&&=", "||=", "??=" ]);
    var P = "\n\r\u2028\u2029";
    var I = "+-*&%=<>!?|~^";
    var d = "[{(";
    var h = ",;:";
    var v = ")}]";
    var De = h + v;
    var H = d + h;
    var Y = H + "`" + v;
    var R = P + "  \t\f\v​             　\ufeff";
    var L = on(t("./'\"#" + I + Y + R));
    P = on(t(P));
    I = on(t(I));
    De = on(t(De));
    H = on(t(H));
    Y = on(t(Y));
    R = on(t(R));
    function te(e) {
        return e >= 55296 && e <= 56319;
    }
    function re(e) {
        return e >= 56320 && e <= 57343;
    }
    function B(e) {
        return e >= 48 && e <= 57;
    }
    function ie(e) {
        return !L[e];
    }
    function Ur(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Vr(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else if (e.length == 5) {
                n = e.slice(1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = c.exec(e)) return parseInt(n[1], 2);
        if (n = l.exec(e)) return parseInt(n[1], 16);
        if (n = p.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function Wr(e, n, t, r, i) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = r;
        this.pos = i;
    }
    Wr.prototype = Object.create(Error.prototype);
    Wr.prototype.constructor = Wr;
    Wr.prototype.name = "SyntaxError";
    r(Wr);
    function Oe(e, n, t, r, i) {
        throw new Wr(e, n, t, r, i);
    }
    function $e(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var V = {};
    function qe(i, a, o, s) {
        var f = {
            text: i,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: [],
            read_template: n("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = r();
                    switch (t) {
                      case "\\":
                        t += r();
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (c() == "{") {
                            l();
                            e.push(n);
                            f.regex_allowed = true;
                            return true;
                        }
                    }
                    n += t;
                }
                function r() {
                    var e = l(true, true);
                    return e == "\r" ? "\n" : e;
                }
            })
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw V;
            if (P[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function h() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (P[e[n]]) return n;
            }
            return -1;
        }
        function r(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw V;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function m(e, n, t) {
            f.regex_allowed = e == "operator" && !Gr[n] || e == "keyword" && M[n] || e == "punc" && H[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var r = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                r.raw = i.substring(r.pos, r.endpos);
            }
            if (!t) {
                r.comments_before = f.comments_before;
                r.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new ne(r);
        }
        function _() {
            while (R[c()]) l();
        }
        function g(e) {
            var n = "", t;
            while ((t = c()) && e(t, n)) n += l();
            return n;
        }
        function b(e) {
            Oe(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function y(e) {
            return /^0[0-7_]+$/.test(e);
        }
        function w(e) {
            var t = false, r = false, i = false, a = e == ".";
            var n = g(function(e, n) {
                switch (e) {
                  case "x":
                  case "X":
                    return i ? false : i = true;

                  case "e":
                  case "E":
                    return i ? true : t ? false : t = r = true;

                  case "+":
                  case "-":
                    return r;

                  case r = false, ".":
                    return a || t || i || y(n) ? false : a = true;
                }
                return /[_0-9a-dfo]/i.test(e);
            });
            if (e) n = e + n;
            if (y(n)) {
                if (z.has_directive("use strict")) b("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(i ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) b("Invalid syntax: " + n);
            if (a || t || c() != "n") return m("num", o);
            return m("bigint", n.toLowerCase() + l());
        }
        function x(e) {
            var n = l(true, e);
            if (n >= "0" && n <= "7") return k(n);
            if (n == "u") {
                var t = l(true, e);
                n += t;
                if (t != "{") {
                    n += l(true, e) + l(true, e) + l(true, e);
                } else do {
                    t = l(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += l(true, e) + l(true, e);
            }
            var r = Vr(n);
            if (typeof r != "string") b("Invalid escape sequence: \\" + n);
            return r;
        }
        function k(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && z.has_directive("use strict")) b("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var E = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var r = l(true, true);
                if (r == "\\") r = x(true); else if (P[r]) b("Unterminated string constant"); else if (r == n) break;
                t += r;
            }
            var i = m("string", t);
            i.quote = e;
            return i;
        });
        function S(e) {
            var n = f.regex_allowed;
            var t = h(), r;
            if (t == -1) {
                r = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                r = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(m(e, r, true));
            f.regex_allowed = n;
            return z;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = r("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(m("comment2", t, true));
            f.regex_allowed = e;
            return z;
        });
        function T() {
            var e = false, n, t = false, r = c() == "#" ? l() : "";
            while (n = c()) {
                if (!e) {
                    if (n == "\\") t = e = true, l(); else if (ie(n)) r += l(); else break;
                } else {
                    if (n != "u") b("Expecting UnicodeEscapeSequence -- uXXXX");
                    n = x();
                    if (!ie(n)) b("Unicode char: " + n.charCodeAt(0) + " is not valid in identifier");
                    r += n;
                    e = false;
                }
            }
            if (Ae[r] && t) {
                var i = r.charCodeAt(0).toString(16).toUpperCase();
                r = "\\u" + "0000".substr(i.length) + i + r.slice(1);
            }
            return r;
        }
        var A = n("Unterminated regular expression", function(e) {
            var n = false, t, r = false;
            while (t = l(true)) if (P[t]) {
                b("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                r = true;
                e += t;
            } else if (t == "]" && r) {
                r = false;
                e += t;
            } else if (t == "/" && !r) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var i = T();
            try {
                var a = new RegExp(e, i);
                a.raw_source = e;
                return m("regexp", a);
            } catch (e) {
                b(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (F[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return m("operator", t(e || l()));
        }
        function O() {
            l();
            switch (c()) {
              case "/":
                l();
                return S("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? A("") : D("/");
        }
        function $() {
            l();
            var e = c();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    l();
                } while (c() == ".");
                return m("operator", n);
            }
            return B(e.charCodeAt(0)) ? w(".") : m("punc", ".");
        }
        function q() {
            var e = T();
            if (u) return m("name", e);
            return C[e] ? m("atom", e) : !Ae[e] ? m("name", e) : F[e] ? m("operator", e) : m("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === V) b(n); else throw e;
                }
            };
        }
        function z(e) {
            if (e != null) return A(e);
            if (s && f.pos == 0 && d("#!")) {
                v();
                p(2);
                S("comment5");
            }
            for (;;) {
                _();
                v();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        S("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        S("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return m("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return E(n);

                  case 46:
                    return $();

                  case 47:
                    var r = O();
                    if (r === z) continue;
                    return r;
                }
                if (B(t)) return w();
                if (Y[n]) return m("punc", l());
                if (d("=>")) return m("punc", l() + l());
                if (I[n]) return D();
                if (t == 35 || t == 92 || !L[n]) return q();
                break;
            }
            b("Unexpected character '" + n + "'");
        }
        z.context = function(e) {
            if (e) f = e;
            return f;
        };
        z.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        z.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        z.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        z.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return z;
    }
    var ze = on("typeof void delete -- ++ ! ~ - +");
    var Gr = on("-- ++");
    var Ce = on("= += -= /= *= %= **= >>= <<= >>>= &= |= ^= &&= ||= ??=");
    var Jr = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var r = e[t++];
            for (var i = 0; i < r.length; i++) {
                n[r[i]] = t;
            }
        }
        return n;
    }([ [ "??" ], [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var Me = on("atom bigint num regexp string");
    function Xr(t, l) {
        l = be(l, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var _ = {
            input: typeof t == "string" ? qe(t, l.filename, l.html5_comments, l.shebang) : t,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_generator: false,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        _.token = b();
        function g(e, n) {
            return $e(_.token, e, n);
        }
        function p() {
            return _.peeked || (_.peeked = _.input());
        }
        function b() {
            _.prev = _.token;
            if (_.peeked) {
                _.token = _.peeked;
                _.peeked = null;
            } else {
                _.token = _.input();
            }
            _.in_directives = _.in_directives && (_.token.type == "string" || g("punc", ";"));
            return _.token;
        }
        function y() {
            return _.prev;
        }
        function s(e, n, t, r) {
            var i = _.input.context();
            Oe(e, i.filename, n != null ? n : i.tokline, t != null ? t : i.tokcol, r != null ? r : i.tokpos);
        }
        function f(e, n) {
            s(n, e.line, e.col);
        }
        function r(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function w(e) {
            if (e == null) e = _.token;
            f(e, "Unexpected token: " + r(e.type, e.value));
        }
        function u(e, n) {
            if (g(e, n)) return b();
            f(_.token, "Unexpected token: " + r(_.token.type, _.token.value) + ", expected: " + r(e, n));
        }
        function x(e) {
            return u("punc", e);
        }
        function o(e) {
            return e.nlb || !sn(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function c() {
            return !l.strict && (g("eof") || g("punc", "}") || o(_.token));
        }
        function k(e) {
            if (g("punc", ";")) b(); else if (!e && !c()) x(";");
        }
        function d() {
            x("(");
            var e = N();
            x(")");
            return e;
        }
        function e(r) {
            return function() {
                var e = _.token;
                var n = r.apply(null, arguments);
                var t = y();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function E() {
            if (g("operator", "/") || g("operator", "/=")) {
                _.peeked = null;
                _.token = _.input(_.token.value.substr(1));
            }
        }
        var h = e(function() {
            E();
            switch (_.token.type) {
              case "string":
                var e = _.in_directives;
                var n = N();
                if (e) {
                    if (n instanceof Pn) {
                        var t = n.start.raw.slice(1, -1);
                        _.input.add_directive(t);
                        n.value = t;
                    } else {
                        _.in_directives = e = false;
                    }
                }
                k();
                return e ? new Zn(n) : new ln({
                    body: n
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return v();

              case "name":
                switch (_.token.value) {
                  case "async":
                    if ($e(p(), "keyword", "function")) {
                        b();
                        b();
                        if (!g("operator", "*")) return A(Dt);
                        b();
                        return A(Ot);
                    }
                    break;

                  case "await":
                    if (_.in_async) return v();
                    break;

                  case "export":
                    b();
                    return U();

                  case "import":
                    var r = p();
                    if (!(r.type == "punc" && /^[(.]$/.test(r.value))) {
                        b();
                        return G();
                    }
                    break;

                  case "let":
                    if (Q()) {
                        b();
                        var i = ee();
                        k();
                        return i;
                    }
                    break;

                  case "yield":
                    if (_.in_generator) return v();
                    break;
                }
                return $e(p(), "punc", ":") ? H() : v();

              case "punc":
                switch (_.token.value) {
                  case "{":
                    return new pn({
                        start: _.token,
                        body: O(),
                        end: y()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return v();

                  case ";":
                    _.in_directives = false;
                    b();
                    return new cn();

                  default:
                    w();
                }

              case "keyword":
                switch (_.token.value) {
                  case "break":
                    b();
                    return Y(Rt);

                  case "class":
                    b();
                    return m(Ct);

                  case "const":
                    b();
                    var i = Z();
                    k();
                    return i;

                  case "continue":
                    b();
                    return Y(Lt);

                  case "debugger":
                    b();
                    k();
                    return new Qn();

                  case "do":
                    b();
                    var n = I(h);
                    u("keyword", "while");
                    var a = d();
                    k(true);
                    return new st({
                        body: n,
                        condition: a
                    });

                  case "while":
                    b();
                    return new ft({
                        condition: d(),
                        body: I(h)
                    });

                  case "for":
                    b();
                    return L();

                  case "function":
                    b();
                    if (!g("operator", "*")) return A($t);
                    b();
                    return A(qt);

                  case "if":
                    b();
                    return B();

                  case "return":
                    if (_.in_function == 0 && !l.bare_returns) s("'return' outside of function");
                    b();
                    var t = null;
                    if (g("punc", ";")) {
                        b();
                    } else if (!c()) {
                        t = N();
                        k();
                    }
                    return new vn({
                        value: t
                    });

                  case "switch":
                    b();
                    return new Bt({
                        expression: d(),
                        body: I(J)
                    });

                  case "throw":
                    b();
                    if (o(_.token)) s("Illegal newline after 'throw'");
                    var t = N();
                    k();
                    return new Ht({
                        value: t
                    });

                  case "try":
                    b();
                    return X();

                  case "var":
                    b();
                    var i = ne();
                    k();
                    return i;

                  case "with":
                    if (_.input.has_directive("use strict")) {
                        s("Strict mode may not include a with statement");
                    }
                    b();
                    return new dt({
                        expression: d(),
                        body: h()
                    });
                }
            }
            w();
        });
        function H() {
            var n = z(Se);
            if (!sn(_.labels, function(e) {
                return e.name != n.name;
            })) {
                s("Label " + n.name + " defined twice");
            }
            x(":");
            _.labels.push(n);
            var e = h();
            _.labels.pop();
            if (!(e instanceof at)) {
                n.references.forEach(function(e) {
                    if (e instanceof Lt) {
                        f(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new it({
                body: e,
                label: n
            });
        }
        function v() {
            var e = N();
            k();
            return new ln({
                body: e
            });
        }
        function Y(e) {
            var n = null, t;
            if (!c()) {
                n = z(Te, true);
            }
            if (n != null) {
                t = Hn(function(e) {
                    return e.name == n.name;
                }, _.labels);
                if (!t) f(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (_.in_loop == 0) s(e.TYPE + " not inside a loop or switch");
            k();
            var r = new e({
                label: n
            });
            if (t) t.references.push(r);
            return r;
        }
        function R(e) {
            if (!g("name", e)) return;
            var n = p();
            if (!n) return;
            if ($e(n, "operator", "=")) return;
            if (n.type == "punc" && /^[(;}]$/.test(n.value)) return;
            if (o(n)) return;
            return b();
        }
        function m(e) {
            var n = _.in_async;
            var t = _.in_generator;
            _.input.push_directives_stack();
            _.input.add_directive("use strict");
            var r;
            if (e === Ct) {
                r = z(Ee);
            } else {
                r = z(Tr, true);
            }
            var i = null;
            if (g("keyword", "extends")) {
                b();
                E();
                i = ie(true);
            }
            x("{");
            var a = [];
            while (!g("punc", "}")) {
                if (g("punc", ";")) {
                    b();
                    continue;
                }
                var o = _.token;
                var s = !!R("static");
                var f = R("async");
                if (g("operator", "*")) {
                    b();
                    var u = g("name") && /^#/.test(_.token.value);
                    var c = q();
                    var l = _.token;
                    var p = A(f ? Et : Tt);
                    p.start = l;
                    p.end = y();
                    a.push(new jt({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: p,
                        end: y()
                    }));
                    continue;
                }
                var u = g("name") && /^#/.test(_.token.value);
                var c = q();
                if (g("punc", "(")) {
                    var d = _.token;
                    var h = A(f ? kt : St);
                    h.start = d;
                    h.end = y();
                    a.push(new jt({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: h,
                        end: y()
                    }));
                    continue;
                }
                if (f) w(f);
                var v = null;
                if (g("operator", "=")) {
                    b();
                    _.in_async = false;
                    _.in_generator = false;
                    v = j();
                    _.in_generator = t;
                    _.in_async = n;
                } else if (!(g("punc", ";") || g("punc", "}"))) {
                    var m = null;
                    switch (c) {
                      case "get":
                        m = we;
                        break;

                      case "set":
                        m = xe;
                        break;
                    }
                    if (m) {
                        a.push(new m({
                            start: o,
                            static: s,
                            private: g("name") && /^#/.test(_.token.value),
                            key: q(),
                            value: oe(),
                            end: y()
                        }));
                        continue;
                    }
                }
                k();
                a.push(new Pt({
                    start: o,
                    static: s,
                    private: u,
                    key: c,
                    value: v,
                    end: y()
                }));
            }
            b();
            _.input.pop_directives_stack();
            _.in_generator = t;
            _.in_async = n;
            return new e({
                extends: i,
                name: r,
                properties: a
            });
        }
        function L() {
            var e = g("name", "await") && b();
            x("(");
            var n = null;
            if (e || !g("punc", ";")) {
                n = g("keyword", "const") ? (b(), Z(true)) : g("name", "let") && Q() ? (b(), 
                ee(true)) : g("keyword", "var") ? (b(), ne(true)) : N(true);
                var t;
                if (e) {
                    u("name", "of");
                    t = pt;
                } else if (g("operator", "in")) {
                    b();
                    t = lt;
                } else if (g("name", "of")) {
                    b();
                    t = ye;
                }
                if (t) {
                    if (n instanceof Kt) {
                        if (n.definitions.length > 1) {
                            f(n.start, "Only one variable declaration allowed in for..in/of loop");
                        }
                        if (t !== lt && n.definitions[0].value) {
                            f(n.definitions[0].value.start, "No initializers allowed in for..of loop");
                        }
                    } else if (!(F(n) || (n = P(n)) instanceof $n)) {
                        f(n.start, "Invalid left-hand side in for..in/of loop");
                    }
                    return a(t, n);
                }
            }
            return i(n);
        }
        function i(e) {
            x(";");
            var n = g("punc", ";") ? null : N();
            x(";");
            var t = g("punc", ")") ? null : N();
            x(")");
            return new ut({
                init: e,
                condition: n,
                step: t,
                body: I(h)
            });
        }
        function a(e, n) {
            E();
            var t = N();
            x(")");
            return new e({
                init: n,
                object: t,
                body: I(h)
            });
        }
        function S(e) {
            if (e instanceof On) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof kn) {
                    n = S(e.elements.pop().expression);
                }
                return new lr({
                    start: e.start,
                    elements: e.elements.map(S),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof Dn) return new gn({
                start: e.start,
                name: S(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof gn) {
                e.name = S(e.name);
                return e;
            }
            if (e instanceof lr) {
                e.elements = e.elements.map(S);
                if (e.rest) e.rest = S(e.rest);
                return e;
            }
            if (e instanceof dr) {
                e.properties.forEach(function(e) {
                    e.value = S(e.value);
                });
                if (e.rest) e.rest = S(e.rest);
                return e;
            }
            if (e instanceof Ir) return e;
            if (e instanceof qn) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof kn) {
                    n = S(e.properties.pop().expression);
                }
                return new dr({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof vr)) f(e.start, "Invalid destructuring assignment");
                        return new pr({
                            start: e.start,
                            key: e.key,
                            value: S(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof Cn) return e;
            if (e instanceof Mn) return new Cn(e);
            if (e instanceof cr) return new Cn({
                start: e.start,
                name: "yield",
                end: e.end
            });
            f(e.start, "Invalid arrow parameter");
        }
        function T(e, n, t) {
            var r = _.in_async;
            var i = _.in_generator;
            _.in_async = t;
            _.in_generator = false;
            var a = _.in_funarg;
            _.in_funarg = _.in_function;
            var o = e.map(S);
            var s = e.rest || null;
            if (s) s = S(s);
            _.in_funarg = a;
            x("=>");
            var f, u;
            var c = _.in_loop;
            var l = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            if (g("punc", "{")) {
                f = O();
                u = null;
            } else {
                f = [];
                E();
                u = j();
            }
            var p = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = c;
            _.labels = l;
            _.in_generator = i;
            _.in_async = r;
            var d = new (t ? xt : wt)({
                start: n,
                argnames: o,
                rest: s,
                body: f,
                value: u,
                end: y()
            });
            if (p) d.each_argname(ce);
            return d;
        }
        var A = function(e) {
            var n = _.in_async;
            var t = _.in_generator;
            var r;
            if (/Defun$/.test(e.TYPE)) {
                r = z(Er);
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
            } else {
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
                r = z(Sr, true);
            }
            if (r && e !== vt && !(r instanceof zn)) w(y());
            x("(");
            var i = _.in_funarg;
            _.in_funarg = _.in_function;
            var a = $(")", !l.strict, false, function() {
                return le(Cn);
            });
            _.in_funarg = i;
            var o = _.in_loop;
            var s = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            var f = O();
            var u = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = o;
            _.labels = s;
            _.in_generator = t;
            _.in_async = n;
            var c = new e({
                name: r,
                argnames: a,
                rest: a.rest || null,
                body: f
            });
            if (u) {
                if (r) ce(r);
                c.each_argname(ce);
            }
            return c;
        };
        function B() {
            var e = d(), n = h(), t = null;
            if (g("keyword", "else")) {
                b();
                t = h();
            }
            return new mn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function D() {
            return g("name") || Ur(_.token.value);
        }
        function U() {
            if (g("operator", "*")) {
                b();
                var e = "*";
                if (g("name", "as")) {
                    b();
                    if (!D()) u("name");
                    e = _.token.value;
                    b();
                }
                u("name", "from");
                var n = _.token;
                u("string");
                k();
                return new ke({
                    aliases: [ e ],
                    keys: [ "*" ],
                    path: n.value,
                    quote: n.quote
                });
            }
            if (g("punc", "{")) {
                b();
                var r = [];
                var t = [];
                while (D()) {
                    var i = _.token;
                    b();
                    t.push(i);
                    if (g("name", "as")) {
                        b();
                        if (!D()) u("name");
                        r.push(_.token.value);
                        b();
                    } else {
                        r.push(i.value);
                    }
                    if (!g("punc", "}")) x(",");
                }
                x("}");
                if (g("name", "from")) {
                    b();
                    var n = _.token;
                    u("string");
                    k();
                    return new ke({
                        aliases: r,
                        keys: t.map(function(e) {
                            return e.value;
                        }),
                        path: n.value,
                        quote: n.quote
                    });
                }
                k();
                return new rr({
                    properties: t.map(function(e, n) {
                        if (!$e(e, "name")) f(e, "Name expected");
                        var t = ue(Dr, e);
                        t.alias = r[n];
                        return t;
                    })
                });
            }
            if (g("keyword", "default")) {
                b();
                var a = _.token;
                var o = V();
                if (o) {
                    o.start = a;
                    o.end = y();
                } else {
                    E();
                    o = N();
                    k();
                }
                return new tr({
                    body: o
                });
            }
            return new nr({
                body: W()
            });
        }
        function n(e, n) {
            if (n.name) {
                n = new e(n);
                n.name = new (e === Ct ? Ee : Er)(n.name);
            }
            return n;
        }
        function V() {
            if (g("name", "async")) {
                if (!$e(p(), "keyword", "function")) return;
                b();
                b();
                if (!g("operator", "*")) return n(Dt, A(kt));
                b();
                return n(Ot, A(Et));
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return n(Ct, m(Mt));

              case "function":
                b();
                if (!g("operator", "*")) return n($t, A(St));
                b();
                return n(qt, A(Tt));
            }
        }
        var W = e(function() {
            if (g("name")) switch (_.token.value) {
              case "async":
                b();
                u("keyword", "function");
                if (!g("operator", "*")) return A(Dt);
                b();
                return A(Ot);

              case "let":
                b();
                var e = ee();
                k();
                return e;
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return m(Ct);

              case "const":
                b();
                var e = Z();
                k();
                return e;

              case "function":
                b();
                if (!g("operator", "*")) return A($t);
                b();
                return A(qt);

              case "var":
                b();
                var e = ne();
                k();
                return e;
            }
            w();
        });
        function G() {
            var e = null;
            var n = z(wr, true);
            var t = null;
            if (n ? (n.key = "", g("punc", ",") && b()) : !g("string")) {
                if (g("operator", "*")) {
                    b();
                    u("name", "as");
                    e = z(wr);
                    e.key = "*";
                } else {
                    x("{");
                    t = [];
                    while (D()) {
                        var r;
                        if ($e(p(), "name", "as")) {
                            var i = _.token.value;
                            b();
                            b();
                            r = z(wr);
                            r.key = i;
                        } else {
                            r = z(wr);
                            r.key = r.name;
                        }
                        t.push(r);
                        if (!g("punc", "}")) x(",");
                    }
                    x("}");
                }
            }
            if (e || n || t) u("name", "from");
            var a = _.token;
            u("string");
            k();
            return new ir({
                all: e,
                default: n,
                path: a.value,
                properties: t,
                quote: a.quote
            });
        }
        function O() {
            x("{");
            var e = [];
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                e.push(h());
            }
            b();
            return e;
        }
        function J() {
            x("{");
            var e = [], n, t, r, i;
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                if (g("keyword", "case")) {
                    if (n) n.end = y();
                    t = [];
                    n = new Wt({
                        start: (i = _.token, b(), i),
                        expression: N(),
                        body: t
                    });
                    e.push(n);
                    x(":");
                } else if (g("keyword", "default")) {
                    if (n) n.end = y();
                    if (r) s("More than one default clause in switch statement");
                    t = [];
                    n = new Vt({
                        start: (i = _.token, b(), x(":"), i),
                        body: t
                    });
                    e.push(n);
                    r = n;
                } else {
                    if (!t) w();
                    t.push(h());
                }
            }
            if (n) n.end = y();
            b();
            return e;
        }
        function X() {
            var e = O(), n = null, t = null;
            if (g("keyword", "catch")) {
                var r = _.token;
                b();
                var i = null;
                if (g("punc", "(")) {
                    b();
                    i = C(Ar);
                    x(")");
                }
                n = new Jt({
                    start: r,
                    argname: i,
                    body: O(),
                    end: y()
                });
            }
            if (g("keyword", "finally")) {
                var r = _.token;
                b();
                t = new Xt({
                    start: r,
                    body: O(),
                    end: y()
                });
            }
            if (!n && !t) s("Missing catch/finally blocks");
            return new Gt({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function K(e, n) {
            var t = [];
            for (;;) {
                var r = _.token;
                var i = C(e);
                var a = null;
                if (g("operator", "=")) {
                    b();
                    a = j(n);
                } else if (!n && (e === yr || i instanceof $n)) {
                    s("Missing initializer in declaration");
                }
                t.push(new _n({
                    start: r,
                    name: i,
                    value: a,
                    end: y()
                }));
                if (!g("punc", ",")) break;
                b();
            }
            return t;
        }
        function Q() {
            var e = p();
            return $e(e, "name") || $e(e, "punc", "[") || $e(e, "punc", "{");
        }
        var Z = function(e) {
            return new Qt({
                start: y(),
                definitions: K(yr, e),
                end: y()
            });
        };
        var ee = function(e) {
            return new Zt({
                start: y(),
                definitions: K(xr, e),
                end: y()
            });
        };
        var ne = function(e) {
            return new er({
                start: y(),
                definitions: K(kr, e),
                end: y()
            });
        };
        var te = function(e) {
            var n = _.token;
            u("operator", "new");
            var t;
            if (g("punc", ".") && $e(p(), "name", "target")) {
                b();
                b();
                t = new zr();
            } else {
                var r = ie(false), i;
                if (g("punc", "(")) {
                    b();
                    i = $(")", !l.strict);
                } else {
                    i = [];
                }
                t = new ar({
                    expression: r,
                    args: i
                });
            }
            t.start = n;
            t.end = y();
            return M(t, e);
        };
        function re() {
            var e, n = _.token, t = n.value;
            switch (n.type) {
              case "num":
                if (isFinite(t)) {
                    e = new jn({
                        value: t
                    });
                } else {
                    e = new Hr();
                    if (t < 0) e = new Sn({
                        operator: "-",
                        expression: e
                    });
                }
                break;

              case "bigint":
                e = new Mr({
                    value: t
                });
                break;

              case "string":
                e = new Pn({
                    value: t,
                    quote: n.quote
                });
                break;

              case "regexp":
                e = new Fr({
                    value: t
                });
                break;

              case "atom":
                switch (t) {
                  case "false":
                    e = new Rr();
                    break;

                  case "true":
                    e = new Lr();
                    break;

                  case "null":
                    e = new Pr();
                    break;

                  default:
                    w();
                }
                break;

              default:
                w();
            }
            b();
            e.start = e.end = n;
            return e;
        }
        var ie = function(e) {
            if (g("operator", "new")) {
                return te(e);
            }
            var n = _.token;
            if (g("punc")) {
                switch (n.value) {
                  case "`":
                    return M(pe(null), e);

                  case "(":
                    b();
                    if (g("punc", ")")) {
                        b();
                        return T([], n);
                    }
                    var t = N(false, true);
                    var r = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var i = n.comments_before[0];
                        if (!i.nlb) {
                            i.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    x(")");
                    var a = y();
                    a.comments_before = t.end.comments_before;
                    a.comments_after.forEach(function(e) {
                        t.end.comments_after.push(e);
                        if (e.nlb) _.token.nlb = true;
                    });
                    a.comments_after.length = 0;
                    a.comments_after = t.end.comments_after;
                    t.end = a;
                    if (g("punc", "=>")) return T(t instanceof yn ? t.expressions : [ t ], n);
                    return M(t, e);

                  case "[":
                    return M(ae(), e);

                  case "{":
                    return M(se(), e);
                }
                w();
            }
            if (g("keyword")) switch (n.value) {
              case "class":
                b();
                var o = m(Mt);
                o.start = n;
                o.end = y();
                return M(o, e);

              case "function":
                b();
                var s;
                if (g("operator", "*")) {
                    b();
                    s = A(Tt);
                } else {
                    s = A(St);
                }
                s.start = n;
                s.end = y();
                return M(s, e);
            }
            if (g("name")) {
                var f = ue(Mn, n);
                b();
                if (f.name == "async") {
                    if (g("keyword", "function")) {
                        b();
                        var s;
                        if (g("operator", "*")) {
                            b();
                            s = A(Et);
                        } else {
                            s = A(kt);
                        }
                        s.start = n;
                        s.end = y();
                        return M(s, e);
                    }
                    if (g("name") && $e(p(), "punc", "=>")) {
                        n = _.token;
                        f = ue(Mn, n);
                        b();
                        return T([ f ], n, true);
                    }
                    if (g("punc", "(")) {
                        var u = M(f, e);
                        if (!g("punc", "=>")) return u;
                        var c = u.args;
                        if (c[c.length - 1] instanceof kn) {
                            c.rest = c.pop().expression;
                        }
                        return T(c, n, true);
                    }
                }
                return g("punc", "=>") ? T([ f ], n) : M(f, e);
            }
            if (Me[_.token.type]) {
                return M(re(), e);
            }
            w();
        };
        function $(e, n, t, r) {
            if (!r) r = j;
            var i = true, a = [];
            while (!g("punc", e)) {
                if (i) i = false; else x(",");
                if (n && g("punc", e)) break;
                if (t && g("punc", ",")) {
                    a.push(new Ir({
                        start: _.token,
                        end: _.token
                    }));
                } else if (!g("operator", "...")) {
                    a.push(r());
                } else if (r === j) {
                    a.push(new kn({
                        start: _.token,
                        expression: (b(), r()),
                        end: y()
                    }));
                } else {
                    b();
                    a.rest = r();
                    if (a.rest instanceof gn) f(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            x(e);
            return a;
        }
        var ae = e(function() {
            x("[");
            return new On({
                elements: $("]", !l.strict, true)
            });
        });
        var oe = e(function() {
            return A(vt);
        });
        var se = e(function() {
            x("{");
            var e = true, n = [];
            while (!g("punc", "}")) {
                if (e) e = false; else x(",");
                if (!l.strict && g("punc", "}")) break;
                var t = _.token;
                if (g("operator", "*")) {
                    b();
                    var r = q();
                    var i = _.token;
                    var a = A(Tt);
                    a.start = i;
                    a.end = y();
                    n.push(new mr({
                        start: t,
                        key: r,
                        value: a,
                        end: y()
                    }));
                    continue;
                }
                if (g("operator", "...")) {
                    b();
                    n.push(new kn({
                        start: t,
                        expression: j(),
                        end: y()
                    }));
                    continue;
                }
                if ($e(p(), "operator", "=")) {
                    var o = z(Mn);
                    b();
                    n.push(new vr({
                        start: t,
                        key: t.value,
                        value: new Dn({
                            start: t,
                            left: o,
                            operator: "=",
                            right: j(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                if ($e(p(), "punc", ",") || $e(p(), "punc", "}")) {
                    n.push(new vr({
                        start: t,
                        key: t.value,
                        value: z(Mn),
                        end: y()
                    }));
                    continue;
                }
                var r = q();
                if (g("punc", "(")) {
                    var s = _.token;
                    var f = A(St);
                    f.start = s;
                    f.end = y();
                    n.push(new mr({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (g("punc", ":")) {
                    b();
                    n.push(new vr({
                        start: t,
                        key: r,
                        value: j(),
                        end: y()
                    }));
                    continue;
                }
                if (t.type == "name") switch (r) {
                  case "async":
                    var u = g("operator", "*") && b();
                    r = q();
                    var s = _.token;
                    var f = A(u ? Et : kt);
                    f.start = s;
                    f.end = y();
                    n.push(new mr({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;

                  case "get":
                    n.push(new gr({
                        start: t,
                        key: q(),
                        value: oe(),
                        end: y()
                    }));
                    continue;

                  case "set":
                    n.push(new _r({
                        start: t,
                        key: q(),
                        value: oe(),
                        end: y()
                    }));
                    continue;
                }
                w();
            }
            b();
            return new qn({
                properties: n
            });
        });
        function q() {
            var e = _.token;
            switch (e.type) {
              case "operator":
                if (!Ae[e.value]) w();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                b();
                return "" + e.value;

              case "punc":
                x("[");
                var n = j();
                x("]");
                return n;

              default:
                w();
            }
        }
        function fe() {
            var e = _.token.value;
            u("name");
            return e;
        }
        function ue(e, n) {
            var t = n.value;
            switch (t) {
              case "await":
                if (_.in_async) w(n);
                break;

              case "super":
                e = $r;
                break;

              case "this":
                e = qr;
                break;

              case "yield":
                if (_.in_generator) w(n);
                break;
            }
            return new e({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function ce(e) {
            if (e.name == "arguments" || e.name == "eval" || e.name == "let") f(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function z(e, n) {
            if (!g("name")) {
                if (!n) s("Name expected");
                return null;
            }
            var t = ue(e, _.token);
            if (_.input.has_directive("use strict") && t instanceof zn) {
                ce(t);
            }
            b();
            return t;
        }
        function C(e) {
            var n = _.token;
            if (g("punc", "[")) {
                b();
                var t = $("]", !l.strict, true, function() {
                    return le(e);
                });
                return new lr({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: y()
                });
            }
            if (g("punc", "{")) {
                b();
                var r = true, i = [], a = null;
                while (!g("punc", "}")) {
                    if (r) r = false; else x(",");
                    if (!l.strict && g("punc", "}")) break;
                    var o = _.token;
                    if (g("punc", "[") || $e(p(), "punc", ":")) {
                        var s = q();
                        x(":");
                        i.push(new pr({
                            start: o,
                            key: s,
                            value: le(e),
                            end: y()
                        }));
                        continue;
                    }
                    if (g("operator", "...")) {
                        b();
                        a = C(e);
                        break;
                    }
                    var f = z(e);
                    if (g("operator", "=")) {
                        b();
                        f = new gn({
                            start: f.start,
                            name: f,
                            value: j(),
                            end: y()
                        });
                    }
                    i.push(new pr({
                        start: o,
                        key: o.value,
                        value: f,
                        end: y()
                    }));
                }
                x("}");
                return new dr({
                    start: n,
                    properties: i,
                    rest: a,
                    end: y()
                });
            }
            return z(e);
        }
        function le(e) {
            var n = _.token;
            var t = C(e);
            if (!g("operator", "=")) return t;
            b();
            return new gn({
                start: n,
                name: t,
                value: j(),
                end: y()
            });
        }
        function pe(e) {
            var n = e ? e.start : _.token;
            var t = _.input.context().read_template;
            var r = [];
            var i = [];
            while (t(r)) {
                b();
                i.push(N());
                if (!g("punc", "}")) w();
            }
            b();
            return new Cr({
                start: n,
                expressions: i,
                strings: r,
                tag: e,
                end: y()
            });
        }
        function M(e, n) {
            var t = e.start;
            var r = null;
            while (true) {
                if (g("operator", "?") && $e(p(), "punc", ".")) {
                    b();
                    b();
                    r = e;
                }
                if (g("punc", "[")) {
                    b();
                    var i = N();
                    x("]");
                    e = new sr({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: i,
                        end: y()
                    });
                } else if (n && g("punc", "(")) {
                    b();
                    e = new bn({
                        start: t,
                        optional: r === e,
                        expression: e,
                        args: $(")", !l.strict),
                        end: y()
                    });
                } else if (r === e || g("punc", ".")) {
                    if (r !== e) b();
                    e = new xn({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: fe(),
                        end: y()
                    });
                } else if (g("punc", "`")) {
                    if (r) s("Invalid template on optional chain");
                    e = pe(e);
                } else {
                    break;
                }
            }
            if (r) e.terminal = true;
            if (e instanceof bn && !e.pure) {
                var t = e.start;
                var a = t.comments_before;
                var o = Jn(t, "comments_before_length") ? t.comments_before_length : a.length;
                while (--o >= 0) {
                    if (/[@#]__PURE__/.test(a[o].value)) {
                        e.pure = true;
                        break;
                    }
                }
            }
            return e;
        }
        function de(e) {
            var n = _.token;
            if (_.in_async && g("name", "await")) {
                if (_.in_funarg === _.in_function) s("Invalid use of await in function argument");
                _.input.context().regex_allowed = true;
                b();
                return new ur({
                    start: n,
                    expression: de(e),
                    end: y()
                });
            }
            if (_.in_generator && g("name", "yield")) {
                if (_.in_funarg === _.in_function) s("Invalid use of yield in function argument");
                _.input.context().regex_allowed = true;
                b();
                var t = null;
                var r = false;
                if (g("operator", "*")) {
                    b();
                    t = j(e);
                    r = true;
                } else if (g("punc") ? !De[_.token.value] : !c()) {
                    t = j(e);
                }
                return new cr({
                    start: n,
                    expression: t,
                    nested: r,
                    end: y()
                });
            }
            if (g("operator") && ze[n.value]) {
                b();
                E();
                var i = he(Sn, n, de(e));
                i.start = n;
                i.end = y();
                return i;
            }
            var a = ie(true);
            while (g("operator") && Gr[_.token.value] && !o(_.token)) {
                a = he(fr, _.token, a);
                a.start = n;
                a.end = _.token;
                b();
            }
            return a;
        }
        function he(e, n, t) {
            var r = n.value;
            switch (r) {
              case "++":
              case "--":
                if (!F(t)) f(n, "Invalid use of " + r + " operator");
                break;

              case "delete":
                if (t instanceof Mn && _.input.has_directive("use strict")) f(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: r,
                expression: t
            });
        }
        var ve = function(e, n, t) {
            var r = g("operator") ? _.token.value : null;
            if (r == "in" && t) r = null;
            var i = r != null ? Jr[r] : null;
            if (i != null && i > n) {
                b();
                var a = ve(de(t), r == "**" ? i - 1 : i, t);
                return ve(new Tn({
                    start: e.start,
                    left: e,
                    operator: r,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function me(e) {
            return ve(de(e), 0, e);
        }
        var _e = function(e) {
            var n = _.token;
            var t = me(e);
            if (g("operator", "?")) {
                b();
                var r = j();
                x(":");
                return new An({
                    start: n,
                    condition: t,
                    consequent: r,
                    alternative: j(e),
                    end: y()
                });
            }
            return t;
        };
        function F(e) {
            return e instanceof wn && !e.optional || e instanceof Mn;
        }
        function P(e) {
            if (e instanceof On) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof kn) {
                    n = P(e.elements.pop().expression);
                    if (!(n instanceof $n || F(n))) return e;
                }
                var t = e.elements.map(P);
                return sn(t, function(e) {
                    return e instanceof gn || e instanceof $n || e instanceof Ir || F(e);
                }) ? new lr({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof Dn) {
                var r = P(e.left);
                return r instanceof $n || F(r) ? new gn({
                    start: e.start,
                    name: r,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof qn)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof kn) {
                n = P(e.properties.pop().expression);
                if (!(n instanceof $n || F(n))) return e;
            }
            var i = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof vr)) return e;
                var s = P(o.value);
                if (!(s instanceof gn || s instanceof $n || F(s))) {
                    return e;
                }
                i.push(new pr({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new dr({
                start: e.start,
                properties: i,
                rest: n,
                end: e.end
            });
        }
        function j(e) {
            var n = _.token;
            var t = _e(e), r = _.token.value;
            if (g("operator") && Ce[r]) {
                if (F(t) || r == "=" && (t = P(t)) instanceof $n) {
                    b();
                    return new Dn({
                        start: n,
                        left: t,
                        operator: r,
                        right: j(e),
                        end: y()
                    });
                }
                s("Invalid assignment");
            }
            return t;
        }
        function N(e, n) {
            var t = _.token;
            var r = [];
            while (true) {
                if (n && g("operator", "...")) {
                    b();
                    r.rest = C(Cn);
                    break;
                }
                r.push(j(e));
                if (!g("punc", ",")) break;
                b();
                if (n && g("punc", ")") && $e(p(), "punc", "=>")) break;
            }
            return r.length == 1 && !r.rest ? r[0] : new yn({
                start: t,
                expressions: r,
                end: y()
            });
        }
        function I(e) {
            ++_.in_loop;
            var n = e();
            --_.in_loop;
            return n;
        }
        if (l.expression) {
            E();
            var ge = N();
            u("eof");
            return ge;
        }
        return function() {
            var e = _.token;
            var n = [];
            _.input.push_directives_stack();
            while (!g("eof")) n.push(h());
            _.input.pop_directives_stack();
            var t = y() || e;
            var r = l.toplevel;
            if (r) {
                r.body = r.body.concat(n);
                r.end = t;
            } else {
                r = new ht({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return r;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function m(e, n, t, r) {
        this._bits = 0;
        this.defun = undefined;
        this.eliminated = 0;
        this.id = e;
        this.init = r;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.safe_ids = undefined;
        this.scope = n;
    }
    m.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = x(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this;
            var n = e.defun;
            if (!n) return;
            var t = e.name;
            var r = n.variables.get(t) || n instanceof ht && n.globals.get(t) || e.orig[0] instanceof yr && Hn(function(e) {
                return e.name == t;
            }, n.enclosed);
            if (r && r !== e) return r.redefined() || r;
        },
        unmangleable: function(e) {
            if (this.exported) return true;
            if (this.undeclared) return true;
            if (!e.eval && this.scope.pinned()) return true;
            if (e.keep_fargs && Kr(this)) return true;
            if (e.keep_fnames) {
                var n = this.orig[0];
                if (n instanceof Tr) return true;
                if (n instanceof Ee) return true;
                if (n instanceof Er) return true;
                if (n instanceof Sr) return true;
            }
            if (!e.toplevel && this.global) return true;
            return false;
        }
    };
    a(m, [ "const_redefs", "cross_loop", "direct_access", "exported", "global", "undeclared" ]);
    function Kr(e) {
        return e.orig[0] instanceof Cn || e.orig[1] instanceof Cn;
    }
    var Qr = on("delete ++ --");
    function Zr(e, n) {
        if (n instanceof Dn) return n.left === e && e;
        if (n instanceof gn) return n.name === e && e;
        if (n instanceof $n) return e;
        if (n instanceof pr) return e;
        if (n instanceof ct) return n.init === e && e;
        if (n instanceof En) return Qr[n.operator] && n.expression;
    }
    ht.DEFMETHOD("figure_out_scope", function(c) {
        c = be(c, {
            cache: null,
            ie: false
        });
        var l = this;
        var o = null;
        var s = false;
        var t = 0;
        var f = l.parent_scope = null;
        var p = new Nn(function(r, e) {
            if (r instanceof Ct) {
                var n = s;
                s = p.parent() instanceof nr;
                r.name.walk(p);
                s = n;
                a(function() {
                    if (r.extends) r.extends.walk(p);
                    r.properties.forEach(function(e) {
                        e.walk(p);
                    });
                });
                return true;
            }
            if (r instanceof Kt) {
                var n = s;
                s = p.parent() instanceof nr;
                e();
                s = n;
                return true;
            }
            if (r instanceof At) {
                var n = s;
                s = p.parent() instanceof nr;
                r.name.walk(p);
                s = n;
                a(function() {
                    r.argnames.forEach(function(e) {
                        e.walk(p);
                    });
                    if (r.rest) r.rest.walk(p);
                    tt(r, p);
                });
                return true;
            }
            if (r instanceof Ut) {
                r.init_vars(f);
                e();
                return true;
            }
            if (r instanceof Gt) {
                a(function() {
                    tt(r, p);
                });
                if (r.bcatch) r.bcatch.walk(p);
                if (r.bfinally) r.bfinally.walk(p);
                return true;
            }
            if (r instanceof dt) {
                var t = f;
                do {
                    t = t.resolve();
                    if (t.uses_with) break;
                    t.uses_with = true;
                } while (t = t.parent_scope);
                a(e);
                return true;
            }
            if (r instanceof nt) {
                a(e);
                return true;
            }
            if (r instanceof br) {
                r.scope = f;
            }
            if (r instanceof Se) {
                r.thedef = r;
                r.references = [];
            }
            if (r instanceof Ar) {
                f.def_variable(r).defun = o;
            } else if (r instanceof yr) {
                var i = f.def_variable(r);
                i.defun = o;
                if (s) i.exported = true;
            } else if (r instanceof Er) {
                var i = o.def_function(r, p.parent());
                if (s) i.exported = true;
            } else if (r instanceof Cn) {
                o.def_variable(r);
            } else if (r instanceof Sr) {
                var i = o.def_function(r, r.name == "arguments" ? undefined : o);
                if (c.ie && r.name != "arguments") i.defun = o.parent_scope.resolve();
            } else if (r instanceof xr) {
                var i = f.def_variable(r);
                if (s) i.exported = true;
            } else if (r instanceof kr) {
                var i = o.def_variable(r, r instanceof wr ? undefined : null);
                if (s) i.exported = true;
            }
            function a(e) {
                r.init_vars(f);
                var n = o;
                var t = f;
                if (r instanceof dn) o = r;
                f = r;
                e();
                f = t;
                o = n;
            }
        });
        l.make_def = function(e, n) {
            return new m(++t, this, e, n);
        };
        l.walk(p);
        l.globals = new fn();
        var d = [];
        var p = new Nn(function(e) {
            if (e instanceof Jt) {
                if (!(e.argname instanceof $n)) return;
                d.push(e);
                e.argname.walk(p);
                d.pop();
                tt(e, p);
                return true;
            }
            if (e instanceof hn) {
                d.push(e);
                if (e.name) e.name.walk(p);
                e.argnames.forEach(function(e) {
                    e.walk(p);
                });
                if (e.rest) e.rest.walk(p);
                d.pop();
                yt(e, p);
                return true;
            }
            if (e instanceof Yt) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof zn) {
                var n = e.definition();
                n.preinit = n.references.length;
                if (e instanceof Ar) {
                    var t = n.redefined();
                    if (t) for (var r = e.scope; r; r = r.parent_scope) {
                        Vn(r.enclosed, t);
                        if (r === t.scope) break;
                    }
                } else if (e instanceof yr) {
                    var t = n.redefined();
                    if (t) t.const_redefs = true;
                } else if (n.scope !== e.scope && (e instanceof Er || e instanceof Cn || e instanceof kr)) {
                    e.mark_enclosed(c);
                    var t = e.scope.find_variable(e.name);
                    if (e.thedef !== t) {
                        e.thedef = t;
                        t.orig.push(e);
                        e.mark_enclosed(c);
                    }
                }
                if (e.name != "arguments") return true;
                var i = e instanceof kr && p.parent();
                if (i instanceof _n && !i.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && h(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof Mn) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = d.length; s > 0 && a; ) {
                    s = d.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof Ar || f instanceof Cn || f instanceof Sr) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = l.def_global(e);
                } else if (o == "arguments" && h(a)) {
                    var i = p.parent();
                    if (Zr(e, i)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(i instanceof wn && i.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var i = p.parent();
                    if (i.TYPE == "Call" && i.expression === e) {
                        var r = e.scope;
                        do {
                            r = r.resolve();
                            if (r.uses_eval) break;
                            r.uses_eval = true;
                        } while (r = r.parent_scope);
                    } else if (a.undeclared) {
                        l.uses_eval = true;
                    }
                }
                if (a.init instanceof At && a.scope !== a.init.name.scope) {
                    var u = e.scope;
                    do {
                        if (u === a.init.name.scope) break;
                    } while (u = u.parent_scope);
                    if (!u) a.init = undefined;
                }
                e.thedef = a;
                e.reference(c);
                return true;
            }
        });
        l.walk(p);
        if (c.ie) l.walk(new Nn(function(e) {
            if (e instanceof Ar) {
                var n = e.thedef.defun;
                if (n.name instanceof Sr && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                r(e, n);
                return true;
            }
            if (e instanceof Sr) {
                var t = e.thedef;
                if (!r(e, e.scope.parent_scope.resolve())) {
                    t.defun = undefined;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function h(e) {
            return e.orig[0] instanceof Cn && !(e.orig[1] instanceof Cn || e.orig[2] instanceof Cn) && !_t(e.scope);
        }
        function r(e, n) {
            var t = e.name;
            var r = e.thedef;
            if (!sn(r.orig, function(e) {
                return !(e instanceof yr || e instanceof xr);
            })) return false;
            var i = n.find_variable(t);
            if (i) {
                var a = i.redefined();
                if (a) i = a;
            } else {
                i = l.globals.get(t);
            }
            if (i) {
                i.orig.push(e);
            } else {
                i = n.def_variable(e);
            }
            if (i.undeclared) l.variables.set(t, i);
            if (t == "arguments" && h(r) && e instanceof Sr) return true;
            r.defun = i.scope;
            r.forEach(function(e) {
                e.redef = r;
                e.thedef = i;
                e.reference(c);
            });
            return true;
        }
    });
    ht.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var r = this.make_def(e);
            r.undeclared = true;
            r.global = true;
            n.set(t, r);
            return r;
        }
    });
    function b(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new fn();
        e.variables = new fn();
        if (n) e.make_def = n.make_def;
    }
    function y(e, n) {
        b(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    nt.DEFMETHOD("init_vars", function(e) {
        b(this, e);
    });
    dn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    wt.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        return this;
    });
    xt.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    hn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        this.uses_arguments = false;
        this.def_variable(new Cn({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    br.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            Vn(t.enclosed, n);
            if (!e) {
                t._var_names = undefined;
            } else {
                if (e.keep_fargs && t instanceof hn) t.each_argname(function(e) {
                    Vn(n.scope.enclosed, e.definition());
                });
                if (e.keep_fnames) t.functions.each(function(e) {
                    Vn(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    br.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    nt.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    nt.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof At) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    nt.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof mt) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function w(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = new fn();
            var r = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t.set(e.name, true);
                if (e.global && r && r.has(e.name)) {
                    t.set(r.get(e.name), true);
                }
            });
        }
        return t;
    }
    function x(e, t) {
        var n = e.scope;
        var r = w(n, t);
        var i = n.cname_holes;
        var a = new fn();
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (In(n, o)) break;
                w(n, t).each(function(e, n) {
                    a.set(n, e);
                });
                o.push(n);
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < i.length; f++) {
            s = E(i[f]);
            if (a.has(s)) continue;
            i.splice(f, 1);
            r.set(s, true);
            return s;
        }
        while (true) {
            s = E(++n.cname);
            if (r.has(s) || N[s] || t.reserved.has[s]) continue;
            if (!a.has(s)) break;
            i.push(n.cname);
        }
        r.set(s, true);
        return s;
    }
    br.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    Se.DEFMETHOD("unmangleable", an);
    br.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function k(e) {
        e = be(e, {
            eval: false,
            ie: false,
            keep_fargs: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        Vn(e.reserved, "arguments");
        e.reserved.has = on(e.reserved);
        return e;
    }
    ht.DEFMETHOD("mangle_names", function(s) {
        s = k(s);
        if (s.cache && s.cache.props) {
            var n = w(this, s);
            s.cache.props.each(function(e) {
                n.set(e, true);
            });
        }
        var f = 36;
        var u = -1;
        var a = [];
        var c = new Nn(function(e, n) {
            if (e instanceof it) {
                var t = u;
                n();
                if (!s.v8 || !d(c)) u = t;
                return true;
            }
            if (e instanceof nt) {
                if (s.webkit && e instanceof at && e.init instanceof Zt) {
                    e.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof xr)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var r = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(r);
                            n.redefined = function() {
                                return r;
                            };
                        });
                    }, true);
                }
                var r = e.to_mangle = [];
                e.variables.each(function(e) {
                    if (!p(e)) r.push(e);
                });
                n();
                if (s.cache && e instanceof ht) {
                    e.globals.each(l);
                }
                if (e instanceof $t && c.has_directive("use asm")) {
                    var i = new Mn(e.name);
                    i.scope = e;
                    i.reference(s);
                }
                if (r.length > f) {
                    var a = r.map(function(e, n) {
                        return n;
                    }).sort(function(e, n) {
                        return r[n].references.length - r[e].references.length || e - n;
                    });
                    r = a.slice(0, f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }).concat(a.slice(f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }));
                }
                r.forEach(l);
                return true;
            }
            if (e instanceof Se) {
                var o;
                do {
                    o = E(++u);
                } while (N[o]);
                e.mangled_name = o;
                return true;
            }
        });
        this.walk(c);
        a.forEach(l);
        function l(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
        function p(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof yr)) return false;
                var r = n.scope.resolve();
                if (n.scope === r) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = r.def_variable(e);
                r.to_mangle.push(t);
            }
            a.push(n);
            n.references.forEach(i);
            if (e instanceof Ar || e instanceof yr) i(e);
            return true;
            function i(e) {
                e.thedef = t;
                e.reference(s);
                e.thedef = n;
            }
        }
        function d(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof rt) return t instanceof ht && !s.toplevel;
                if (t instanceof it) return true;
            }
        }
    });
    ht.DEFMETHOD("find_colliding_names", function(t) {
        var r = t.cache && t.cache.props;
        var n = Object.create(N);
        t.reserved.forEach(i);
        this.globals.each(a);
        this.walk(new Nn(function(e) {
            if (e instanceof nt) e.variables.each(a);
        }));
        return n;
        function i(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && r && r.has(n)) n = r.get(n); else if (!e.unmangleable(t)) return;
            i(n);
        }
    });
    ht.DEFMETHOD("expand_names", function(r) {
        E.reset();
        E.sort();
        r = k(r);
        var n = this.find_colliding_names(r);
        var t = 0;
        this.globals.each(a);
        this.walk(new Nn(function(e) {
            if (e instanceof nt) e.variables.each(a);
        }));
        function i() {
            var e;
            do {
                e = E(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && r.cache) return;
            if (n.unmangleable(r)) return;
            if (r.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : i();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    un.DEFMETHOD("tail_node", Ln);
    yn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    ht.DEFMETHOD("compute_char_frequency", function(e) {
        e = k(e);
        E.reset();
        var n = br.prototype.add_source_map;
        try {
            br.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) E.consider(this.name, -1);
            };
            if (e.properties) {
                xn.prototype.add_source_map = function() {
                    E.consider(this.property, -1);
                };
                sr.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            E.consider(this.print_to_string(), 1);
        } finally {
            br.prototype.add_source_map = n;
            delete xn.prototype.add_source_map;
            delete sr.prototype.add_source_map;
        }
        E.sort();
        function t(e) {
            if (e instanceof Pn) {
                E.consider(e.value, -1);
            } else if (e instanceof An) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof yn) {
                t(e.tail_node());
            }
        }
    });
    var E = function() {
        var i = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var r = e[t];
                n.push(r);
                i[r] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var r, a;
        function o() {
            r = null;
            a = Object.create(i);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            r = t.sort(s).concat(n).sort(s);
        };
        f.reset = o;
        o();
        function f(e) {
            var n = t[e % 54];
            for (e = Math.floor(e / 54); --e >= 0; e >>= 6) {
                n += r[e & 63];
            }
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ei(e, n) {
        if (!(this instanceof ei)) return new ei(e, n);
        Br.call(this, this.before, this.after);
        this.options = be(e, {
            annotations: !n,
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_exports: !n,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie: false,
            if_return: !n,
            imports: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            optional_chains: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n,
            webkit: false,
            yields: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var r = this.options["global_defs"];
        if (typeof r == "object") for (var i in r) {
            if (/^@/.test(i) && Jn(r, i)) {
                r[i.slice(1)] = Xr(r[i], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 4;
        this.drop_fargs = this.options["keep_fargs"] ? an : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var r = t.definition();
            if (r.direct_access) return false;
            var i = r.escaped;
            return i && i.depth != 1;
        };
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof bn) {
                    n = e.expression;
                } else if (e instanceof Cr) {
                    n = e.tag;
                }
                return !(n && a === n.print_to_string());
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof bn) {
                    n = e.expression;
                } else if (e instanceof Cr) {
                    n = e.tag;
                }
                return !(n && In(n.print_to_string(), a));
            };
        } else {
            this.pure_funcs = Rn;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return In(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    ei.prototype = new Br(function(e, n, t) {
        if (e._squeezed) return e;
        var r = e instanceof dn;
        if (r) {
            e.hoist_properties(this);
            e.hoist_declarations(this);
            e.process_returns(this);
        }
        n(e, this);
        n(e, this);
        var i = e.optimize(this);
        if (r && i === e && !this.has_directive("use asm") && !i.pinned()) {
            i.drop_unused(this);
            if (i.merge_variables(this)) i.drop_unused(this);
            n(i, this);
        }
        if (i === e) i._squeezed = true;
        return i;
    });
    ei.prototype.option = function(e) {
        return this.options[e];
    };
    ei.prototype.exposed = function(e) {
        if (e.exported) return true;
        if (e.undeclared) return true;
        if (!(e.global || e.scope.resolve() instanceof ht)) return false;
        var n = this.toplevel;
        return !sn(e.orig, function(e) {
            return n[e instanceof Er ? "funcs" : "vars"];
        });
    };
    ei.prototype.compress = function(e) {
        e = e.resolve_defines(this);
        e.hoist_exports(this);
        if (this.option("expression")) e.process_expression(true);
        var n = this.options.merge_vars;
        var t = +this.options.passes || 1;
        var r = 1 / 0;
        var i = false;
        var a = {
            ie: this.option("ie")
        };
        for (var o = 0; o < t; o++) {
            e.figure_out_scope(a);
            if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
            this.options.merge_vars = n && (i || o == t - 1);
            e = e.transform(this);
            if (t > 1) {
                var s = 0;
                e.walk(new Nn(function() {
                    s++;
                }));
                un.info("pass {pass}: last_count: {min_count}, count: {count}", {
                    pass: o,
                    min_count: r,
                    count: s
                });
                if (s < r) {
                    r = s;
                    i = false;
                } else if (i) {
                    break;
                } else {
                    i = true;
                }
            }
        }
        if (this.option("expression")) e.process_expression(false);
        return e;
    };
    (function(e) {
        e(un, function(e, n) {
            return e;
        });
        un.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        ht.DEFMETHOD("hoist_exports", function(e) {
            if (!e.option("hoist_exports")) return;
            var n = this.body, t = [];
            for (var r = 0; r < n.length; r++) {
                var i = n[r];
                if (i instanceof nr) {
                    n[r] = i = i.body;
                    if (i instanceof Kt) {
                        i.definitions.forEach(function(e) {
                            e.name.match_symbol(a, true);
                        });
                    } else {
                        a(i.name);
                    }
                } else if (i instanceof rr) {
                    n.splice(r--, 1);
                    [].push.apply(t, i.properties);
                }
            }
            if (t.length) n.push(ze(rr, this, {
                properties: t
            }));
            function a(e) {
                if (!(e instanceof zn)) return;
                var n = ze(Dr, e, e);
                n.alias = n.name;
                t.push(n);
            }
        });
        dn.DEFMETHOD("process_expression", function(i, a) {
            var o = this;
            var s = new Br(function(e) {
                if (i) {
                    if (e instanceof Zn) e = ze(ln, e, {
                        body: ze(Pn, e, e)
                    });
                    if (e instanceof ln) {
                        return a ? a(e) : ze(vn, e, {
                            value: e.body
                        });
                    }
                } else if (e instanceof vn) {
                    if (a) return a(e);
                    var n = e.value;
                    if (n instanceof Pn) return ze(Zn, e, n);
                    return ze(ln, e, {
                        body: n || ze(Sn, e, {
                            operator: "void",
                            expression: ze(jn, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof rt) {
                    if (e instanceof hn) {
                        if (e !== o) return e;
                    } else if (i === "awaits" && e instanceof Gt) {
                        if (e.bfinally) return e;
                    }
                    for (var t = e.body.length; --t >= 0; ) {
                        var r = e.body[t];
                        if (!F(r, true)) {
                            e.body[t] = r.transform(s);
                            break;
                        }
                    }
                } else if (e instanceof mn) {
                    e.body = e.body.transform(s);
                    if (e.alternative) e.alternative = e.alternative.transform(s);
                } else if (e instanceof dt) {
                    e.body = e.body.transform(s);
                }
                return e;
            });
            o.transform(s);
        });
        function q(e, n) {
            var t = n.get_property();
            if (t instanceof un) return;
            var r;
            if (e instanceof On) {
                var i = e.elements;
                if (t == "length") return fe(i.length, e);
                if (typeof t == "number" && t in i) r = i[t];
            } else if (e instanceof hn) {
                if (t == "length") {
                    e.length_read = true;
                    return fe(e.argnames.length, e);
                }
            } else if (e instanceof qn) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!nn(s)) return;
                    if (!r && a[o].key === t) r = a[o].value;
                }
            }
            return r instanceof Mn && r.fixed_value() || r;
        }
        function l(e, n) {
            if (e instanceof Yr) return b.Boolean[n];
            if (e instanceof jn) return b.Number[n];
            if (e instanceof Pn) return b.String[n];
            if (n == "valueOf") return false;
            if (e instanceof On) return b.Array[n];
            if (e instanceof hn) return b.Function[n];
            if (e instanceof qn) return b.Object[n];
            if (e instanceof Fr) return b.RegExp[n] && !e.value.global;
        }
        function De(e, n, t, r, i, a, o) {
            var s = n.parent(i);
            if (e.option("unsafe") && s instanceof xn && l(r, s.property)) {
                return;
            }
            var f = Zr(t, s);
            if (f) return f;
            if (i == 0 && r && r.is_constant()) return;
            if (s instanceof On) return De(e, n, s, s, i + 1);
            if (s instanceof Dn) switch (s.operator) {
              case "=":
                return De(e, n, s, r, i + 1, a, o);

              case "&&=":
              case "||=":
              case "??=":
                return De(e, n, s, s, i + 1);

              default:
                return;
            }
            if (s instanceof Tn) {
                if (!je[s.operator]) return;
                return De(e, n, s, s, i + 1);
            }
            if (s instanceof bn) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!(r instanceof mt) || !(s instanceof ar) && r.contains_this());
            }
            if (s instanceof An) {
                if (s.condition === t) return;
                return De(e, n, s, s, i + 1);
            }
            if (s instanceof ct) return s.init === t;
            if (s instanceof vr) {
                if (s.value !== t) return;
                var u = n.parent(i + 1);
                return De(e, n, u, u, i + 2);
            }
            if (s instanceof wn) {
                if (s.expression !== t) return;
                var c = q(r, s);
                return (!a || o) && De(e, n, s, c, i + 1);
            }
            if (s instanceof yn) {
                if (s.tail_node() !== t) return;
                return De(e, n, s, r, i + 1, a, o);
            }
        }
        function D(e) {
            return e instanceof zt || e instanceof hn;
        }
        function h(e) {
            return e instanceof zt || e instanceof $t || e instanceof St;
        }
        function Oe(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function Z(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof dn) return true;
            } while (n = n.parent_scope);
        }
        function $e(e, n, t) {
            var r = e.redef || e.definition();
            if (e.in_arg && Kr(r)) return false;
            return sn(r.orig, function(e) {
                if (e instanceof yr || e instanceof xr) {
                    if (e instanceof wr) return true;
                    return n && te(n, e);
                }
                return !(t && e instanceof Sr);
            });
        }
        function He(e, n, t, r) {
            if (r instanceof Dn) return r.operator == "=" && r.right === t;
            if (r instanceof bn) return r.expression !== t || r instanceof ar;
            if (r instanceof It) return r.value === t && n.resolve() !== e.scope.resolve();
            if (r instanceof _n) return r.value === t;
        }
        var z = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(un, Yn);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_return = 0;
                t.drop_return = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof mt && t.init !== t.scope) && t.init;
                t.reassigned = 0;
                t.recursive_refs = 0;
                t.references = [];
                t.single_use = undefined;
            }
            function s(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                });
            }
            function p(t, r, i) {
                i.fn_defs = [];
                i.variables.each(function(e) {
                    a(t, r, e);
                    var n = e.init;
                    if (n instanceof At) {
                        i.fn_defs.push(n);
                        n.safe_ids = null;
                    }
                    if (e.fixed === null) {
                        e.safe_ids = t.safe_ids;
                        _(t, e);
                    } else if (e.fixed) {
                        t.loop_ids[e.id] = t.in_loop;
                        _(t, e);
                    }
                });
                i.may_call_this = function() {
                    i.may_call_this = i.contains_this() ? Rn : an;
                };
                if (i.uses_arguments) i.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (r.option("ie")) i.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function o(e, n) {
                var t = n.safe_ids;
                return t === undefined || t === e.safe_ids;
            }
            function f(e, n) {
                var t = e.fn_scanning;
                e.fn_scanning = n;
                n.walk(e);
                e.fn_scanning = t;
            }
            function u(t, r) {
                r.enclosed.forEach(function(e) {
                    if (r.variables.get(e.name) === e) return;
                    if (b(t, e)) return;
                    e.single_use = false;
                    var n = e.fixed;
                    if (typeof n == "function") n = n();
                    if (n instanceof hn && n.safe_ids !== undefined) return;
                    e.fixed = false;
                });
            }
            function h(e, n, t) {
                var r = t.safe_ids;
                if (r === undefined) return;
                if (r === false) return;
                if (t.parent_scope.resolve().may_call_this === Rn) {
                    if (In(t, e.fn_visited)) u(e, t);
                } else if (r) {
                    var i = In(t, e.fn_visited);
                    if (r === e.safe_ids) {
                        if (!i) f(e, t);
                    } else if (i) {
                        u(e, t);
                    } else {
                        t.safe_ids = false;
                    }
                } else if (e.fn_scanning && e.fn_scanning !== n.scope.resolve()) {
                    t.safe_ids = false;
                } else {
                    t.safe_ids = e.safe_ids;
                    f(e, t);
                }
            }
            function d(n, e) {
                var t = e.fn_defs;
                var r = e.may_call_this === Rn ? t : t.filter(function(e) {
                    if (e.safe_ids === false) return true;
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                    return false;
                });
                m(n);
                r.forEach(function(e) {
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                });
                t.forEach(function(e) {
                    e.safe_ids = undefined;
                });
                e.fn_defs = undefined;
                e.may_call_this = undefined;
            }
            function v(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function m(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function _(e, n) {
                e.safe_ids[n.id] = {};
            }
            function g(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function b(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    var r = Jn(e.safe_ids, n.id);
                    if (!r) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (Oe(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = ze(Nr, n.orig[0]);
                        if (r) n.safe_ids = undefined;
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof At;
            }
            function y(e, n, t) {
                if (!t) {
                    if (Kr(n) && n.scope.uses_arguments && !e.has_directive("use strict")) return false;
                    if (!sn(n.orig, function(e) {
                        return !(e instanceof yr);
                    })) return false;
                }
                if (n.fixed === undefined) return t || sn(n.orig, function(e) {
                    return !(e instanceof xr);
                });
                if (n.fixed === false || n.fixed === 0) return false;
                var r = e.safe_ids[n.id];
                if (n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    n.safe_ids = undefined;
                    return n.fixed === null || Jn(e.safe_ids, n.id) && !r.read;
                }
                if (!Jn(e.safe_ids, n.id)) {
                    if (!r) return false;
                    if (r.read) {
                        var i = e.find_parent(nt);
                        if (i instanceof zt) return false;
                        if (n.scope.resolve() !== i.resolve()) return false;
                    }
                    r.assign = r.assign && r.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && r.read) {
                    if (r.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return b(e, n) && sn(n.orig, function(e) {
                    return !(e instanceof Sr);
                });
            }
            function w(e, n) {
                var t = ze(Mn, e, e);
                t.fixed = n || ze(Nr, e);
                return t;
            }
            function x(t, r) {
                return function() {
                    var e = w(t, r);
                    var n = t.definition();
                    n.references.push(e);
                    n.replaced++;
                    return e;
                };
            }
            function c(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(Kr(n) && n.scope.uses_arguments);
            }
            function k(e) {
                if (!e) return false;
                if (e instanceof Dn) {
                    var n = e.operator;
                    return n == "=" ? k(e.right) : !je[n.slice(0, -1)];
                }
                if (e instanceof yn) return k(e.tail_node());
                return e.is_constant() || D(e) || e instanceof Or;
            }
            function l(e, n) {
                if (n instanceof On) return true;
                if (n instanceof Tn) return je[n.operator];
                if (n instanceof An) return n.condition !== e;
                if (n instanceof yn) return n.tail_node() === e;
                if (n instanceof kn) return true;
            }
            function E(e, n, t, r, i, a, o) {
                var s = e.parent(a);
                if (i && i.is_constant()) return;
                if (He(n, t, r, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(i && i.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    if (n.scope.resolve() !== t.resolve()) n.escaped.cross_scope = true;
                    if (n.fixed) n.fixed.escaped = n.escaped;
                    return;
                } else if (l(r, s)) {
                    E(e, n, t, s, s, a + 1, o);
                } else if (s instanceof vr && s.value === r) {
                    var f = e.parent(a + 1);
                    E(e, n, t, f, f, a + 2, o);
                } else if (s instanceof wn && s.expression === r) {
                    i = q(i, s);
                    E(e, n, t, s, i, a + 1, o + 1);
                    if (i) return;
                }
                if (a > 0) return;
                if (s instanceof bn && s.expression === r) return;
                if (s instanceof yn && s.tail_node() !== r) return;
                if (s instanceof ln) return;
                if (s instanceof En && !Qr[s.operator]) return;
                n.direct_access = true;
                if (n.fixed) n.fixed.direct_access = true;
            }
            function S(e) {
                if (!(e instanceof sr)) return;
                var n = e.expression;
                if (!(n instanceof Mn)) return;
                var t = n.definition();
                if (!Oe(t)) return;
                var r = e.property;
                if (r.is_constant()) r = r.value;
                if (!(r instanceof un) && !z.test(r)) return;
                t.reassigned++;
                (r instanceof un ? t.scope.argnames : [ t.scope.argnames[r] ]).forEach(function(e) {
                    if (e instanceof Cn) e.definition().fixed = false;
                });
            }
            function T(o, t, e, s, n) {
                var f = new Nn(function(r) {
                    if (r instanceof gn) {
                        O(r);
                        v(o);
                        r.value.walk(o);
                        m(o);
                        var i = s;
                        if (i) s = function() {
                            var e = i();
                            var n;
                            if (Pe(e, t) || (n = $(t, e, true)) === undefined) {
                                return Ce(r, [ e, r.value ]);
                            }
                            return n instanceof un ? r : e;
                        };
                        r.name.walk(f);
                        s = i;
                        return true;
                    }
                    if (r instanceof lr) {
                        O(r);
                        var i = s;
                        r.elements.forEach(function(e, n) {
                            if (e instanceof Ir) return O(e);
                            if (i) s = function() {
                                return ze(sr, e, {
                                    expression: i(),
                                    property: ze(jn, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(f);
                        });
                        if (r.rest) {
                            var a;
                            if (i) s = t.option("rests") && function() {
                                var e = i();
                                if (!(e instanceof On)) return r;
                                for (var n = 0, t = r.elements.length; n < t; n++) {
                                    if (e.elements[n] instanceof kn) return r;
                                }
                                if (!a) a = ze(On, r);
                                a.elements = e.elements.slice(t);
                                return a;
                            };
                            r.rest.walk(f);
                        }
                        s = i;
                        return true;
                    }
                    if (r instanceof dr) {
                        O(r);
                        var i = s;
                        r.properties.forEach(function(t) {
                            O(t);
                            if (t.key instanceof un) {
                                v(o);
                                t.key.walk(o);
                                m(o);
                            }
                            if (i) s = function() {
                                var e = t.key;
                                var n = sr;
                                if (typeof e == "string") {
                                    if (Ur(e)) {
                                        n = xn;
                                    } else {
                                        e = fe(e, t);
                                    }
                                }
                                return ze(n, t, {
                                    expression: i(),
                                    property: e
                                });
                            };
                            t.value.walk(f);
                        });
                        if (r.rest) {
                            s = false;
                            r.rest.walk(f);
                        }
                        s = i;
                        return true;
                    }
                    n(r, s, function() {
                        var e = o.stack.length;
                        for (var n = 0, t = f.stack.length - 1; n < t; n++) {
                            o.stack.push(f.stack[n]);
                        }
                        r.walk(o);
                        o.stack.length = e;
                    });
                    return true;
                });
                e.walk(f);
            }
            function A(i, e, n) {
                var a = this;
                a.inlined = false;
                var o = i.parent();
                var t = gt(a) || bt(a);
                var r = false;
                a.walk(new Nn(function(e) {
                    if (t) return r = true;
                    if (e instanceof vn) return t = true;
                    if (e instanceof dn && e !== a) return true;
                }));
                if (r) v(i);
                p(i, n, a);
                var s = !a.uses_arguments || i.has_directive("use strict");
                a.argnames.forEach(function(t, e) {
                    var r = o.args[e];
                    T(i, n, t, function() {
                        var e = a.argnames.indexOf(t);
                        var n = e < 0 ? r : o.args[e];
                        if (n instanceof yn && n.expressions.length < 2) n = n.expressions[0];
                        return n || ze(Nr, o);
                    }, l);
                });
                var f = a.rest, u;
                if (f) T(i, n, f, n.option("rests") && function() {
                    if (a.rest !== f) return f;
                    if (!u) u = ze(On, a);
                    u.elements = o.args.slice(a.argnames.length);
                    return u;
                }, l);
                yt(a, i);
                var c = i.safe_ids;
                d(i, a);
                if (!r) i.safe_ids = c;
                return true;
                function l(e, n) {
                    var t = e.definition();
                    if (n && s && t.fixed === undefined) {
                        _(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(Dn, function(a, e, n) {
                var o = this;
                var s = o.left;
                var f = o.right;
                var t = s instanceof Mn && s.definition();
                var r = t || s instanceof $n;
                switch (o.operator) {
                  case "=":
                    if (s.equivalent_to(f) && !s.has_side_effects(n)) {
                        f.walk(a);
                        l(s);
                        o.redundant = true;
                        return true;
                    }
                    if (t && f instanceof mt) {
                        p();
                        f.parent_scope.resolve().fn_defs.push(f);
                        f.safe_ids = null;
                        if (!t.fixed || !o.write_only) h(a, t, f);
                        return true;
                    }
                    if (r) {
                        f.walk(a);
                        p();
                        return true;
                    }
                    S(s);
                    return;

                  case "&&=":
                  case "||=":
                  case "??=":
                    var i = true;

                  default:
                    if (!r) {
                        S(s);
                        return d();
                    }
                    t.assignments++;
                    var u = t.fixed;
                    if (De(n, a, o, o, 0)) {
                        t.fixed = false;
                        return d();
                    }
                    var c = b(a, t);
                    if (i) v(a);
                    f.walk(a);
                    if (i) m(a);
                    if (c && !s.in_arg && y(a, t)) {
                        g(t, s);
                        _(a, t);
                        if (t.single_use) t.single_use = false;
                        s.fixed = t.fixed = function() {
                            return ze(Tn, o, {
                                operator: o.operator.slice(0, -1),
                                left: w(s, u),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !u || !u.assigns ? [ t.orig[0] ] : u.assigns.slice();
                        s.fixed.assigns.push(o);
                        s.fixed.to_binary = x(s, u);
                    } else {
                        s.walk(a);
                        t.fixed = false;
                    }
                    return true;
                }
                function l(e) {
                    if (e instanceof xn) {
                        l(e.expression);
                    } else if (e instanceof sr) {
                        l(e.expression);
                        e.property.walk(a);
                    } else if (e instanceof Mn) {
                        var n = e.definition();
                        g(n, e);
                        if (n.fixed) {
                            e.fixed = n.fixed;
                            if (e.fixed.assigns) {
                                e.fixed.assigns.push(o);
                            } else {
                                e.fixed.assigns = [ o ];
                            }
                        }
                    } else {
                        e.walk(a);
                    }
                }
                function p() {
                    var e = t && We(a, t);
                    var i = De(n, a, o, f, 0, k(f), e);
                    T(a, n, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof Mn)) {
                            S(e);
                            t();
                            return;
                        }
                        var r = e.definition();
                        r.assignments++;
                        if (!n || e.in_arg || !y(a, r)) {
                            t();
                            r.fixed = false;
                        } else if (i) {
                            t();
                            r.fixed = 0;
                        } else {
                            g(r, e);
                            _(a, r);
                            if (s instanceof $n || r.orig.length == 1 && r.orig[0] instanceof Er) {
                                r.single_use = false;
                            }
                            a.loop_ids[r.id] = a.in_loop;
                            e.fixed = r.fixed = n;
                            e.fixed.assigns = [ o ];
                            E(a, r, e.scope, o, f, 0, 1);
                        }
                    });
                }
                function d() {
                    if (!i) return;
                    s.walk(a);
                    v(a);
                    f.walk(a);
                    m(a);
                    return true;
                }
            });
            e(Tn, function(e) {
                if (!je[this.operator]) return;
                this.left.walk(e);
                v(e);
                this.right.walk(e);
                m(e);
                return true;
            });
            e(nt, function(e, n, t) {
                s(e, t, this);
            });
            e(bn, function(n, e) {
                var t = this;
                var r = t.expression;
                if (r instanceof mt) {
                    var i = Re(t);
                    t.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof kn) i = false;
                    });
                    if (i) r.reduce_vars = A;
                    r.walk(n);
                    if (i) delete r.reduce_vars;
                    return true;
                }
                if (t.TYPE == "Call") switch (n.in_boolean_context()) {
                  case "d":
                    var a = true;

                  case true:
                    f(r, a);
                }
                r.walk(n);
                var o = t.optional;
                if (o) v(n);
                t.args.forEach(function(e) {
                    e.walk(n);
                });
                if (o) m(n);
                var s = r instanceof Mn && r.fixed_value();
                if (s instanceof hn) {
                    h(n, r.definition(), s);
                } else {
                    n.find_parent(dn).may_call_this();
                }
                return true;
                function f(e, n) {
                    if (e instanceof Dn) {
                        if (e.operator != "=") return;
                        f(e.left, n);
                        f(e.right, n);
                    } else if (e instanceof Tn) {
                        if (!je[e.operator]) return;
                        f(e.left, n);
                        f(e.right, n);
                    } else if (e instanceof An) {
                        f(e.consequent, n);
                        f(e.alternative, n);
                    } else if (e instanceof Mn) {
                        var t = e.definition();
                        t.bool_return++;
                        if (n) t.drop_return++;
                    }
                }
            });
            e(zt, function(n, e, t) {
                var r = this;
                s(n, t, r);
                if (r.extends) r.extends.walk(n);
                var i = r.properties.filter(function(e) {
                    O(e);
                    if (e.key instanceof un) e.key.walk(n);
                    return e.value;
                });
                if (r.name) {
                    var a = r.name.definition();
                    var o = n.parent();
                    if (o instanceof nr || o instanceof tr) a.single_use = false;
                    if (y(n, a, true)) {
                        _(n, a);
                        n.loop_ids[a.id] = n.in_loop;
                        a.fixed = function() {
                            return r;
                        };
                        a.fixed.assigns = [ r ];
                        if (!Q(a)) a.single_use = false;
                    } else {
                        a.fixed = false;
                    }
                }
                i.forEach(function(e) {
                    if (!e.static || e instanceof Pt && e.value.contains_this()) {
                        v(n);
                        e.value.walk(n);
                        m(n);
                    } else {
                        e.value.walk(n);
                    }
                });
                return true;
            });
            e(An, function(e) {
                this.condition.walk(e);
                v(e);
                this.consequent.walk(e);
                m(e);
                v(e);
                this.alternative.walk(e);
                m(e);
                return true;
            });
            e(gn, function(e) {
                this.name.walk(e);
                v(e);
                this.value.walk(e);
                m(e);
                return true;
            });
            e(st, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                v(e);
                this.body.walk(e);
                if (V(this, e.parent())) {
                    m(e);
                    v(e);
                }
                this.condition.walk(e);
                m(e);
                e.in_loop = n;
                return true;
            });
            e(ut, function(e, n, t) {
                var r = this;
                s(e, t, r);
                if (r.init) r.init.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                v(e);
                if (r.condition) r.condition.walk(e);
                r.body.walk(e);
                if (r.step) {
                    if (V(r, e.parent())) {
                        m(e);
                        v(e);
                    }
                    r.step.walk(e);
                }
                m(e);
                e.in_loop = i;
                return true;
            });
            e(ct, function(e, n, t) {
                var r = this;
                s(e, t, r);
                r.object.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                v(e);
                var a = r.init;
                if (a instanceof Kt) {
                    a.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof zn) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, e);
                } else if (a instanceof $n || a instanceof Mn) {
                    a.mark_symbol(function(e) {
                        if (e instanceof Mn) {
                            var n = e.definition();
                            g(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, e);
                } else {
                    a.walk(e);
                }
                r.body.walk(e);
                m(e);
                e.in_loop = i;
                return true;
            });
            e(mn, function(e) {
                this.condition.walk(e);
                v(e);
                this.body.walk(e);
                m(e);
                if (this.alternative) {
                    v(e);
                    this.alternative.walk(e);
                    m(e);
                }
                return true;
            });
            e(it, function(e) {
                v(e);
                this.body.walk(e);
                m(e);
                return true;
            });
            e(hn, function(e, n, t) {
                var r = this;
                if (!o(e, r)) return true;
                if (!Vn(e.fn_visited, r)) return true;
                r.inlined = false;
                v(e);
                p(e, t, r);
                n();
                d(e, r);
                if (r.name) E(e, r.name.definition(), r, r.name, r, 0, 1);
                return true;
            });
            e(At, function(e, n, t) {
                var r = this;
                var i = r.name.definition();
                var a = e.parent();
                if (a instanceof nr || a instanceof tr) i.single_use = false;
                if (!o(e, r)) return true;
                if (!Vn(e.fn_visited, r)) return true;
                r.inlined = false;
                v(e);
                p(e, t, r);
                n();
                d(e, r);
                return true;
            });
            e(sr, function(e) {
                if (!this.optional) return;
                this.expression.walk(e);
                v(e);
                this.property.walk(e);
                m(e);
                return true;
            });
            e(Bt, function(n, e, t) {
                var r = this;
                s(n, t, r);
                r.expression.walk(n);
                var i = true;
                r.body.forEach(function(e) {
                    if (e instanceof Vt) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        v(n);
                    }
                });
                if (!i) m(n);
                tt(r, n);
                return true;
            });
            e(Ut, function(e) {
                v(e);
                tt(this, e);
                m(e);
                return true;
            });
            e(Ar, function() {
                this.definition().fixed = false;
            });
            e(wr, function() {
                this.definition().fixed = false;
            });
            e(Mn, function(r, e, n) {
                var i = this.definition();
                g(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof Er) {
                    r.loop_ids[i.id] = r.in_loop;
                }
                var a = We(r, i);
                if (a) a.enclosed.forEach(function(e) {
                    if (i === e) return;
                    if (e.scope.resolve() === a) return;
                    var n = e.fixed && e.fixed.assigns;
                    if (!n) return;
                    if (n[n.length - 1] instanceof _n) return;
                    var t = r.safe_ids[e.id];
                    if (!t) return;
                    t.assign = true;
                });
                if (i.fixed === false || i.fixed === 0) {
                    var t = i.redefined();
                    if (t && Z(i.scope, this.scope)) t.single_use = false;
                } else if (i.fixed === undefined || !b(r, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof Sr) this.fixed = i.scope;
                    var o = this.fixed_value();
                    if (a) {
                        i.recursive_refs++;
                    } else if (o && c(n, i)) {
                        i.in_loop = r.loop_ids[i.id] !== r.in_loop;
                        i.single_use = D(o) && !o.pinned() && (!i.in_loop || r.parent() instanceof bn) || !i.in_loop && i.scope === this.scope.resolve() && o.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (De(n, r, this, o, 0, k(o), a)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = 0;
                        }
                    }
                    if (i.fixed && r.loop_ids[i.id] !== r.in_loop) i.cross_loop = true;
                    E(r, i, this.scope, this, o, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (o instanceof hn && !((s = r.parent()) instanceof bn && s.expression === this)) {
                    h(r, i, o);
                }
            });
            e(Cr, function(n, e) {
                var t = this;
                var r = t.tag;
                if (!r) return;
                if (r instanceof mt) {
                    t.expressions.forEach(function(e) {
                        e.walk(n);
                    });
                    r.walk(n);
                    return true;
                }
                r.walk(n);
                t.expressions.forEach(function(e) {
                    e.walk(n);
                });
                var i = r instanceof Mn && r.fixed_value();
                if (i instanceof hn) {
                    h(n, r.definition(), i);
                } else {
                    n.find_parent(dn).may_call_this();
                }
                return true;
            });
            e(ht, function(n, e, t) {
                var r = this;
                r.globals.each(function(e) {
                    a(n, t, e);
                });
                v(n);
                p(n, t, r);
                e();
                d(n, r);
                return true;
            });
            e(Gt, function(e, n, t) {
                var r = this;
                s(e, t, r);
                v(e);
                tt(r, e);
                m(e);
                if (r.bcatch) {
                    v(e);
                    r.bcatch.walk(e);
                    m(e);
                }
                if (r.bfinally) r.bfinally.walk(e);
                return true;
            });
            e(En, function(e, n) {
                var t = this;
                if (!Gr[t.operator]) return;
                var r = t.expression;
                if (!(r instanceof Mn)) {
                    S(r);
                    return;
                }
                var i = r.definition();
                i.assignments++;
                var a = i.fixed;
                if (b(e, i) && !r.in_arg && y(e, i)) {
                    g(i, r);
                    _(e, i);
                    if (i.single_use) i.single_use = false;
                    i.fixed = function() {
                        return ze(Tn, t, {
                            operator: t.operator.slice(0, -1),
                            left: ze(Sn, t, {
                                operator: "+",
                                expression: w(r, a)
                            }),
                            right: ze(jn, t, {
                                value: 1
                            })
                        });
                    };
                    i.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    i.fixed.assigns.push(t);
                    if (t instanceof Sn) {
                        r.fixed = i.fixed;
                    } else {
                        r.fixed = function() {
                            return ze(Sn, t, {
                                operator: "+",
                                expression: w(r, a)
                            });
                        };
                        r.fixed.assigns = a && a.assigns;
                        r.fixed.to_prefix = x(r, i.fixed);
                    }
                } else {
                    r.walk(e);
                    i.fixed = false;
                }
                return true;
            });
            e(_n, function(r, e, n) {
                var i = this;
                var t = i.value;
                if (t instanceof mt && i.name instanceof zn) {
                    o();
                    t.parent_scope.resolve().fn_defs.push(t);
                    t.safe_ids = null;
                    var a = i.name.definition();
                    if (!a.fixed) h(r, a, t);
                } else if (t) {
                    t.walk(r);
                    o();
                } else if (r.parent() instanceof Zt) {
                    o();
                }
                return true;
                function o() {
                    T(r, n, i.name, function() {
                        return i.value || ze(Nr, i);
                    }, function(e, n) {
                        var t = e.definition();
                        if (n && y(r, t, true)) {
                            _(r, t);
                            r.loop_ids[t.id] = r.in_loop;
                            t.fixed = n;
                            t.fixed.assigns = [ i ];
                            if (e instanceof yr && t.redefined() || !($e(e) || Q(t))) {
                                t.single_use = false;
                            }
                        } else {
                            t.fixed = false;
                        }
                    });
                }
            });
            e(ft, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                v(e);
                n();
                m(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function O(e) {
            e._squeezed = false;
            e._optimized = false;
            if (e instanceof nt) e._var_names = undefined;
            if (e instanceof Mn) e.fixed = undefined;
        }
        ht.DEFMETHOD("reset_opt_flags", function(t) {
            var r = new Nn(t.option("reduce_vars") ? function(e, n) {
                O(e);
                return e.reduce_vars(r, n, t);
            } : O);
            r.fn_scanning = null;
            r.fn_visited = [];
            r.in_loop = null;
            r.loop_ids = Object.create(null);
            r.safe_ids = Object.create(null);
            this.walk(r);
        });
        br.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (e) {
                if (this.fixed) e = this.fixed;
                return (e instanceof un ? e : e()).tail_node();
            }
            e = e === 0 && this.fixed;
            if (!e) return e;
            var n = (e instanceof un ? e : e()).tail_node();
            return n.is_constant() && n;
        });
        Mn.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            return (this.in_arg || e.orig.length == 1) && e.orig[0] instanceof Sr;
        });
        un.DEFMETHOD("convert_symbol", Yn);
        function t(t, r) {
            return this.transform(new Br(function(e, n) {
                if (e instanceof gn) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof $n) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof pr) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, r);
            }));
        }
        gn.DEFMETHOD("convert_symbol", t);
        $n.DEFMETHOD("convert_symbol", t);
        function r(e, n) {
            var t = ze(e, this, this);
            n(t, this);
            return t;
        }
        zn.DEFMETHOD("convert_symbol", r);
        Mn.DEFMETHOD("convert_symbol", r);
        function N(e) {
            var n = e.definition();
            n.assignments++;
            n.references.push(e);
        }
        function i(n, t) {
            var r = new Nn(function(e) {
                if (e instanceof gn) {
                    e.value.walk(t);
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof pr) {
                    if (e.key instanceof un) e.key.walk(t);
                    e.value.walk(r);
                    return true;
                }
                return n(e);
            });
            this.walk(r);
        }
        gn.DEFMETHOD("mark_symbol", i);
        $n.DEFMETHOD("mark_symbol", i);
        function a(e) {
            return e(this);
        }
        zn.DEFMETHOD("mark_symbol", a);
        Mn.DEFMETHOD("mark_symbol", a);
        un.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        function o(n, t) {
            var r = false;
            var i = new Nn(function(e) {
                if (r) return true;
                if (e instanceof gn) {
                    if (!t) return r = true;
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof pr) {
                    if (!t && e.key instanceof un) return r = true;
                    e.value.walk(i);
                    return true;
                }
                if (n(e)) return r = true;
            });
            this.walk(i);
            return r;
        }
        gn.DEFMETHOD("match_symbol", o);
        $n.DEFMETHOD("match_symbol", o);
        function k(e) {
            return e instanceof Ot || e instanceof Et;
        }
        function qe(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        var _e = on("Infinity NaN undefined");
        function Ye(e, n) {
            if (e instanceof Or) return true;
            if (e instanceof wn) {
                if (e.property === "__proto__") return true;
                e = e.expression;
                if (e instanceof Mn) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.tail_node().is_constant()) return true;
                return Ye(e, n);
            }
            if (e instanceof Mn) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && _e[t.name];
            }
            return false;
        }
        function ze(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function Ce(e, n) {
            if (n.length == 1) return n[0];
            return ze(yn, e, {
                expressions: n.reduce(T, [])
            });
        }
        function fe(e, n) {
            switch (typeof e) {
              case "string":
                return ze(Pn, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return ze(jr, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? ze(Sn, n, {
                        operator: "-",
                        expression: ze(jn, n, {
                            value: -e
                        })
                    }) : ze(jn, n, {
                        value: e
                    });
                }
                return e < 0 ? ze(Sn, n, {
                    operator: "-",
                    expression: ze(Hr, n)
                }) : ze(Hr, n);

              case "boolean":
                return ze(e ? Lr : Rr, n);

              case "undefined":
                return ze(Nr, n);

              default:
                if (e === null) {
                    return ze(Pr, n);
                }
                if (e instanceof RegExp) {
                    return ze(Fr, n, {
                        value: e
                    });
                }
                throw new Error(Wn("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function ge(e, n) {
            return n instanceof wn || Fe(n) && n.name == "eval";
        }
        function Me(e, n, t, r) {
            var i = false;
            if (n.TYPE == "Call") {
                i = n.expression === t && ge(e, r);
            } else if (n instanceof Cr) {
                i = n.tag === t && ge(e, r);
            } else if (n instanceof Sn) {
                i = n.operator == "delete" || n.operator == "typeof" && Fe(r);
            }
            return i ? Ce(t, [ ze(jn, t, {
                value: 0
            }), r ]) : r;
        }
        function T(e, n) {
            if (n instanceof yn) {
                [].push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function I(e) {
            return e instanceof Qt || e instanceof Ct || e instanceof Zt;
        }
        function A(e) {
            if (e instanceof At) {
                var n = e.name.definition();
                var t = e.name.scope;
                return n.scope === t || sn(n.references, function(e) {
                    var n = e.scope;
                    do {
                        if (n === t) return true;
                    } while (n = n.parent_scope);
                });
            }
            return !I(e);
        }
        function H(e) {
            if (e === null) return [];
            if (e instanceof pn) return sn(e.body, A) ? e.body : [ e ];
            if (e instanceof cn) return [];
            if (et(e)) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function ue(e) {
            if (e === null) return true;
            if (e instanceof cn) return true;
            if (e instanceof pn) return e.body.length == 0;
            return false;
        }
        function E(e) {
            return sn(e.body, function(e) {
                return ue(e) || e instanceof $t || e instanceof er && ce(e);
            });
        }
        function Y(e) {
            if (e instanceof at) {
                return e.body instanceof pn ? e.body : e;
            }
            return e;
        }
        function be(e) {
            if (e.TYPE != "Call") return false;
            do {
                e = e.expression;
            } while (e instanceof wn);
            return e instanceof mt ? !_t(e) : be(e);
        }
        function Re(e) {
            var n = e.expression;
            if (n.name) return false;
            if (!(e instanceof ar)) return true;
            var t = false;
            n.walk(new Nn(function(e) {
                if (t) return true;
                if (e instanceof zr) return t = true;
                if (e instanceof dn && e !== n) return true;
            }));
            return !t;
        }
        function Fe(e) {
            return e instanceof Mn && e.definition().undeclared;
        }
        var Le = on("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Map Math Number parseFloat parseInt RangeError ReferenceError RegExp Object Set setInterval setTimeout String SyntaxError TypeError unescape URIError WeakMap WeakSet");
        Mn.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && Le[this.name];
        });
        function ce(e) {
            return sn(e.definitions, function(e) {
                return !e.value;
            });
        }
        function F(e, n) {
            if (e instanceof Ct) return n && !e.extends && sn(e.properties, function(e) {
                if (e.key instanceof un) return false;
                if (e instanceof Pt && e.static && e.value) return false;
                return true;
            });
            if (e instanceof Kt) return (n || e instanceof er) && ce(e);
            if (e instanceof nr) return F(e.body, n);
            if (e instanceof tr) return F(e.body, n);
            return e instanceof At;
        }
        function R(e, n) {
            var t = e.lastIndexOf(n);
            if (t < 0) return false;
            while (++t < e.length) {
                if (!F(e[t], true)) return false;
            }
            return true;
        }
        function Be(e, n) {
            var t;
            if (e.init instanceof pn) {
                t = e.init;
                e.init = t.body.pop();
                t.body.push(e);
            }
            if (e.init instanceof $t) {
                if (!t) t = ze(pn, e, {
                    body: [ e ]
                });
                t.body.splice(-1, 0, e.init);
                e.init = null;
            } else if (e.init instanceof ln) {
                e.init = e.init.body;
            } else if (ue(e.init)) {
                e.init = null;
            }
            if (!t) return;
            return n ? Un.splice(t.body) : t;
        }
        function c(e, s) {
            var C = M(s, function(e) {
                return e instanceof hn;
            });
            var Ee, Se, Te, Ae;
            i();
            var n, t, r = 10;
            do {
                t = n;
                n = 0;
                if (o(e)) n = 1;
                if (!n && t == 1) break;
                if (s.option("dead_code")) {
                    if (u(e, s)) n = 2;
                    if (!n && t == 2) break;
                }
                if (s.option("if_return")) {
                    if (f(e, s)) n = 3;
                    if (!n && t == 3) break;
                }
                if (s.option("awaits") && s.option("side_effects")) {
                    if (c(e, s)) n = 4;
                    if (!n && t == 4) break;
                }
                if (s.option("inline") >= 4) {
                    if (l(e, s)) n = 5;
                    if (!n && t == 5) break;
                }
                if (s.sequences_limit > 0) {
                    if (p(e, s)) n = 6;
                    if (!n && t == 6) break;
                    if (h(e, s)) n = 7;
                    if (!n && t == 7) break;
                }
                if (s.option("join_vars")) {
                    if (w(e)) n = 8;
                    if (!n && t == 8) break;
                }
                if (s.option("collapse_vars")) {
                    if (a(e, s)) n = 9;
                }
            } while (n && r-- > 0);
            return e;
            function M(e, n) {
                var t = e.self(), r, i = 0;
                do {
                    do {
                        if (n(t)) return true;
                        t = e.parent(i++);
                    } while (t instanceof mn && (r = t));
                } while ((t instanceof pn || t instanceof dn) && R(t.body, r));
            }
            function i() {
                var e = s.self(), n = 0;
                do {
                    if (!Ee && e.variables) Ee = e;
                    if (e instanceof Jt) {
                        if (s.parent(n).bfinally) {
                            if (!Te) Te = {};
                            Te.bfinally = true;
                        }
                        n++;
                    } else if (e instanceof Xt) {
                        n++;
                    } else if (e instanceof at) {
                        Se = true;
                    } else if (e instanceof dn) {
                        Ae = e;
                        break;
                    } else if (e instanceof Gt) {
                        if (!Te) Te = {};
                        if (e.bcatch) Te.bcatch = true;
                        if (e.bfinally) Te.bfinally = true;
                    }
                } while (e = s.parent(n++));
            }
            function a(s, d) {
                if (Ae.pinned()) return;
                var h;
                var N = new fn();
                var v = [];
                var I = false;
                var f = new fn();
                var a;
                var u = s.length;
                var l = new Br(function(e, n) {
                    if ($) return e;
                    if (!O) {
                        if (e !== c[p]) return e;
                        p++;
                        if (p < c.length) return M(e, l);
                        O = true;
                        w = (y ? P : re)(e, 0);
                        if (w === e) $ = true;
                        return e;
                    }
                    var t = l.parent();
                    if (!x && ee(e, t)) {
                        x = t;
                    }
                    if (Y && H && z && !x && e instanceof Dn && e.operator != "=" && e.left.equivalent_to(k)) {
                        q++;
                        I = true;
                        un.info("Cascading {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        z = false;
                        T = me(k);
                        e.right.transform(l);
                        de(m);
                        var r;
                        if ($) {
                            r = m;
                        } else {
                            $ = true;
                            r = ze(Tn, m, {
                                operator: Y,
                                left: k.fixed && k.definition().fixed ? k.fixed.to_binary() : k,
                                right: D
                            });
                        }
                        return ze(Dn, e, {
                            operator: "=",
                            left: e.left,
                            right: ze(Tn, e, {
                                operator: e.operator.slice(0, -1),
                                left: r,
                                right: e.right
                            })
                        });
                    }
                    if (Q(e, t)) {
                        $ = true;
                        return e;
                    }
                    if (e.single_use && t instanceof _n && t.value === e) return e;
                    var i;
                    if (!(e instanceof zn) && (H && k.equivalent_to(e) || S && (i = S(e, this)))) {
                        if (!z || x && (i || !G || !X)) {
                            if (!i && !y) $ = true;
                            return e;
                        }
                        if (Zr(e, t)) {
                            if (y && !i) g = true;
                            return e;
                        } else if (y) {
                            if (x && _ == 0) _ = b - q;
                            if (!i) q++;
                            return e;
                        } else {
                            q++;
                        }
                        I = $ = true;
                        un.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (m.TYPE == "Binary") {
                            he(m, e);
                            return ze(Dn, m, {
                                operator: "=",
                                left: m.right.left,
                                right: m.operator == "&&" ? ze(An, m, {
                                    condition: m.left,
                                    consequent: m.right.right,
                                    alternative: e
                                }) : ze(An, m, {
                                    condition: m.left,
                                    consequent: e,
                                    alternative: m.right.right
                                })
                            });
                        }
                        if (m instanceof fr) return ze(Sn, m, {
                            operator: m.operator,
                            expression: k.fixed && k.definition().fixed ? k.fixed.to_prefix() : k
                        });
                        if (m instanceof Sn) {
                            de(m);
                            return m;
                        }
                        he(D, e);
                        if (m instanceof _n) {
                            var a = m.name.definition();
                            if (a.references.length - a.replaced == 1 && !d.exposed(a)) {
                                a.replaced++;
                                return Me(d, t, e, D);
                            }
                            return ze(Dn, m, {
                                operator: "=",
                                left: e,
                                right: D
                            });
                        }
                        de(D);
                        var o = m.clone();
                        o.right = D;
                        return o;
                    }
                    if (Z(e, t)) {
                        $ = true;
                        return e;
                    }
                    if (ne(e, t) || L(e)) {
                        w = e;
                        if (e instanceof dn) $ = true;
                    }
                    if (e instanceof vt) {
                        var s = z;
                        z = false;
                        n(e, l);
                        z = s;
                        return C(e);
                    }
                    if (e instanceof $n) {
                        var s = z;
                        z = false;
                        n(e, l);
                        z = s;
                        return C(e);
                    }
                    if (e instanceof gn) {
                        e.name = e.name.transform(l);
                        var s = z;
                        z = false;
                        e.value = e.value.transform(l);
                        z = s;
                        return C(e);
                    }
                    if (e instanceof nt && !(e instanceof dn) && !(e.variables && e.variables.all(function(e) {
                        return !V.has(e.name) && !T.has(e.name);
                    }))) {
                        var s = z;
                        z = false;
                        if (!M(e, l)) n(e, l);
                        z = s;
                        return C(e);
                    }
                    return M(e, l);
                }, C);
                var r = new Br(function(e) {
                    if ($) return e;
                    if (!O) {
                        if (e !== c[p]) return e;
                        p++;
                        switch (c.length - p) {
                          case 0:
                            O = true;
                            if (g) return e;
                            if (e !== m) return e;
                            if (e instanceof _n) return e;
                            i.replaced++;
                            var n = r.parent();
                            if (n instanceof yn && n.tail_node() !== e) {
                                y.replaced++;
                                if (D === A) return Un.skip;
                                return Ce(A, A.expressions.slice(0, -1));
                            }
                            return D;

                          case 1:
                            if (!g && e.body === m) {
                                O = true;
                                i.replaced++;
                                y.replaced++;
                                return null;
                            }

                          default:
                            return M(e, r);
                        }
                    }
                    if (e instanceof Mn && e.definition() === i) {
                        if (Zr(e, r.parent())) return e;
                        if (!--q) $ = true;
                        un.info("Replacing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        var t = D.clone();
                        t.scope = e.scope;
                        t.reference();
                        if (q == _) {
                            $ = true;
                            return ze(Dn, m, {
                                operator: "=",
                                left: e,
                                right: t
                            });
                        }
                        i.replaced++;
                        return t;
                    }
                    if (e instanceof Vt || e instanceof dn) return e;
                }, function(e) {
                    return ge(e, r);
                });
                while (--u >= 0) {
                    if (u == 0 && d.option("unused")) te();
                    var c = [];
                    o(s[u]);
                    while (v.length > 0) {
                        c = v.pop();
                        var p = 0;
                        var m = c[c.length - 1];
                        var _ = -1;
                        var g = false;
                        var b;
                        var y = null;
                        var w = null;
                        var x = null;
                        var k = fe(m);
                        var E = k && k.has_side_effects(d);
                        var H = k && (!E || k instanceof Mn) && !Ye(k, d);
                        var S = le(m);
                        if (!H && !S) continue;
                        var Y = m instanceof Dn && m.operator.slice(0, -1);
                        var R = m.name instanceof Cn;
                        var L = an;
                        if (m.may_throw(d)) {
                            if (R && gt(Ae)) continue;
                            L = Te ? function(e) {
                                return e.has_side_effects(d);
                            } : t;
                        }
                        var B = false;
                        var U = false;
                        var V = new fn();
                        var W = true;
                        var T = me(m);
                        var G = be(k);
                        var A = ue(m);
                        var D = !Y && A instanceof yn ? A.tail_node() : A;
                        if (!E) E = ye();
                        var J = Te || !G ? function(e) {
                            return e instanceof $n;
                        } : an;
                        var X = we(m);
                        var O = R;
                        var $ = false;
                        var q = 0;
                        var z = !h || !O;
                        if (!z) {
                            for (var n = m.arg_index + 1; !$ && n < h.length; n++) {
                                if (h[n]) h[n].transform(l);
                            }
                            z = true;
                        }
                        for (var e = u; !$ && e < s.length; e++) {
                            s[e].transform(l);
                        }
                        if (y) {
                            if (!q || b > q + g) {
                                v.push(c);
                                a = true;
                                continue;
                            }
                            if (q == _) g = true;
                            var i = k.definition();
                            $ = false;
                            p = 0;
                            O = R;
                            for (var e = u; !$ && e < s.length; e++) {
                                if (!s[e].transform(r)) s.splice(e--, 1);
                            }
                            q = m instanceof _n && m === c[c.length - 1] && i.references.length == i.replaced && !d.exposed(i);
                            y.last_ref = false;
                            y.single_use = false;
                            I = true;
                        }
                        if (q) _e(m);
                    }
                }
                return I;
                function C(e) {
                    if ($) return e;
                    if (w === e) $ = true;
                    if (x === e) x = null;
                    return e;
                }
                function M(e, n) {
                    if (!(e instanceof nt)) {
                        if (!(e instanceof Ft && !e.static)) return;
                        if (e.key instanceof un) e.key = e.key.transform(n);
                        return e;
                    }
                    if (e instanceof dn) return e;
                    if (e instanceof ct) {
                        e.object = e.object.transform(n);
                        $ = true;
                        return e;
                    }
                    if (e instanceof Bt) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !$ && t < e.body.length; t++) {
                            var r = e.body[t];
                            if (r instanceof Wt) {
                                if (!O) {
                                    if (r !== c[p]) continue;
                                    p++;
                                }
                                r.expression = r.expression.transform(n);
                                if (!X) break;
                                S = false;
                            }
                        }
                        $ = true;
                        return e;
                    }
                }
                function K(e, n) {
                    if (n instanceof Dn) return n.operator == "=" && n.left === e;
                    if (n instanceof gn) return n.name === e;
                    if (n instanceof lr) return true;
                    if (n instanceof pr) return n.value === e;
                }
                function Q(e, n) {
                    if (e === D) return true;
                    if (n instanceof ut) {
                        if (e !== n.init) return true;
                    }
                    if (e instanceof Dn) {
                        return e.operator != "=" && k.equivalent_to(e.left);
                    }
                    if (e instanceof bn) {
                        if (!(k instanceof wn)) return false;
                        if (!k.equivalent_to(e.expression)) return false;
                        return !(D instanceof mt && !D.contains_this());
                    }
                    if (e instanceof zt) return !d.has_directive("use strict");
                    if (e instanceof Qn) return true;
                    if (e instanceof $t) return R && k.name === e.name.name;
                    if (e instanceof pr) return e.key instanceof un;
                    if (e instanceof ot) return true;
                    if (e instanceof Yt) return true;
                    if (e instanceof Gt) return true;
                    if (e instanceof dt) return true;
                    return false;
                }
                function Z(e, n) {
                    if (!(e instanceof Mn)) return false;
                    if (e.is_declared(d)) {
                        if (e.fixed_value()) return false;
                        if ($e(e)) {
                            return !(n instanceof wn && n.expression === e) && Oe(e.definition());
                        }
                    } else if (K(e, n)) {
                        return false;
                    }
                    if (!X) return true;
                    S = false;
                    return false;
                }
                function ee(e, n) {
                    if (n instanceof Dn) return n.left !== e && je[n.operator.slice(0, -1)];
                    if (n instanceof Tn) return n.left !== e && je[n.operator];
                    if (n instanceof bn) return n.optional && n.expression !== e;
                    if (n instanceof Wt) return n.expression !== e;
                    if (n instanceof An) return n.condition !== e;
                    if (n instanceof mn) return n.condition !== e;
                    if (n instanceof sr) return n.optional && n.expression !== e;
                }
                function ne(e, n) {
                    if (e instanceof ur) return true;
                    if (e.TYPE == "Binary") return e.operator == "in" && !Ne(e.right);
                    if (e instanceof bn) {
                        var t, r = e.expression;
                        if (r instanceof Mn) {
                            t = r.definition();
                            r = r.fixed_value();
                        }
                        if (!(r instanceof hn)) return !e.is_expr_pure(d);
                        if (t && We(d, t, r)) return true;
                        if (r.collapse_scanning) return false;
                        r.collapse_scanning = true;
                        var i = z;
                        z = false;
                        var a = w;
                        var o = x;
                        if (!sn(r.argnames, function(e) {
                            if (e instanceof gn) {
                                e.value.transform(l);
                                if ($) return false;
                                e = e.name;
                            }
                            return !(e instanceof $n);
                        })) {
                            $ = true;
                        } else if (_t(r) && r.value) {
                            r.value.transform(l);
                        } else for (var s = 0; !$ && s < r.body.length; s++) {
                            var f = r.body[s];
                            if (f instanceof vn) {
                                if (f.value) f.value.transform(l);
                                break;
                            }
                            f.transform(l);
                        }
                        x = o;
                        w = a;
                        z = i;
                        r.collapse_scanning = false;
                        if (!$) return false;
                        $ = false;
                        return true;
                    }
                    if (e instanceof It) {
                        if (Te) {
                            if (Te.bfinally) return true;
                            if (Te.bcatch && e instanceof Ht) return true;
                        }
                        return E || k instanceof wn || ke(k);
                    }
                    if (e instanceof St) {
                        return d.option("ie") && e.name && T.has(e.name.name);
                    }
                    if (e instanceof Or) return xe(e, n);
                    if (e instanceof wn) {
                        if (E) return true;
                        var u = e.expression;
                        if (u instanceof Mn && Oe(u.definition())) return true;
                        if (d.option("unsafe")) {
                            if (Fe(u) && Le[u.name]) return false;
                            if (Ue(u)) return false;
                        }
                        if (!W) return true;
                        if (y) return false;
                        if (!Te && G) return false;
                        if (e.optional) return false;
                        return u.may_throw_on_access(d);
                    }
                    if (e instanceof kn) return true;
                    if (e instanceof Mn) {
                        if (xe(e, n)) return !K(e, n);
                        if (E && ke(e)) return true;
                        var t = e.definition();
                        return (Te || t.scope.resolve() !== Ae) && !$e(e);
                    }
                    if (e instanceof Cr) return !e.is_expr_pure(d);
                    if (e instanceof _n) {
                        if (J(e.name)) return true;
                        return (e.value || n instanceof Zt) && e.name.match_symbol(function(e) {
                            return e instanceof zn && (T.has(e.name) || E && ke(e));
                        }, true);
                    }
                    if (e instanceof cr) return true;
                    var c = Zr(e.left, e);
                    if (!c) return false;
                    if (c instanceof wn) return true;
                    if (J(c)) return true;
                    return c.match_symbol(function(e) {
                        return e instanceof Mn && (T.has(e.name) || B && d.exposed(e.definition()));
                    }, true);
                }
                function F(e, n) {
                    if (!n) return !(e instanceof br);
                    if (e instanceof gn) {
                        return n.has_side_effects(d) || e.value.has_side_effects(d) || F(e.name, Pe(n) && e.value);
                    }
                    if (e instanceof $n) {
                        if (e.rest && F(e.rest)) return true;
                        if (e instanceof lr) {
                            if (!(n instanceof On || n.is_string(d))) return true;
                            return !sn(e.elements, function(e) {
                                return !F(e);
                            });
                        }
                        if (e instanceof dr) {
                            if (!n.is_defined(d)) return true;
                            return !sn(e.properties, function(e) {
                                if (e instanceof un && e.has_side_effects(d)) return false;
                                return !F(e.value);
                            });
                        }
                    }
                }
                function te() {
                    var e, i = d.self();
                    if (i instanceof mt && !bt(i) && !i.uses_arguments && !i.pinned() && (e = d.parent()) instanceof bn && e.expression === i && Re(e) && sn(e.args, function(e) {
                        return !(e instanceof kn);
                    })) {
                        var a = d.has_directive("use strict");
                        if (a && !In(a, i.body)) a = false;
                        var o = gt(i) ? function(e) {
                            return e instanceof br && e.name == "await";
                        } : function(e) {
                            return e instanceof ur && !n.find_parent(dn);
                        };
                        var s = null;
                        var n = new Nn(function(e, n) {
                            if (!c) return true;
                            if (o(e) || e instanceof cr) {
                                c = null;
                                return true;
                            }
                            if (e instanceof Or && (a || !s)) {
                                c = null;
                                return true;
                            }
                            if (e instanceof Mn && i.variables.has(e.name)) {
                                var t = e.definition().scope;
                                if (t !== Ae) while (t = t.parent_scope) {
                                    if (t === Ae) return true;
                                }
                                c = null;
                            }
                            if (e instanceof dn && !_t(e)) {
                                var r = s;
                                s = e;
                                n();
                                s = r;
                                return true;
                            }
                        });
                        h = e.args.slice();
                        var t = h.length;
                        var r = new fn();
                        for (var f = i.argnames.length; --f >= 0; ) {
                            var u = i.argnames[f];
                            var c = h[f];
                            var l;
                            if (u instanceof gn) {
                                l = u.value;
                                u = u.name;
                                h[t + f] = l;
                            }
                            if (u instanceof $n) {
                                if (!F(u, c)) continue;
                                v.length = 0;
                                break;
                            }
                            if (r.has(u.name)) continue;
                            r.set(u.name, true);
                            if (l) c = Pe(c) ? l : null;
                            if (!c && !l) {
                                c = ze(Nr, u).transform(d);
                            } else if (c instanceof hn && c.pinned()) {
                                c = null;
                            } else if (c) {
                                c.walk(n);
                            }
                            if (!c) continue;
                            var p = ze(_n, u, {
                                name: u,
                                value: c
                            });
                            p.name_index = f;
                            p.arg_index = l ? t + f : f;
                            v.unshift([ p ]);
                        }
                    }
                }
                function o(e, n) {
                    c.push(e);
                    if (e instanceof On) {
                        e.elements.forEach(function(e) {
                            o(e, n);
                        });
                    } else if (e instanceof Dn) {
                        var t = e.left;
                        if (!(t instanceof $n)) v.push(c.slice());
                        o(t);
                        o(e.right);
                        if (t instanceof Mn && e.operator == "=") {
                            N.set(t.name, (N.get(t.name) || 0) + 1);
                        }
                    } else if (e instanceof ur) {
                        o(e.expression, n);
                    } else if (e instanceof Tn) {
                        var r = je[e.operator];
                        if (n && r && e.operator != "??" && e.right instanceof Dn && e.right.operator == "=" && !(e.right.left instanceof $n)) {
                            v.push(c.slice());
                        }
                        o(e.left, !r && n);
                        o(e.right, n);
                    } else if (e instanceof bn) {
                        o(e.expression);
                        e.args.forEach(o);
                    } else if (e instanceof Wt) {
                        o(e.expression);
                    } else if (e instanceof An) {
                        o(e.condition);
                        o(e.consequent, n);
                        o(e.alternative, n);
                    } else if (e instanceof Kt) {
                        e.definitions.forEach(o);
                    } else if (e instanceof xn) {
                        o(e.expression);
                    } else if (e instanceof ot) {
                        o(e.condition);
                        if (!(e.body instanceof rt)) {
                            o(e.body);
                        }
                    } else if (e instanceof It) {
                        if (e.value) o(e.value);
                    } else if (e instanceof ut) {
                        if (e.init) o(e.init, true);
                        if (e.condition) o(e.condition);
                        if (e.step) o(e.step, true);
                        if (!(e.body instanceof rt)) {
                            o(e.body);
                        }
                    } else if (e instanceof ct) {
                        o(e.object);
                        if (!(e.body instanceof rt)) {
                            o(e.body);
                        }
                    } else if (e instanceof mn) {
                        o(e.condition);
                        if (!(e.body instanceof rt)) {
                            o(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof rt)) {
                            o(e.alternative);
                        }
                    } else if (e instanceof qn) {
                        e.properties.forEach(function(e) {
                            c.push(e);
                            if (e.key instanceof un) o(e.key);
                            if (e instanceof vr) o(e.value, n);
                            c.pop();
                        });
                    } else if (e instanceof yn) {
                        var i = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            o(e, n < i);
                        });
                    } else if (e instanceof ln) {
                        o(e.body, true);
                    } else if (e instanceof kn) {
                        o(e.expression);
                    } else if (e instanceof sr) {
                        o(e.expression);
                        o(e.property);
                    } else if (e instanceof Bt) {
                        o(e.expression);
                        e.body.forEach(o);
                    } else if (e instanceof En) {
                        if (Gr[e.operator]) {
                            v.push(c.slice());
                        } else {
                            o(e.expression);
                        }
                    } else if (e instanceof _n) {
                        if (e.name instanceof kr) {
                            if (e.value) {
                                var a = e.name.definition();
                                if (a.references.length > a.replaced) {
                                    v.push(c.slice());
                                }
                            } else {
                                f.set(e.name.name, (f.get(e.name.name) || 0) + 1);
                            }
                        }
                        if (e.value) o(e.value);
                    } else if (e instanceof cr) {
                        if (e.expression) o(e.expression);
                    }
                    c.pop();
                }
                function re(e, n) {
                    var t = l.parent(n);
                    if (t instanceof On) return e;
                    if (t instanceof Dn) return e;
                    if (t instanceof ur) return e;
                    if (t instanceof Tn) return e;
                    if (t instanceof bn) return e;
                    if (t instanceof Wt) return e;
                    if (t instanceof An) return e;
                    if (t instanceof Kt) return j(t, n + 1);
                    if (t instanceof It) return e;
                    if (t instanceof mn) return e;
                    if (t instanceof at) return e;
                    if (t instanceof hr) return e;
                    if (t instanceof wn) return e;
                    if (t instanceof yn) {
                        return (t.tail_node() === e ? re : j)(t, n + 1);
                    }
                    if (t instanceof ln) return j(t, n + 1);
                    if (t instanceof kn) return e;
                    if (t instanceof Bt) return e;
                    if (t instanceof En) return e;
                    if (t instanceof _n) return e;
                    if (t instanceof cr) return e;
                    return null;
                }
                function ie(e, n, t) {
                    var r;
                    do {
                        r = e;
                        e = l.parent(++t);
                    } while (e instanceof Dn && e.operator.slice(0, -1) == n || e instanceof Tn && e.operator == n);
                    return r;
                }
                function ae(e, n, t, r, i) {
                    var a = z;
                    z = false;
                    var o = w;
                    var s = x;
                    var f = l.stack;
                    l.stack = [ r ];
                    e.transform(l);
                    l.stack = f;
                    x = s;
                    w = o;
                    z = a;
                    if ($) {
                        $ = false;
                        return t;
                    }
                    return n(r, i + 1);
                }
                function P(e, n) {
                    var t = l.parent(n);
                    if (t instanceof On) return P(t, n + 1);
                    if (t instanceof Dn) {
                        if (L(t)) return e;
                        if (t.left.match_symbol(function(e) {
                            return e instanceof Mn && (k.name == e.name || y.name == e.name);
                        })) return e;
                        var r;
                        if (t.left === e || !je[r = t.operator.slice(0, -1)]) {
                            return P(t, n + 1);
                        }
                        return ie(t, r, n);
                    }
                    if (t instanceof Tn) {
                        var r;
                        if (t.left === e || !je[r = t.operator]) {
                            return P(t, n + 1);
                        }
                        return ie(t, r, n);
                    }
                    if (t instanceof bn) return t;
                    if (t instanceof Wt) {
                        if (t.expression !== e) return e;
                        return P(t, n + 1);
                    }
                    if (t instanceof An) {
                        if (t.condition !== e) return e;
                        return P(t, n + 1);
                    }
                    if (t instanceof Kt) return j(t, n + 1);
                    if (t instanceof st) return e;
                    if (t instanceof It) return j(t, n + 1);
                    if (t instanceof ut) {
                        if (t.init !== e && t.condition !== e) return e;
                        return P(t, n + 1);
                    }
                    if (t instanceof ct) {
                        if (t.init !== e) return e;
                        return P(t, n + 1);
                    }
                    if (t instanceof mn) {
                        if (t.condition !== e) return e;
                        return P(t, n + 1);
                    }
                    if (t instanceof hr) {
                        var i = l.parent(n + 1);
                        return sn(i.properties, function(e) {
                            return e instanceof vr;
                        }) ? P(i, n + 2) : i;
                    }
                    if (t instanceof wn) {
                        var a = t.expression;
                        return a === e ? P(t, n + 1) : e;
                    }
                    if (t instanceof yn) {
                        return (t.tail_node() === e ? P : j)(t, n + 1);
                    }
                    if (t instanceof ln) return j(t, n + 1);
                    if (t instanceof kn) return P(t, n + 1);
                    if (t instanceof Bt) {
                        if (t.expression !== e) return e;
                        return P(t, n + 1);
                    }
                    if (t instanceof En) {
                        if (t.operator == "delete") return e;
                        return P(t, n + 1);
                    }
                    if (t instanceof _n) return t.name.match_symbol(function(e) {
                        return e instanceof zn && (k.name == e.name || y.name == e.name);
                    }) ? e : P(t, n + 1);
                    if (t instanceof ft) {
                        if (t.condition !== e) return e;
                        return P(t, n + 1);
                    }
                    if (t instanceof cr) return P(t, n + 1);
                    return null;
                }
                function j(n, t) {
                    var r = l.parent(t);
                    if (ne(n, r)) return n;
                    if (ee(n, r)) return n;
                    if (r instanceof On) return j(r, t + 1);
                    if (r instanceof Dn) return a(r.left);
                    if (r instanceof ur) return n;
                    if (r instanceof Tn) return j(r, t + 1);
                    if (r instanceof bn) return j(r, t + 1);
                    if (r instanceof Wt) return j(r, t + 1);
                    if (r instanceof An) return j(r, t + 1);
                    if (r instanceof Kt) return j(r, t + 1);
                    if (r instanceof It) return j(r, t + 1);
                    if (r instanceof mn) return j(r, t + 1);
                    if (r instanceof at) return n;
                    if (r instanceof hr) {
                        var e = l.parent(t + 1);
                        return sn(e.properties, function(e) {
                            return e instanceof vr;
                        }) ? j(e, t + 2) : e;
                    }
                    if (r instanceof wn) {
                        var i = r.expression;
                        if (i === n) return j(r, t + 1);
                        return ae(i, j, n, r, t);
                    }
                    if (r instanceof yn) return j(r, t + 1);
                    if (r instanceof ln) return j(r, t + 1);
                    if (r instanceof kn) return n;
                    if (r instanceof Bt) return j(r, t + 1);
                    if (r instanceof En) return j(r, t + 1);
                    if (r instanceof _n) return a(r.name);
                    if (r instanceof cr) return n;
                    return null;
                    function a(e) {
                        if (L(r)) return n;
                        if (e !== n && e instanceof $n) {
                            return ae(e, j, n, r, t);
                        }
                        return j(r, t + 1);
                    }
                }
                function oe(e) {
                    if (a) {
                        a = false;
                        return;
                    }
                    if (b < 1) return;
                    e = e.tail_node();
                    var n = e instanceof Dn && e.operator == "=" ? e.left : e;
                    if (!(n instanceof Mn)) return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    if (Oe(t)) return;
                    if (n !== e) {
                        if (Ye(n, d)) return;
                        var r = t.references.length - t.replaced;
                        if (r < 2) return;
                        var i = m.clone();
                        i[i instanceof Dn ? "right" : "value"] = n;
                        if (m.name_index >= 0) {
                            i.name_index = m.name_index;
                            i.arg_index = m.arg_index;
                        }
                        m = i;
                    }
                    return y = t;
                }
                function se(e) {
                    return e.references.length - e.replaced - (N.get(e.name) || 0);
                }
                function fe(t) {
                    if (t instanceof Dn) {
                        var r = t.left;
                        if (!(r instanceof Mn)) return r;
                        var e = r.definition();
                        if (Ae.uses_arguments && Kr(e)) return r;
                        if (d.exposed(e)) return r;
                        b = se(e);
                        if (e.fixed && r.fixed) {
                            var n = e.references.filter(function(e) {
                                return e.fixed === r.fixed;
                            }).length - 1;
                            if (n < b) {
                                b = n;
                                _ = 0;
                            }
                        }
                        if (t.operator == "=") oe(t.right);
                        return r;
                    }
                    if (t instanceof Tn) return t.right.left;
                    if (t instanceof En) return t.expression;
                    if (t instanceof _n) {
                        var r = t.name;
                        var e = r.definition();
                        if (e.const_redefs) return;
                        if (!In(r, e.orig)) return;
                        if (Ae.uses_arguments && Kr(e)) return;
                        var i = e.orig.length - e.eliminated - (f.get(e.name) || 0);
                        b = se(e);
                        if (e.fixed) b = Math.min(b, e.references.filter(function(e) {
                            if (!e.fixed) return true;
                            if (!e.fixed.assigns) return true;
                            var n = e.fixed.assigns[0];
                            return n === r || ue(n) === t.value;
                        }).length);
                        if (i > 1 && !(r instanceof Cn)) {
                            oe(t.value);
                            return ze(Mn, r, r);
                        }
                        if (oe(t.value) || b == 1 && !d.exposed(e)) {
                            return ze(Mn, r, r);
                        }
                        return;
                    }
                }
                function ue(e) {
                    if (e instanceof Dn) return e.right;
                    if (e instanceof Tn) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof _n) return e.value;
                }
                function ce(e) {
                    if (e instanceof On) return false;
                    if (e instanceof Tn && je[e.operator]) {
                        return ce(e.left) && ce(e.right);
                    }
                    if (e instanceof bn) return false;
                    if (e instanceof An) {
                        return ce(e.consequent) && ce(e.alternative);
                    }
                    if (e instanceof qn) return false;
                    return !e.has_side_effects(d);
                }
                function le(n) {
                    if (n instanceof Dn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Nn(function(e) {
                        if (e instanceof Mn) t[e.definition().id] = true;
                    });
                    while (n instanceof Dn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof Or) return o;
                    if (n instanceof Mn) {
                        var r = n.evaluate(d);
                        if (r === n) return o;
                        return pe(r, o);
                    }
                    if (n.is_truthy()) return pe(true, an);
                    if (n.is_constant()) {
                        var i = n.evaluate(d);
                        if (!(i instanceof un)) return pe(i, o);
                    }
                    if (!(k instanceof Mn)) return false;
                    if (!ce(n)) return false;
                    var a;
                    n.walk(new Nn(function(e) {
                        if (a) return true;
                        if (e instanceof Mn && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function pe(r, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (r && e.is_truthy() && !e.has_side_effects(d)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(d);
                                if (!(t instanceof un)) return !t == !r;
                            }
                        }
                        return i(e);
                    };
                }
                function de(e) {
                    while (e.write_only) {
                        e.write_only = false;
                        if (!(e instanceof Dn)) break;
                        e = e.right;
                    }
                }
                function he(e, n) {
                    var t = n.scope || qe(l) || Ee;
                    e.walk(new Nn(function(e) {
                        if (e instanceof nt) return true;
                        if (e instanceof br) e.scope = t;
                    }));
                }
                function ve(e) {
                    if (e instanceof Mn) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Dn) return e.operator == "=" && ve(e.right);
                    return e instanceof wn || e instanceof Or;
                }
                function me(f) {
                    var u = new fn();
                    if (f instanceof _n) {
                        if (!f.name.definition().fixed) W = false;
                        u.add(f.name.name, k);
                    }
                    var c = Ae.uses_arguments && !d.has_directive("use strict");
                    var l = Ae instanceof ht;
                    var p = new Nn(function(n) {
                        var e;
                        if (n instanceof Mn) {
                            e = n.fixed_value();
                            if (!e) {
                                e = n;
                                var t = n.definition();
                                var r = n.fixed && n.fixed.escaped || t.escaped;
                                if (!t.undeclared && (t.assignments || !r || r.cross_scope) && (He(t, n.scope, n, p.parent()) || !Ie(t))) {
                                    W = false;
                                }
                            }
                        } else if (n instanceof Or) {
                            e = n;
                        }
                        if (e) {
                            u.add(n.name, De(d, p, n, e, 0));
                        } else if (n instanceof hn) {
                            for (var i = 0, a, o = n; a = p.parent(i++); o = a) {
                                if (a instanceof Dn) {
                                    if (a.left === o) break;
                                    if (a.operator == "=") continue;
                                    if (je[a.operator.slice(0, -1)]) continue;
                                    break;
                                }
                                if (a instanceof Tn) {
                                    if (je[a.operator]) continue;
                                    break;
                                }
                                if (a instanceof bn) return;
                                if (a instanceof dn) return;
                                if (a instanceof yn) {
                                    if (a.tail_node() === o) continue;
                                    break;
                                }
                                if (a instanceof Cr) {
                                    if (a.tag) return;
                                    break;
                                }
                            }
                            n.enclosed.forEach(function(e) {
                                if (e.scope !== n) V.set(e.name, true);
                            });
                            return true;
                        } else if (c && n instanceof sr) {
                            Ae.each_argname(function(e) {
                                if (!d.option("reduce_vars") || e.definition().assignments) {
                                    if (!e.definition().fixed) W = false;
                                    u.add(e.name, true);
                                }
                            });
                            c = false;
                        }
                        if (!l) return;
                        if (n.TYPE == "Call") {
                            if (U) return;
                            var s = n.expression;
                            if (s instanceof wn) return;
                            if (s instanceof mt && !s.contains_this()) return;
                            U = true;
                        } else if (n instanceof wn && ve(n.expression)) {
                            if (n === k && !(f instanceof En)) {
                                U = true;
                            } else {
                                B = true;
                            }
                        }
                    });
                    f.walk(p);
                    return u;
                }
                function _e(e) {
                    var r = D === A ? null : Ce(A, A.expressions.slice(0, -1));
                    var n = e.name_index;
                    if (n >= 0) {
                        var t, i = Ae.argnames[n];
                        if (i instanceof gn) {
                            Ae.argnames[n] = i = i.clone();
                            i.value = r || ze(jn, i, {
                                value: 0
                            });
                        } else if ((t = d.parent().args)[n]) {
                            Ae.argnames[n] = i.clone();
                            t[n] = r || ze(jn, t[n], {
                                value: 0
                            });
                        }
                        return;
                    }
                    var a = c.length - 1;
                    if (c[a - 1].body === c[a]) a--;
                    var o = new Br(function(e, n, t) {
                        if (O) return e;
                        if (e !== c[p]) return e;
                        p++;
                        if (p <= a) return M(e, o);
                        O = true;
                        if (e instanceof _n) {
                            f.set(e.name.name, (f.get(e.name.name) || 0) + 1);
                            if (y) y.replaced++;
                            e = e.clone();
                            e.value = null;
                            return r ? Un.splice([ r, e ]) : e;
                        }
                        if (!r) return t ? Un.skip : null;
                        return et(e) ? ze(ln, r, {
                            body: r
                        }) : r;
                    }, function(n, e) {
                        if (n instanceof Kt) {
                            var t = [], r = n.definitions;
                            for (var i = 0, a = 0; i < r.length; i++) {
                                var o = r[i];
                                if (o instanceof _n) continue;
                                s();
                                a = i + 1;
                                t.push(ze(ln, o, {
                                    body: o
                                }));
                            }
                            if (a == 0) return;
                            s();
                            if (t.length == 1) return t[0];
                            return e ? Un.splice(t) : ze(pn, n, {
                                body: t
                            });
                        }
                        if (n instanceof ut) return Be(n, e);
                        return ge(n, this);
                        function s() {
                            if (a < i) {
                                var e = n.clone();
                                e.definitions = r.slice(a, i);
                                t.push(e);
                            }
                        }
                    });
                    $ = false;
                    O = false;
                    p = 0;
                    if (!(s[u] = s[u].transform(o))) s.splice(u, 1);
                }
                function ge(e, n) {
                    if (e instanceof yn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return Me(d, n.parent(), e, e.expressions[0]);
                    }
                }
                function be(e) {
                    var n = or(e);
                    if (!(n instanceof Mn)) return false;
                    if (n.definition().scope.resolve() !== Ae) return false;
                    if (!Se) return true;
                    if (Y) return false;
                    if (m instanceof En) return false;
                    var t = T.get(n.name);
                    return !t || t[0] === e;
                }
                function ye() {
                    if (m instanceof En) return false;
                    return D.has_side_effects(d);
                }
                function we(e) {
                    if (e instanceof En) return false;
                    if (E) return false;
                    if (y) return true;
                    if (!(k instanceof Mn)) return false;
                    var n;
                    if (e instanceof _n) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = k.definition();
                    if (t.references.length - t.replaced == n) return true;
                    return t.fixed && k.fixed && t.references.filter(function(e) {
                        return e.fixed === k.fixed;
                    }).length == n;
                }
                function xe(e, n) {
                    var t = T.get(e.name);
                    if (!t || sn(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== k) return true;
                    S = false;
                }
                function ke(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof Er) return false;
                    if (n.scope.resolve() !== Ae) return true;
                    if (U && d.exposed(n)) return true;
                    return !sn(n.references, function(e) {
                        return e.scope.resolve() === Ae;
                    });
                }
                function t(e, n) {
                    if (e instanceof Dn) return t(e.left, true);
                    if (e instanceof En) return t(e.expression, true);
                    if (e instanceof _n) return e.value && t(e.value);
                    if (n) {
                        if (e instanceof xn) return t(e.expression, true);
                        if (e instanceof sr) return t(e.expression, true);
                        if (e instanceof Mn) return e.definition().scope.resolve() !== Ae;
                    }
                    return false;
                }
            }
            function o(e) {
                var n = false, t = [];
                for (var r = 0; r < e.length; ) {
                    var i = e[r];
                    if (i instanceof pn) {
                        if (sn(i.body, A)) {
                            n = true;
                            o(i.body);
                            [].splice.apply(e, [ r, 1 ].concat(i.body));
                            r += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof Zn) {
                        if (In(i.value, t)) {
                            n = true;
                            e.splice(r, 1);
                            continue;
                        }
                        t.push(i.value);
                    }
                    if (i instanceof cn) {
                        n = true;
                        e.splice(r, 1);
                        continue;
                    }
                    r++;
                }
                return n;
            }
            function f(a, o) {
                var e = false;
                var n = o.parent();
                var t = o.self();
                var r = C && n && n.TYPE == "Call" && n.expression === t;
                var i = C && o.option("conditionals") && o.option("sequences");
                var s = E(a);
                for (var f = a.length; --f >= 0; ) {
                    var u = a[f];
                    var c = $(f);
                    var l = a[c];
                    if (C && !l && u instanceof vn) {
                        if (!u.value) {
                            e = true;
                            a.splice(f, 1);
                            continue;
                        }
                        var p = u.value.tail_node();
                        if (p instanceof Sn && p.operator == "void") {
                            e = true;
                            var d;
                            if (p === u.value) {
                                d = p.expression;
                            } else {
                                d = u.value.clone();
                                d.expressions[d.length - 1] = p.expression;
                            }
                            a[f] = ze(ln, u, {
                                body: d
                            });
                            continue;
                        }
                    }
                    if (u instanceof mn) {
                        var h = P(u.body);
                        if (A(h)) {
                            if (h.label) Gn(h.label.thedef.references, h);
                            e = true;
                            u = u.clone();
                            u.body = ze(pn, u, {
                                body: O(u.body, h)
                            });
                            u.alternative = ze(pn, u, {
                                body: H(u.alternative).concat(D())
                            });
                            a[f] = u;
                            a[f] = u.transform(o);
                            continue;
                        }
                        if (h && !u.alternative && l instanceof Nt) {
                            var v = u.condition;
                            v = le(v, v.negate(o), u.body instanceof pn);
                            if (v !== u.condition) {
                                e = true;
                                u = u.clone();
                                u.condition = v;
                                a[c] = u.body;
                                u.body = l;
                                a[f] = u;
                                a[f] = u.transform(o);
                                continue;
                            }
                        }
                        var m = P(u.alternative);
                        if (A(m)) {
                            if (m.label) Gn(m.label.thedef.references, m);
                            e = true;
                            u = u.clone();
                            u.body = ze(pn, u.body, {
                                body: H(u.body).concat(D())
                            });
                            u.alternative = ze(pn, u.alternative, {
                                body: O(u.alternative, m)
                            });
                            a[f] = u;
                            a[f] = u.transform(o);
                            continue;
                        }
                        if (o.option("typeofs")) {
                            if (h && !m) {
                                var _ = ze(pn, t, {
                                    body: a.slice(f + 1)
                                });
                                j(u.condition, null, _);
                            }
                            if (!h && m) {
                                var _ = ze(pn, t, {
                                    body: a.slice(f + 1)
                                });
                                j(u.condition, _);
                            }
                        }
                    }
                    if (u instanceof mn && u.body instanceof vn) {
                        var g = u.body.value;
                        var b = u.body.in_bool || l instanceof vn && l.in_bool;
                        if (!u.alternative && l instanceof vn) {
                            e = true;
                            u = u.clone();
                            u.alternative = l;
                            a.splice(f, 1, u.transform(o));
                            a.splice(c, 1);
                            continue;
                        }
                        if (!u.alternative && !l && C && (b || g && s)) {
                            e = true;
                            u = u.clone();
                            u.alternative = ze(vn, u, {
                                value: null
                            });
                            a.splice(f, 1, u.transform(o));
                            continue;
                        }
                        var y, w;
                        if (i && !u.alternative && (!(w = a[y = q(f)]) && r || w instanceof mn && w.body instanceof vn) && $(c) == a.length && l instanceof ln) {
                            e = true;
                            var x = [];
                            var k = w ? z(y, x) : [ f, 1 ];
                            u = u.clone();
                            x.push(u.condition);
                            u.condition = Ce(u, x);
                            u.alternative = ze(pn, l, {
                                body: [ l, ze(vn, l, {
                                    value: null
                                }) ]
                            });
                            k.push(u.transform(o));
                            a.splice(c, 1);
                            [].splice.apply(a, k);
                            f = y + 1;
                            continue;
                        }
                    }
                }
                return e;
                function E(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var r = e[t];
                        if (r instanceof mn && r.body instanceof vn) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function S(n) {
                    return M(o, function(e) {
                        return e === n;
                    });
                }
                function T(e) {
                    if (e instanceof vn) return C && Pe(e.value);
                    if (!(e instanceof Yt)) return false;
                    var n = o.loopcontrol_target(e);
                    if (e instanceof Lt) return S(Y(n));
                    if (n instanceof at) return false;
                    return S(n);
                }
                function A(e) {
                    if (!T(e)) return false;
                    for (var n = a.length; --n > f; ) {
                        var t = a[n];
                        if (t instanceof Ct) {
                            if (t.name.definition().preinit) return false;
                        } else if (t instanceof Qt || t instanceof Zt) {
                            if (!sn(t.definitions, function(e) {
                                return !e.name.match_symbol(function(e) {
                                    return e instanceof zn && e.definition().preinit;
                                });
                            })) return false;
                        }
                    }
                    return true;
                }
                function D() {
                    var n = [];
                    var t = false;
                    var e = a.splice(f + 1).filter(function(e) {
                        if (e instanceof At) {
                            n.push(e);
                            return false;
                        }
                        if (I(e)) t = true;
                        return true;
                    });
                    [].push.apply(t ? e : a, n);
                    return e;
                }
                function O(e, n) {
                    var t = H(e);
                    var r = t, i;
                    while ((i = r[r.length - 1]) !== n) {
                        r = i.body;
                    }
                    r.pop();
                    if (n.value) r.push(ze(ln, n.value, {
                        body: n.value
                    }));
                    return t;
                }
                function $(e) {
                    for (var n = e + 1; n < a.length; n++) {
                        if (!F(a[n])) break;
                    }
                    return n;
                }
                function q(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!(a[n] instanceof er)) break;
                    }
                    return n;
                }
                function z(e, n) {
                    var t = [ e + 1, f - e ];
                    var r = [];
                    while (++e < f) {
                        var i = a[e];
                        i.remove_initializers(o, r);
                        i.definitions.forEach(function(e) {
                            if (!e.value) return;
                            n.push(ze(Dn, e, {
                                operator: "=",
                                left: e.name.convert_symbol(Mn, N),
                                right: e.value
                            }));
                        });
                    }
                    if (r.length > 0) t.push(ze(er, i, {
                        definitions: r
                    }));
                    return t;
                }
            }
            function u(n, t) {
                var e;
                var r = t.self();
                for (var i = 0, a = 0, o = n.length; i < o; i++) {
                    var s = n[i];
                    if (s instanceof Yt) {
                        var f = t.loopcontrol_target(s);
                        if (Y(f) !== r || s instanceof Rt && f instanceof at) {
                            n[a++] = s;
                        } else if (s.label) {
                            Gn(s.label.thedef.references, s);
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (P(s)) {
                        e = n.slice(i + 1);
                        break;
                    }
                }
                n.length = a;
                if (e) e.forEach(function(e) {
                    S(t, e, n);
                });
                return n.length != o;
            }
            function c(e, n) {
                if (!C || Te && Te.bfinally) return;
                var t = false;
                for (var r = e.length; --r >= 0; ) {
                    var i = e[r];
                    if (!(i instanceof ln)) break;
                    var a = i.body;
                    if (!(a instanceof ur)) break;
                    var o = a.expression;
                    if (!x(n, o)) break;
                    t = true;
                    o = o.drop_side_effect_free(n, true);
                    if (o) {
                        i.body = o;
                        break;
                    }
                }
                e.length = r + 1;
                return t;
            }
            function l(e, n) {
                var t = false;
                var r = e.length - 1;
                if (C && r >= 0) {
                    var i = e[r].try_inline(n, Ee);
                    if (i) {
                        e[r--] = i;
                        t = true;
                    }
                }
                var a = Se && Te && Te.bfinally ? "try" : Se;
                for (;r >= 0; r--) {
                    var i = e[r].try_inline(n, Ee, true, a);
                    if (!i) continue;
                    e[r] = i;
                    t = true;
                }
                return t;
            }
            function p(n, e) {
                if (n.length < 2) return;
                var t = [], r = 0;
                function i() {
                    if (!t.length) return;
                    var e = Ce(t[0], t);
                    n[r++] = ze(ln, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof ln) {
                        if (t.length >= e.sequences_limit) i();
                        T(t, s.body);
                    } else if (F(s)) {
                        n[r++] = s;
                    } else {
                        i();
                        n[r++] = s;
                    }
                }
                i();
                n.length = r;
                return r != o;
            }
            function d(e, n) {
                if (!(e instanceof pn)) return e;
                var t = null;
                for (var r = 0; r < e.body.length; r++) {
                    var i = e.body[r];
                    if (i instanceof er && ce(i)) {
                        n.push(i);
                    } else if (t || I(i)) {
                        return false;
                    } else {
                        t = i;
                    }
                }
                return t;
            }
            function h(e, n) {
                var t = false, r = 0, i;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (i) {
                        if (o instanceof It) {
                            if (o.value || !k(Ae)) {
                                o.value = p(o.value || ze(Nr, o)).optimize(n);
                            }
                        } else if (o instanceof ut) {
                            if (!(o.init instanceof Kt)) {
                                var s = false;
                                i.body.walk(new Nn(function(e) {
                                    if (s || e instanceof dn) return true;
                                    if (e instanceof Tn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = p(o.init); else {
                                        o.init = i.body;
                                        r--;
                                        t = true;
                                    }
                                }
                            }
                        } else if (o instanceof lt) {
                            if (!I(o.init)) o.object = p(o.object);
                        } else if (o instanceof mn) {
                            o.condition = p(o.condition);
                        } else if (o instanceof Bt) {
                            o.expression = p(o.expression);
                        } else if (o instanceof dt) {
                            o.expression = p(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof mn) {
                        var f = [];
                        var u = d(o.body, f);
                        var c = d(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(ze(mn, o, {
                                condition: o.condition,
                                body: u || ze(cn, o.body),
                                alternative: c
                            }));
                            f.unshift(r, 1);
                            [].splice.apply(e, f);
                            a += l;
                            r += l + 1;
                            i = null;
                            t = true;
                            continue;
                        }
                    }
                    e[r++] = o;
                    i = o instanceof ln ? o : null;
                }
                e.length = r;
                return t;
                function p(e) {
                    r--;
                    t = true;
                    var n = i.body;
                    return Ce(n, [ n, e ]);
                }
            }
            function v(e) {
                if (e instanceof Dn) return [ e ];
                if (e instanceof yn) return e.expressions.slice();
            }
            function m(e, n, t) {
                var r = v(n);
                if (!r) return;
                t = t || 0;
                var i = false;
                for (var a = r.length - t; --a >= 0; ) {
                    var o = r[a];
                    if (!c(o)) continue;
                    var s;
                    if (o.left instanceof Mn) {
                        s = r.slice(a + 1);
                    } else if (o.left instanceof wn && c(o.left.expression)) {
                        s = r.slice(a + 1);
                        var f = o.clone();
                        o = o.left.expression;
                        f.left = f.left.clone();
                        f.left.expression = o.left.clone();
                        s.unshift(f);
                    } else {
                        continue;
                    }
                    if (s.length == 0) continue;
                    if (!y(o.left, o.right, s)) continue;
                    i = true;
                    r = r.slice(0, a).concat(o, s);
                }
                if (e instanceof Kt) {
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var u = e.definitions[a];
                        if (!u.value) continue;
                        if (y(u.name, u.value, r)) i = true;
                        if (g(u, r, t)) i = true;
                        break;
                    }
                    if (e instanceof er && b(e.definitions, r, t)) i = true;
                }
                return i && r;
                function c(e) {
                    return e instanceof Dn && e.operator == "=";
                }
            }
            function _(e, n) {
                if (!(e instanceof ln)) return;
                if (ce(n)) return;
                var t = v(e.body);
                if (!t) return;
                var r = [];
                if (!b(r, t.reverse(), 0)) return;
                n.definitions = r.reverse().concat(n.definitions);
                return t.reverse();
            }
            function g(e, n, t) {
                if (!s.option("conditionals")) return;
                if (e.name instanceof $n) return;
                var r = false;
                var i = e.name.definition();
                while (n.length > t) {
                    var a = ie(s, i, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function b(e, n, t) {
                var r = false;
                while (n.length > t) {
                    var i = n[0];
                    if (!(i instanceof Dn)) break;
                    if (i.operator != "=") break;
                    var a = i.left;
                    if (!(a instanceof Mn)) break;
                    if (Fe(a)) break;
                    if (a.scope.resolve() !== Ae) break;
                    var o = a.definition();
                    if (o.scope !== Ae) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = ze(kr, a, a);
                    e.push(ze(_n, i, {
                        name: s,
                        value: i.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function y(e, i, n) {
                var a = new fn();
                a.set(e.name, true);
                while (i instanceof Dn && i.operator == "=") {
                    if (i.left instanceof Mn) a.set(i.left.name, true);
                    i = i.right;
                }
                if (!(i instanceof qn)) return;
                var t = false;
                do {
                    if (!o(n[0])) break;
                    n.shift();
                    t = true;
                } while (n.length);
                return t;
                function o(e) {
                    if (!(e instanceof Dn)) return;
                    if (e.operator != "=") return;
                    if (!(e.left instanceof wn)) return;
                    var n = e.left.expression;
                    if (!(n instanceof Mn)) return;
                    if (!a.has(n.name)) return;
                    if (!e.right.is_constant_expression(Ae)) return;
                    var t = e.left.property;
                    if (t instanceof un) {
                        if (o(t)) t = e.left.property = t.right.clone();
                        t = t.evaluate(s);
                    }
                    if (t instanceof un) return;
                    t = "" + t;
                    var r = t == "__proto__" || s.has_directive("use strict") ? function(e) {
                        var n = e.key;
                        return typeof n == "string" && n != t && n != "__proto__";
                    } : function(e) {
                        var n = e.key;
                        if (e instanceof gr || e instanceof _r) {
                            return typeof n == "string" && n != t;
                        }
                        return n !== "__proto__";
                    };
                    if (!sn(i.properties, r)) return;
                    i.properties.push(ze(vr, e, {
                        key: t,
                        value: e.right
                    }));
                    return true;
                }
            }
            function w(e) {
                var i = false, a;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var r = e[n];
                    var o = e[t];
                    if (r instanceof Kt) {
                        if (o && o.TYPE == r.TYPE) {
                            o.definitions = o.definitions.concat(r.definitions);
                            i = true;
                        } else if (a && a.TYPE == r.TYPE && ce(r)) {
                            a.definitions = a.definitions.concat(r.definitions);
                            i = true;
                        } else if (r instanceof er) {
                            var s = _(o, r);
                            if (s) {
                                if (s.length) {
                                    o.body = Ce(o, s);
                                    t++;
                                }
                                i = true;
                            } else {
                                t++;
                            }
                            e[t] = a = r;
                        } else {
                            e[++t] = r;
                        }
                        continue;
                    } else if (r instanceof It) {
                        r.value = c(r.value);
                    } else if (r instanceof ut) {
                        var s = m(o, r.init);
                        if (s) {
                            i = true;
                            r.init = s.length ? Ce(r.init, s) : null;
                        } else if (o instanceof er && (!r.init || r.init.TYPE == o.TYPE)) {
                            if (r.init) {
                                o.definitions = o.definitions.concat(r.init.definitions);
                            }
                            r = r.clone();
                            a = r.init = o;
                            e[t] = l(r);
                            i = true;
                            continue;
                        } else if (a && r.init && a.TYPE == r.init.TYPE && ce(r.init)) {
                            a.definitions = a.definitions.concat(r.init.definitions);
                            r.init = null;
                            i = true;
                        } else if (r.init instanceof er) {
                            a = r.init;
                            s = _(o, r.init);
                            if (s) {
                                i = true;
                                if (s.length == 0) {
                                    e[t] = l(r);
                                    continue;
                                }
                                o.body = Ce(o, s);
                            }
                        }
                    } else if (r instanceof ct) {
                        if (a && a.TYPE == r.init.TYPE) {
                            var f = a.definitions.slice();
                            r.init = r.init.definitions[0].name.convert_symbol(Mn, function(e, n) {
                                f.push(ze(_n, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            a.definitions = f;
                            i = true;
                        }
                        r.object = c(r.object);
                    } else if (r instanceof mn) {
                        r.condition = c(r.condition);
                    } else if (r instanceof ln) {
                        var s = m(o, r.body), u;
                        if (s) {
                            i = true;
                            if (!s.length) continue;
                            r.body = Ce(r.body, s);
                        } else if (o instanceof Kt && (u = e[n + 1]) && o.TYPE == u.TYPE && (u = u.definitions[0]).value) {
                            i = true;
                            u.value = Ce(r, [ r.body, u.value ]);
                            continue;
                        }
                    } else if (r instanceof Bt) {
                        r.expression = c(r.expression);
                    } else if (r instanceof dt) {
                        r.expression = c(r.expression);
                    }
                    e[++t] = a ? l(r) : r;
                }
                e.length = t + 1;
                return i;
                function c(e) {
                    var n = m(o, e, 1);
                    if (!n) return e;
                    i = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return Ce(e, n);
                }
                function l(e) {
                    return e.transform(new Br(function(e, n, t) {
                        if (e instanceof Kt) {
                            if (a === e) return e;
                            if (a.TYPE != e.TYPE) return e;
                            var r = this.parent();
                            if (r instanceof ct && r.init === e) return e;
                            if (!ce(e)) return e;
                            a.definitions = a.definitions.concat(e.definitions);
                            i = true;
                            if (r instanceof ut && r.init === e) return null;
                            return t ? Un.skip : ze(cn, e);
                        }
                        if (e instanceof nr) return e;
                        if (e instanceof dn) return e;
                        if (!et(e)) return e;
                    }));
                }
            }
        }
        function S(i, a, o) {
            var s;
            var f = false;
            a.walk(new Nn(function(e, n) {
                if (e instanceof Ct) {
                    e.extends = null;
                    e.properties = [];
                    u(e);
                    return true;
                }
                if (e instanceof Kt) {
                    var t = [];
                    if (e.remove_initializers(i, t)) {
                        un.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        u(e);
                    }
                    return true;
                }
                if (e instanceof At) {
                    u(e);
                    return true;
                }
                if (e instanceof dn) return true;
                if (e instanceof nt) {
                    var r = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(ze(pn, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = r;
                    return true;
                }
                if (!(e instanceof Yt)) f = true;
            }));
            if (f) un.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            function u(e) {
                if (s) {
                    s.push(e);
                    if (!A(e)) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function Pe(e, n) {
            return e == null || e.is_undefined || e instanceof Nr || e instanceof Sn && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(un, an);
            e(On, Rn);
            e(Dn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(hn, Rn);
            e(qn, Rn);
            e(Fr, Rn);
            e(yn, function() {
                return this.tail_node().is_truthy();
            });
            e(Mn, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = an;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(un, Rn);
            e(On, an);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof Fn) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                  case "**":
                    return true;

                  default:
                    return false;
                }
            }
            e(Dn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(Tn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(Fn, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(hn, an);
            e(qn, an);
            e(Fr, an);
            e(yn, function() {
                return this.tail_node().is_negative_zero();
            });
            e(Mn, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = Rn;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(Sn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            un.DEFMETHOD("may_throw_on_access", function(e, n) {
                return !e.option("pure_getters") || this._dot_throw(e, n);
            });
            function i(e, n) {
                return n || /strict/.test(e.option("pure_getters"));
            }
            e(un, i);
            e(On, an);
            e(Dn, function(e) {
                var n = this.operator;
                var t = this.left;
                var r = this.right;
                if (n != "=") {
                    return je[n.slice(0, -1)] && (t._dot_throw(e) || r._dot_throw(e));
                }
                if (!r._dot_throw(e)) return false;
                if (!(t instanceof Mn)) return true;
                if (r instanceof Tn && r.operator == "||" && t.name == r.left.name) {
                    return r.right._dot_throw(e);
                }
                return true;
            });
            e(Tn, function(e) {
                return je[this.operator] && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(zt, an);
            e(An, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(Fn, an);
            e(xn, function(e, n) {
                if (!i(e, n)) return false;
                var t = this.expression;
                if (t instanceof Mn) t = t.fixed_value();
                return !(this.property == "prototype" && D(t));
            });
            e(hn, an);
            e(Pr, Rn);
            e(qn, function(n, t) {
                return i(n, t) && !sn(this.properties, function(e) {
                    if (!(e instanceof vr)) return false;
                    return !(e.key === "__proto__" && e.value._dot_throw(n, t));
                });
            });
            e(Or, function(e, n) {
                return i(e, n) && !this.scope.resolve().new;
            });
            e(yn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(Mn, function(e, n) {
                if (this.is_undefined) return true;
                if (!i(e, n)) return false;
                if (Fe(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var t = this.definition();
                if (Oe(t) && !t.scope.rest && sn(t.scope.argnames, function(e) {
                    return e instanceof Cn;
                })) return t.scope.uses_arguments > 2;
                var r = this.fixed_value();
                if (!r) return true;
                this._dot_throw = Rn;
                if (r._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = an;
                return false;
            });
            e(Sn, function() {
                return this.operator == "void";
            });
            e(fr, an);
            e(Nr, Rn);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(un, an);
            e(On, Rn);
            function t(e, n, t) {
                switch (n) {
                  case "&&":
                    return t.left.is_defined(e) && t.right.is_defined(e);

                  case "||":
                    return t.left.is_truthy() || t.right.is_defined(e);

                  case "??":
                    return t.left.is_defined(e) || t.right.is_defined(e);

                  default:
                    return true;
                }
            }
            e(Dn, function(e) {
                var n = this.operator;
                if (n == "=") return this.right.is_defined(e);
                return t(e, n.slice(0, -1), this);
            });
            e(Tn, function(e) {
                return t(e, this.operator, this);
            });
            e(An, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(Fn, Rn);
            e(Ir, an);
            e(hn, Rn);
            e(qn, Rn);
            e(yn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(Mn, function(e) {
                if (this.is_undefined) return false;
                if (Fe(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = an;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(Sn, function() {
                return this.operator != "void";
            });
            e(fr, Rn);
            e(Nr, an);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(un, an);
            e(Dn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = on("in instanceof == != === !== < <= >= >");
            e(Tn, function(e) {
                return n[this.operator] || je[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Yr, Rn);
            var t = on("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(bn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof xn && (t[n.property] || n.property == "test" && n.expression instanceof Fr);
            });
            e(An, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(ar, an);
            e(yn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(Mn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = an;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var r = on("! delete");
            e(Sn, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(un, an);
            var n = on("- * / % ** & | ^ << >> >>>");
            e(Dn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(Tn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = on([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear" ]);
            e(bn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof xn && (t[n.property] || Fe(n.expression) && n.expression.name == "Math");
            });
            e(An, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(ar, an);
            e(jn, Rn);
            e(yn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(Mn, function(e, n) {
                var t = this.fixed_value();
                if (!t) return false;
                if (n && t instanceof Sn && t.operator == "+" && t.expression.equivalent_to(this)) {
                    return false;
                }
                this.is_number = an;
                var r = t.is_number(e);
                delete this.is_number;
                return r;
            });
            var r = on("+ - ~ ++ --");
            e(En, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(un, an);
            e(Dn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(Tn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = on([ "charAt", "substr", "substring", "toExponential", "toFixed", "toLowerCase", "toPrecision", "toString", "toUpperCase", "trim" ]);
            e(bn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof xn && t[n.property];
            });
            e(An, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(yn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(Pn, Rn);
            e(Mn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = an;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Cr, function(e) {
                return !this.tag || Ge(e, this.tag);
            });
            e(Sn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var je = on("&& || ??");
        (function(e) {
            function i(e, n) {
                if (e instanceof un) return e.clone(true);
                if (Array.isArray(e)) return ze(On, n, {
                    elements: e.map(function(e) {
                        return i(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var r in e) if (Jn(e, r)) {
                        t.push(ze(vr, n, {
                            key: r,
                            value: i(e[r], n)
                        }));
                    }
                    return ze(qn, n, {
                        properties: t
                    });
                }
                return fe(e, n);
            }
            function o(e) {
                un.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            ht.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie: a.option("ie")
                });
                return this.transform(new Br(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, r = e, i;
                    while (i = this.parent(t++)) {
                        if (!(i instanceof wn)) break;
                        if (i.expression !== r) break;
                        r = i;
                    }
                    if (Zr(r, i)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(un, Yn);
            e(xn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(zn, function(e) {
                if (!this.definition().global) return;
                if (Jn(e.option("global_defs"), this.name)) o(this);
            });
            e(Mn, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var r = this.name + n;
                if (Jn(t, r)) return i(t[r], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function le(e, n, t) {
            var r = n.print_to_string().length - e.print_to_string().length;
            return r < (t || 0) ? n : e;
        }
        function v(e, n, t) {
            return le(ze(ln, e, {
                body: e
            }), ze(ln, n, {
                body: n
            }), t).body;
        }
        function pe(e, n, t, r) {
            return (Xn(e) ? v : le)(n, t, r);
        }
        function s(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = on(n[e]);
            });
            return t;
        }
        function f(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof Zn)) return t;
            }
        }
        function u() {
            if (this.value) return ze(vn, this.value, {
                value: this.value
            });
            return f(this.body);
        }
        wt.DEFMETHOD("first_statement", u);
        xt.DEFMETHOD("first_statement", u);
        hn.DEFMETHOD("first_statement", function() {
            return f(this.body);
        });
        hn.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof gn) break;
            }
            return n;
        });
        function de(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = fe(t, n).optimize(e);
            return pe(e, n, t, e.eval_threshold);
        }
        var n = [ "constructor", "toString", "valueOf" ];
        var b = s({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(n),
            Boolean: n,
            Function: n,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(n),
            Object: n,
            RegExp: [ "exec", "test" ].concat(n),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(n)
        });
        var y = s({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode", "raw" ]
        });
        function Ue(e) {
            if (!(e instanceof xn)) return false;
            var n = e.expression;
            if (!Fe(n)) return false;
            var t = y[n.name];
            return t && (t[e.property] || n.name == "Math" && e.property == "random");
        }
        (function(e) {
            e(un, an);
            e(Fn, Rn);
            e(Fr, an);
            var n = on("! ~ - + void");
            e(Sn, function() {
                return n[this.operator] && this.expression instanceof Fn;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            un.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var r = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return r;
                if (!r || r instanceof RegExp) return r;
                if (typeof r == "function" || typeof r == "object") return this;
                return r;
            });
            var m = new Nn(function(e) {
                if (e instanceof Dn) u(e.left);
                if (e instanceof En && Gr[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof lr) {
                    e.elements.forEach(u);
                } else if (e instanceof dr) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof wn) {
                    u(e.expression);
                } else if (e instanceof Mn) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(Kn, function() {
                throw new Error(Wn("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(vt, Ln);
            e(Mr, Ln);
            e(zt, Ln);
            e(un, Ln);
            e(Fn, function() {
                return this.value;
            });
            e(Dn, function(e, n, t, r) {
                var i = this.left;
                if (!n) {
                    if (!(i instanceof Mn)) return this;
                    if (!Jn(i, "_eval")) {
                        if (!i.fixed) return this;
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!Jn(i, "_eval") && i instanceof Mn && i.fixed && i.definition().fixed) {
                    s = i;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = ze(Tn, this, {
                        operator: o.slice(0, -1),
                        left: i,
                        right: this.right
                    });
                }
                i.walk(m);
                var f = s._eval(e, n, t, r);
                if (typeof f == "object") return this;
                u(i);
                return f;
            });
            e(yn, function(e, n, t, r) {
                if (!n) return this;
                var i = this.expressions;
                for (var a = 0, o = i.length - 1; a < o; a++) {
                    i[a].walk(m);
                }
                var s = i[o];
                var f = s._eval(e, n, t, r);
                return f === s ? this : f;
            });
            e(hn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(On, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Ir) return this;
                        var s = o._eval(e, n, t, r);
                        if (o === s) return this;
                        i.push(s);
                    }
                    return i;
                }
                return this;
            });
            e(qn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof vr)) return this;
                        var s = o.key;
                        if (s instanceof un) {
                            s = s._eval(e, n, t, r);
                            if (s === o.key) return this;
                        }
                        switch (s) {
                          case "__proto__":
                          case "toString":
                          case "valueOf":
                            return this;
                        }
                        i[s] = o.value._eval(e, n, t, r);
                        if (i[s] === o.value) return this;
                    }
                    return i;
                }
                return this;
            });
            var f = on("! typeof void");
            e(Sn, function(e, n, t, r) {
                var i = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (i instanceof hn || i instanceof Mn && i.fixed_value() instanceof hn)) {
                    return typeof function() {};
                }
                var o = i instanceof Mn && i.definition();
                if (!f[a] && !(o && o.fixed)) r++;
                i.walk(m);
                var s = i._eval(e, n, t, r);
                if (s === i) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== i) return this;
                    }
                    if (Jn(i, "_eval")) s = +(a[0] + 1) + +s;
                    u(i);
                    return s;
                }
                return this;
            });
            e(fr, function(e, n, t, r) {
                var i = this.expression;
                if (!(i instanceof Mn)) {
                    if (!n) return this;
                } else if (!Jn(i, "_eval")) {
                    if (!i.fixed) return this;
                    if (!n) {
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                    }
                }
                if (!(i instanceof Mn && i.definition().fixed)) r++;
                i.walk(m);
                var o = i._eval(e, n, t, r);
                if (o === i) return this;
                u(i);
                return +o;
            });
            var c = on("&& || === !==");
            e(Tn, function(e, n, t, r) {
                if (!c[this.operator]) r++;
                var i = this.left._eval(e, n, t, r);
                if (i === this.left) return this;
                if (this.operator == (i ? "||" : "&&")) return i;
                var a = n && !(i && typeof i == "object");
                var o = this.right._eval(e, a, t, r);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = i && o;
                    break;

                  case "||":
                    s = i || o;
                    break;

                  case "??":
                    s = i == null ? o : i;
                    break;

                  case "|":
                    s = i | o;
                    break;

                  case "&":
                    s = i & o;
                    break;

                  case "^":
                    s = i ^ o;
                    break;

                  case "+":
                    s = i + o;
                    break;

                  case "-":
                    s = i - o;
                    break;

                  case "*":
                    s = i * o;
                    break;

                  case "/":
                    s = i / o;
                    break;

                  case "%":
                    s = i % o;
                    break;

                  case "<<":
                    s = i << o;
                    break;

                  case ">>":
                    s = i >> o;
                    break;

                  case ">>>":
                    s = i >>> o;
                    break;

                  case "==":
                    s = i == o;
                    break;

                  case "===":
                    s = i === o;
                    break;

                  case "!=":
                    s = i != o;
                    break;

                  case "!==":
                    s = i !== o;
                    break;

                  case "<":
                    s = i < o;
                    break;

                  case "<=":
                    s = i <= o;
                    break;

                  case ">":
                    s = i > o;
                    break;

                  case ">=":
                    s = i >= o;
                    break;

                  case "**":
                    s = Math.pow(i, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && Jn(o, i)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(dt) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(i), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e[^e]+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(An, function(e, n, t, r) {
                var i = this.condition._eval(e, n, t, r);
                if (i === this.condition) return this;
                var a = i ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, r);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var r = false;
                    t[0].walk(new Nn(function(e) {
                        if (r) return true;
                        if (e === n) return r = true;
                        if (e instanceof dn) return true;
                    }));
                    return r;

                  default:
                    return e <= t.depth;
                }
            }
            e(Mn, function(e, n, t, r) {
                var i = this.fixed_value();
                if (!i) return this;
                var a;
                if (Jn(i, "_eval")) {
                    a = i._eval();
                } else {
                    this._eval = Ln;
                    a = i._eval(e, n, t, r);
                    delete this._eval;
                    if (a === i) return this;
                    i._eval = function() {
                        return a;
                    };
                    t.push(i);
                }
                return a && typeof a == "object" && !o(this, r) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var l = s({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var p = on("global ignoreCase multiline source");
            e(wn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i;
                    var a = this.expression;
                    if (!Fe(a)) {
                        i = a._eval(e, n, t, r + 1);
                        if (i == null || i === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof un) {
                        o = o._eval(e, n, t, r);
                        if (o === this.property) return this;
                    }
                    if (i === undefined) {
                        var s = l[a.name];
                        if (!s || !s[o]) return this;
                        i = _[a.name];
                    } else if (i instanceof RegExp) {
                        if (!p[o]) return this;
                    } else if (typeof i == "object") {
                        if (!Jn(i, o)) return this;
                    } else if (typeof i == "function") switch (o) {
                      case "name":
                        return i.node.name ? i.node.name.name : "";

                      case "length":
                        return i.node.length();

                      default:
                        return this;
                    }
                    return i[o];
                }
                return this;
            });
            function g(e, n, t, r, i) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, r, i);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(bn, function(r, i, a, o) {
                var e = this.expression;
                var n = e instanceof Mn ? e.fixed_value() : e;
                if (n instanceof wt || n instanceof $t || n instanceof St) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(r)) return this;
                    var s = g(this.args, r, i, a, o);
                    if (!sn(n.argnames, function(e, n) {
                        if (e instanceof gn) {
                            if (!s) return false;
                            if (s[n] === undefined) {
                                var t = e.value._eval(r, i, a, o);
                                if (t === e.value) return false;
                                s[n] = t;
                            }
                            e = e.name;
                        }
                        return !(e instanceof $n);
                    })) return this;
                    if (n.rest instanceof $n) return this;
                    if (!s && !i) return this;
                    var t = n.first_statement();
                    if (!(t instanceof vn)) {
                        if (i) {
                            n.walk(m);
                            var f = false;
                            n.evaluating = true;
                            tt(n, new Nn(function(e) {
                                if (f) return true;
                                if (e instanceof vn) {
                                    if (e.value && e.value._eval(r, true, a, o) !== undefined) {
                                        f = true;
                                    }
                                    return true;
                                }
                                if (e instanceof dn && e !== n) return true;
                            }));
                            n.evaluating = false;
                            if (!f) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!s || sn(n.argnames, function(e, n) {
                        return v(e, s[n]);
                    }) && !(n.rest && !v(n.rest, s.slice(n.argnames.length))) || i) {
                        if (i) n.argnames.forEach(function(e) {
                            if (e instanceof gn) e.value.walk(m);
                        });
                        n.evaluating = true;
                        u = u._eval(r, i, a, o);
                        n.evaluating = false;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (r.option("unsafe") && e instanceof wn) {
                    var l = e.property;
                    if (l instanceof un) {
                        l = l._eval(r, i, a, o);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (Fe(p)) {
                        var d = y[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(r, i, a, o + 1);
                        if (u == null || u === p) return this;
                        var h = b[u.constructor.name];
                        if (!h || !h[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof Fr)) return this;
                    }
                    var s = g(this.args, r, i, a, o);
                    if (!s) return this;
                    if (l == "replace" && typeof s[1] == "function") return this;
                    try {
                        return u[l].apply(u, s);
                    } catch (e) {
                        un.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function v(e, n) {
                    if (e instanceof gn) e = e.name;
                    var t = e.definition();
                    if (t.orig[t.orig.length - 1] !== e) return false;
                    var r = n;
                    t.references.forEach(function(e) {
                        e._eval = function() {
                            return r;
                        };
                        c.push(e);
                    });
                    return true;
                }
            });
            e(ar, Ln);
            e(Cr, function(e, n, t, r) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!Ge(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var i = g(this.expressions, e, n, t, r);
                if (!i) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < i.length; s++) {
                    o += i[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = Ln;
                return this;
                function f(e) {
                    e = Je(e);
                    if (typeof e != "string") a = true;
                    return e;
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return ze(Sn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function i(e, n, t) {
                var r = a(e);
                if (t) {
                    var i = ze(ln, n, {
                        body: n
                    });
                    return le(r, i) === i ? n : r;
                }
                return le(r, n);
            }
            e(un, function() {
                return a(this);
            });
            e(Kn, function() {
                throw new Error("Cannot negate a statement");
            });
            e(Tn, function(e, n) {
                var t = this.clone(), r = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (r) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (r) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return i(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return i(this, t, n);
                }
                return a(this);
            });
            e(Mt, function() {
                return a(this);
            });
            e(An, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return i(this, t, n);
            });
            e(mt, function() {
                return a(this);
            });
            e(yn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return Ce(this, n);
            });
            e(Sn, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var p = on("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        var d = on("Map Set WeakMap WeakSet");
        bn.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (Fe(n)) {
                    if (p[n.name]) return true;
                    if (this instanceof ar && d[n.name]) return true;
                }
                if (Ue(n)) return true;
            }
            return e.option("annotations") && this.pure || !e.pure_funcs(this);
        });
        Cr.DEFMETHOD("is_expr_pure", function(e) {
            var n = this.tag;
            if (!n) return true;
            if (e.option("unsafe")) {
                if (Fe(n) && p[n.name]) return true;
                if (n instanceof xn && Fe(n.expression)) {
                    var t = y[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return !e.pure_funcs(this);
        });
        un.DEFMETHOD("is_call_pure", an);
        bn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof xn)) return false;
            var t = n.expression;
            var r;
            var i = n.property;
            if (t instanceof On) {
                r = b.Array;
            } else if (t.is_boolean(e)) {
                r = b.Boolean;
            } else if (t.is_number(e)) {
                r = b.Number;
            } else if (t instanceof Fr) {
                r = b.RegExp;
            } else if (t.is_string(e)) {
                r = b.String;
                if (i == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                r = b.Object;
            }
            return r && r[i];
        });
        (function(e) {
            e(un, an);
            e(On, Rn);
            e(Dn, function() {
                switch (this.operator) {
                  case "=":
                    return this.right.safe_to_spread();

                  case "&&=":
                  case "||=":
                  case "??=":
                    return this.left.safe_to_spread() && this.right.safe_to_spread();
                }
                return true;
            });
            e(Tn, function() {
                return !je[this.operator] || this.left.safe_to_spread() && this.right.safe_to_spread();
            });
            e(Fn, Rn);
            e(hn, Rn);
            e(qn, function() {
                return sn(this.properties, function(e) {
                    return !(e instanceof gr || e instanceof kn);
                });
            });
            e(Or, Rn);
            e(yn, function() {
                return this.tail_node().safe_to_spread();
            });
            e(Mn, function() {
                var e = this.fixed_value();
                return e && e.safe_to_spread();
            });
            e(En, Rn);
        })(function(e, n) {
            e.DEFMETHOD("safe_to_spread", n);
        });
        (function(e) {
            function t(e, n, t) {
                return !sn(e, t ? function(e) {
                    return e instanceof kn ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function n(e, n) {
                var t = e.expression;
                return !t.is_string(n) || t.has_side_effects(n);
            }
            e(un, Rn);
            e(On, function(e) {
                return t(this.elements, e, n);
            });
            e(Dn, function(e) {
                var n = this.left;
                if (!(n instanceof wn)) return true;
                var t = n.expression;
                return !(t instanceof Or) || !t.scope.resolve().new || n instanceof sr && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Tn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !Ne(this.right);
            });
            e(rt, function(e) {
                return t(this.body, e);
            });
            e(bn, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return t(this.args, e, n);
            });
            e(Wt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(zt, function(e) {
                var n = this.extends;
                if (n) {
                    if (n instanceof Mn) n = n.fixed_value();
                    if (!h(n)) return true;
                }
                return t(this.properties, e);
            });
            e(Ft, function(e) {
                return this.key instanceof un && this.key.has_side_effects(e) || this.static && this.value && this.value.has_side_effects(e);
            });
            e(An, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(Fn, an);
            e(Kt, function(e) {
                return t(this.definitions, e);
            });
            e(lr, function(e) {
                return t(this.elements, e);
            });
            e(pr, function(e) {
                return this.key instanceof un && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(dr, function(e) {
                return t(this.properties, e);
            });
            e(xn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(cn, an);
            e(mn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(it, function(e) {
                return this.body.has_side_effects(e);
            });
            e(hn, an);
            e(qn, function(e) {
                return t(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return !t.safe_to_spread() || t.has_side_effects(n);
                });
            });
            e(Or, an);
            e(hr, function(e) {
                return this.key instanceof un && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(yn, function(e) {
                return t(this.expressions, e);
            });
            e(ln, function(e) {
                return this.body.has_side_effects(e);
            });
            e(sr, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(Bt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(zn, an);
            e(Mn, function(e) {
                return !this.is_declared(e) || !$e(this, e);
            });
            e(Cr, function(e) {
                return !this.is_expr_pure(e) || t(this.expressions, e);
            });
            e(Gt, function(e) {
                return t(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(En, function(e) {
                return Qr[this.operator] || this.expression.has_side_effects(e);
            });
            e(_n, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(un, Rn);
            e(Fn, an);
            e(cn, an);
            e(hn, an);
            e(Or, an);
            e(zn, an);
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            function r(e, n) {
                if (e.may_throw(n)) return true;
                if (e instanceof Mn) e = e.fixed_value();
                if (!(e instanceof hn)) return true;
                if (t(e.argnames, n)) return true;
                if (t(e.body, n)) return true;
                return _t(e) && e.value && e.value.may_throw(n);
            }
            e(On, function(e) {
                return t(this.elements, e);
            });
            e(Dn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof Mn) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(ur, function(e) {
                return this.expression.may_throw(e);
            });
            e(Tn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !Ne(this.right);
            });
            e(rt, function(e) {
                return t(this.body, e);
            });
            e(bn, function(e) {
                if (t(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                this.may_throw = Rn;
                var n = r(this.expression, e);
                delete this.may_throw;
                return n;
            });
            e(Wt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(An, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(gn, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
            e(Kt, function(e) {
                return t(this.definitions, e);
            });
            e(xn, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(ct, function(e) {
                if (this.init.may_throw(e)) return true;
                var n = this.object;
                if (n.may_throw(e)) return true;
                n = n.tail_node();
                if (!(n instanceof On || n.is_string(e))) return true;
                return this.body.may_throw(e);
            });
            e(mn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(it, function(e) {
                return this.body.may_throw(e);
            });
            e(qn, function(e) {
                return t(this.properties, e);
            });
            e(hr, function(e) {
                return this.value.may_throw(e) || this.key instanceof un && this.key.may_throw(e);
            });
            e(vn, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(yn, function(e) {
                return t(this.expressions, e);
            });
            e(ln, function(e) {
                return this.body.may_throw(e);
            });
            e(sr, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(Bt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Mn, function(e) {
                return !this.is_declared(e) || !$e(this, e);
            });
            e(Cr, function(e) {
                if (t(this.expressions, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (!this.tag) return false;
                this.may_throw = Rn;
                var n = r(this.tag, e);
                delete this.may_throw;
                return n;
            });
            e(Gt, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : t(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(En, function(e) {
                return this.expression.may_throw(e) && !(this.operator == "typeof" && this.expression instanceof Mn);
            });
            e(_n, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (!e[t].is_constant_expression(n)) return false;
                return true;
            }
            e(un, an);
            e(On, function(e) {
                return t(this.elements, e);
            });
            e(Tn, function(e) {
                return this.left.is_constant_expression(e) && this.right.is_constant_expression(e) && (this.operator != "in" || Ne(this.right));
            });
            e(zt, function(e) {
                var n = this.extends;
                if (n && !h(n)) return false;
                return t(this.properties, e);
            });
            e(Ft, function(e) {
                return typeof this.key == "string" && (!this.value || this.value.is_constant_expression(e));
            });
            e(Fn, Rn);
            e(hn, function(i) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Nn(function(e, n) {
                    if (!o) return true;
                    if (e instanceof nt) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof Mn) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (In(t.scope, s)) return true;
                        if (i && !t.redefined()) {
                            var r = i.find_variable(e.name);
                            if (r ? r === t : t.undeclared) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof Or) {
                        if (_t(a) && sn(s, function(e) {
                            return !(e instanceof dn) || _t(e);
                        })) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(qn, function(e) {
                return t(this.properties, e);
            });
            e(hr, function(e) {
                return typeof this.key == "string" && this.value.is_constant_expression(e);
            });
            e(En, function(e) {
                return this.expression.is_constant_expression(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function P(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(Kn, Bn);
            e(Nt, Ln);
            function n() {
                var e = this.body.length;
                return e > 0 && P(this.body[e - 1]);
            }
            e(pn, n);
            e(Ut, n);
            e(mn, function() {
                return this.alternative && P(this.body) && P(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var m = on([ "use asm", "use strict" ]);
        e(Zn, function(e, n) {
            if (n.option("directives") && (!m[e.value] || n.has_directive(e.value) !== e)) {
                return ze(cn, e);
            }
            return e;
        });
        e(Qn, function(e, n) {
            if (n.option("drop_debugger")) return ze(cn, e);
            return e;
        });
        e(it, function(e, n) {
            if (n.option("dead_code") && e.body instanceof Rt && n.loopcontrol_target(e.body) === e.body) {
                return ze(cn, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(Yt, function(e, n) {
            if (!n.option("dead_code")) return e;
            var t = e.label;
            if (t) {
                var r = n.loopcontrol_target(e);
                e.label = null;
                if (n.loopcontrol_target(e) === r) {
                    Gn(t.thedef.references, e);
                } else {
                    e.label = t;
                }
            }
            return e;
        });
        e(rt, function(e, n) {
            e.body = c(e.body, n);
            return e;
        });
        function ee(e, n, t) {
            switch (e.body.length) {
              case 0:
                return t ? Un.skip : ze(cn, e);

              case 1:
                var r = e.body[0];
                if (!A(r)) return e;
                if (n instanceof at && r instanceof At) return e;
                return r;
            }
            return e;
        }
        e(pn, function(e, n) {
            e.body = c(e.body, n);
            return ee(e, n.parent());
        });
        function g(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof lr)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = e.rest.rest;
        }
        e(hn, function(e, n) {
            g(e, n);
            e.body = c(e.body, n);
            return e;
        });
        function w(e, n) {
            if (!n.option("arrows")) return e;
            g(e, n);
            var t = c(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var r = t[0];
                if (r instanceof vn) {
                    e.body.length = 0;
                    e.value = r.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(wt, w);
        e(xt, w);
        e(St, function(n, e) {
            g(n, e);
            n.body = c(n.body, e);
            var t = e.parent();
            if (e.option("inline")) for (var r = 0; r < n.body.length; r++) {
                var i = n.body[r];
                if (i instanceof Zn) continue;
                if (i instanceof vn) {
                    if (r != n.body.length - 1) break;
                    var a = i.value;
                    if (!a || a.TYPE != "Call") break;
                    if (a.is_expr_pure(e)) break;
                    var o = a.expression;
                    if (o instanceof Mn) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof $t || o instanceof St)) break;
                    if (o.rest) break;
                    if (o.uses_arguments) break;
                    if (o === a.expression) {
                        if (o.parent_scope !== n) break;
                        if (!sn(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.name && (t instanceof jt || t instanceof mr) && t.value === e.self()) break;
                    if (o.contains_this()) break;
                    var s = o.argnames.length;
                    if (s > 0 && e.option("inline") < 2) break;
                    if (s > n.argnames.length) break;
                    if (!sn(n.argnames, function(e) {
                        return e instanceof Cn;
                    })) break;
                    if (!sn(a.args, function(e) {
                        return !(e instanceof kn);
                    })) break;
                    for (var f = 0; f < s; f++) {
                        var u = a.args[f];
                        if (!(u instanceof Mn)) break;
                        if (u.definition() !== n.argnames[f].definition()) break;
                    }
                    if (f < s) break;
                    for (;f < a.args.length; f++) {
                        if (a.args[f].has_side_effects(e)) break;
                    }
                    if (f < a.args.length) break;
                    if (s < n.argnames.length && !e.drop_fargs(n, t)) {
                        if (!e.drop_fargs(o, a)) break;
                        do {
                            o.argnames.push(o.make_var(Cn, o, "argument_" + s));
                        } while (++s < n.argnames.length);
                    }
                    return a.expression;
                }
                break;
            }
            return n;
        });
        var C = on("arguments await yield");
        dn.DEFMETHOD("merge_variables", function(v) {
            if (!v.option("merge_vars")) return;
            var m, _, g = {}, b = this;
            var o = [], s = [], f = 0;
            var y = new fn();
            var w = Object.create(null);
            var u = Object.create(null);
            var x = new Nn(function(i, e) {
                if (i instanceof Dn) {
                    var n = i.left;
                    var t = i.right;
                    if (n instanceof $n) {
                        t.walk(x);
                        var r = new Nn(function(e) {
                            if (e instanceof $n) return;
                            if (e instanceof gn) {
                                k();
                                e.value.walk(x);
                                E();
                                e.name.walk(r);
                            } else if (e instanceof pr) {
                                if (e.key instanceof un) {
                                    k();
                                    g.block = e;
                                    e.key.walk(x);
                                    e.value.walk(r);
                                    E();
                                } else {
                                    e.value.walk(r);
                                }
                            } else if (e instanceof Mn) {
                                S(e);
                            } else {
                                e.walk(x);
                            }
                            return true;
                        });
                        n.walk(r);
                        return true;
                    }
                    if (je[i.operator.slice(0, -1)]) {
                        n.walk(x);
                        k();
                        t.walk(x);
                        if (n instanceof Mn) S(n);
                        E();
                        return true;
                    }
                    if (n instanceof Mn) {
                        if (i.operator != "=") S(n, true);
                        t.walk(x);
                        S(n);
                        return true;
                    }
                    return;
                }
                if (i instanceof Tn) {
                    if (!je[i.operator]) return;
                    h(i);
                    return true;
                }
                if (i instanceof Rt) {
                    var a = x.loopcontrol_target(i);
                    if (!(a instanceof at)) T(a);
                    return true;
                }
                if (i instanceof bn) {
                    var o = i.expression;
                    var s = o.tail_node();
                    if (!(s instanceof mt)) {
                        e();
                        return d(o);
                    }
                    if (o !== s) o.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(x);
                    });
                    i.args.forEach(function(e) {
                        e.walk(x);
                    });
                    s.walk(x);
                    return true;
                }
                if (i instanceof zt) {
                    if (i.name) i.name.walk(x);
                    if (i.extends) i.extends.walk(x);
                    i.properties.filter(function(e) {
                        if (e.key instanceof un) e.key.walk(x);
                        return e.value;
                    }).forEach(function(e) {
                        if (e.static) {
                            e.value.walk(x);
                        } else {
                            k(x);
                            e.value.walk(x);
                            E(x);
                        }
                    });
                    return true;
                }
                if (i instanceof An) {
                    h(i.condition, i.consequent, i.alternative);
                    return true;
                }
                if (i instanceof Lt) {
                    var a = x.loopcontrol_target(i);
                    if (a instanceof st) T(a);
                    return true;
                }
                if (i instanceof st) {
                    k();
                    g.block = i;
                    g.loop = true;
                    var f = g;
                    i.body.walk(x);
                    if (g.inserted === i) g = f;
                    i.condition.walk(x);
                    E();
                    return true;
                }
                if (i instanceof ut) {
                    if (i.init) i.init.walk(x);
                    k();
                    g.block = i;
                    g.loop = true;
                    if (i.condition) i.condition.walk(x);
                    i.body.walk(x);
                    if (i.step) i.step.walk(x);
                    E();
                    return true;
                }
                if (i instanceof ct) {
                    i.object.walk(x);
                    k();
                    g.block = i;
                    g.loop = true;
                    i.init.walk(x);
                    i.body.walk(x);
                    E();
                    return true;
                }
                if (i instanceof mn) {
                    h(i.condition, i.body, i.alternative);
                    return true;
                }
                if (i instanceof it) {
                    k();
                    g.block = i;
                    var f = g;
                    i.body.walk(x);
                    if (g.inserted === i) g = f;
                    E();
                    return true;
                }
                if (i instanceof dn) {
                    k();
                    g.block = i;
                    if (i === b) _ = g;
                    if (i instanceof hn) {
                        if (i.name) w[i.name.definition().id] = false;
                        var r = i.uses_arguments && !x.has_directive("use strict") ? function(e) {
                            if (e instanceof Cn) w[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof Cn) S(e);
                        };
                        var u = new Nn(function(e) {
                            if (e instanceof zn) w[e.definition().id] = false;
                            if (!(e instanceof Mn)) return;
                            var n = e.definition();
                            var t = i.variables.get(e.name);
                            if (t && (t === n || n.undeclared || i.parent_scope.find_variable(e.name) === n)) {
                                w[n.id] = false;
                                w[t.id] = false;
                            } else {
                                var r = g;
                                E();
                                S(e, true);
                                g = r;
                            }
                            return true;
                        });
                        i.argnames.forEach(function(e) {
                            e.mark_symbol(r, u);
                        });
                        if (i.rest) i.rest.mark_symbol(r, u);
                    }
                    yt(i, x);
                    E();
                    return true;
                }
                if (i instanceof sr) {
                    var o = i.expression;
                    if (i.optional) {
                        o.walk(x);
                        k();
                        i.property.walk(x);
                        E();
                    } else {
                        e();
                    }
                    return d(o);
                }
                if (i instanceof Bt) {
                    i.expression.walk(x);
                    var f = g;
                    i.body.forEach(function(e) {
                        if (e instanceof Vt) return;
                        e.expression.walk(x);
                        if (f === g) k();
                    });
                    g = f;
                    i.body.forEach(function(e) {
                        k();
                        g.block = i;
                        var n = g;
                        tt(e, x);
                        if (g.inserted === i) g = n;
                        E();
                    });
                    return true;
                }
                if (i instanceof yr || i instanceof xr) {
                    w[i.definition().id] = false;
                    return true;
                }
                if (i instanceof Mn) {
                    S(i, true);
                    return true;
                }
                if (i instanceof Gt) {
                    var c = m;
                    m = i;
                    var f = g;
                    tt(i, x);
                    g = f;
                    if (i.bcatch) {
                        if (i.bcatch.argname) i.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof Ar) {
                                var n = e.definition();
                                w[n.id] = false;
                                if (n = n.redefined()) w[n.id] = false;
                            }
                        }, x);
                        if (i.bfinally || (m = c)) {
                            tt(i.bcatch, x);
                        } else {
                            k();
                            tt(i.bcatch, x);
                            E();
                        }
                    }
                    m = c;
                    g = f;
                    if (i.bfinally) i.bfinally.walk(x);
                    return true;
                }
                if (i instanceof En) {
                    if (!Gr[i.operator]) return;
                    var l = i.expression;
                    if (!(l instanceof Mn)) return;
                    S(l, true);
                    return true;
                }
                if (i instanceof _n) {
                    var p = i.value;
                    if (p) {
                        p.walk(x);
                    } else {
                        p = g.block instanceof ct && g.block.init === x.parent();
                    }
                    i.name.mark_symbol(p ? function(e) {
                        if (!(e instanceof zn)) return;
                        if (e instanceof kr) {
                            S(e);
                        } else {
                            w[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof zn)) return;
                        var n = e.definition().id;
                        if (!(e instanceof kr)) {
                            w[n] = false;
                        } else if (!(n in w)) {
                            y.add(n, e);
                        } else if (w[n]) {
                            w[n].push(e);
                        }
                        return true;
                    }, x);
                    return true;
                }
                if (i instanceof ft) {
                    k();
                    g.block = i;
                    g.loop = true;
                    e();
                    E();
                    return true;
                }
                function d(e) {
                    if (v.option("ie")) {
                        var n = or(e);
                        if (n instanceof Mn) n.walk(x);
                    }
                    return true;
                }
                function h(e, n, t) {
                    var r = g;
                    var i = [ r, r ];
                    if (e instanceof Tn) switch (e.operator) {
                      case "&&":
                        i[0] = h(e.left, e.right)[0];
                        break;

                      case "||":
                      case "??":
                        i[1] = h(e.left, null, e.right)[1];
                        break;

                      default:
                        e.walk(x);
                        break;
                    } else if (e instanceof An) {
                        h(e.condition, e.consequent, e.alternative);
                    } else {
                        e.walk(x);
                    }
                    g = i[0];
                    if (n) {
                        k();
                        n.walk(x);
                    }
                    i[0] = g;
                    g = i[1];
                    if (t) {
                        k();
                        t.walk(x);
                    }
                    i[1] = g;
                    g = r;
                    return i;
                }
            });
            x.directives = Object.create(v.directives);
            b.walk(x);
            var e = false;
            var n = Object.create(null);
            while (o.length && s.length) {
                var t = s.shift();
                if (!t) continue;
                var r = t.definition;
                var i = w[r.id];
                if (!i) continue;
                i = {
                    end: i.end
                };
                while (r.id in n) r = n[r.id];
                i.start = w[r.id].start;
                var a = [];
                do {
                    var c = o.shift();
                    if (t.index > c.index) continue;
                    var l = c.definition.id;
                    if (!(l in u)) continue;
                    var p = w[l];
                    if (!p) continue;
                    if (p.start.block !== i.start.block || !h(p, i) || (p.start.loop || !Ie(r)) && !h(i, p) || v.option("webkit") && Kr(r) !== Kr(c.definition) || c.definition.const_redefs || !sn(p, function(e) {
                        return e.scope.find_variable(r.name) === r;
                    })) {
                        a.push(c);
                        continue;
                    }
                    p.forEach(function(e) {
                        e.thedef = r;
                        e.name = r.name;
                        if (e instanceof Mn) {
                            r.references.push(e);
                        } else {
                            r.orig.push(e);
                        }
                    });
                    if (!c.definition.fixed) r.fixed = false;
                    n[l] = r;
                    e = true;
                    break;
                } while (o.length);
                if (a.length) o = a.concat(o);
            }
            return e;
            function k() {
                g = Object.create(g);
            }
            function E() {
                g = Object.getPrototypeOf(g);
            }
            function S(e, n) {
                var t = e.definition(), r, i = g;
                if (m) {
                    k();
                    i = g;
                    E();
                }
                if (t.id in w) {
                    var a = w[t.id];
                    if (!a) return;
                    if (a.start.block !== i.block) return w[t.id] = false;
                    a.push(e);
                    a.end = i;
                    if (t.id in u) {
                        s[u[t.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((r = b.variables.get(t.name)) !== t) {
                    if (r && _ === i) w[r.id] = false;
                    return w[t.id] = false;
                } else if (v.exposed(t) || C[e.name]) {
                    return w[t.id] = false;
                } else {
                    var a = y.get(t.id) || [];
                    a.push(e);
                    w[t.id] = a;
                    if (!n) {
                        a.start = i;
                        return o.push({
                            index: f++,
                            definition: t
                        });
                    }
                    if (i.block !== b) return w[t.id] = false;
                    a.start = _;
                }
                u[t.id] = s.length;
                s.push({
                    index: f++,
                    definition: t
                });
            }
            function T(e) {
                var n = [];
                while (true) {
                    if (Jn(g, "block")) {
                        var t = g.block;
                        if (t instanceof it) t = t.body;
                        if (t === e) break;
                    }
                    n.push(g);
                    E();
                }
                g.inserted = g.block;
                k();
                while (n.length) {
                    var r = n.pop();
                    k();
                    if (Jn(r, "block")) g.block = r.block;
                    if (Jn(r, "loop")) g.loop = r.loop;
                }
            }
            function d(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function h(e, n) {
                return d(e.start, e.end) || d(e.start, n.start);
            }
        });
        function ye(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = ze(Ir, e);
            }
        }
        function ne(e, n) {
            var t = ze(Mt, e, e);
            if (t.name) t.name = n ? null : ze(Tr, t.name, t.name);
            return t;
        }
        function we(e, n) {
            var t;
            switch (e.CTOR) {
              case Dt:
                t = kt;
                break;

              case Ot:
                t = Et;
                break;

              case $t:
                t = St;
                break;

              case qt:
                t = Tt;
                break;
            }
            var r = ze(t, e, e);
            r.name = n ? null : ze(Sr, e.name, e.name);
            return r;
        }
        dn.DEFMETHOD("drop_unused", function(D) {
            if (!D.option("unused")) return;
            var O = this;
            var $ = !(O instanceof ht) || D.toplevel.funcs;
            var q = !(O instanceof ht) || D.toplevel.vars;
            var z = /keep_assign/.test(D.option("unused")) ? an : function(e, n) {
                var t, i = false;
                if (e instanceof Dn) {
                    if (e.write_only || e.operator == "=") t = a(e.left, n);
                } else if (e instanceof En) {
                    if (e.write_only) t = a(e.expression, n);
                }
                if (!(t instanceof Mn)) return;
                var r = t.definition();
                if (o[r.id]) return;
                if (D.exposed(r)) return;
                if (!$e(t, D, i)) return;
                return t;
                function a(e, n) {
                    if (e instanceof wn) {
                        var t = e.expression;
                        if (!t.may_throw_on_access(D, true)) {
                            i = true;
                            if (n && e instanceof sr) n.unshift(e.property);
                            return a(t, n);
                        }
                    } else if (e instanceof Dn && e.operator == "=") {
                        e.write_only = "p";
                        var r = a(e.right);
                        if (!n) return r;
                        n.assign = e;
                        return r instanceof Mn ? r : e.left;
                    }
                    return e;
                }
            };
            var C = Object.create(null);
            var o = Object.create(null);
            var v = function(e) {
                v = a(O, 0, Yn);
                return v(e);
                function a(e, n, r) {
                    var i = D.parent(n);
                    if (!i) return r;
                    var t = i instanceof hn && In(e, i.argnames);
                    return a(i, n + 1, t ? function(e) {
                        var n = r(e);
                        if (n) return n;
                        n = i.variables.get(e);
                        if (n) {
                            var t = n.orig[0];
                            if (t instanceof Cn || t instanceof Sr) return n;
                        }
                    } : i.variables ? function(e) {
                        return r(e) || i.variables.get(e);
                    } : r);
                }
            };
            var M = Object.create(null);
            var m = [];
            var F = Object.create(null);
            var _ = Object.create(null);
            var g = Object.create(null);
            var P = Object.create(null);
            if (O instanceof ht && D.top_retain) {
                O.variables.each(function(e) {
                    if (D.top_retain(e) && !(e.id in F)) {
                        F[e.id] = true;
                        m.push(e);
                    }
                });
            }
            var b = new fn();
            var y = new fn();
            var j = this;
            var w = new Nn(function(s, e) {
                if (s instanceof hn && s.uses_arguments && !w.has_directive("use strict")) {
                    s.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in F)) {
                            F[n.id] = true;
                            m.push(n);
                        }
                    });
                }
                if (s === O) return;
                if (j === O) {
                    if (s instanceof Ct) {
                        var n = s.name.definition();
                        var t = $ && !n.exported;
                        if (!t && !(n.id in F)) {
                            F[n.id] = true;
                            m.push(n);
                        }
                        if (s.extends) s.extends.walk(w);
                        var r = w.parent() instanceof tr;
                        if (r) o[n.id] = true;
                        var i = [];
                        s.properties.forEach(function(e) {
                            if (e.key instanceof un) e.key.walk(w);
                            var n = e.value;
                            if (!n) return;
                            if (e instanceof Pt && e.static) {
                                if (!r && n.contains_this()) r = true;
                                a(n);
                            } else {
                                i.push(n);
                            }
                        });
                        i.forEach(t && r ? a : function(e) {
                            y.add(n.id, e);
                        });
                        return true;
                    }
                    if (s instanceof At) {
                        var n = s.name.definition();
                        if ((!$ || n.exported) && !(n.id in F)) {
                            F[n.id] = true;
                            m.push(n);
                        }
                        y.add(n.id, s);
                        if (w.parent() instanceof tr) {
                            o[n.id] = true;
                        } else {
                            return true;
                        }
                    }
                    if (s instanceof Kt) {
                        s.definitions.forEach(function(r) {
                            var i = r.value;
                            var a = i && (r.name instanceof $n || i.has_side_effects(D));
                            var o = a && i.tail_node().operator == "=";
                            r.name.mark_symbol(function(e) {
                                if (!(e instanceof zn)) return;
                                var n = e.definition();
                                P[n.id] = (P[n.id] || 0) + 1;
                                if (s instanceof er && n.orig[0] instanceof Ar) {
                                    var t = n.redefined();
                                    if (t) P[t.id] = (P[t.id] || 0) + 1;
                                }
                                if (!(n.id in F) && (!q || n.exported || (s instanceof Qt ? n.redefined() : n.const_redefs) || !(s instanceof er || Q(n)))) {
                                    F[n.id] = true;
                                    m.push(n);
                                }
                                if (i) {
                                    if (!a) {
                                        y.add(n.id, i);
                                    } else if (o) {
                                        E(n, e, g[n.id]);
                                    }
                                    b.add(n.id, r);
                                }
                                return true;
                            }, w);
                            if (a) i.walk(w);
                        });
                        return true;
                    }
                    if (s instanceof Cn) {
                        var n = s.definition();
                        P[n.id] = (P[n.id] || 0) + 1;
                        b.add(n.id, s);
                        return true;
                    }
                    if (s instanceof wr) {
                        var n = s.definition();
                        if (!(n.id in F) && (!q || !Q(n))) {
                            F[n.id] = true;
                            m.push(n);
                        }
                        return true;
                    }
                }
                return f(s, e, true);
                function a(e) {
                    var n = j;
                    j = s;
                    e.walk(w);
                    j = n;
                }
            });
            w.directives = Object.create(D.directives);
            O.walk(w);
            var N = D.option("keep_fnames") ? an : D.option("ie") ? function(e) {
                return !D.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in F)) return true;
                if (e.orig.length - e.eliminated < 2) return false;
                if (e.orig[1] instanceof Cn) return true;
                return sn(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            if (D.option("ie")) y.each(function(e, n) {
                if (n in F) return;
                e.forEach(function(e) {
                    e.walk(new Nn(function(e) {
                        if (e instanceof St && e.name && !N(e.name.definition())) {
                            e.walk(w);
                            return true;
                        }
                        if (e instanceof dn) return true;
                    }));
                });
            });
            w = new Nn(f);
            for (var e = 0; e < m.length; e++) {
                var n = y.get(m[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(w);
                });
            }
            Object.keys(C).forEach(function(e) {
                var t = C[e];
                if (!t) {
                    delete C[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        Vn(n, e);
                    });
                    return n;
                }, []);
                var n = (b.get(e) || []).filter(function(n) {
                    return Hn(n instanceof En ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof En) return false;
                        return r(e) === r(n);
                    }, t);
                });
                if (t.length == n.length) {
                    C[e] = n;
                } else {
                    delete C[e];
                }
            });
            var I = [];
            var H = [];
            var Y = [];
            var R = new Br(function(r) {
                if (r instanceof gn) return T(R, r);
                if (r instanceof $n && r.rest) r.rest = r.rest.transform(R);
                if (r instanceof lr) {
                    var e = !r.rest;
                    for (var n = r.elements.length; --n >= 0; ) {
                        var t = r.elements[n].transform(R);
                        if (t) {
                            r.elements[n] = t;
                            e = false;
                        } else if (e) {
                            r.elements.pop();
                        } else {
                            r.elements[n] = ze(Ir, r.elements[n]);
                        }
                    }
                    return r;
                }
                if (r instanceof dr) {
                    var i = [];
                    r.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof un) {
                            e.key = e.key.transform(L);
                            n = e.key.has_side_effects(D);
                        }
                        if ((n || r.rest) && a(e.value)) {
                            e.value = e.value.transform(L);
                            i.push(e);
                        } else {
                            var t = e.value.transform(R);
                            if (!t && r.rest) {
                                if (e.value instanceof lr) {
                                    t = ze(lr, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = ze(dr, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                i.push(e);
                            }
                        }
                    });
                    r.properties = i;
                    return r;
                }
                if (r instanceof zn) return r.definition().id in F ? r : null;
            });
            var L = new Br(function(_, n, e) {
                var g = L.parent();
                if (q) {
                    var t = [], r = z(_, t);
                    if (r) {
                        var i;
                        if (X(r, _)) {
                            if (_ instanceof Dn) {
                                i = K(_);
                                if (_.write_only === true) i = i.drop_side_effect_free(D);
                            }
                            if (!i) i = ze(jn, _, {
                                value: 0
                            });
                        }
                        if (i) {
                            if (t.assign) {
                                var a = t.assign.drop_side_effect_free(D);
                                if (a) {
                                    a.write_only = true;
                                    t.unshift(a);
                                }
                            }
                            if (!(g instanceof yn) || g.tail_node() === _ || i.has_side_effects(D)) {
                                t.push(i);
                            }
                            switch (t.length) {
                              case 0:
                                return Un.skip;

                              case 1:
                                return Me(D, g, _, t[0].transform(L));

                              default:
                                return Ce(_, t.map(function(e) {
                                    return e.transform(L);
                                }));
                            }
                        }
                    } else if (_ instanceof fr && _.expression instanceof Mn && G(_.expression.definition(), _) < 0) {
                        return ze(Sn, _, {
                            operator: "+",
                            expression: _.expression
                        });
                    }
                }
                if (_ instanceof bn) H.push(_);
                if (j !== O) return;
                if ($ && _ !== O && _ instanceof Ct) {
                    var o = _.name.definition();
                    if (!(o.id in F)) {
                        B(_.name, "Dropping unused class {name}");
                        o.eliminated++;
                        n(_, L);
                        var s = ne(_, true);
                        if (g instanceof tr) return s;
                        s = s.drop_side_effect_free(D, true);
                        if (s) return ze(ln, _, {
                            body: s
                        });
                        return e ? Un.skip : ze(cn, _);
                    }
                }
                if (_ instanceof Mt && _.name && N(_.name.definition())) {
                    I.push(_);
                }
                if (_ instanceof hn) {
                    if ($ && _ !== O && _ instanceof At) {
                        var o = _.name.definition();
                        if (!(o.id in F)) {
                            B(_.name, "Dropping unused function {name}");
                            o.eliminated++;
                            if (g instanceof tr) {
                                A();
                                return we(_, true);
                            }
                            return e ? Un.skip : ze(cn, _);
                        }
                    }
                    if (_ instanceof mt && _.name && N(_.name.definition())) {
                        I.push(_);
                    }
                    if (!(_ instanceof vt)) {
                        var f, u, c = D.drop_fargs(_, g);
                        if (c && g instanceof bn && g.expression === _) {
                            f = g.args;
                            for (u = 0; u < f.length; u++) {
                                if (f[u] instanceof kn) break;
                            }
                        }
                        var l = _.argnames;
                        var p = _.rest;
                        if (p) {
                            if (!f || u < l.length || p instanceof Cn) {
                                p = p.transform(R);
                            } else {
                                var s = J(p, ze(On, g, {
                                    elements: f.slice(l.length)
                                }), function(e) {
                                    return e.definition().id in F ? e : null;
                                }, !_.uses_arguments, p);
                                p = s.name;
                                f.length = l.length;
                                if (s.value.elements.length) [].push.apply(f, s.value.elements);
                            }
                            if (p instanceof $n && !p.rest && (!_.uses_arguments || L.has_directive("use strict"))) {
                                if (p instanceof lr) {
                                    if (p.elements.length == 0) p = null;
                                } else if (p.properties.length == 0) {
                                    p = null;
                                }
                            }
                            _.rest = p;
                            if (p) c = false;
                        }
                        var d = c ? -1 : _.length();
                        for (var h = l.length; --h >= 0; ) {
                            var r = l[h];
                            if (r instanceof Cn) {
                                var o = r.definition();
                                if (o.id in F) {
                                    c = false;
                                    if (G(o, r) < 0) r.unused = null;
                                } else if (c) {
                                    B(r, "Dropping unused function argument {name}");
                                    l.pop();
                                } else {
                                    r.unused = true;
                                }
                            } else {
                                var v;
                                if (!f || u < h) {
                                    v = r.transform(R);
                                } else {
                                    v = J(r, f[h], function(e) {
                                        return e.definition().id in F ? e : null;
                                    }, !_.uses_arguments, r).name;
                                }
                                if (v) {
                                    c = false;
                                } else if (c) {
                                    U(r, "Dropping unused default argument {name}");
                                    l.pop();
                                } else if (h > d) {
                                    U(r, "Dropping unused default argument assignment {name}");
                                    if (r.name instanceof Cn) r.name.unused = true;
                                    l[h] = r.name;
                                } else {
                                    U(r, "Dropping unused default argument value {name}");
                                    r.value = ze(jn, r, {
                                        value: 0
                                    });
                                }
                            }
                        }
                        Y.push(_);
                    }
                }
                if (_ instanceof Jt && _.argname instanceof $n) {
                    _.argname.transform(R);
                }
                if (_ instanceof Kt && !(g instanceof ct && g.init === _)) {
                    var b = [], y = [], w = [];
                    var x = [];
                    var k = 0;
                    var E = _ instanceof er;
                    _.definitions.forEach(function(t) {
                        if (t.value) t.value = t.value.transform(L);
                        var e = t.value;
                        if (t.name instanceof $n) {
                            var n = J(t.name, e, function(e) {
                                if (!q) return e;
                                if (e.definition().id in F) return e;
                                if (v(e)) return e;
                                if (E && !$e(e)) return e;
                                return null;
                            }, true);
                            if (n.name) {
                                t = ze(_n, t, {
                                    name: n.name,
                                    value: e = n.value
                                });
                                m();
                            } else if (n.value) {
                                x.push(n.value);
                            }
                            return;
                        }
                        var a = t.name.definition();
                        var r = E ? $e(t.name) : Q(a);
                        if (!r || !q || a.id in F) {
                            var i;
                            if (e && ((i = G(a, t)) < 0 || l(e.tail_node()))) {
                                t = t.clone();
                                e = e.drop_side_effect_free(D);
                                if (e) un.warn("Side effects in definition of variable {name} [{file}:{line},{col}]", V(t.name));
                                if (_ instanceof Qt) {
                                    t.value = e || ze(jn, t, {
                                        value: 0
                                    });
                                } else {
                                    t.value = null;
                                    if (e) x.push(e);
                                }
                                e = null;
                                if (i >= 0) C[a.id][i] = t;
                            }
                            var o, s;
                            if (!e && !(_ instanceof Zt)) {
                                if (g instanceof nr) {
                                    m();
                                } else if (r && P[a.id] > 1) {
                                    un.info("Dropping declaration of variable {name} [{file}:{line},{col}]", V(t.name));
                                    P[a.id]--;
                                    a.eliminated++;
                                } else {
                                    y.push(t);
                                }
                            } else if (D.option("functions") && !D.option("ie") && r && e && P[a.id] == 1 && a.assignments == 0 && (s = e.tail_node()) instanceof mt && !Oe(a) && !_t(s) && p(s, a.references) && d(s) && (o = h(s, t.name.name)) !== false) {
                                un.warn("Declaring {name} as function [{file}:{line},{col}]", V(t.name));
                                var f;
                                switch (s.CTOR) {
                                  case kt:
                                    f = Dt;
                                    break;

                                  case Et:
                                    f = Ot;
                                    break;

                                  case St:
                                    f = $t;
                                    break;

                                  case Tt:
                                    f = qt;
                                    break;
                                }
                                var u = ze(f, t, s);
                                u.name = ze(Er, t.name, t.name);
                                var c = t.name.scope.resolve().def_function(u.name);
                                if (o) o.forEach(function(e) {
                                    e.name = c.name;
                                    e.thedef = c;
                                    e.reference();
                                });
                                b.push(u);
                                if (e !== s) [].push.apply(x, e.expressions.slice(0, -1));
                            } else {
                                if (r && P[a.id] > 1 && !(g instanceof nr) && a.orig.indexOf(t.name) > a.eliminated) {
                                    P[a.id]--;
                                    k++;
                                }
                                m();
                            }
                        } else if (v(t.name)) {
                            e = e && e.drop_side_effect_free(D);
                            if (e) x.push(e);
                            if (P[a.id] > 1) {
                                un.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", V(t.name));
                                P[a.id]--;
                                a.eliminated++;
                            } else {
                                t.value = null;
                                y.push(t);
                            }
                        } else {
                            e = e && e.drop_side_effect_free(D);
                            if (e) {
                                un.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", V(t.name));
                                x.push(e);
                            } else {
                                B(t.name, "Dropping unused variable {name}");
                            }
                            a.eliminated++;
                        }
                        function l(e) {
                            return e instanceof Mn && e.definition() === a;
                        }
                        function p(n, e) {
                            if (e.length == 0) return n === t.name.fixed_value();
                            return sn(e, function(e) {
                                return n === e.fixed_value();
                            });
                        }
                        function d(e) {
                            if (!E || D.has_directive("use strict") || !(e instanceof St)) {
                                return g instanceof dn;
                            }
                            return g instanceof rt || g instanceof ut && g.init === _ || g instanceof mn;
                        }
                        function h(t, r) {
                            if (!t.name) return null;
                            var e = t.name.definition();
                            if (e.orig.length > 1) return null;
                            if (e.assignments > 0) return false;
                            if (e.name == r) return e;
                            var i;
                            switch (r) {
                              case "await":
                                i = gt;
                                break;

                              case "yield":
                                i = bt;
                                break;
                            }
                            return sn(e.references, function(e) {
                                var n = e.scope;
                                if (n.find_variable(r) !== a) return false;
                                if (i) do {
                                    n = n.resolve();
                                    if (i(n)) return false;
                                } while (n !== t && (n = n.parent_scope));
                                return true;
                            }) && e;
                        }
                        function v(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof Ar && n.scope.resolve() === e.scope.resolve();
                        }
                        function m() {
                            if (x.length > 0) {
                                if (w.length == 0) {
                                    b.push(ze(ln, _, {
                                        body: Ce(_, x)
                                    }));
                                } else if (e) {
                                    x.push(e);
                                    t.value = Ce(e, x);
                                } else {
                                    t.value = ze(Sn, t, {
                                        operator: "void",
                                        expression: Ce(t, x)
                                    });
                                }
                                x = [];
                            }
                            w.push(t);
                        }
                    });
                    switch (y.length) {
                      case 0:
                        if (w.length == 0) break;
                        if (w.length == k) {
                            [].unshift.apply(x, w.map(function(e) {
                                un.info("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", V(e.name));
                                var n = e.name.definition();
                                var t = ze(Mn, e.name, e.name);
                                n.references.push(t);
                                var r = ze(Dn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var i = G(n, e);
                                if (i >= 0) C[n.id][i] = r;
                                n.eliminated++;
                                return r;
                            }));
                            break;
                        }

                      case 1:
                        if (w.length == 0) {
                            var m = y[0].name.definition().id;
                            if (m in M) {
                                _.definitions = y;
                                M[m].init = _;
                                break;
                            }
                        }

                      default:
                        var S;
                        if (w.length > 0 && (S = w[0].value) instanceof yn) {
                            w[0].value = S.tail_node();
                            b.push(ze(ln, _, {
                                body: Ce(S, S.expressions.slice(0, -1))
                            }));
                        }
                        _.definitions = y.concat(w);
                        b.push(_);
                    }
                    if (x.length > 0) {
                        b.push(ze(ln, _, {
                            body: Ce(_, x)
                        }));
                    }
                    return W(b, _, e);
                }
                if (_ instanceof Dn) {
                    n(_, L);
                    if (!(_.left instanceof $n)) return _;
                    var s = J(_.left, _.right, function(e) {
                        return e;
                    }, _.write_only === true);
                    if (s.name) return ze(Dn, _, {
                        operator: _.operator,
                        left: s.name,
                        right: s.value
                    });
                    if (s.value) return s.value;
                    if (g instanceof yn && g.tail_node() !== _) return Un.skip;
                    return ze(jn, _, {
                        value: 0
                    });
                }
                if (_ instanceof it && _.body instanceof ut) {
                    n(_, L);
                    if (_.body instanceof pn) {
                        var T = _.body;
                        _.body = T.body.pop();
                        T.body.push(_);
                        return e ? Un.splice(T.body) : T;
                    }
                    return _;
                }
                if (_ instanceof dn) {
                    A();
                    return _;
                }
                if (_ instanceof wr) {
                    if (!D.option("imports") || _.definition().id in F) return _;
                    return e ? Un.skip : null;
                }
                function A() {
                    var e = j;
                    j = _;
                    n(_, L);
                    j = e;
                }
            }, function(e, n) {
                if (e instanceof pn) return ee(e, L.parent(), n);
                if (e instanceof ut) return Be(e, n);
                if (e instanceof lt) {
                    if (!q || !D.option("loops")) return;
                    if (!ue(e.body)) return;
                    var t = S(e);
                    if (!t) return;
                    var r = t.definition();
                    if (r.id in F) return;
                    B(t, "Dropping unused loop variable {name}");
                    if (M[r.id] === e) delete M[r.id];
                    var i = [];
                    var a = e.object.drop_side_effect_free(D);
                    if (a) {
                        un.warn("Side effects in object of for-in loop [{file}:{line},{col}]", a.start);
                        i.push(ze(ln, e, {
                            body: a
                        }));
                    }
                    if (e.init instanceof Kt && r.orig[0] instanceof Ar) {
                        i.push(e.init);
                    }
                    return W(i, e, n);
                }
                if (e instanceof ir) {
                    if (e.properties && e.properties.length == 0) e.properties = null;
                    return e;
                }
                if (e instanceof yn) {
                    if (e.expressions.length > 1) return;
                    return Me(D, L.parent(), e, e.expressions[0]);
                }
            });
            L.push(D.parent());
            O.transform(L);
            if (O instanceof hn && O.body.length == 1 && O.body[0] instanceof Zn && O.body[0].value == "use strict") {
                O.body.length = 0;
            }
            I.forEach(function(e) {
                e.name = null;
            });
            H.forEach(function(e) {
                Ee(e, D, Y);
            });
            function B(e, n) {
                un[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", V(e));
            }
            function U(e, n) {
                if (e.name instanceof Cn) {
                    B(e.name, n);
                } else {
                    un.info(n + " [{file}:{line},{col}]", {
                        name: e,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    });
                }
            }
            function V(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function r(e) {
                return e[e instanceof Dn ? "right" : "value"];
            }
            function W(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? Un.skip : ze(cn, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? Un.splice(e) : ze(pn, n, {
                        body: e
                    });
                }
            }
            function x(e, n) {
                if (e.scope.resolve() !== O) return false;
                if (!e.fixed || !n.fixed) C[e.id] = false;
                return C[e.id] !== false;
            }
            function k(e, n) {
                if (!C[e.id]) C[e.id] = [];
                if (n.fixed.assigns) Vn(C[e.id], n.fixed.assigns);
            }
            function G(e, n) {
                var t = C[e.id];
                return t && t.indexOf(n);
            }
            function E(e, n, t) {
                if (e.id in F) return;
                if (n && t) {
                    F[e.id] = n;
                    m.push(e);
                } else {
                    _[e.id] = n;
                    g[e.id] = t;
                }
            }
            function X(e, n) {
                var t = e.definition();
                var r = F[t.id];
                if (!r) return true;
                if (n[n instanceof Dn ? "left" : "expression"] !== e) return false;
                return r === e && t.references.length - t.replaced == 1 || G(t, n) < 0;
            }
            function K(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof Tn && je[n.operator])) return n;
                if (!(n.left instanceof Mn)) return n;
                if (!(e.left instanceof Mn)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(D)) return n;
                if (x(t, n.left)) k(t, n.left);
                return n.right;
            }
            function S(e) {
                var n = e.init;
                if (n instanceof Kt) {
                    n = n.definitions[0].name;
                    return n instanceof zn && n;
                }
                while (n instanceof wn) n = n.expression.tail_node();
                if (n instanceof Mn) return n;
            }
            function f(e, n, t) {
                if (e instanceof Dn && e.left instanceof Mn) {
                    var r = e.left.definition();
                    if (r.scope.resolve() === O) b.add(r.id, e);
                }
                if (e instanceof En && e.expression instanceof Mn) {
                    var r = e.expression.definition();
                    if (r.scope.resolve() === O) b.add(r.id, e);
                }
                var i, a = [], o = z(e, a);
                if (o && ((i = o.definition()).scope.resolve() === O || O.variables.get(o.name) === i) && !(Oe(i) && !sn(O.argnames, function(e) {
                    return !e.match_symbol(function(e) {
                        if (e instanceof Cn) {
                            var n = e.definition();
                            return n.references.length > n.replaced;
                        }
                    }, true);
                }))) {
                    if (e.write_only === "p" && e.right.may_throw_on_access(D, true)) return;
                    var s = a.assign;
                    if (s) {
                        s.write_only = true;
                        s.walk(w);
                    }
                    a.forEach(function(e) {
                        e.walk(w);
                    });
                    if (e instanceof Dn) {
                        var f = K(e), u = false;
                        if (t && e.write_only === true && !f.has_side_effects(D)) {
                            y.add(i.id, f);
                        } else {
                            f.walk(w);
                            u = f.tail_node().operator == "=";
                        }
                        if (e.left === o) {
                            if (!e.write_only || u) {
                                E(i, o, g[i.id]);
                            }
                        } else {
                            var c = o.fixed_value();
                            if (!c || !c.is_constant()) {
                                E(i, _[i.id], true);
                            }
                        }
                    }
                    if (x(i, o) && Zr(o, e) !== o) k(i, o);
                    return true;
                }
                if (e instanceof lt) {
                    if (e.init instanceof Mn && j === O) {
                        var l = e.init.definition().id;
                        if (!(l in M)) M[l] = e;
                    }
                    if (!q || !D.option("loops")) return;
                    if (!ue(e.body)) return;
                    if (e.init.has_side_effects(D)) return;
                    var o = S(e);
                    if (!o) return;
                    var r = o.definition();
                    if (r.scope.resolve() !== O) {
                        var p = v(o.name);
                        if (p === r || p && p.redefined() === r) return;
                    }
                    e.object.walk(w);
                    return true;
                }
                if (e instanceof Mn) {
                    i = e.definition();
                    if (!(i.id in F)) {
                        F[i.id] = true;
                        m.push(i);
                    }
                    if (Z(i.scope, e.scope)) {
                        var d = i.redefined();
                        if (d && !(d.id in F)) {
                            F[d.id] = true;
                            m.push(d);
                        }
                    }
                    if (x(i, e)) k(i, e);
                    return true;
                }
                if (e instanceof dn) {
                    var h = j;
                    j = e;
                    n();
                    j = h;
                    return true;
                }
            }
            function a(e) {
                return (e instanceof gn ? e.name : e) instanceof zn;
            }
            function T(e, n) {
                n.value = n.value.transform(L);
                var t = n.name.transform(e);
                if (!t) {
                    if (n.name instanceof $n) return null;
                    var r = n.value.drop_side_effect_free(D);
                    if (!r) return null;
                    B(n.name, "Side effects in default value of unused variable {name}");
                    n.name.unused = null;
                    n.value = r;
                }
                return n;
            }
            function J(e, m, _, g, b) {
                var y = new Br(function(a) {
                    if (a instanceof gn) {
                        if (!(D.option("default_values") && m && m.is_defined(D))) {
                            var e = g;
                            g = false;
                            var n = T(y, a);
                            g = e;
                            if (!n && g && m) m = m.drop_side_effect_free(D);
                            return n;
                        } else if (a === b) {
                            b = a = a.name;
                        } else {
                            a = a.name;
                        }
                    }
                    if (a instanceof lr) {
                        var e = g;
                        var t = m;
                        if (m instanceof Mn) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var r = m instanceof On && m.elements;
                        var i = [], o = g && [], s = 0;
                        a.elements.forEach(function(e, n) {
                            m = r && r[n];
                            if (m instanceof Ir) {
                                m = null;
                            } else if (m instanceof kn) {
                                if (g) {
                                    o.length = s;
                                    ye(t, o);
                                    [].push.apply(o, r.slice(n));
                                    t.elements = o;
                                }
                                m = r = false;
                            }
                            e = e.transform(y);
                            if (e) i[s] = e;
                            if (g && m) o[s] = m;
                            if (e || m || !g || !r) s++;
                        });
                        m = r && ze(On, t, {
                            elements: r.slice(a.elements.length)
                        });
                        if (a.rest) {
                            var f = g;
                            g = false;
                            a.rest = a.rest.transform(D.option("rests") ? y : L);
                            g = f;
                            if (a.rest) i.length = s;
                        }
                        if (g) {
                            if (m && !a.rest) m = m.drop_side_effect_free(D);
                            if (m instanceof On) {
                                m = m.elements;
                            } else if (m instanceof yn) {
                                m = m.expressions;
                            } else if (m) {
                                m = [ m ];
                            }
                            if (m && m.length) {
                                o.length = s;
                                [].push.apply(o, m);
                            }
                        }
                        m = t;
                        g = e;
                        if (r && o) {
                            ye(m, o);
                            m.elements = o;
                        }
                        if (!a.rest && (m instanceof On || m && m.is_string(D))) switch (i.length) {
                          case 0:
                            if (a === b) break;
                            if (g) m = m.drop_side_effect_free(D);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var u = i[0];
                            if (u.has_side_effects(D)) break;
                            if (m.has_side_effects(D) && u.match_symbol(function(e) {
                                return e instanceof wn;
                            })) break;
                            m = ze(sr, a, {
                                expression: m,
                                property: ze(jn, a, {
                                    value: 0
                                })
                            });
                            return u;
                        }
                        ye(a, i);
                        a.elements = i;
                        return a;
                    }
                    if (a instanceof dr) {
                        var e = g;
                        var t = m;
                        if (m instanceof Mn) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var c, l;
                        if (m instanceof qn) {
                            c = [];
                            l = new fn();
                            m.properties.forEach(function(e, n) {
                                if (e instanceof kn) return l = false;
                                var t = e.key;
                                if (t instanceof un) t = t.evaluate(D, true);
                                if (t instanceof un) {
                                    l = false;
                                } else if (l && !(e instanceof _r)) {
                                    l.set(t, e);
                                }
                                c[n] = t;
                            });
                        }
                        if (a.rest) {
                            m = false;
                            a.rest = a.rest.transform(D.option("rests") ? y : L);
                        }
                        var p = new fn();
                        var d = g && new fn();
                        var h = [];
                        a.properties.map(function(e) {
                            var n = e.key;
                            if (n instanceof un) {
                                e.key = n = n.transform(L);
                                n = n.evaluate(D, true);
                            }
                            if (n instanceof un) {
                                d = false;
                            } else {
                                p.set(n, !p.has(n));
                            }
                            return n;
                        }).forEach(function(e, n) {
                            var t = a.properties[n], r;
                            if (e instanceof un) {
                                g = false;
                                m = false;
                                r = t.value.transform(y) || x(t.value);
                            } else {
                                g = d && p.get(e);
                                var i = l && l.get(e);
                                if (i) {
                                    m = i.value;
                                    if (m instanceof vt) m = false;
                                } else {
                                    m = false;
                                }
                                r = t.value.transform(y);
                                if (!r) {
                                    if (a.rest || w(t)) r = x(t.value);
                                    if (d && !d.has(e)) {
                                        if (i) {
                                            d.set(e, i);
                                            if (m === null) {
                                                l.set(e, w(i) && ze(vr, i, {
                                                    key: i.key,
                                                    value: ze(jn, i, {
                                                        value: 0
                                                    })
                                                }));
                                            }
                                        } else {
                                            d.set(e, true);
                                        }
                                    }
                                } else if (d) {
                                    d.set(e, false);
                                }
                                if (m) i.value = m;
                            }
                            if (r) {
                                t.value = r;
                                h.push(t);
                            }
                        });
                        m = t;
                        g = e;
                        if (d && c) m.properties = Un(m.properties, function(e, n) {
                            if (e instanceof kn) return e;
                            var t = c[n];
                            if (t instanceof un) return e;
                            if (d.has(t)) {
                                var r = d.get(t);
                                if (!r) return e;
                                if (r === e) return l.get(t) || Un.skip;
                            } else if (a.rest) {
                                return e;
                            }
                            var i = e.value.drop_side_effect_free(D);
                            if (i) {
                                e.value = i;
                                return e;
                            }
                            return w(e) ? ze(vr, e, {
                                key: e.key,
                                value: ze(jn, e, {
                                    value: 0
                                })
                            }) : Un.skip;
                        });
                        if (m && !a.rest) switch (h.length) {
                          case 0:
                            if (a === b) break;
                            if (m.may_throw_on_access(D, true)) break;
                            if (g) m = m.drop_side_effect_free(D);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var v = h[0];
                            if (v.key instanceof un) break;
                            if (v.value.has_side_effects(D)) break;
                            if (m.has_side_effects(D) && v.value.match_symbol(function(e) {
                                return e instanceof wn;
                            })) break;
                            m = ze(sr, a, {
                                expression: m,
                                property: fe(v.key, v)
                            });
                            return v.value;
                        }
                        a.properties = h;
                        return a;
                    }
                    if (a instanceof Ir) {
                        a = null;
                    } else {
                        a = _(a);
                    }
                    if (!a && g && m) m = m.drop_side_effect_free(D);
                    return a;
                });
                return {
                    name: e.transform(y),
                    value: m
                };
                function w(e) {
                    return e.key instanceof un && e.key.has_side_effects(D);
                }
                function n(e) {
                    if (e instanceof Dn) {
                        e.write_only = false;
                        n(e.right);
                    } else if (e instanceof Tn) {
                        if (!je[e.operator]) return;
                        n(e.left);
                        n(e.right);
                    } else if (e instanceof An) {
                        n(e.consequent);
                        n(e.alternative);
                    } else if (e instanceof yn) {
                        n(e.tail_node());
                    } else if (e instanceof En) {
                        e.write_only = false;
                    }
                }
                function x(e) {
                    if (e instanceof gn) return x(e.name);
                    if (e instanceof $n) {
                        if (m === null) {
                            m = ze(jn, e, {
                                value: 0
                            });
                        } else if (m) {
                            if (m.may_throw_on_access(D, true)) {
                                m = ze(On, e, {
                                    elements: m instanceof yn ? m.expressions : [ m ]
                                });
                            } else {
                                n(m);
                            }
                        }
                        return ze(dr, e, {
                            properties: []
                        });
                    }
                    e.unused = null;
                    return e;
                }
            }
        });
        dn.DEFMETHOD("hoist_declarations", function(o) {
            if (o.has_directive("use asm")) return;
            var s = o.option("hoist_funs");
            var f = o.option("hoist_vars");
            var u = this;
            if (f) {
                var n = 0;
                u.walk(new Nn(function(e) {
                    if (n > 1) return true;
                    if (e instanceof nr) return true;
                    if (e instanceof dn && e !== u) return true;
                    if (e instanceof er) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) f = false;
            }
            if (!s && !f) return;
            var c = new fn();
            var l = [];
            var p = [];
            var d = new fn(), h = 0;
            var v = new Br(function(e, n, t) {
                if (e === u) return;
                if (e instanceof Zn) {
                    l.push(e);
                    return t ? Un.skip : ze(cn, e);
                }
                if (e instanceof At) {
                    if (!s) return e;
                    var r = v.parent();
                    if (r instanceof nr) return e;
                    if (r instanceof tr) return e;
                    if (r !== u && o.has_directive("use strict")) return e;
                    p.push(e);
                    return t ? Un.skip : ze(cn, e);
                }
                if (e instanceof er) {
                    if (!f) return e;
                    var r = v.parent();
                    if (r instanceof nr) return e;
                    if (!sn(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof kr && !c.has(n.name) && u.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        d.set(e.name.name, e);
                        ++h;
                    });
                    var i = e.to_assignments();
                    if (r instanceof ct && r.init === e) {
                        if (i) return i;
                        var a = e.definitions[0].name;
                        return ze(Mn, a, a);
                    }
                    if (r instanceof ut && r.init === e) return i;
                    if (!i) return t ? Un.skip : ze(cn, e);
                    return ze(ln, e, {
                        body: i
                    });
                }
                if (e instanceof dn) return e;
                if (e instanceof yr) {
                    c.set(e.name, true);
                    return e;
                }
            });
            u.transform(v);
            if (h > 0) {
                var m = [];
                if (u instanceof hn) u.each_argname(function(e) {
                    d.del(e.name);
                });
                d.each(function(e, n) {
                    e = e.clone();
                    e.name = e.name.clone();
                    e.value = null;
                    m.push(e);
                    d.set(n, e);
                    e.name.definition().orig.unshift(e.name);
                });
                if (m.length > 0) {
                    _(u.body);
                    p.push(ze(er, u, {
                        definitions: m
                    }));
                }
            }
            u.body = l.concat(p, u.body);
            function _(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof ln) {
                        var t = n.body, r, i;
                        if (t instanceof Dn && t.operator == "=" && (r = t.left) instanceof br && d.has(r.name)) {
                            var a = d.get(r.name);
                            if (a.value) break;
                            var o = t.right;
                            if (o instanceof yn) o = o.clone();
                            a.value = o;
                            Gn(m, a);
                            m.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof yn && (i = t.expressions[0]) instanceof Dn && i.operator == "=" && (r = i.left) instanceof br && d.has(r.name)) {
                            var a = d.get(r.name);
                            if (a.value) break;
                            a.value = i.right;
                            Gn(m, a);
                            m.push(a);
                            n.body = Ce(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof cn) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof pn && !_(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function _(n, t) {
            n.walk(new Nn(function(e) {
                if (e instanceof vn) {
                    t(e);
                    return true;
                }
                if (e instanceof dn && e !== n) return true;
            }));
        }
        function M(e) {
            var r = Object.create(null);
            _(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof Mn) {
                    var t = n.definition().id;
                    r[t] = (r[t] || 0) + 1;
                }
            });
            return r;
        }
        function L(e, n, t) {
            if (t.exposed(e)) return false;
            switch (e.references.length - e.replaced - (n[e.id] || 0)) {
              case e.drop_return:
                return "d";

              case e.bool_return:
                return true;
            }
        }
        function B(e, r) {
            _(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = $(r, n);
                    if (!t) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Ce(e.value, [ n, ze(jn, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (!(t instanceof un)) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Ce(e.value, [ n, ze(jn, e.value, {
                            value: 1
                        }) ]) : ze(jn, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        dn.DEFMETHOD("process_returns", Yn);
        $t.DEFMETHOD("process_returns", function(e) {
            if (!e.option("booleans")) return;
            if (e.parent() instanceof tr) return;
            switch (L(this.name.definition(), M(this), e)) {
              case "d":
                U(e, this, true);
                break;

              case true:
                B(this, e);
                break;
            }
        });
        St.DEFMETHOD("process_returns", function(n) {
            if (!n.option("booleans")) return;
            var t = true;
            var r = M(this);
            if (this.name && !c(this.name.definition())) return;
            var e = n.parent();
            if (e instanceof Dn) {
                if (e.operator != "=") return;
                var i = e.left;
                if (!(i instanceof Mn)) return;
                if (!c(i.definition())) return;
            } else if (e instanceof bn && e.expression !== this) {
                var a = e.expression;
                if (a instanceof Mn) a = a.fixed_value();
                if (!(a instanceof hn)) return;
                if (a.uses_arguments || a.pinned()) return;
                var o = e.args, i;
                for (var s = 0; s < o.length; s++) {
                    var f = o[s];
                    if (f === this) {
                        i = a.argnames[s];
                        if (!i && a.rest) return;
                        break;
                    }
                    if (f instanceof kn) return;
                }
                if (i instanceof gn) i = i.name;
                if (i instanceof Cn && !c(i.definition())) return;
            } else if (e.TYPE == "Call") {
                n.pop();
                var u = n.in_boolean_context();
                n.push(this);
                switch (u) {
                  case true:
                    t = false;

                  case "d":
                    break;

                  default:
                    return;
                }
            } else return;
            if (t) {
                U(n, this, true);
            } else {
                B(this, n);
            }
            function c(e) {
                switch (L(e, r, n)) {
                  case true:
                    t = false;

                  case "d":
                    return true;
                }
            }
        });
        nt.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = new fn();
                this.enclosed.forEach(function(e) {
                    t.set(e.name, true);
                });
                this.variables.each(function(e, n) {
                    t.set(n, true);
                });
            }
            return t;
        });
        dn.DEFMETHOD("make_var", function(e, n, t) {
            var r = [ this ];
            if (n instanceof zn) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (In(n, r)) return;
                do {
                    Vn(r, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/^[^a-z_$]|[^a-z0-9_$]/gi, "_");
            var i = t;
            for (var a = 0; !sn(r, function(e) {
                return !e.var_names().has(i);
            }); a++) i = t + "$" + a;
            var o = ze(e, n, {
                name: i,
                scope: this
            });
            var s = this.def_variable(o);
            r.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names().set(i, true);
            });
            return o;
        });
        dn.DEFMETHOD("hoist_properties", function(a) {
            if (!a.option("hoist_props") || a.has_directive("use asm")) return;
            var f = this;
            var o = f instanceof ht && a.top_retain || an;
            var u = Object.create(null);
            f.transform(new Br(function(r, e) {
                if (r instanceof Dn) {
                    if (r.operator != "=") return;
                    if (!r.write_only) return;
                    if (!c(r.left, r.right, 1)) return;
                    e(r, this);
                    var i = new fn();
                    var a = [];
                    var o = [];
                    r.right.properties.forEach(function(e) {
                        var n = s(kr, r.left, e.key);
                        o.push(ze(_n, r, {
                            name: n,
                            value: null
                        }));
                        var t = ze(Mn, r, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference();
                        a.push(ze(Dn, r, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    i.value = r.right;
                    u[r.left.definition().id] = i;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, ze(er, r, {
                        definitions: o
                    }));
                    return Ce(r, a);
                }
                if (r instanceof dn) return r === f ? undefined : r;
                if (r instanceof _n) {
                    if (!c(r.name, r.value, 0)) return;
                    e(r, this);
                    var i = new fn();
                    var n = [];
                    var t = r.clone();
                    t.value = r.name instanceof yr ? ze(jn, r, {
                        value: 0
                    }) : null;
                    n.push(t);
                    r.value.properties.forEach(function(e) {
                        n.push(ze(_n, r, {
                            name: s(r.name.CTOR, r.name, e.key),
                            value: e.value
                        }));
                    });
                    i.value = r.value;
                    u[r.name.definition().id] = i;
                    return Un.splice(n);
                }
                function s(e, n, t) {
                    var r = f.make_var(e, n, n.name + "_" + t);
                    i.set(t, r.definition());
                    return r;
                }
            }));
            f.transform(new Br(function(e, n) {
                if (e instanceof wn) {
                    if (!(e.expression instanceof Mn)) return;
                    var t = u[e.expression.definition().id];
                    if (!t) return;
                    if (e.expression.fixed_value() !== t.value) return;
                    var r = t.get(e.get_property());
                    var i = ze(Mn, e, {
                        name: r.name,
                        scope: e.expression.scope,
                        thedef: r
                    });
                    i.reference();
                    return i;
                }
                if (e instanceof Mn) {
                    var t = u[e.definition().id];
                    if (!t) return;
                    if (e.fixed_value() !== t.value) return;
                    return ze(qn, e, {
                        properties: []
                    });
                }
            }));
            function c(e, n, t) {
                if (!(e instanceof br)) return;
                var r = e.definition();
                if (r.assignments != t) return;
                if (r.references.length - r.replaced == t) return;
                if (r.single_use) return;
                if (o(r)) return;
                if (e.fixed_value() !== n) return;
                var i = e.fixed || r.fixed;
                if (i.direct_access) return;
                if (i.escaped && i.escaped.depth == 1) return;
                return n instanceof qn && n.properties.length > 0 && sn(n.properties, nn) && $e(e, a);
            }
        });
        function xe(e, n) {
            if (!e.name || !n.option("ie")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return sn(t.references, function(e) {
                return !(e instanceof Mn);
            });
        }
        function U(o, n, e) {
            if (!(n instanceof hn)) return;
            var t = _t(n);
            var r = gt(n);
            var s = false;
            var i = false;
            if (t && o.option("arrows")) {
                if (!n.value) {
                    i = true;
                } else if (!r || x(o, n.value)) {
                    var a = n.value.drop_side_effect_free(o);
                    if (a !== n.value) {
                        s = true;
                        n.value = a;
                    }
                }
            } else if (!bt(n)) {
                if (!e && n.name) {
                    var f = n.name.definition();
                    i = f.references.length == f.replaced;
                } else {
                    i = true;
                }
            }
            if (i) {
                n.process_expression(false, function(e) {
                    var n = e.value;
                    if (n) {
                        if (r && !x(o, n)) return e;
                        n = n.drop_side_effect_free(o, true);
                    }
                    s = true;
                    if (!n) return ze(cn, e);
                    return ze(ln, e, {
                        body: n
                    });
                });
                _(n, function(e) {
                    var n = e.value;
                    if (n) {
                        if (r && !x(o, n)) return;
                        var t = n.drop_side_effect_free(o);
                        if (t !== n) {
                            s = true;
                            e.value = t;
                        }
                    }
                });
            }
            if (r && o.option("awaits")) {
                if (i) n.process_expression("awaits", function(e) {
                    var n = e.body;
                    if (n instanceof ur) {
                        if (x(o, n.expression)) {
                            s = true;
                            n = n.expression.drop_side_effect_free(o, true);
                            if (!n) return ze(cn, e);
                            e.body = n;
                        }
                    } else if (n instanceof yn) {
                        var t = n.expressions;
                        for (var r = t.length; --r >= 0; ) {
                            var i = t[r];
                            if (!(i instanceof ur)) break;
                            var a = i.expression;
                            if (!x(o, a)) break;
                            s = true;
                            if (t[r] = a.drop_side_effect_free(o)) break;
                        }
                        switch (r) {
                          case -1:
                            return ze(cn, e);

                          case 0:
                            e.body = t[0];
                            break;

                          default:
                            t.length = r + 1;
                            break;
                        }
                    }
                    return e;
                });
                var u = !i && n.name || t && n.value && !x(o, n.value);
                var c = new Nn(function(e) {
                    if (u) return true;
                    if (c.parent() === n && e.may_throw(o)) return u = true;
                    if (e instanceof ur) return u = true;
                    if (e instanceof pt) return u = true;
                    if (e instanceof vn) {
                        if (e.value && !x(o, e.value)) return u = true;
                        return;
                    }
                    if (e instanceof dn && e !== n) return true;
                });
                n.walk(c);
                if (!u) {
                    var l;
                    switch (n.CTOR) {
                      case xt:
                        l = wt;
                        break;

                      case kt:
                        l = St;
                        break;

                      case Et:
                        l = Tt;
                        break;
                    }
                    return ze(l, n, n);
                }
            }
            return s && n.clone();
        }
        (function(e) {
            function c(e, n, t, r) {
                var i = e.length;
                var a = [], o = false;
                for (var s = 0; s < i; s++) {
                    var f = e[s];
                    var u;
                    if (r && f instanceof kn) {
                        u = r(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return a.length ? o ? a : e : null;
            }
            function l(e, n, t) {
                var r = e.expression;
                if (!r.is_string(n)) return e;
                return r.drop_side_effect_free(n, t);
            }
            function p(e) {
                return e instanceof kn ? ze(On, e, {
                    elements: [ e ]
                }) : e;
            }
            e(un, Ln);
            e(vt, Bn);
            e(On, function(e, n) {
                var t = c(this.elements, e, n, l);
                if (!t) return null;
                if (t === this.elements && sn(t, function(e) {
                    return e instanceof kn;
                })) return this;
                return Ce(this, t.map(p));
            });
            e(Dn, function(e) {
                var n = this.left;
                if (n instanceof wn) {
                    var t = n.expression;
                    if (t.may_throw_on_access(e, true)) return this;
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                if (je[this.operator.slice(0, -1)]) return this;
                this.write_only = true;
                if (!or(n).is_constant_expression(e.find_parent(dn))) return this;
                return this.right.drop_side_effect_free(e);
            });
            e(ur, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression;
                if (!x(e, n)) return this;
                if (n instanceof Sn && n.operator == "!") n = n.expression;
                var t = n.drop_side_effect_free(e);
                if (t === n) return this;
                if (!t) {
                    t = ze(jn, n, {
                        value: 0
                    });
                } else if (!x(e, t)) {
                    t = t.negate(e);
                }
                var r = this.clone();
                r.expression = t;
                return r;
            });
            e(Tn, function(e, n) {
                var t = this.left;
                var r = this.right;
                var i = this.operator;
                if (i == "in" && !Ne(r)) {
                    var a = t.drop_side_effect_free(e, n);
                    if (a === t) return this;
                    var o = this.clone();
                    o.left = a || ze(jn, t, {
                        value: 0
                    });
                    return o;
                }
                var s = r.drop_side_effect_free(e, n);
                if (!s) return t.drop_side_effect_free(e, n);
                if (je[i] && s.has_side_effects(e)) {
                    var o = this;
                    if (s !== r) {
                        o = o.clone();
                        o.right = s.drop_side_effect_free(e);
                    }
                    if (i == "??") return o;
                    var f = o.clone();
                    f.operator = i == "&&" ? "||" : "&&";
                    f.left = t.negate(e, n);
                    if (f.operator == f.right.operator) Ve(f);
                    var u = n ? v : le;
                    return i == "&&" ? u(o, f) : u(f, o);
                }
                var a = t.drop_side_effect_free(e, n);
                if (!a) return s;
                s = s.drop_side_effect_free(e);
                if (!s) return a;
                return Ce(this, [ a, s ]);
            });
            function d(e, n) {
                e.new = true;
                var t = sn(e.body, function(e) {
                    return !e.has_side_effects(n);
                }) && sn(e.argnames, function(e) {
                    return !e.match_symbol(an);
                }) && !(e.rest && e.rest.match_symbol(an));
                e.new = false;
                return t;
            }
            e(bn, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    if (t.pure) un.warn("Dropping __PURE__ call [{file}:{line},{col}]", t.start);
                    var r = c(t.args, e, n, l);
                    return r && Ce(t, r.map(p));
                }
                var i = t.expression;
                if (t.is_call_pure(e)) {
                    var a = t.args.slice();
                    a.unshift(i.expression);
                    a = c(a, e, n, l);
                    return a && Ce(t, a.map(p));
                }
                if (e.option("yields") && bt(i)) {
                    var o = t.clone();
                    o.expression = ze(St, i, i);
                    o.expression.body = [];
                    var s = o.transform(e);
                    if (s !== o) return s.drop_side_effect_free(e, n);
                }
                var f = U(e, i);
                if (f) {
                    t = t.clone();
                    t.expression = f;
                    if (i._squeezed) t.expression._squeezed = true;
                }
                if (t instanceof ar) {
                    var u = i;
                    if (u instanceof Mn) u = u.fixed_value();
                    if (u instanceof hn) {
                        if (d(u, e)) {
                            var a = t.args.slice();
                            a.unshift(i);
                            a = c(a, e, n, l);
                            return a && Ce(t, a.map(p));
                        }
                        if (!u.contains_this()) {
                            t = ze(bn, t, t);
                            t.expression = t.expression.clone();
                            t.args = t.args.slice();
                        }
                    }
                }
                t.call_only = true;
                return t;
            });
            e(Mt, function(e, n) {
                var t = this;
                var r = [], i = [];
                var a = t.properties;
                for (var o = 0; o < a.length; o++) {
                    var s = a[o];
                    if (s.key instanceof un) r.push(s.key);
                    if (s.static && s.value && s instanceof Pt && s.value.has_side_effects(e)) {
                        if (s.value.contains_this()) return t;
                        i.push(s.value);
                    }
                }
                var f = t.extends;
                if (f) {
                    if (f instanceof Mn) f = f.fixed_value();
                    f = !h(f);
                    if (!f) r.unshift(t.extends);
                }
                r = c(r, e, n);
                if (r) n = false;
                i = c(i, e, n);
                if (!r) {
                    if (!f && !i && !t.name) return null;
                    r = [];
                }
                if (f || t.name || !e.has_directive("use strict")) {
                    var u = ne(t);
                    if (!f) u.extends = null;
                    u.properties = [];
                    if (i) {
                        u.properties.push(ze(Pt, t, {
                            static: true,
                            key: r.length ? Ce(t, r) : "c",
                            value: Ce(t, i)
                        }));
                    } else if (r.length) {
                        u.properties.push(ze(jt, t, {
                            key: Ce(t, r),
                            value: ze(St, t, {
                                argnames: [],
                                body: []
                            }).init_vars(u)
                        }));
                    }
                    return u;
                }
                if (i) r.push(ze(bn, t, {
                    expression: ze(wt, t, {
                        argnames: [],
                        body: [],
                        value: Ce(t, i)
                    }).init_vars(t.parent_scope),
                    args: []
                }));
                return Ce(t, r);
            });
            e(An, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var r;
                if (e.option("ie")) {
                    r = [];
                    if (n instanceof St) {
                        r.push(n);
                        n = null;
                    }
                    if (t instanceof St) {
                        r.push(t);
                        t = null;
                    }
                }
                var i;
                if (!n) {
                    i = t ? ze(Tn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    i = ze(Tn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    i = this.clone();
                    i.consequent = n;
                    i.alternative = t;
                }
                if (!r) return i;
                if (i) r.push(i);
                return r.length == 0 ? null : Ce(this, r);
            });
            e(Fn, Bn);
            e(xn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(St, function(e) {
                return xe(this, e) ? null : this;
            });
            e(mt, Bn);
            e(qn, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof kn) {
                        t.push(e);
                    } else {
                        if (e.key instanceof un) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var r = c(t, e, n, function(e, n, t) {
                    var r = e.expression;
                    return r.safe_to_spread() ? r.drop_side_effect_free(n, t) : e;
                });
                if (!r) return null;
                if (r === t && !sn(r, function(e) {
                    return !(e instanceof kn);
                })) return this;
                return Ce(this, r.map(function(e) {
                    return e instanceof kn ? ze(qn, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(Or, Bn);
            e(yn, function(e, n) {
                var t = c(this.expressions, e, n);
                if (!t) return null;
                var r = t.length - 1;
                var i = t[r];
                if (e.option("awaits") && r > 0 && i instanceof ur && i.expression.is_constant()) {
                    t = t.slice(0, -1);
                    r--;
                    var a = t[r];
                    i.expression = x(e, a) ? a : a.negate(e);
                    t[r] = i;
                }
                var o, s, f;
                if (e.option("conditionals") && r > 0 && (o = t[r - 1]) instanceof Dn && o.operator == "=" && (f = o.left) instanceof Mn && (s = ie(e, f.definition(), o.right, i))) {
                    o = o.clone();
                    o.right = s;
                    t = t.slice(0, -2);
                    t.push(o.drop_side_effect_free(e, n));
                }
                return t === this.expressions ? this : Ce(this, t);
            });
            e(sr, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                var r = this.property;
                t = t.drop_side_effect_free(e, n);
                if (!t) return r.drop_side_effect_free(e, n);
                r = r.drop_side_effect_free(e);
                if (!r) return t;
                return Ce(this, [ t, r ]);
            });
            e(Mn, function(e) {
                return this.is_declared(e) && $e(this, e) ? null : this;
            });
            e(Cr, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    var r = t.expressions;
                    if (r.length == 0) return null;
                    return Ce(t, r).drop_side_effect_free(e, n);
                }
                var i = t.tag;
                var a = U(e, i);
                if (a) {
                    t = t.clone();
                    t.tag = a;
                    if (i._squeezed) t.tag._squeezed = true;
                }
                return t;
            });
            e(En, function(e, n) {
                var t = this.expression;
                if (Qr[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof Mn && $e(t, e)) {
                    return null;
                }
                var r = t.drop_side_effect_free(e, n);
                if (n && r && be(r)) {
                    if (r === t && this.operator == "!") return this;
                    return r.negate(e, n);
                }
                return r;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(ln, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var r = t.drop_side_effect_free(n, true);
                if (!r) {
                    un.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return ze(cn, e);
                }
                if (r !== t) {
                    return ze(ln, e, {
                        body: r
                    });
                }
            }
            return e;
        });
        e(ft, function(e, n) {
            return n.option("loops") ? ze(ut, e, e).optimize(n) : e;
        });
        function V(n, e, t) {
            if (!t) t = Yt;
            var r = false;
            var i = new Nn(function(e) {
                if (r || e instanceof dn) return true;
                if (e instanceof t && i.loopcontrol_target(e) === n) {
                    return r = true;
                }
            });
            if (e instanceof it) i.push(e);
            i.push(n);
            n.body.walk(i);
            return r;
        }
        e(st, function(t, e) {
            if (!e.option("loops")) return t;
            var n = $(e, t.condition);
            if (!(n instanceof un)) {
                if (n && !V(t, e.parent(), Lt)) return ze(ut, t, {
                    body: ze(pn, t.body, {
                        body: [ t.body, ze(ln, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!V(t, e.parent())) return ze(pn, t.body, {
                    body: [ t.body, ze(ln, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof pn && !V(t, e.parent(), Lt)) {
                var r = t.body.body;
                for (var i = r.length; --i >= 0; ) {
                    var a = r[i];
                    if (a instanceof mn && !a.alternative && a.body instanceof Rt && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = ze(Tn, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        r.splice(i, 1);
                    } else if (a instanceof ln) {
                        if (o(a.body)) break;
                        t.condition = Ce(t, [ a.body, t.condition ]);
                        r.splice(i, 1);
                    } else if (!F(a, true)) {
                        break;
                    }
                }
                t.body = ee(t.body, e.parent());
            }
            if (t.body instanceof cn) return ze(ut, t, t).optimize(e);
            if (t.body instanceof ln) return ze(ut, t, {
                condition: Ce(t.condition, [ t.body.body, t.condition ]),
                body: ze(cn, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Nn(function(e) {
                    if (n) return true;
                    if (e instanceof Mn) {
                        if (!In(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function W(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof Rt || e instanceof Lt && s(e) || e instanceof It)) {
                var r = [];
                if (et(n.init)) {
                    r.push(n.init);
                } else if (n.init) {
                    r.push(ze(ln, n.init, {
                        body: n.init
                    }));
                }
                var i = s(e) || e instanceof It;
                if (n.condition && i) {
                    r.push(ze(mn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    r.push(ze(ln, n.condition, {
                        body: n.condition
                    }));
                } else if (i) {
                    r.push(e);
                }
                S(t, n.body, r);
                return ze(pn, n, {
                    body: r
                });
            }
            if (e instanceof mn) {
                var a = o(e.body);
                if (a instanceof Rt && !s(a)) {
                    if (n.condition) {
                        n.condition = ze(Tn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var r = H(e.alternative);
                    S(t, e.body, r);
                    return f(r);
                }
                a = o(e.alternative);
                if (a instanceof Rt && !s(a)) {
                    if (n.condition) {
                        n.condition = ze(Tn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var r = H(e.body);
                    S(t, e.alternative, r);
                    return f(r);
                }
            }
            return n;
            function o(e) {
                return e instanceof pn ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof pn) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = ze(pn, n.body, {
                        body: e
                    }).transform(t);
                }
                return W(n, t);
            }
        }
        e(ut, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = $(n, e.condition);
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (et(e.init)) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(ze(ln, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(ze(ln, e.condition, {
                            body: e.condition
                        }));
                        S(n, e.body, r);
                        return ze(pn, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (!(t instanceof un)) {
                    e.body = ze(pn, e.body, {
                        body: [ ze(ln, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return W(e, n);
        });
        e(ct, function(e, t) {
            if (t.option("varify") && I(e.init)) {
                var n = e.init.definitions[0].name;
                if ((n instanceof $n || n instanceof xr) && !n.match_symbol(function(e) {
                    if (e instanceof zn) {
                        var n = e.definition();
                        return !Ie(n) || X(t, n);
                    }
                }, true)) {
                    e.init = K(e.init);
                }
            }
            return e;
        });
        function j(e, n, t) {
            if (e instanceof yn) e = e.tail_node();
            if (!(e instanceof Tn)) return;
            if (!(e.left instanceof Pn)) {
                switch (e.operator) {
                  case "&&":
                    j(e.left, n);
                    j(e.right, n);
                    break;

                  case "||":
                    j(p(e.left), t);
                    j(p(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof Sn)) return;
            if (e.right.operator != "typeof") return;
            var r = e.right.expression;
            if (!Fe(r)) return;
            var i;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                i = a ? t : n;
                break;

              case "!=":
                i = a ? n : t;
                break;

              default:
                return;
            }
            if (!i) return;
            var o = false;
            var s = r.definition();
            var f;
            var u = [];
            var c = [];
            var l = new Nn(function(e, n) {
                if (o) return true;
                if (e instanceof Dn) {
                    var t = e.left;
                    if (!(t instanceof Mn && t.definition() === s)) return;
                    e.right.walk(l);
                    switch (e.operator) {
                      case "=":
                      case "&&=":
                        o = true;
                    }
                    return true;
                }
                if (e instanceof bn) {
                    n();
                    f = e.expression.tail_node();
                    var r;
                    if (f instanceof Mn) {
                        f = f.fixed_value();
                        r = u.length;
                    }
                    if (!(f instanceof hn)) {
                        o = true;
                    } else if (Vn(c, f)) {
                        f.walk(l);
                    }
                    if (r >= 0) u.length = r;
                    return true;
                }
                if (e instanceof ot) {
                    var r = u.length;
                    n();
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof ut) {
                    if (e.init) e.init.walk(l);
                    var r = u.length;
                    if (e.condition) e.condition.walk(l);
                    e.body.walk(l);
                    if (e.step) e.step.walk(l);
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof ct) {
                    e.object.walk(l);
                    var r = u.length;
                    e.init.walk(l);
                    e.body.walk(l);
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof dn) {
                    if (e === f) return;
                    return true;
                }
                if (e instanceof Mn) {
                    if (e.definition() === s) u.push(e);
                    return true;
                }
            });
            i.walk(l);
            u.forEach(function(e) {
                e.defined = true;
            });
            function p(e) {
                if (!(e instanceof Tn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        function $(e, n, t) {
            if (n.truthy) return true;
            if (n.falsy && !t) return false;
            if (n.is_truthy()) return true;
            return n.evaluate(e, true);
        }
        function G(e, n) {
            var t;
            var r = 0;
            var i = false;
            var a = e.self();
            if (!et(a)) while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof Tn) {
                    var o = a.operator;
                    if (!je[o]) return;
                    var s = a.left;
                    if (s === t) continue;
                    if (u(s)) switch (o) {
                      case "&&":
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case "||":
                      case "??":
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof An) {
                    var f = a.condition;
                    if (f === t) continue;
                    if (u(f)) switch (t) {
                      case a.consequent:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof It) {
                    break;
                } else if (a instanceof mn) {
                    break;
                } else if (a instanceof yn) {
                    if (a.expressions[0] === t) continue;
                } else if (a instanceof ln) {
                    break;
                }
                return;
            }
            while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof pn) {
                    if (a.body[0] === t) continue;
                } else if (a instanceof mn) {
                    if (u(a.condition)) switch (t) {
                      case a.body:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                }
                return;
            }
            function u(e) {
                if (n.equivalent_to(e)) return true;
                if (!(e instanceof Sn)) return false;
                if (e.operator != "!") return false;
                if (!n.equivalent_to(e.expression)) return false;
                i = true;
                return true;
            }
        }
        e(mn, function(e, u) {
            if (ue(e.alternative)) e.alternative = null;
            if (!u.option("conditionals")) return e;
            if (u.option("booleans") && !e.condition.has_side_effects(u)) {
                G(u, e.condition);
            }
            if (u.option("dead_code")) {
                var n = $(u, e.condition);
                if (!n) {
                    un.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var t = [ ze(ln, e.condition, {
                        body: e.condition
                    }).transform(u) ];
                    S(u, e.body, t);
                    if (e.alternative) t.push(e.alternative);
                    return ze(pn, e, {
                        body: t
                    }).optimize(u);
                } else if (!(n instanceof un)) {
                    un.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var t = [ ze(ln, e.condition, {
                        body: e.condition
                    }).transform(u), e.body ];
                    if (e.alternative) S(u, e.alternative, t);
                    return ze(pn, e, {
                        body: t
                    }).optimize(u);
                }
            }
            var r = e.condition.negate(u);
            var i = e.condition.print_to_string().length;
            var a = r.print_to_string().length;
            var o = a < i;
            if (e.alternative && o) {
                o = false;
                e.condition = r;
                var s = e.body;
                e.body = e.alternative;
                e.alternative = ue(s) ? null : s;
            }
            var f = [];
            var c = [];
            var l = [];
            var p = y(e.body, f, c, l);
            var d = [];
            var h = [];
            var v = [];
            var m = y(e.alternative, d, h, v);
            if (p instanceof pn || m instanceof pn) {
                var t = [], _ = [];
                if (p) {
                    [].push.apply(t, f);
                    [].push.apply(_, c);
                    if (p instanceof pn) {
                        e.body = p;
                    } else if (p.length == 0) {
                        e.body = ze(cn, e.body);
                    } else {
                        e.body = ze(ln, e.body, {
                            body: Ce(e.body, p)
                        });
                    }
                    l.forEach(N);
                }
                if (m) {
                    [].push.apply(t, d);
                    [].push.apply(_, h);
                    if (m instanceof pn) {
                        e.alternative = m;
                    } else if (m.length == 0) {
                        e.alternative = null;
                    } else {
                        e.alternative = ze(ln, e.alternative, {
                            body: Ce(e.alternative, m)
                        });
                    }
                    v.forEach(N);
                }
                if (_.length > 0) t.push(ze(er, e, {
                    definitions: _
                }));
                if (t.length > 0) {
                    t.push(e);
                    return ze(pn, e, {
                        body: t
                    }).optimize(u);
                }
            } else if (p && m) {
                var t = f.concat(d);
                if (c.length > 0 || h.length > 0) t.push(ze(er, e, {
                    definitions: c.concat(h)
                }));
                if (p.length == 0) {
                    t.push(ze(ln, e.condition, {
                        body: m.length > 0 ? ze(Tn, e, {
                            operator: "||",
                            left: e.condition,
                            right: Ce(e.alternative, m)
                        }).transform(u) : e.condition.clone()
                    }).optimize(u));
                } else if (m.length == 0) {
                    if (i === a && !o && e.condition instanceof Tn && e.condition.operator == "||") {
                        o = true;
                    }
                    t.push(ze(ln, e, {
                        body: ze(Tn, e, {
                            operator: o ? "||" : "&&",
                            left: o ? r : e.condition,
                            right: Ce(e.body, p)
                        }).transform(u)
                    }).optimize(u));
                } else {
                    t.push(ze(ln, e, {
                        body: ze(An, e, {
                            condition: e.condition,
                            consequent: Ce(e.body, p),
                            alternative: Ce(e.alternative, m)
                        })
                    }).optimize(u));
                }
                l.forEach(N);
                v.forEach(N);
                return ze(pn, e, {
                    body: t
                }).optimize(u);
            }
            if (ue(e.body)) e = ze(mn, e, {
                condition: r,
                body: e.alternative,
                alternative: null
            });
            if (e.alternative instanceof It && e.body.TYPE == e.alternative.TYPE) {
                var g = ze(e.body.CTOR, e, {
                    value: ze(An, e, {
                        condition: e.condition,
                        consequent: e.body.value || ze(Nr, e.body).transform(u),
                        alternative: e.alternative.value || ze(Nr, e.alternative).transform(u)
                    })
                });
                if (g instanceof vn) g.in_bool = e.body.in_bool || e.alternative.in_bool;
                return g;
            }
            if (e.body instanceof mn && !e.body.alternative && !e.alternative) {
                e = ze(mn, e, {
                    condition: ze(Tn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (P(e.body) && e.alternative) {
                var b = e.alternative;
                e.alternative = null;
                return ze(pn, e, {
                    body: [ e, b ]
                }).optimize(u);
            }
            if (P(e.alternative)) {
                var t = e.body;
                e.body = e.alternative;
                e.condition = o ? r : e.condition.negate(u);
                e.alternative = null;
                return ze(pn, e, {
                    body: [ e, t ]
                }).optimize(u);
            }
            if (u.option("typeofs")) j(e.condition, e.body, e.alternative);
            return e;
            function y(e, n, t, r) {
                if (e == null) return [];
                if (e instanceof pn) {
                    var i = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof cn) continue;
                        if (o instanceof It) {
                            if (a == 0) return;
                            if (i.length > 0) {
                                o = o.clone();
                                i.push(o.value || ze(Nr, o).transform(u));
                                o.value = Ce(e, i);
                            }
                            var s = e.clone();
                            s.body = s.body.slice(a + 1);
                            s.body.unshift(o);
                            return s;
                        }
                        if (o instanceof At) {
                            n.push(o);
                        } else if (o instanceof ln) {
                            if (!u.option("sequences") && i.length > 0) return;
                            i.push(o.body);
                        } else if (o instanceof er) {
                            if (!u.option("sequences") && i.length > 0) return;
                            o.remove_initializers(u, t);
                            o.definitions.forEach(f);
                        } else {
                            return;
                        }
                    }
                    return i;
                }
                if (e instanceof At) {
                    n.push(e);
                    return [];
                }
                if (e instanceof cn) return [];
                if (e instanceof ln) return [ e.body ];
                if (e instanceof er) {
                    var i = [];
                    e.remove_initializers(u, t);
                    e.definitions.forEach(f);
                    return i;
                }
                function f(e) {
                    if (!e.value) return;
                    i.push(ze(Dn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(Mn, function(e) {
                            r.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(Bt, function(r, t) {
            if (!t.option("switches")) return r;
            if (!t.option("dead_code")) return r;
            var e = [];
            var n;
            var i = [];
            var a;
            var o;
            var s = [];
            for (var f = 0, u = r.body.length; f < u; f++) {
                n = r.body[f];
                if (n instanceof Vt) {
                    var c = e[e.length - 1];
                    if (a || w(n.body[0], t) && (!c || P(c))) {
                        k(n, c);
                        continue;
                    } else {
                        a = n;
                    }
                } else {
                    var l = n.expression;
                    var p = ze(Tn, r, {
                        operator: "===",
                        left: r.expression,
                        right: l
                    }).evaluate(t, true);
                    if (!p) {
                        if (l.has_side_effects(t)) s.push(l);
                        k(n, e[e.length - 1]);
                        continue;
                    }
                    if (!(p instanceof un)) {
                        if (a) {
                            var d = e.indexOf(a);
                            e.splice(d, 1);
                            k(a, e[d - 1]);
                            a = null;
                        }
                        if (l.has_side_effects(t)) {
                            o = n;
                        } else {
                            a = n = ze(Vt, n, n);
                        }
                        while (++f < u) k(r.body[f], n);
                    }
                }
                if (f + 1 >= u || P(n)) {
                    var c = e[e.length - 1];
                    var h = n.body;
                    if (P(c)) switch (c.body.length - h.length) {
                      case 1:
                        var v = c.body[c.body.length - 1];
                        if (!w(v, t)) break;
                        h = h.concat(v);

                      case 0:
                        var m = ze(pn, c, c);
                        var _ = ze(pn, n, {
                            body: h
                        });
                        if (m.equivalent_to(_)) c.body = [];
                    }
                }
                if (s.length) {
                    if (n instanceof Vt) {
                        e.push(ze(Wt, r, {
                            expression: Ce(r, s),
                            body: []
                        }));
                    } else {
                        s.push(n.expression);
                        n.expression = Ce(r, s);
                    }
                    s = [];
                }
                e.push(n);
            }
            if (s.length && !o) {
                e.push(ze(Wt, r, {
                    expression: Ce(r, s),
                    body: []
                }));
            }
            while (n = e[e.length - 1]) {
                var v = n.body[n.body.length - 1];
                if (w(v, t)) n.body.pop();
                if (n === a) {
                    if (!E(n)) break;
                } else if (n.expression.has_side_effects(t)) {
                    break;
                } else if (a) {
                    if (!E(a)) break;
                    if (e[e.length - 2] !== a) break;
                    a.body = a.body.concat(n.body);
                    n.body = [];
                } else if (!E(n)) break;
                k(n);
                if (e.pop() === a) a = null;
            }
            if (!n) {
                i.push(ze(ln, r.expression, {
                    body: r.expression
                }));
                if (s.length) i.push(ze(ln, r, {
                    body: Ce(r, s)
                }));
                return ze(pn, r, {
                    body: i
                }).optimize(t);
            }
            if (n === a) while (n = e[e.length - 2]) {
                if (n instanceof Vt) break;
                if (!E(n)) break;
                var l = n.expression;
                if (l.has_side_effects(t)) {
                    var c = e[e.length - 3];
                    if (c && !P(c)) break;
                    a.body.unshift(ze(ln, r, {
                        body: l
                    }));
                }
                k(n);
                e.splice(-2, 1);
            }
            e[0].body = i.concat(e[0].body);
            r.body = e;
            if (t.option("conditionals")) switch (e.length) {
              case 1:
                if (!x(e[0])) break;
                var l = e[0].expression;
                var h = e[0].body.slice();
                if (e[0] !== a && e[0] !== o) return ze(mn, r, {
                    condition: ze(Tn, r, {
                        operator: "===",
                        left: r.expression,
                        right: l
                    }),
                    body: ze(pn, r, {
                        body: h
                    }),
                    alternative: null
                }).optimize(t);
                if (l) h.unshift(ze(ln, l, {
                    body: l
                }));
                h.unshift(ze(ln, r.expression, {
                    body: r.expression
                }));
                return ze(pn, r, {
                    body: h
                }).optimize(t);

              case 2:
                if (!In(a, e) || !x(e[1])) break;
                var h = e[0].body.slice();
                var g = h.length && w(h[h.length - 1], t);
                if (g) h.pop();
                if (!sn(h, x)) break;
                var b = e[1].body.length && ze(pn, e[1], e[1]);
                var y = ze(mn, r, {
                    condition: ze(Tn, r, e[0] === a ? {
                        operator: "!==",
                        left: r.expression,
                        right: e[1].expression
                    } : {
                        operator: "===",
                        left: r.expression,
                        right: e[0].expression
                    }),
                    body: ze(pn, e[0], {
                        body: h
                    }),
                    alternative: g && b || null
                });
                if (!g && b) y = ze(pn, r, {
                    body: [ y, b ]
                });
                return y.optimize(t);
            }
            return r;
            function w(e, n) {
                return e instanceof Rt && n.loopcontrol_target(e) === r;
            }
            function x(e) {
                var n = false;
                var t = new Nn(function(e) {
                    if (n || e instanceof hn || e instanceof ln) return true;
                    if (w(e, t)) n = true;
                });
                t.push(r);
                e.walk(t);
                return !n;
            }
            function k(e, n) {
                if (n && !P(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    S(t, e, i);
                }
            }
        });
        e(Gt, function(e, n) {
            e.body = c(e.body, n);
            if (n.option("dead_code")) {
                if (E(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof Ar && !$e(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        S(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof er)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(ze(pn, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(ze(pn, e.bfinally, e.bfinally).optimize(n));
                    }
                    return ze(pn, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && E(e.bfinally)) {
                    var t = ze(pn, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return ze(pn, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function J(i) {
            return function(n, t) {
                var r = false;
                this.definitions.forEach(function(e) {
                    if (e.value) r = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof zn) t.push(ze(_n, e, {
                            name: e,
                            value: i(n, e)
                        }));
                    }, true);
                });
                return r;
            };
        }
        Qt.DEFMETHOD("remove_initializers", J(function(e, n) {
            return ze(Nr, n).optimize(e);
        }));
        Zt.DEFMETHOD("remove_initializers", J(Bn));
        er.DEFMETHOD("remove_initializers", J(Bn));
        Kt.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, t) {
                var n = t.name.definition();
                var r = t.value;
                if (r) {
                    if (r instanceof yn) r = r.clone();
                    var i = ze(Mn, t.name, t.name);
                    var a = ze(Dn, t, {
                        operator: "=",
                        left: i,
                        right: r
                    });
                    e.push(a);
                    var o = function() {
                        return a.right;
                    };
                    o.assigns = [ a ];
                    o.direct_access = n.direct_access;
                    o.escaped = n.escaped;
                    i.fixed = o;
                    n.references.forEach(function(e) {
                        var n = e.fixed && e.fixed.assigns;
                        if (n && n[0] === t) n[0] = a;
                    });
                    n.references.push(i);
                }
                n.assignments++;
                n.eliminated++;
                n.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return Ce(this, e);
        });
        function Q(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof Sr ? 3 : 2);
        }
        function X(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var r = n.scope; r !== t; ) {
                r = r.parent_scope;
                if (r.var_names().has(n.name)) return true;
            }
        }
        function K(e) {
            return ze(er, e, {
                definitions: e.definitions.map(function(e) {
                    return ze(_n, e, {
                        name: e.name.convert_symbol(kr, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var r = t.scope.resolve();
                            if (t.scope === r) return;
                            t.scope = r;
                            r.variables.set(t.name, t);
                            r.enclosed.push(t);
                            r.var_names().set(t.name, true);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function te(e, n) {
            if (!n.fixed_value()) return false;
            var t = n.definition();
            return Q(t) && Ie(t) && !X(e, t);
        }
        function re(e, n) {
            return n.option("varify") && sn(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof zn) return !te(n, e);
                }, true);
            }) ? K(e) : e;
        }
        e(Qt, re);
        e(Zt, re);
        function ke(e, n) {
            if (!n.option("optional_chains")) return;
            if (e.terminal) do {
                var t = e.expression;
                if (e.optional) {
                    var r = $(n, t, true);
                    if (r == null) return ze(Sn, e, {
                        operator: "void",
                        expression: t
                    }).optimize(n);
                    if (!(r instanceof un)) e.optional = false;
                }
                e = t;
            } while ((e.TYPE == "Call" || e instanceof wn) && !e.terminal);
        }
        function he(e, n) {
            var t = e.expression;
            if (!(t instanceof yn)) return e;
            var r = t.expressions.slice();
            var i = e.clone();
            i.expression = r.pop();
            r.push(i);
            return Ce(e, r);
        }
        function Ee(e, t, n) {
            var r = e.expression;
            var i = r instanceof Mn ? r.fixed_value() : r;
            if (!(i instanceof hn)) return;
            if (i.uses_arguments) return;
            if (i.pinned()) return;
            if (n && n.indexOf(i) < 0) return;
            var a = e.args;
            if (!sn(a, function(e) {
                return !(e instanceof kn);
            })) return;
            var o = i.argnames;
            var s = i === r && !i.name;
            if (i.rest) {
                if (!(s && t.option("rests"))) return;
                var f = o.length;
                a = a.slice(0, f);
                while (a.length < f) a.push(ze(Nr, e).optimize(t));
                a.push(ze(On, e, {
                    elements: e.args.slice(f)
                }));
                o = o.concat(i.rest);
                i.rest = null;
            } else {
                a = a.slice();
                o = o.slice();
            }
            var u = 0, c = 0;
            var l = s && t.option("default_values");
            var p = s && t.drop_fargs(i, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof lr) {
                    return e.elements.length == 0 && !e.rest && n instanceof On;
                }
                if (e instanceof dr) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.unused;
            } : an;
            var d = [];
            for (var h = 0; h < a.length; h++) {
                var v = o[h];
                if (l && v instanceof gn && a[h].is_defined(t)) {
                    o[h] = v = v.name;
                }
                if (!v || v.unused !== undefined) {
                    var m = a[h].drop_side_effect_free(t);
                    if (p(v)) {
                        if (v) o.splice(h, 1);
                        a.splice(h, 1);
                        if (m) d.push(m);
                        h--;
                        continue;
                    } else if (m) {
                        d.push(m);
                        a[u++] = Ce(e, d);
                        d = [];
                    } else if (v) {
                        if (d.length) {
                            a[u++] = Ce(e, d);
                            d = [];
                        } else {
                            a[u++] = ze(jn, a[h], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (p(v, a[h])) {
                    var m = a[h].drop_side_effect_free(t);
                    o.splice(h, 1);
                    a.splice(h, 1);
                    if (m) d.push(m);
                    h--;
                    continue;
                } else {
                    d.push(a[h]);
                    a[u++] = Ce(e, d);
                    d = [];
                }
                c = u;
            }
            for (;h < o.length; h++) {
                if (p(o[h])) o.splice(h--, 1);
            }
            i.argnames = o;
            a.length = c;
            e.args = a;
            if (!d.length) return;
            var _ = Ce(e, d);
            a.push(a.length < o.length ? ze(Sn, e, {
                operator: "void",
                expression: _
            }) : _);
        }
        function ve(e) {
            var n = [];
            if (gt(e)) n.push("await");
            if (bt(e)) n.push("yield");
            return n.length && on(n);
        }
        function Se(t, r) {
            if (!r) return true;
            var i = true;
            var a = new Nn(function(e) {
                if (!i) return true;
                if (e instanceof dn) {
                    if (e === t) return;
                    if (_t(e)) {
                        for (var n = 0; i && n < e.argnames.length; n++) e.argnames[n].walk(a);
                    } else if (e instanceof At && r[e.name.name]) {
                        i = false;
                    }
                    return true;
                }
                if (e instanceof br && r[e.name] && e !== t.name) i = false;
            });
            t.walk(a);
            return i;
        }
        e(bn, function(p, u) {
            var a = p.expression;
            var P = ke(p, u);
            if (P) return P;
            if (u.option("sequences")) {
                if (a instanceof wn) {
                    var e = he(a, u);
                    if (e !== a) {
                        var j = p.clone();
                        j.expression = e.expressions.pop();
                        e.expressions.push(j);
                        return e.optimize(u);
                    }
                } else if (!ge(u, a.tail_node())) {
                    var e = he(p, u);
                    if (e !== p) return e.optimize(u);
                }
            }
            if (u.option("unused")) Ee(p, u);
            if (u.option("unsafe")) {
                if (Fe(a)) switch (a.name) {
                  case "Array":
                    if (p.args.length == 1) {
                        var n = p.args[0];
                        if (n instanceof jn) try {
                            var t = n.value;
                            if (t > 6) break;
                            var r = Array(t);
                            for (var i = 0; i < t; i++) r[i] = ze(Ir, p);
                            return ze(On, p, {
                                elements: r
                            });
                        } catch (e) {
                            un.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: t,
                                file: p.start.file,
                                line: p.start.line,
                                col: p.start.col
                            });
                            break;
                        }
                        if (!n.is_boolean(u) && !n.is_string(u)) break;
                    }
                    return ze(On, p, {
                        elements: p.args
                    });

                  case "Object":
                    if (p.args.length == 0) return ze(qn, p, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (p.args.length == 0) return ze(Pn, p, {
                        value: ""
                    });
                    if (p.args.length == 1) return ze(Tn, p, {
                        operator: "+",
                        left: ze(Pn, p, {
                            value: ""
                        }),
                        right: p.args[0]
                    }).optimize(u);
                    break;

                  case "Number":
                    if (p.args.length == 0) return ze(jn, p, {
                        value: 0
                    });
                    if (p.args.length == 1) return ze(Sn, p, {
                        operator: "+",
                        expression: ze(Tn, p, {
                            operator: "+",
                            left: ze(Pn, p, {
                                value: ""
                            }),
                            right: p.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "Boolean":
                    if (p.args.length == 0) return ze(Rr, p).optimize(u);
                    if (p.args.length == 1) return ze(Sn, p, {
                        operator: "!",
                        expression: ze(Sn, p, {
                            operator: "!",
                            expression: p.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var N = [];
                    if (sn(p.args, function(e) {
                        var n = e.evaluate(u);
                        N.unshift(n);
                        return e !== n;
                    })) try {
                        return pe(u, p, ze(Fr, p, {
                            value: RegExp.apply(RegExp, N)
                        }));
                    } catch (e) {
                        un.warn("Error converting {expr} [{file}:{line},{col}]", {
                            expr: p,
                            file: p.start.file,
                            line: p.start.line,
                            col: p.start.col
                        });
                    }
                    break;
                } else if (a instanceof xn) switch (a.property) {
                  case "toString":
                    var o = a.expression;
                    if (p.args.length == 0 && !(o.may_throw_on_access(u) || o instanceof $r)) {
                        return ze(Tn, p, {
                            operator: "+",
                            left: ze(Pn, p, {
                                value: ""
                            }),
                            right: o
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (a.expression instanceof On && p.args.length < 2) e: {
                        var s = p.args[0];
                        if (a.expression.elements.length == 0 && !(s instanceof kn)) {
                            return s ? Ce(p, [ s, ze(Pn, p, {
                                value: ""
                            }) ]).optimize(u) : ze(Pn, p, {
                                value: ""
                            });
                        }
                        if (s) {
                            s = s.evaluate(u);
                            if (s instanceof un) break e;
                        }
                        var r = [];
                        var f = [];
                        for (var i = 0; i < a.expression.elements.length; i++) {
                            var c = a.expression.elements[i];
                            var l = c.evaluate(u);
                            if (l !== c) {
                                f.push(l);
                            } else if (c instanceof kn) {
                                break e;
                            } else {
                                if (f.length > 0) {
                                    r.push(ze(Pn, p, {
                                        value: f.join(s)
                                    }));
                                    f.length = 0;
                                }
                                r.push(c);
                            }
                        }
                        if (f.length > 0) r.push(ze(Pn, p, {
                            value: f.join(s)
                        }));
                        if (r.length == 1) {
                            if (r[0].is_string(u)) return r[0];
                            return ze(Tn, r[0], {
                                operator: "+",
                                left: ze(Pn, p, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (s == "") {
                            var n;
                            if (r[0].is_string(u) || r[1].is_string(u)) {
                                n = r.shift();
                            } else {
                                n = ze(Pn, p, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return ze(Tn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, n).optimize(u);
                        }
                        var d = p.clone();
                        d.expression = d.expression.clone();
                        d.expression.expression = d.expression.expression.clone();
                        d.expression.expression.elements = r;
                        return pe(u, p, d);
                    }
                    break;

                  case "charAt":
                    if (p.args.length < 2) {
                        var d = ze(Tn, p, {
                            operator: "||",
                            left: ze(sr, p, {
                                expression: a.expression,
                                property: p.args.length ? ze(Tn, p.args[0], {
                                    operator: "|",
                                    left: ze(jn, p, {
                                        value: 0
                                    }),
                                    right: p.args[0]
                                }) : ze(jn, p, {
                                    value: 0
                                })
                            }).optimize(u),
                            right: ze(Pn, p, {
                                value: ""
                            })
                        });
                        d.is_string = Rn;
                        return d.optimize(u);
                    }
                    break;

                  case "apply":
                    if (p.args.length == 2 && p.args[1] instanceof On) {
                        var h = p.args[1].elements.slice();
                        h.unshift(p.args[0]);
                        return ze(bn, p, {
                            expression: ze(xn, a, {
                                expression: a.expression,
                                property: "call"
                            }),
                            args: h
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var v = a.expression;
                    if (v instanceof Mn) {
                        v = v.fixed_value();
                    }
                    if (v instanceof hn && !v.contains_this()) {
                        return (p.args.length ? Ce(this, [ p.args[0], ze(bn, p, {
                            expression: a.expression,
                            args: p.args.slice(1)
                        }) ]) : ze(bn, p, {
                            expression: a.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && Fe(a) && a.name == "Function") {
                if (p.args.length == 0) return ze(St, p, {
                    argnames: [],
                    body: []
                }).init_vars(a.scope);
                if (sn(p.args, function(e) {
                    return e instanceof Pn;
                })) {
                    try {
                        var m = "n(function(" + p.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + p.args[p.args.length - 1].value + "})";
                        var _ = Xr(m);
                        var g = {
                            ie: u.option("ie")
                        };
                        _.figure_out_scope(g);
                        var I = new ei(u.options);
                        _ = _.transform(I);
                        _.figure_out_scope(g);
                        _.compute_char_frequency(g);
                        _.mangle_names(g);
                        var b;
                        _.walk(new Nn(function(e) {
                            if (b) return true;
                            if (e instanceof hn) {
                                b = e;
                                return true;
                            }
                        }));
                        var m = ni();
                        pn.prototype._codegen.call(b, m);
                        p.args = [ ze(Pn, p, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), ze(Pn, p.args[p.args.length - 1], {
                            value: m.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return p;
                    } catch (e) {
                        if (e instanceof Wr) {
                            un.warn("Error parsing code passed to new Function [{file}:{line},{col}]", p.args[p.args.length - 1].start);
                            un.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = a instanceof Mn ? a.fixed_value() : a;
            var w = u.parent(), x = u.self();
            var k = y instanceof hn && (!gt(y) || u.option("awaits") && w instanceof ur) && (!bt(y) || u.option("yields") && x instanceof cr && x.nested);
            var E = k && y.first_statement();
            var S = 0, T = false;
            var A = !sn(p.args, function(e) {
                return !(e instanceof kn);
            });
            var H = k && sn(y.argnames, function(e, n) {
                if (S == 1 && p.args[n] instanceof kn) S = 2;
                if (e instanceof gn) {
                    if (!S) S = 1;
                    var t = S == 1 && p.args[n];
                    if (!Pe(t)) S = 2;
                    if (me(y, e.value)) return false;
                    e = e.name;
                }
                if (e instanceof $n) {
                    T = true;
                    if (me(y, e)) return false;
                }
                return true;
            }) && !(y.rest instanceof $n && me(y, y.rest));
            var Y = H && u.option("inline") && !p.is_expr_pure(u);
            if (Y && E instanceof vn) {
                var l = E.value;
                if (a === y && !y.name && (!l || l.is_constant_expression()) && Se(y, ve(u.find_parent(dn)))) {
                    return Ce(p, G(l)).optimize(u);
                }
            }
            if (k && !y.contains_this()) {
                var D, l, O = false;
                if (Y && !y.uses_arguments && !y.pinned() && !(y.name && y instanceof mt) && (a === y || !We(u, D = a.definition(), y) && y.is_constant_expression(qe(u))) && (l = K(E))) {
                    var $ = a === y || D.single_use && D.references.length - D.replaced == 1;
                    if (Z()) {
                        var h = p.args.slice();
                        var R = [];
                        var L = l.clone(true).transform(new Br(function(e) {
                            if (e instanceof Mn) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    R.push(e);
                                    return e;
                                }
                                var t = Q(n);
                                var r = h[t];
                                if (!r) return ze(Nr, p);
                                h[t] = null;
                                var i = this.parent();
                                return i ? Me(u, i, e, r) : r;
                            }
                        }));
                        var B = y.inlined;
                        if (a !== y) y.inlined = true;
                        var U = [];
                        h.forEach(function(e) {
                            if (!e) return;
                            e = e.clone(true);
                            e.walk(new Nn(function(e) {
                                if (e instanceof Mn) R.push(e);
                            }));
                            U.push(e);
                        }, []);
                        U.push(L);
                        var d = Ce(p, U).optimize(u);
                        y.inlined = B;
                        d = Me(u, w, x, d);
                        if ($ || le(d, p) === d) {
                            R.forEach(function(e) {
                                e.scope = a === y ? y.parent_scope : a.scope;
                                e.reference();
                                var n = e.definition();
                                if ($) n.replaced++;
                                n.single_use = false;
                            });
                            return d;
                        } else if (!d.has_side_effects(u)) {
                            p.drop_side_effect_free = function(e, n) {
                                var t = this;
                                var r = t.args.slice();
                                r.unshift(t.expression);
                                return Ce(t, r).drop_side_effect_free(e, n);
                            };
                        }
                    }
                    var q, V, z, C;
                    if ($ && re()) {
                        y._squeezed = true;
                        if (a !== y) y.parent_scope = a.scope;
                        var d = Ce(p, se()).optimize(u);
                        return Me(u, w, x, d);
                    }
                }
                if (u.option("side_effects") && H && sn(y.body, ue) && (y === a ? xe(y, u) : !S && !T && !y.rest) && !(_t(y) && y.value) && Se(y, ve(u.find_parent(dn)))) {
                    return Ce(p, G()).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (a instanceof wn) {
                    var M = a.expression;
                    while (M.expression) {
                        M = M.expression;
                    }
                    if (Fe(M) && M.name == "console") {
                        return ze(Nr, p).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && w instanceof ln && be(x)) {
                return p.negate(u, true);
            }
            return de(u, p);
            function W(e) {
                return ze(xn, e, {
                    expression: ze(On, e, {
                        elements: []
                    }),
                    property: "e"
                });
            }
            function G(e) {
                var n = p.args.slice();
                var t = S > 1 || T || y.rest;
                if (t || A) n = [ ze(On, p, {
                    elements: n
                }) ];
                if (t) {
                    var o = new Br(function(r, e) {
                        if (r instanceof gn) return ze(gn, r, {
                            name: r.name.transform(o) || W(r),
                            value: r.value
                        });
                        if (r instanceof lr) {
                            var t = [];
                            r.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            ye(r, t);
                            return ze(lr, r, {
                                elements: t
                            });
                        }
                        if (r instanceof dr) {
                            var i = [], a = [];
                            r.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    if (a.length) {
                                        if (!(n instanceof un)) n = fe(n, e);
                                        a.push(n);
                                        n = Ce(r, a);
                                        a = [];
                                    }
                                    i.push(ze(pr, e, {
                                        key: n,
                                        value: t
                                    }));
                                } else if (n instanceof un) {
                                    a.push(n);
                                }
                            });
                            if (a.length) i.push(ze(pr, r, {
                                key: Ce(r, a),
                                value: W(r)
                            }));
                            return ze(dr, r, {
                                properties: i
                            });
                        }
                        if (r instanceof Cn) return null;
                    });
                    var r = [];
                    y.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) r[n] = e;
                    });
                    var i = y.rest && y.rest.transform(o);
                    if (i) r.length = y.argnames.length;
                    ye(y, r);
                    n[0] = ze(Dn, p, {
                        operator: "=",
                        left: ze(lr, y, {
                            elements: r,
                            rest: i
                        }),
                        right: n[0]
                    });
                } else y.argnames.forEach(function(e) {
                    if (e instanceof gn) n.push(e.value);
                });
                n.push(e || ze(Nr, p));
                return n;
            }
            function J() {
                return p.call_only ? ze(jn, p, {
                    value: 0
                }) : ze(Nr, p);
            }
            function X(e) {
                if (!e) return J();
                if (e instanceof vn) return e.value || J();
                if (e instanceof ln) {
                    return p.call_only ? e.body : ze(Sn, e, {
                        operator: "void",
                        expression: e.body
                    });
                }
            }
            function K(e) {
                var n = y.body.length;
                if (n < 2) {
                    e = X(e);
                    if (e) return e;
                }
                if (u.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var r = y.body[t];
                    if (r instanceof er) {
                        if (O) {
                            if (!e) continue;
                            if (!(e instanceof ln)) return false;
                            if (!ce(r)) e = null;
                        } else if (!ce(r)) {
                            if (e && !(e instanceof ln)) return false;
                            e = null;
                            O = true;
                        }
                    } else if (r instanceof Dt || r instanceof $t || r instanceof cn) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = r;
                    }
                }
                return X(e);
            }
            function Q(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function Z() {
                if (S || T || A || O || y.rest) return;
                if (u.option("inline") < 2 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof Cn;
                })) return;
                var n = u.find_parent(dn);
                var i = false;
                var a = ve(n);
                var o;
                var s = [];
                var f = false;
                l.walk(new Nn(function(e, n) {
                    if (i) return true;
                    if (e instanceof Tn && je[e.operator] || e instanceof An) {
                        s = null;
                        return;
                    }
                    if (e instanceof dn) return i = true;
                    if (a && e instanceof br && a[e.name]) return i = true;
                    if (e instanceof Mn) {
                        var t = e.definition();
                        if (y.variables.get(e.name) !== t) {
                            s = null;
                            return;
                        }
                        if (t.init instanceof At) return i = true;
                        if (Zr(e, this.parent())) return i = true;
                        var r = Q(t);
                        if (!(o < r)) o = r;
                        if (!s) return;
                        if (f) {
                            s = null;
                        } else {
                            s.push(y.argnames[r]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        f = true;
                        return true;
                    }
                }));
                if (i) return;
                var e = p.args.length;
                if (s && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > o && y.argnames[e] === s.pop());
                    e++;
                }
                return e <= o || sn(p.args.slice(o, e), f && !s ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function ee(e, n) {
                return e.has(n) || _e[n] || C.var_names().has(n);
            }
            function ne(n, t) {
                var r = false;
                y.each_argname(function(e) {
                    if (r) return;
                    if (e.unused) return;
                    if (!t || ee(n, e.name)) return r = true;
                    q.set(e.name, true);
                    if (z) z.push(e.definition());
                });
                return !r;
            }
            function te(n, e) {
                for (var t = 0; t < y.body.length; t++) {
                    var r = y.body[t];
                    if (r instanceof At) {
                        var i = r.name;
                        if (!e) return false;
                        if (q.has(i.name)) return false;
                        if (ee(n, i.name)) return false;
                        if (!sn(r.enclosed, function(e) {
                            return e.scope === C || e.scope === r || !n.has(e.name);
                        })) return false;
                        if (z) z.push(i.definition());
                        continue;
                    }
                    if (!(r instanceof er)) continue;
                    if (!e) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var i = r.definitions[a].name;
                        if (ee(n, i.name)) return false;
                        if (z) z.push(i.definition());
                    }
                }
                return true;
            }
            function re() {
                var n = new fn();
                var e = 0, t;
                C = x;
                do {
                    if (C.variables) C.variables.each(function(e) {
                        n.set(e.name, true);
                    });
                    t = C;
                    C = u.parent(e++);
                    if (C instanceof ot) {
                        z = [];
                    } else if (C instanceof ut) {
                        if (C.init === t) continue;
                        z = [];
                    } else if (C instanceof ct) {
                        if (C.init === t) continue;
                        if (C.object === t) continue;
                        z = [];
                    }
                } while (!(C instanceof dn));
                V = C.body.indexOf(t) + 1;
                if (!V) return false;
                if (!Se(y, ve(C))) return false;
                var r = (a !== y || y.parent_scope.resolve() === C) && !C.pinned();
                if (C instanceof ht) {
                    if (u.toplevel.vars) {
                        n.set("arguments", true);
                    } else {
                        r = false;
                    }
                }
                q = new fn();
                var i = u.option("inline");
                if (!ne(n, i >= 2 && r)) return false;
                if (!te(n, i >= 3 && r)) return false;
                return !z || z.length == 0 || !Ke(y, z);
            }
            function F(e, n, t, r) {
                var i = t.definition();
                if (!C.var_names().has(t.name)) {
                    C.var_names().set(t.name, true);
                    e.push(ze(_n, t, {
                        name: t,
                        value: null
                    }));
                }
                C.variables.set(t.name, i);
                C.enclosed.push(i);
                if (!r) return;
                var a = ze(Mn, t, t);
                i.assignments++;
                i.references.push(a);
                n.push(ze(Dn, p, {
                    operator: "=",
                    left: a,
                    right: r
                }));
            }
            function ie(e, n) {
                var t = y.argnames.length;
                for (var r = p.args.length; --r >= t; ) {
                    n.push(p.args[r]);
                }
                var i = [];
                for (r = t; --r >= 0; ) {
                    var a = y.argnames[r];
                    var o;
                    if (a instanceof gn) {
                        i.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = p.args[r];
                    if (o.unused || C.var_names().has(o.name)) {
                        if (s) n.push(s);
                    } else {
                        var f = ze(kr, o, o);
                        var u = o.definition();
                        u.orig.push(f);
                        u.eliminated++;
                        if (o.unused !== undefined) {
                            F(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && z && a === o) s = ze(Nr, p);
                            F(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (r = i.length; --r >= 0; ) {
                    var c = i[r];
                    if (c.name.unused !== undefined) {
                        n.push(c.value);
                    } else {
                        var l = ze(Mn, c.name, c.name);
                        c.name.definition().references.push(l);
                        n.push(ze(Dn, c, {
                            operator: "=",
                            left: l,
                            right: c.value
                        }));
                    }
                }
            }
            function ae(i, a) {
                a.push(ze(Dn, p, {
                    operator: "=",
                    left: ze(lr, p, {
                        elements: y.argnames.map(function(e) {
                            if (e.unused) return ze(Ir, e);
                            return e.convert_symbol(Mn, n);
                        }),
                        rest: y.rest && y.rest.convert_symbol(Mn, n)
                    }),
                    right: ze(On, p, {
                        elements: p.args.slice()
                    })
                }));
                function n(e, n) {
                    var t = n.definition();
                    t.assignments++;
                    t.references.push(e);
                    var r = ze(kr, n, n);
                    t.orig.push(r);
                    t.eliminated++;
                    F(i, a, r);
                }
            }
            function oe(r, e) {
                var t = [ V, 0 ];
                var a = [], i = [], o = [], s = [], f = [];
                y.body.filter(z ? function(e) {
                    if (!(e instanceof At)) return true;
                    var n = ze(kr, e.name, tn(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    F(r, i, n, we(e, true));
                    return false;
                } : function(e) {
                    if (!(e instanceof At)) return true;
                    var n = e.name.definition();
                    C.functions.set(n.name, n);
                    C.variables.set(n.name, n);
                    C.enclosed.push(n);
                    C.var_names().set(n.name, true);
                    t.push(e);
                    return false;
                }).forEach(function(e) {
                    if (!(e instanceof er)) {
                        if (e instanceof ln) f.push(e.body);
                        return;
                    }
                    for (var n = 0; n < e.definitions.length; n++) {
                        var t = e.definitions[n];
                        var r = tn(t.name);
                        var i = t.value;
                        if (i && f.length > 0) {
                            f.push(i);
                            i = Ce(t, f);
                            f = [];
                        }
                        F(a, o, r, i);
                        if (!z) continue;
                        if (q.has(r.name)) continue;
                        if (r.definition().orig.length == 1 && y.functions.has(r.name)) continue;
                        s.push(rn(u, r));
                    }
                });
                [].push.apply(r, a);
                [].push.apply(e, s);
                [].push.apply(e, i);
                [].push.apply(e, o);
                return t;
            }
            function se() {
                var e = [];
                var n = [];
                if (S > 1 || T || A || y.rest) {
                    ae(e, n);
                } else {
                    ie(e, n);
                }
                var t = oe(e, n);
                n.push(l);
                if (e.length) t.push(ze(er, y, {
                    definitions: e
                }));
                [].splice.apply(C.body, t);
                y.enclosed.forEach(function(e) {
                    if (C.var_names().has(e.name)) return;
                    C.enclosed.push(e);
                    C.var_names().set(e.name, true);
                });
                return n;
            }
        });
        e(ar, function(e, n) {
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unused")) Ee(e, n);
            if (n.option("unsafe")) {
                var r = e.expression;
                if (Fe(r)) {
                    switch (r.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return ze(bn, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function ie(t, r, e, n) {
            if (!(n instanceof Tn)) return;
            if (!(n.operator == "&&" || n.operator == "||")) return;
            if (!(n.right instanceof Dn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof Mn)) return;
            if (n.right.left.definition() !== r) return;
            if (e.has_side_effects(t)) return;
            if (!i(n.left)) return;
            if (!i(n.right.right)) return;
            r.replaced++;
            return n.operator == "&&" ? ze(An, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : ze(An, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function i(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Nn(function(e) {
                    if (n) return true;
                    if (e instanceof Mn && e.definition() === r) return n = true;
                }));
                return !n;
            }
        }
        e(yn, function(e, a) {
            var o = n();
            var s = o.length - 1;
            r();
            t();
            if (s == 0) {
                e = Me(a, a.parent(), a.self(), o[0]);
                if (!(e instanceof yn)) e = e.optimize(a);
                return e;
            }
            e.expressions = o;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var r = Xn(a);
                var i = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < i) e = e.drop_side_effect_free(a, r);
                    if (e) {
                        T(t, e);
                        r = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (s > 0 && Pe(o[s], a)) s--;
                if (s < o.length - 1) {
                    o[s] = ze(Sn, e, {
                        operator: "void",
                        expression: o[s]
                    });
                    o.length = s + 1;
                }
            }
            function f(e) {
                return e instanceof Dn && e.operator == "=" && e.left instanceof Mn && e.left.definition();
            }
            function r() {
                for (var e = 1; e < s; e++) {
                    var n = o[e - 1];
                    var t = f(n);
                    if (!t) continue;
                    var r = o[e];
                    if (a.option("conditionals")) {
                        var i = ie(a, t, n.right, r);
                        if (i) {
                            n.right = i;
                            o.splice(e--, 1);
                            s--;
                            continue;
                        }
                    }
                    if (a.option("dead_code") && f(r) === t && r.right.is_constant_expression(t.scope.resolve())) {
                        o[--e] = n.right;
                    }
                }
            }
        });
        e(fr, function(e, n) {
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            return de(n, e);
        });
        var ae = on("+ -");
        var oe = on("* / %");
        e(Sn, function(e, n) {
            var t = e.operator;
            var r = e.expression;
            if (n.option("sequences") && f()) {
                var i = he(e, n);
                if (i !== e) return i.optimize(n);
            }
            switch (t) {
              case "+":
                if (!n.option("evaluate")) break;
                if (!r.is_number(n, true)) break;
                var a = n.parent();
                if (a instanceof Sn && a.operator == "delete") break;
                return r;

              case "-":
                if (r instanceof Hr) r = r.transform(n);
                if (r instanceof jn || r instanceof Hr) return e;
                break;

              case "!":
                if (!n.option("booleans")) break;
                if (r.is_truthy()) return Ce(e, [ r, ze(Rr, e) ]).optimize(n);
                if (n.in_boolean_context()) {
                    if (r instanceof Sn && r.operator == "!") return r.expression;
                    if (r instanceof Tn) {
                        e = pe(n, e, r.negate(n, Xn(n)));
                    }
                }
                break;

              case "delete":
                if (!n.option("evaluate")) break;
                if (s(r)) break;
                return Ce(e, [ r, ze(Lr, e) ]).optimize(n);

              case "typeof":
                if (!n.option("booleans")) break;
                if (!n.in_boolean_context()) break;
                un.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                var o = [ ze(Lr, e) ];
                if (!(r instanceof Mn && $e(r, n))) o.unshift(r);
                return Ce(e, o).optimize(n);

              case "void":
                if (!n.option("side_effects")) break;
                r = r.drop_side_effect_free(n);
                if (!r) return ze(Nr, e).optimize(n);
                e.expression = r;
                return e;
            }
            if (n.option("evaluate") && r instanceof Tn && ae[t] && oe[r.operator] && (r.left.is_constant() || !r.right.has_side_effects(n))) {
                return ze(Tn, e, {
                    operator: r.operator,
                    left: ze(Sn, r.left, {
                        operator: t,
                        expression: r.left
                    }),
                    right: r.right
                });
            }
            return de(n, e);
            function s(e) {
                return e instanceof Hr || e instanceof jr || e instanceof zr || e instanceof wn || e instanceof Mn || e instanceof Nr;
            }
            function f() {
                switch (t) {
                  case "delete":
                    return !s(r.tail_node());

                  case "typeof":
                    return !Fe(r.tail_node());

                  default:
                    return true;
                }
            }
        });
        e(ur, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var r = e.expression;
                if (r instanceof ur) return r.optimize(n);
                if (r instanceof Sn && r.expression instanceof ur) return r.optimize(n);
                for (var i = 0, a = e, o; o = n.parent(i++); a = o) {
                    if (_t(o)) {
                        if (o.value === a) return r.optimize(n);
                    } else if (o instanceof vn) {
                        var s = true;
                        do {
                            a = o;
                            o = n.parent(i++);
                            if (o instanceof Gt && (o.bfinally || o.bcatch) !== a) {
                                s = false;
                                break;
                            }
                        } while (o && !(o instanceof dn));
                        if (s) return r.optimize(n);
                    } else if (o instanceof yn) {
                        if (o.tail_node() === a) continue;
                    }
                    break;
                }
            }
            return e;
        });
        e(cr, function(e, n) {
            if (!n.option("yields")) return e;
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            var r = e.expression;
            if (e.nested && r.TYPE == "Call") {
                var i = r.clone().optimize(n);
                if (i.TYPE != "Call") return i;
            }
            return e;
        });
        Tn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof wn) {
                if (!(this.left.expression instanceof yn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return Ce(this, n);
            }
            if (this.left instanceof yn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return Ce(this, n);
            }
            if (this.right instanceof yn) {
                if (this.left.has_side_effects(e)) return this;
                var r = this.operator == "=" && this.left instanceof Mn;
                var n = this.right.expressions;
                var i = n.length - 1;
                for (var a = 0; a < i; a++) {
                    if (!r && n[a].has_side_effects(e)) break;
                }
                if (a == i) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return Ce(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = Ce(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return Ce(this, n);
                }
            }
            return this;
        });
        var se = on("indexOf lastIndexOf");
        var Te = on("== === != !== * & | ^");
        function Ne(e) {
            if (e instanceof Dn) return e.operator == "=" && Ne(e.right);
            if (e instanceof yn) return Ne(e.tail_node());
            if (e instanceof Mn) return Ne(e.fixed_value());
            return e instanceof On || e instanceof zt || e instanceof hn || e instanceof ar || e instanceof qn;
        }
        function x(e, n) {
            if (n.is_constant()) return true;
            if (n instanceof Dn) return n.operator != "=" || x(e, n.right);
            if (n instanceof Tn) {
                return !je[n.operator] || x(e, n.left) && x(e, n.right);
            }
            if (n instanceof An) {
                return x(e, n.consequent) && x(e, n.alternative);
            }
            if (n instanceof yn) return x(e, n.tail_node());
            if (n instanceof Mn) {
                var t = n.fixed_value();
                return t && x(e, t);
            }
            if (n instanceof Cr) return !n.tag || Ge(e, n.tag);
            if (n instanceof En) return true;
        }
        function Ae(e, n) {
            if (n instanceof xn) return Ae(e, n.expression);
            if (n instanceof sr) {
                return Ae(e, n.expression) && Ae(e, n.property);
            }
            if (n instanceof br) return true;
            return !n.has_side_effects(e);
        }
        function Ve(e, n) {
            var t = e.right;
            e.left = ze(Tn, e, {
                operator: e.operator,
                left: e.left,
                right: t.left,
                start: e.left.start,
                end: t.left.end
            });
            e.right = t.right;
            if (n) {
                e.left = e.left.transform(n);
            } else if (e.operator == t.left.operator) {
                Ve(e.left);
            }
        }
        e(Tn, function(r, o) {
            if (Te[r.operator] && r.right.is_constant() && !r.left.is_constant() && !(r.left instanceof Tn && Jr[r.left.operator] >= Jr[r.operator])) {
                O();
            }
            if (o.option("sequences")) {
                var e = r.lift_sequences(o);
                if (e !== r) return e.optimize(o);
            }
            if (o.option("assignments") && je[r.operator]) {
                var n = r.right;
                if (r.left instanceof Mn && n instanceof Dn && n.operator == "=" && r.left.equivalent_to(n.left)) {
                    r.right = n.right;
                    n.right = r;
                    return n;
                }
            }
            if (o.option("comparisons")) switch (r.operator) {
              case "===":
              case "!==":
                if (Pe(r.left, o) && r.right.is_defined(o)) {
                    un.warn("Expression always defined [{file}:{line},{col}]", r.start);
                    return Ce(r, [ r.right, ze(r.operator == "===" ? Rr : Lr, r) ]).optimize(o);
                }
                var t = true;
                if (r.left.is_string(o) && r.right.is_string(o) || r.left.is_number(o) && r.right.is_number(o) || r.left.is_boolean(o) && r.right.is_boolean(o) || Ae(o, r.left) && r.left.equivalent_to(r.right)) {
                    r.operator = r.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!t && Pe(r.left, o)) {
                    r.left = ze(Pr, r.left);
                } else if (o.option("typeofs") && r.left instanceof Pn && r.left.value == "undefined" && r.right instanceof Sn && r.right.operator == "typeof") {
                    var i = r.right.expression;
                    if (i instanceof Mn ? i.is_declared(o) : !(i instanceof wn && o.option("ie"))) {
                        r.right = i;
                        r.left = ze(Nr, r.left).optimize(o);
                        if (r.operator.length == 2) r.operator += "=";
                    }
                } else if (r.left instanceof Mn && r.right instanceof Mn && r.left.definition() === r.right.definition() && Ne(r.left)) {
                    return ze(r.operator[0] == "=" ? Lr : Rr, r).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var a = r.left;
                if (a.operator == r.operator) a = a.right;
                var i = a.right;
                if (i instanceof Dn && i.operator == "=") i = i.left;
                if (a instanceof Tn && a.operator == (r.operator == "&&" ? "!==" : "===") && r.right instanceof Tn && a.operator == r.right.operator && (Pe(a.left, o) && r.right.left instanceof Pr || a.left instanceof Pr && Pe(r.right.left, o)) && !i.has_side_effects(o) && i.equivalent_to(r.right.right)) {
                    a.operator = a.operator.slice(0, -1);
                    a.left = ze(Pr, r);
                    return r.left;
                }
                break;
            }
            var s = false;
            var f = o.parent();
            if (o.option("booleans")) {
                var a = r.left;
                if (je[r.operator] && !a.has_side_effects(o)) {
                    if (a.equivalent_to(r.right)) {
                        return Me(o, f, o.self(), a).optimize(o);
                    }
                    G(o, a);
                }
                s = o.in_boolean_context();
            }
            if (s) switch (r.operator) {
              case "+":
                var u = r.left.evaluate(o, true);
                if (u && typeof u == "string" || (u = r.right.evaluate(o, true)) && typeof u == "string") {
                    un.warn("+ in boolean context always true [{file}:{line},{col}]", r.start);
                    var c = [];
                    if (r.left.evaluate(o) instanceof un) c.push(r.left);
                    if (r.right.evaluate(o) instanceof un) c.push(r.right);
                    if (c.length < 2) {
                        c.push(ze(Lr, r));
                        return Ce(r, c).optimize(o);
                    }
                    r.truthy = true;
                }
                break;

              case "==":
                if (r.left instanceof Pn && r.left.value == "" && r.right.is_string(o)) {
                    return ze(Sn, r, {
                        operator: "!",
                        expression: r.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (r.left instanceof Pn && r.left.value == "" && r.right.is_string(o)) {
                    return r.right.optimize(o);
                }
                break;
            }
            if (o.option("comparisons") && r.is_boolean(o)) {
                if (!(f instanceof Tn) || f instanceof Dn) {
                    var l = pe(o, r, ze(Sn, r, {
                        operator: "!",
                        expression: r.negate(o, Xn(o))
                    }));
                    if (l !== r) return l;
                }
                switch (r.operator) {
                  case ">":
                    O("<");
                    break;

                  case ">=":
                    O("<=");
                    break;
                }
            }
            if (o.option("conditionals") && je[r.operator] && r.right instanceof Tn && r.operator == r.right.operator) {
                Ve(r, o);
            }
            if (o.option("strings") && r.operator == "+") {
                if (r.right instanceof Pn && r.right.value == "" && r.left.is_string(o)) {
                    return r.left.optimize(o);
                }
                if (r.left instanceof Pn && r.left.value == "" && r.right.is_string(o)) {
                    return r.right.optimize(o);
                }
                if (r.left instanceof Tn && r.left.operator == "+" && r.left.left instanceof Pn && r.left.left.value == "" && r.right.is_string(o) && (r.left.right.is_constant() || !r.right.has_side_effects(o))) {
                    r.left = r.left.right;
                    return r.optimize(o);
                }
                if (r.right instanceof Tn && r.operator == r.right.operator && (r.left.is_string(o) && r.right.is_string(o) || r.right.left.is_string(o) && (r.left.is_constant() || !r.right.right.has_side_effects(o)))) {
                    Ve(r, o);
                }
            }
            if (o.option("evaluate")) {
                var p = true;
                switch (r.operator) {
                  case "&&":
                    var d = $(o, r.left);
                    if (!d) {
                        un.warn("Condition left of && always false [{file}:{line},{col}]", r.start);
                        return Me(o, f, o.self(), r.left).optimize(o);
                    } else if (!(d instanceof un)) {
                        un.warn("Condition left of && always true [{file}:{line},{col}]", r.start);
                        return Ce(r, [ r.left, r.right ]).optimize(o);
                    }
                    if (!r.right.evaluate(o, true)) {
                        if (s && !(r.right.evaluate(o) instanceof un)) {
                            un.warn("Boolean && always false [{file}:{line},{col}]", r.start);
                            return Ce(r, [ r.left, ze(Rr, r) ]).optimize(o);
                        } else r.falsy = true;
                    } else if ((s || f.operator == "&&" && f.left === o.self()) && !(r.right.evaluate(o) instanceof un)) {
                        un.warn("Dropping side-effect-free && [{file}:{line},{col}]", r.start);
                        return r.left.optimize(o);
                    }
                    if (r.left.operator == "||") {
                        var h = $(o, r.left.right);
                        if (!h) return ze(An, r, {
                            condition: r.left.left,
                            consequent: r.right,
                            alternative: r.left.right
                        }).optimize(o);
                    }
                    break;

                  case "??":
                    var v = true;

                  case "||":
                    var d = $(o, r.left, v);
                    if (v ? d == null : !d) {
                        un.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: r.operator,
                            value: v ? "nulish" : "false",
                            file: r.start.file,
                            line: r.start.line,
                            col: r.start.col
                        });
                        return Ce(r, [ r.left, r.right ]).optimize(o);
                    } else if (!(d instanceof un)) {
                        un.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: r.operator,
                            value: v ? "defined" : "true",
                            file: r.start.file,
                            line: r.start.line,
                            col: r.start.col
                        });
                        return Me(o, f, o.self(), r.left).optimize(o);
                    }
                    var m;
                    if (!v && (m = r.right.evaluate(o, true)) && !(m instanceof un)) {
                        if (s && !(r.right.evaluate(o) instanceof un)) {
                            un.warn("Boolean || always true [{file}:{line},{col}]", r.start);
                            return Ce(r, [ r.left, ze(Lr, r) ]).optimize(o);
                        } else r.truthy = true;
                    } else if ((s || f.operator == "||" && f.left === o.self()) && !r.right.evaluate(o)) {
                        un.warn("Dropping side-effect-free {operator} [{file}:{line},{col}]", {
                            operator: r.operator,
                            file: r.start.file,
                            line: r.start.line,
                            col: r.start.col
                        });
                        return r.left.optimize(o);
                    }
                    if (!v && r.left.operator == "&&") {
                        var h = $(o, r.left.right);
                        if (h && !(h instanceof un)) return ze(An, r, {
                            condition: r.left.left,
                            consequent: r.left.right,
                            alternative: r.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (r.left instanceof Fn && r.right instanceof Tn && r.right.operator == "+" && r.right.left instanceof Fn && r.right.is_string(o)) {
                        r = ze(Tn, r, {
                            operator: "+",
                            left: ze(Pn, r.left, {
                                value: "" + r.left.value + r.right.left.value,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                    }
                    if (r.right instanceof Fn && r.left instanceof Tn && r.left.operator == "+" && r.left.right instanceof Fn && r.left.is_string(o)) {
                        r = ze(Tn, r, {
                            operator: "+",
                            left: r.left.left,
                            right: ze(Pn, r.right, {
                                value: "" + r.left.right.value + r.right.value,
                                start: r.left.right.start,
                                end: r.right.end
                            })
                        });
                    }
                    if (r.right instanceof Sn && r.right.operator == "-" && r.left.is_number(o)) {
                        r = ze(Tn, r, {
                            operator: "-",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }
                    if (r.left instanceof Sn && r.left.operator == "-" && D() && r.right.is_number(o)) {
                        r = ze(Tn, r, {
                            operator: "-",
                            left: r.right,
                            right: r.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && r.left instanceof Tn && Jr[r.left.operator] == Jr[r.operator] && r.right.is_constant() && (r.right.is_boolean(o) || r.right.is_number(o)) && r.left.is_number(o) && !r.left.right.is_constant() && (r.left.left.is_boolean(o) || r.left.left.is_number(o))) {
                        r = ze(Tn, r, {
                            operator: r.left.operator,
                            left: ze(Tn, r, {
                                operator: r.operator,
                                left: r.right,
                                right: r.left.left
                            }),
                            right: r.left.right
                        });
                        break;
                    }

                  case "-":
                    if (r.right instanceof Sn && r.right.operator == "-" && r.left.is_number(o) && r.right.expression.is_number(o)) {
                        r = ze(Tn, r, {
                            operator: "+",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    p = o.option("unsafe_math");
                    if (r.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = r[e];
                        if (n instanceof Sn && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                r[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (r.operator != "-" && r.operator != "/" && (r.left.is_boolean(o) || r.left.is_number(o)) && (r.right.is_boolean(o) || r.right.is_number(o)) && D() && !(r.left instanceof Tn && r.left.operator != r.operator && Jr[r.left.operator] >= Jr[r.operator])) {
                        var _ = ze(Tn, r, {
                            operator: r.operator,
                            left: r.right,
                            right: r.left
                        });
                        if (r.right instanceof Fn && !(r.left instanceof Fn)) {
                            r = pe(o, _, r);
                        } else {
                            r = pe(o, r, _);
                        }
                    }
                    if (!p || !r.is_number(o)) break;
                    if (r.right instanceof Tn && r.right.operator != "%" && Jr[r.right.operator] == Jr[r.operator] && r.right.is_number(o) && (r.operator != "+" || r.right.left.is_boolean(o) || r.right.left.is_number(o)) && (r.operator != "-" || !r.left.is_negative_zero()) && (r.right.left.is_constant_expression() || !r.right.right.has_side_effects(o)) && !k(r.right.right)) {
                        r = ze(Tn, r, {
                            operator: E(r.operator, r.right.operator),
                            left: ze(Tn, r.left, {
                                operator: r.operator,
                                left: r.left,
                                right: r.right.left,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                        if (r.operator == "+" && !r.right.is_boolean(o) && !r.right.is_number(o)) {
                            r.right = ze(Sn, r.right, {
                                operator: "+",
                                expression: r.right
                            });
                        }
                    }
                    if (r.right instanceof Fn && r.left instanceof Tn && r.left.operator != "%" && Jr[r.left.operator] == Jr[r.operator] && r.left.is_number(o)) {
                        if (r.left.left instanceof Fn) {
                            var a = S(r.left, r.operator, r.left.left, r.right, r.left.left.start, r.right.end);
                            r = S(r, r.left.operator, de(o, a), r.left.right);
                        } else if (r.left.right instanceof Fn) {
                            var g = E(r.left.operator, r.operator);
                            var b = de(o, S(r.left, g, r.left.right, r.right));
                            if (b.is_constant() && !(r.left.operator == "-" && r.right.value != 0 && +b.value == 0 && r.left.left.is_negative_zero())) {
                                r = S(r, r.left.operator, r.left.left, b);
                            }
                        }
                    }
                    break;
                }
                if (!(f instanceof Sn && f.operator == "delete")) {
                    if (r.left instanceof jn && !r.right.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.left.value == 0) {
                            if (r.right.is_boolean(o)) return ze(Sn, r, {
                                operator: "+",
                                expression: r.right
                            }).optimize(o);
                            if (r.right.is_number(o) && !r.right.is_negative_zero()) return r.right;
                        }
                        break;

                      case "*":
                        if (r.left.value == 1) return ze(Sn, r, {
                            operator: "+",
                            expression: r.right
                        }).optimize(o);
                        break;
                    }
                    if (r.right instanceof jn && !r.left.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.right.value == 0) {
                            if (r.left.is_boolean(o)) return ze(Sn, r, {
                                operator: "+",
                                expression: r.left
                            }).optimize(o);
                            if (r.left.is_number(o) && !r.left.is_negative_zero()) return r.left;
                        }
                        break;

                      case "-":
                        if (r.right.value == 0) return ze(Sn, r, {
                            operator: "+",
                            expression: r.left
                        }).optimize(o);
                        break;

                      case "/":
                        if (r.right.value == 1) return ze(Sn, r, {
                            operator: "+",
                            expression: r.left
                        }).optimize(o);
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (r.operator) {
              case "&&":
                j(r.left, r.right, null);
                break;

              case "||":
                j(r.left, null, r.right);
                break;
            }
            if (o.option("unsafe")) {
                var y = T(r.right);
                if (s && y && (r.operator == "==" || r.operator == "!=") && r.left instanceof jn && r.left.value == 0) {
                    return (r.operator == "==" ? ze(Sn, r, {
                        operator: "!",
                        expression: r.right
                    }) : r.right).optimize(o);
                }
                var w = T(r.left);
                if (o.option("comparisons") && A()) {
                    var x = ze(Sn, r, {
                        operator: "!",
                        expression: ze(Sn, r, {
                            operator: "~",
                            expression: w ? r.left : r.right
                        })
                    });
                    switch (r.operator) {
                      case "<":
                        if (w) break;

                      case "<=":
                      case "!=":
                        x = ze(Sn, r, {
                            operator: "!",
                            expression: x
                        });
                        break;
                    }
                    return x.optimize(o);
                }
            }
            return de(o, r);
            function k(e) {
                var n = false;
                e.walk(new Nn(function(e) {
                    if (n) return true;
                    if (e instanceof Dn) {
                        if (e.left instanceof wn) return n = true;
                    } else if (e instanceof En) {
                        if (Qr[e.operator] && e.expression instanceof wn) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function E(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function S(e, n, t, r, i, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = ze(Sn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!r.is_boolean(o) && !r.is_number(o)) {
                        r = ze(Sn, r, {
                            operator: "+",
                            expression: r
                        });
                    }
                }
                return ze(Tn, e, {
                    operator: n,
                    left: t,
                    right: r,
                    start: i,
                    end: a
                });
            }
            function T(e) {
                return e.TYPE == "Call" && e.expression instanceof xn && se[e.expression.property];
            }
            function A() {
                switch (r.operator) {
                  case "<=":
                    return y && r.left instanceof jn && r.left.value == 0;

                  case "<":
                    if (w && r.right instanceof jn && r.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!y) return false;
                    return r.left instanceof jn && r.left.value == -1 || r.left instanceof Sn && r.left.operator == "-" && r.left.expression instanceof jn && r.left.expression.value == 1;
                }
            }
            function D() {
                return r.left.is_constant() || r.right.is_constant() || !r.left.has_side_effects(o) && !r.right.has_side_effects(o);
            }
            function O(e) {
                if (D()) {
                    if (e) r.operator = e;
                    var n = r.left;
                    r.left = r.right;
                    r.right = n;
                }
            }
        });
        e(Dr, function(e) {
            return e;
        });
        function We(e, n, t) {
            var r = 0, i = e.self();
            do {
                if (i === t) return i;
                if (D(i) && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(r++));
        }
        function Ie(e) {
            var n = e.scope.resolve();
            return sn(e.references, function(e) {
                return n === e.scope.resolve();
            });
        }
        e(Mn, function(t, e) {
            if (!e.option("ie") && Fe(t) && !(t.scope.resolve().uses_with && e.find_parent(dt))) {
                switch (t.name) {
                  case "undefined":
                    return ze(Nr, t).optimize(e);

                  case "NaN":
                    return ze(jr, t).optimize(e);

                  case "Infinity":
                    return ze(Hr, t).optimize(e);
                }
            }
            var n = e.parent();
            if (e.option("reduce_vars") && Zr(e.self(), n) !== e.self()) {
                var r = t.definition();
                var i = t.fixed_value();
                var a = r.single_use && !(n instanceof bn && n.is_expr_pure(e));
                if (a) {
                    if (D(i)) {
                        if ((r.scope !== t.scope.resolve() || r.in_loop) && (!e.option("reduce_funcs") || r.escaped.depth == 1 || i.inlined)) {
                            a = false;
                        } else if (We(e, r, i)) {
                            a = false;
                        } else if (i.name && i.name.definition() !== r) {
                            a = false;
                        } else if (i.parent_scope !== t.scope || Kr(r)) {
                            a = i.is_constant_expression(t.scope);
                            if (a == "f") {
                                var o = t.scope;
                                do {
                                    if (o instanceof At || o instanceof mt) {
                                        o.inlined = true;
                                    }
                                } while (o = o.parent_scope);
                            }
                        } else if (i.name && (i.name.name == "await" && gt(i) || i.name.name == "yield" && bt(i))) {
                            a = false;
                        } else if (i.has_side_effects(e)) {
                            a = false;
                        } else if (e.option("ie") && i instanceof zt) {
                            a = false;
                        }
                        if (a) i.parent_scope = t.scope;
                    } else if (!i || r.recursive_refs > 0 || !i.is_constant_expression() || i.drop_side_effect_free(e)) {
                        a = false;
                    }
                }
                if (a) {
                    r.single_use = false;
                    i._squeezed = true;
                    i.single_use = true;
                    if (i instanceof Ct) i = ne(i);
                    if (i instanceof At) i = we(i);
                    if (D(i)) {
                        var o = t.scope.resolve();
                        i.enclosed.forEach(function(e) {
                            if (i.variables.has(e.name)) return;
                            if (o.var_names().has(e.name)) return;
                            o.enclosed.push(e);
                            o.var_names().set(e.name, true);
                        });
                    }
                    var s;
                    if (r.recursive_refs > 0) {
                        s = i.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        var l, p;
                        if (s instanceof zt) {
                            l = "def_function";
                            p = Tr;
                        } else {
                            l = "def_variable";
                            p = Sr;
                        }
                        if (!(c instanceof p)) {
                            c = ze(p, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s[l](c);
                            u.recursive_refs = r.recursive_refs;
                        }
                        s.walk(new Nn(function(e) {
                            if (e instanceof zn) {
                                if (e !== c) {
                                    var n = e.definition();
                                    n.orig.push(e);
                                    n.eliminated++;
                                }
                                return;
                            }
                            if (!(e instanceof Mn)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = n = u;
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (D(t) && t.name && t.name.definition() === n && n.scope === t.name.scope && i.variables.get(t.name.name) === n) {
                                    t.name = t.name.clone();
                                    e.thedef = n = s.variables.get(t.name.name) || s[l](t.name);
                                }
                            }
                            n.references.push(e);
                        }));
                    } else {
                        if (i instanceof dn) {
                            e.push(i);
                            s = i.optimize(e);
                            e.pop();
                        } else {
                            s = i.optimize(e);
                        }
                        s = s.transform(new Br(function(e, n) {
                            if (e instanceof dn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    r.replaced++;
                    return s;
                }
                var d;
                if (i && (d = t.fixed || r.fixed).should_replace !== false) {
                    var h, v;
                    if (i instanceof qr) {
                        if (!Kr(r) && Ie(r) && !b(r)) v = i;
                    } else if ((h = i.evaluate(e, true)) !== i && typeof h != "function" && (h === null || typeof h != "object" || e.option("unsafe_regexp") && h instanceof RegExp && !r.cross_loop && Ie(r))) {
                        v = fe(h, i);
                    }
                    if (v) {
                        if (d.should_replace === undefined) {
                            var m = v.optimize(e).print_to_string().length;
                            if (!y(i)) {
                                m = Math.min(m, i.print_to_string().length);
                            }
                            var _ = r.name.length;
                            if (e.option("unused") && !e.exposed(r)) {
                                var g = r.references.length - r.replaced - r.assignments;
                                g = Math.min(g, r.references.filter(function(e) {
                                    return e.fixed === d;
                                }).length);
                                _ += (_ + 2 + m) / Math.max(1, g);
                            }
                            d.should_replace = m - Math.floor(_) < e.eval_threshold;
                        }
                        if (d.should_replace) {
                            var s;
                            if (y(i)) {
                                s = v.optimize(e);
                                if (s === v) s = s.clone(true);
                            } else {
                                s = le(v.optimize(e), i);
                                if (s === v || s === i) s = s.clone(true);
                            }
                            r.replaced++;
                            return s;
                        }
                    }
                }
            }
            return t;
            function b(e) {
                var n = t.scope;
                while (n !== e.scope) {
                    if (n instanceof zt) return true;
                    n = n.parent_scope;
                }
            }
            function y(e) {
                var n;
                e.walk(new Nn(function(e) {
                    if (e instanceof Mn) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function Ge(e, n) {
            return e.option("unsafe") && n instanceof xn && n.property == "raw" && Fe(n.expression) && n.expression.name == "String";
        }
        function Je(e) {
            var r = false;
            e = e.replace(/\\(u\{[^{}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                var t = Vr(n);
                if (typeof t == "string") return t;
                r = true;
            });
            if (!r) return e;
        }
        e(Cr, function(e, t) {
            if (!t.option("templates")) return e;
            var r = e.tag;
            if (!r || Ge(t, r)) {
                var n = [];
                var i = [];
                for (var a = 0, o; a < e.strings.length; a++) {
                    var s = e.strings[a];
                    if (!r) {
                        var f = Je(s);
                        if (f) s = v(f);
                    }
                    if (a > 0) {
                        var u = e.expressions[a - 1];
                        var c = m(u);
                        if (c) {
                            var l = i[i.length - 1];
                            var p = l + c + s;
                            var d;
                            if (r || typeof (d = Je(p)) == o) {
                                i[i.length - 1] = d ? v(d) : p;
                                continue;
                            }
                        }
                        n.push(u);
                    }
                    i.push(s);
                    if (!r) o = typeof f;
                }
                if (!r && i.length > 1) {
                    if (i[i.length - 1] == "") return ze(Tn, e, {
                        operator: "+",
                        left: ze(Cr, e, {
                            expressions: n.slice(0, -1),
                            strings: i.slice(0, -1),
                            tag: r
                        }).transform(t),
                        right: n[n.length - 1]
                    }).optimize(t);
                    if (i[0] == "") {
                        var h = ze(Tn, e, {
                            operator: "+",
                            left: ze(Pn, e, {
                                value: ""
                            }),
                            right: n[0]
                        });
                        for (var a = 1; i[a] == "" && a < n.length; a++) {
                            h = ze(Tn, e, {
                                operator: "+",
                                left: h,
                                right: n[a]
                            });
                        }
                        return pe(t, e, ze(Tn, e, {
                            operator: "+",
                            left: h.transform(t),
                            right: ze(Cr, e, {
                                expressions: n.slice(a),
                                strings: i.slice(a),
                                tag: r
                            }).transform(t)
                        }).optimize(t));
                    }
                }
                e.expressions = n;
                e.strings = i;
            }
            return de(t, e);
            function v(e) {
                return e.replace(/\r|\\|`|\${/g, function(e) {
                    return "\\" + (e == "\r" ? "r" : e);
                });
            }
            function m(e) {
                var n = e.evaluate(t);
                if (n === e) return;
                if (r && /\r|\\|`/.test(n)) return;
                n = v("" + n);
                if (n.length > e.print_to_string().length + "${}".length) return;
                return n;
            }
        });
        function Xe(e, n) {
            return e instanceof Mn || e.TYPE === n.TYPE;
        }
        e(Nr, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = qe(n).find_variable("undefined");
                if (t) {
                    var r = ze(Mn, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    r.is_undefined = true;
                    return r;
                }
            }
            var i = Zr(n.self(), n.parent());
            if (i && Xe(i, e)) return e;
            return ze(Sn, e, {
                operator: "void",
                expression: ze(jn, e, {
                    value: 0
                })
            });
        });
        e(Hr, function(e, n) {
            var t = Zr(n.self(), n.parent());
            if (t && Xe(t, e)) return e;
            if (n.option("keep_infinity") && !t && !qe(n).find_variable("Infinity")) {
                return e;
            }
            return ze(Tn, e, {
                operator: "/",
                left: ze(jn, e, {
                    value: 1
                }),
                right: ze(jn, e, {
                    value: 0
                })
            });
        });
        e(jr, function(e, n) {
            var t = Zr(n.self(), n.parent());
            if (t && Xe(t, e)) return e;
            if (!t && !qe(n).find_variable("NaN")) return e;
            return ze(Tn, e, {
                operator: "/",
                left: ze(jn, e, {
                    value: 0
                }),
                right: ze(jn, e, {
                    value: 0
                })
            });
        });
        function Ke(t, n) {
            var r = false;
            var i = new Nn(function(e) {
                if (r) return true;
                if (e instanceof Mn && In(e.definition(), n)) return r = true;
            });
            var a = new Nn(function(e) {
                if (r) return true;
                if (e instanceof hn && e !== t) {
                    if (!(e.name || gt(e) || bt(e))) {
                        var n = a.parent();
                        if (n instanceof bn && n.expression === e) return;
                    }
                    e.walk(i);
                    return true;
                }
            });
            t.walk(a);
            return r;
        }
        var Qe = on("+ - * / % >> << >>> | ^ &");
        var Ze = on("* | ^ &");
        e(Dn, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof wn) {
                    if (a.operator == "=") {
                        if (a.redundant) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof sr) e.push(a.left.property);
                            e.push(a.right);
                            return Ce(a, e).optimize(o);
                        }
                        if (a.left.equivalent_to(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof hn || !o.has_directive("use strict") && n instanceof Fn && !n.may_throw_on_access(o)) {
                            return a.left instanceof xn ? a.right : Ce(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof Mn && $e(a.left, o)) {
                    var t;
                    if (a.operator == "=" && a.left.equivalent_to(a.right) && !((t = o.parent()) instanceof Sn && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return _();
                    var r = a.left.definition();
                    var s = r.scope.resolve();
                    var i = s === o.find_parent(hn);
                    var f = 0, u;
                    t = o.self();
                    if (!(s.uses_arguments && Kr(r)) || o.has_directive("use strict")) do {
                        u = t;
                        t = o.parent(f++);
                        if (t instanceof Dn) {
                            if (t.left instanceof Mn && t.left.definition() === r) {
                                if (m(f, t)) break;
                                return _(r);
                            }
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof wn) return true;
                            })) break;
                            continue;
                        }
                        if (t instanceof It) {
                            if (!i) break;
                            if (m(f, t)) break;
                            if (Ke(s, [ r ])) break;
                            return _(r);
                        }
                        if (t instanceof ln) {
                            if (!i) break;
                            if (Ke(s, [ r ])) break;
                            var c;
                            do {
                                c = t;
                                t = o.parent(f++);
                                if (t === s && R(t.body, c)) return _(r);
                            } while (v(c, t));
                            break;
                        }
                        if (t instanceof _n) {
                            if (!(t.name instanceof zn)) continue;
                            if (t.name.definition() !== r) continue;
                            if (m(f, t)) break;
                            return _(r);
                        }
                    } while (h(u, t));
                }
            }
            if (o.option("sequences")) {
                var l = a.lift_sequences(o);
                if (l !== a) return l.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof Mn && a.right instanceof Tn) {
                    var p;
                    if ((p = a.right.left) instanceof Mn && p.name == a.left.name && Qe[a.right.operator]) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return p;
                        };
                        return ze(Dn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        });
                    }
                    if ((p = a.right.right) instanceof Mn && p.name == a.left.name && Ze[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return p;
                        };
                        return ze(Dn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        });
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof jn && a.right.value == 1) {
                    var d = a.operator.slice(0, -1);
                    return ze(Sn, a, {
                        operator: d + d,
                        expression: a.left
                    });
                }
            }
            return de(o, a);
            function h(e, n) {
                if (n instanceof Tn) {
                    return n.right === e || n.right.is_constant_expression(s);
                }
                if (n instanceof An) {
                    return n.condition !== e || n.consequent.is_constant_expression(s) && n.alternative.is_constant_expression(s);
                }
                if (n instanceof yn) {
                    var t = n.expressions;
                    var r = t.indexOf(e);
                    if (r < 0) return false;
                    for (var i = t.length; --i > r; ) {
                        if (!t[i].is_constant_expression(s)) return false;
                    }
                    return true;
                }
                if (n instanceof Sn) return true;
            }
            function v(e, n) {
                if (n instanceof pn) return R(n.body, e);
                if (n instanceof Jt) return R(n.body, e);
                if (n instanceof Xt) return R(n.body, e);
                if (n instanceof mn) return n.body === e || n.alternative === e;
                if (n instanceof Gt) return n.bfinally ? n.bfinally === e : n.bcatch === e;
            }
            function m(e, n) {
                var t = a.right;
                a.right = ze(Pr, t);
                var r = n.may_throw(o);
                a.right = t;
                for (var i; i = o.parent(e++); n = i) {
                    if (i === s) return false;
                    if (i instanceof Gt) {
                        if (i.bfinally && i.bfinally !== n) return true;
                        if (r && i.bcatch && i.bcatch !== n) return true;
                    }
                }
            }
            function _(e) {
                if (e) e.fixed = false;
                return (a.operator != "=" ? ze(Tn, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : Me(o, o.parent(), a, a.right)).optimize(o);
            }
        });
        e(An, function(i, n) {
            if (n.option("sequences") && i.condition instanceof yn) {
                var e = i.condition.expressions.slice();
                i.condition = e.pop();
                e.push(i);
                return Ce(i, e);
            }
            if (!n.option("conditionals")) return i;
            var a = i.condition;
            if (n.option("booleans") && !a.has_side_effects(n)) {
                G(n, a);
            }
            a = $(n, a);
            if (!a) {
                un.warn("Condition always false [{file}:{line},{col}]", i.start);
                return Ce(i, [ i.condition, i.alternative ]).optimize(n);
            } else if (!(a instanceof un)) {
                un.warn("Condition always true [{file}:{line},{col}]", i.start);
                return Ce(i, [ i.condition, i.consequent ]).optimize(n);
            }
            var t = a.negate(n, Xn(n));
            if (pe(n, a, t) === t) {
                i = ze(An, i, {
                    condition: t,
                    consequent: i.alternative,
                    alternative: i.consequent
                });
                t = a;
                a = i.condition;
            }
            var r = i.consequent;
            var o = i.alternative;
            if (Ae(n, a)) {
                if (a.equivalent_to(r)) return ze(Tn, i, {
                    operator: "||",
                    left: a,
                    right: o
                }).optimize(n);
                if (a.equivalent_to(o)) return ze(Tn, i, {
                    operator: "&&",
                    left: a,
                    right: r
                }).optimize(n);
            }
            var s = r.tail_node();
            if (s instanceof Dn) {
                var f = s.operator == "=";
                var u = f ? o.tail_node() : o;
                if ((f || r === s) && u instanceof Dn && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof Mn || !a.has_side_effects(n) && w(r) && w(o))) {
                    return ze(Dn, i, {
                        operator: s.operator,
                        left: s.left,
                        right: ze(An, i, {
                            condition: a,
                            consequent: x(r),
                            alternative: x(o)
                        })
                    });
                }
            }
            if (r.equivalent_to(o)) return Ce(i, [ a, r ]).optimize(n);
            var c = y(r, o, true);
            if (c) return c;
            var l;
            if (r instanceof bn && o.TYPE == r.TYPE && (l = g(r, o)) >= 0 && r.expression.equivalent_to(o.expression) && !a.has_side_effects(n) && !r.expression.has_side_effects(n)) {
                var p = r.clone();
                var d = r.args[l];
                p.args[l] = d instanceof kn ? ze(kn, i, {
                    expression: ze(An, i, {
                        condition: a,
                        consequent: d.expression,
                        alternative: o.args[l].expression
                    })
                }) : ze(An, i, {
                    condition: a,
                    consequent: d,
                    alternative: o.args[l]
                });
                return p;
            }
            if (r instanceof An && r.alternative.equivalent_to(o)) {
                return ze(An, i, {
                    condition: ze(Tn, i, {
                        left: a,
                        operator: "&&",
                        right: r.condition
                    }),
                    consequent: r.consequent,
                    alternative: o
                });
            }
            if (r instanceof An && r.consequent.equivalent_to(o)) {
                return ze(An, i, {
                    condition: ze(Tn, i, {
                        left: t,
                        operator: "||",
                        right: r.condition
                    }),
                    consequent: o,
                    alternative: r.alternative
                });
            }
            if (o instanceof An && r.equivalent_to(o.consequent)) {
                return ze(An, i, {
                    condition: ze(Tn, i, {
                        left: a,
                        operator: "||",
                        right: o.condition
                    }),
                    consequent: r,
                    alternative: o.alternative
                });
            }
            if (o instanceof An && r.equivalent_to(o.alternative)) {
                return ze(An, i, {
                    condition: ze(Tn, i, {
                        left: t,
                        operator: "&&",
                        right: o.condition
                    }),
                    consequent: o.consequent,
                    alternative: r
                });
            }
            if ((r instanceof yn || o instanceof yn) && r.tail_node().equivalent_to(o.tail_node())) {
                return Ce(i, [ ze(An, i, {
                    condition: a,
                    consequent: k(r),
                    alternative: k(o)
                }), r.tail_node() ]).optimize(n);
            }
            if (r instanceof Tn && r.operator == "&&" && r.right.equivalent_to(o)) {
                return ze(Tn, i, {
                    operator: "&&",
                    left: ze(Tn, i, {
                        operator: "||",
                        left: t,
                        right: r.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (r instanceof Tn && r.operator == "||" && r.right.equivalent_to(o)) {
                return ze(Tn, i, {
                    operator: "||",
                    left: ze(Tn, i, {
                        operator: "&&",
                        left: a,
                        right: r.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (o instanceof Tn && o.operator == "&&" && o.right.equivalent_to(r)) {
                return ze(Tn, i, {
                    operator: "&&",
                    left: ze(Tn, i, {
                        operator: "||",
                        left: a,
                        right: o.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (o instanceof Tn && o.operator == "||" && o.right.equivalent_to(r)) {
                return ze(Tn, i, {
                    operator: "||",
                    left: ze(Tn, i, {
                        operator: "&&",
                        left: t,
                        right: o.left
                    }),
                    right: r
                }).optimize(n);
            }
            var h = n.option("booleans") && n.in_boolean_context();
            if (m(r)) {
                if (_(o)) {
                    return v(a);
                }
                return ze(Tn, i, {
                    operator: "||",
                    left: v(a),
                    right: o
                });
            }
            if (_(r)) {
                if (m(o)) {
                    return v(a.negate(n));
                }
                return ze(Tn, i, {
                    operator: "&&",
                    left: v(a.negate(n)),
                    right: o
                });
            }
            if (m(o)) {
                return ze(Tn, i, {
                    operator: "||",
                    left: v(a.negate(n)),
                    right: r
                });
            }
            if (_(o)) {
                return ze(Tn, i, {
                    operator: "&&",
                    left: v(a),
                    right: r
                });
            }
            if (n.option("typeofs")) j(a, r, o);
            return i;
            function v(e) {
                if (e.is_boolean(n)) return e;
                return ze(Sn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function m(e) {
                return e instanceof Lr || h && e instanceof Fn && e.value || e instanceof Sn && e.operator == "!" && e.expression instanceof Fn && !e.expression.value;
            }
            function _(e) {
                return e instanceof Rr || h && (e instanceof Fn && !e.value || e instanceof Sn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof Sn && e.operator == "!" && e.expression instanceof Fn && e.expression.value;
            }
            function g(e, n) {
                var t = e.args;
                var r = n.args;
                var i = t.length;
                if (i != r.length) return -2;
                for (var a = 0; a < i; a++) {
                    if (!t[a].equivalent_to(r[a])) {
                        if (t[a] instanceof kn !== r[a] instanceof kn) return -3;
                        for (var o = a + 1; o < i; o++) {
                            if (!t[o].equivalent_to(r[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function b(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e.optional != n.optional) return;
                if (e instanceof bn) {
                    if (g(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof wn || n.expression instanceof wn) || b(e.expression, n.expression);
                }
                if (!(e instanceof wn)) return;
                var t = e.property;
                var r = n.property;
                return (t instanceof un ? t.equivalent_to(r) : t == r) && !(e.expression instanceof $r || n.expression instanceof $r);
            }
            function y(e, n, t) {
                if (!b(e, n)) return !t && ze(An, i, {
                    condition: a,
                    consequent: e,
                    alternative: n
                });
                var r = e.clone();
                r.expression = y(e.expression, n.expression);
                return r;
            }
            function w(e) {
                return e === e.tail_node() || sn(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function x(e) {
                if (!(e instanceof yn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return Ce(e, n);
            }
            function k(e) {
                if (!(e instanceof yn)) return ze(jn, e, {
                    value: 0
                });
                return Ce(e, e.expressions.slice(0, -1));
            }
        });
        e(Yr, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return ze(jn, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof Tn && (t.operator == "==" || t.operator == "!=")) {
                un.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return ze(jn, e, {
                    value: +e.value
                });
            }
            return ze(Sn, e, {
                operator: "!",
                expression: ze(jn, e, {
                    value: 1 - e.value
                })
            });
        });
        e(kn, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof On && !(n.parent() instanceof qn)) {
                return Un.splice(t.elements.map(function(e) {
                    return e instanceof Ir ? ze(Nr, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function en(e, n) {
            if (!e) return false;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            if (e instanceof Mn) {
                e = e.fixed_value();
                if (!e) return false;
            }
            return e instanceof hn && !e.contains_this();
        }
        e(sr, function(e, t) {
            var n = e.expression;
            var r = e.property;
            var i = ke(e, t);
            if (i) return i;
            if (t.option("properties")) {
                var a = r.evaluate(t);
                if (a !== r) {
                    if (typeof a == "string") {
                        if (a == "undefined") {
                            a = undefined;
                        } else {
                            var o = parseFloat(a);
                            if (o.toString() == a) {
                                a = o;
                            }
                        }
                    }
                    r = e.property = le(r, fe(a, r).transform(t));
                    var s = "" + a;
                    if (Ur(s) && s.length <= r.print_to_string().length + 1) {
                        return ze(xn, e, {
                            optional: e.optional,
                            expression: n,
                            property: s
                        }).optimize(t);
                    }
                }
            }
            var f = t.parent();
            var u = Zr(t.self(), f);
            var c, l, p, d;
            if (t.option("arguments") && n instanceof Mn && Oe(c = n.definition()) && !n.in_arg && r instanceof jn && Math.floor(d = r.value) == d && (l = c.scope) === S() && l.uses_arguments < (u ? 2 : 3)) {
                if (f instanceof Sn && f.operator == "delete") {
                    if (!c.deleted) c.deleted = [];
                    c.deleted[d] = true;
                }
                var h = l.argnames[d];
                if (c.deleted && c.deleted[d]) {
                    h = null;
                } else if (h) {
                    var v;
                    if (!(h instanceof Cn) || h.name == "await" || n.scope.find_variable(h.name) !== (v = h.definition())) {
                        h = null;
                    } else if (t.has_directive("use strict") || l.name || l.rest || !(p instanceof bn && d < p.args.length && sn(p.args.slice(0, d + 1), function(e) {
                        return !(e instanceof kn);
                    })) || !sn(l.argnames, function(e) {
                        return e instanceof Cn;
                    })) {
                        if (T() || v.assignments || v.orig.length > 1) h = null;
                    }
                } else if ((u || !T()) && d < l.argnames.length + 5 && t.drop_fargs(l, p) && !l.rest) {
                    while (d >= l.argnames.length) {
                        h = l.make_var(Cn, l, "argument_" + l.argnames.length);
                        l.argnames.push(h);
                    }
                }
                if (h && Hn(function(e) {
                    return e.name === h.name;
                }, l.argnames) === h) {
                    if (u) c.reassigned--;
                    var m = ze(Mn, e, h);
                    m.reference();
                    h.unused = undefined;
                    return m;
                }
            }
            if (u) return e;
            if (t.option("sequences") && f.TYPE != "Call" && !(f instanceof ct && f.init === e)) {
                var _ = he(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (a !== r) {
                var g = e.flatten_object(s, t);
                if (g) {
                    n = e.expression = g.expression;
                    r = e.property = g.property;
                }
            }
            var b;
            if (t.option("properties") && t.option("side_effects") && r instanceof jn && n instanceof On && sn(b = n.elements, function(e) {
                return !(e instanceof kn);
            })) {
                var d = r.value;
                var y = b[d];
                if (en(y, t)) {
                    var w = y instanceof Ir;
                    var x = !w;
                    var k = [];
                    for (var E = b.length; --E > d; ) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                            if (x && o.has_side_effects(t)) x = false;
                        }
                    }
                    if (!x) k.unshift(y);
                    while (--E >= 0) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                        } else if (w) {
                            k.unshift(ze(Ir, b[E]));
                        } else {
                            d--;
                        }
                    }
                    if (x) {
                        k.push(y);
                        return Ce(e, k).optimize(t);
                    }
                    return ze(sr, e, {
                        expression: ze(On, n, {
                            elements: k
                        }),
                        property: ze(jn, r, {
                            value: d
                        })
                    });
                }
            }
            return de(t, e);
            function S() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof hn) {
                        if (n instanceof vt) return;
                        if (_t(n)) continue;
                        p = t.parent(e);
                        return n;
                    }
                }
            }
            function T() {
                return !t.option("reduce_vars") || c.reassigned;
            }
        });
        mt.DEFMETHOD("contains_super", function() {
            var n = false;
            var t = this;
            t.walk(new Nn(function(e) {
                if (n) return true;
                if (e instanceof $r) return n = true;
                if (e !== t && e instanceof dn && !_t(e)) return true;
            }));
            return n;
        });
        (function(e) {
            e(wt, an);
            e(xt, an);
            e(un, function() {
                var n = false;
                var t = this;
                t.walk(new Nn(function(e) {
                    if (n) return true;
                    if (e instanceof qr) return n = true;
                    if (e !== t && e instanceof dn && !_t(e)) return true;
                }));
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("contains_this", n);
        });
        function nn(e) {
            return e instanceof vr && typeof e.key == "string" && !(e instanceof mr && e.value.contains_super());
        }
        wn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            if (e === "__proto__") return;
            var t = this.expression;
            if (t instanceof qn) {
                var r = t.properties;
                for (var i = r.length; --i >= 0; ) {
                    var a = r[i];
                    if (a.key !== e) continue;
                    if (!sn(r, nn)) return;
                    if (!en(a.value, n)) return;
                    var o, s = [];
                    for (var f = 0; f < r.length; f++) {
                        var u = r[f].value;
                        if (r[f] instanceof mr) {
                            var c = !(u.uses_arguments || bt(u) || u.contains_this());
                            if (c) {
                                if (!o) o = n.find_parent(dn);
                                var l = ve(o);
                                u.each_argname(function(e) {
                                    if (l[e.name]) c = false;
                                });
                            }
                            var p;
                            if (c) {
                                p = gt(u) ? xt : wt;
                            } else if (i === f && !(n.parent() instanceof bn)) {
                                return;
                            } else {
                                p = u.CTOR;
                            }
                            u = ze(p, u, u);
                        }
                        s.push(u);
                    }
                    return ze(sr, this, {
                        expression: ze(On, t, {
                            elements: s
                        }),
                        property: ze(jn, this, {
                            value: i
                        })
                    });
                }
            }
        });
        e(xn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                un.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (Zr(n.self(), t)) return e;
            var r = ke(e, n);
            if (r) return r;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof ct && t.init === e)) {
                var i = he(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof xn && e.expression.property == "prototype") {
                var a = e.expression.expression;
                if (Fe(a)) switch (a.name) {
                  case "Array":
                    e.expression = ze(On, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = ze(St, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(a.scope);
                    break;

                  case "Number":
                    e.expression = ze(jn, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = ze(qn, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = ze(Fr, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = ze(Pn, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return de(n, e);
        });
        e(lr, function(e, n) {
            if (n.option("rests") && e.rest instanceof lr) {
                return ze(lr, e, {
                    elements: e.elements.concat(e.rest.elements),
                    rest: e.rest.rest
                });
            }
            return e;
        });
        e(pr, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof un) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(qn, function(r, i) {
            if (!i.option("objects")) return r;
            var a = false;
            var t = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = [];
            var u = new fn();
            var c = [];
            r.properties.forEach(function(e) {
                if (!(e instanceof kn)) return p(e);
                t = true;
                var n = e.expression;
                if (i.option("spreads") && n instanceof qn && sn(n.properties, function(e) {
                    if (e instanceof gr) return false;
                    if (e instanceof kn) return false;
                    if (e.key !== "__proto__") return true;
                    if (e instanceof _r) return true;
                    return !e.value.has_side_effects(i);
                })) {
                    a = true;
                    n.properties.forEach(function(e) {
                        var n = e.key;
                        var t = e instanceof _r;
                        if (n === "__proto__") {
                            if (!t) return;
                            n = fe(n, e);
                        }
                        p(t ? ze(vr, e, {
                            key: n,
                            value: ze(Nr, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    l();
                    c.push(e);
                }
            });
            l();
            if (!a) return r;
            if (t && o && c.length == 1) {
                var e = c[0];
                if (e instanceof hr && e.key instanceof jn) {
                    e.key = "" + e.key.value;
                }
            }
            return ze(qn, r, {
                properties: c
            });
            function l() {
                f.forEach(function(e) {
                    var n = u.get(e);
                    switch (n.length) {
                      case 0:
                        return;

                      case 1:
                        return c.push(n[0]);
                    }
                    a = true;
                    var t = s && !o && n.pop();
                    c.push(n.length == 1 ? n[0] : ze(vr, r, {
                        key: n[0].key,
                        value: Ce(r, n.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (t) c.push(t);
                    n.length = 0;
                });
                f = [];
                u = new fn();
            }
            function p(e) {
                var n = e.key;
                if (n instanceof un) {
                    t = true;
                    n = n.evaluate(i);
                    if (n === e.key || n === "__proto__") {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (nn(e)) {
                    if (e.value.has_side_effects(i)) l();
                    f.push(n);
                    u.add(n, e);
                } else {
                    l();
                    c.push(e);
                }
                if (t && !o && typeof n == "string" && z.test(n)) {
                    o = true;
                    if (u.has(n)) e = u.get(n)[0];
                    e.key = ze(jn, e, {
                        value: +n
                    });
                }
            }
        });
        function tn(e) {
            var n = e.definition().redefined();
            if (n) {
                e = e.clone();
                e.thedef = n;
            }
            return e;
        }
        function me(n, e) {
            var t = false;
            e.walk(new Nn(function(e) {
                if (t) return true;
                if (e instanceof Mn && n.variables.get(e.name) === e.definition()) {
                    return t = true;
                }
            }));
            return t;
        }
        function rn(e, n) {
            var t = ze(Mn, n, n);
            var r = ze(Dn, n, {
                operator: "=",
                left: t,
                right: ze(Nr, n).transform(e)
            });
            var i = n.definition();
            if (i.fixed) {
                t.fixed = function() {
                    return r.right;
                };
                t.fixed.assigns = [ r ];
                var a = [];
                i.references.forEach(function(e) {
                    var n = e.fixed;
                    if (!n || !Vn(a, n)) return;
                    if (n.assigns) {
                        n.assigns.unshift(r);
                    } else {
                        n.assigns = [ r ];
                    }
                });
            }
            i.assignments++;
            i.references.push(t);
            return r;
        }
        (function(e) {
            e(un, Yn);
            e(Dn, Yn);
            e(ur, function(t, e, r, n) {
                var i = this;
                var a = o(i.expression).try_inline(t, e, r, n);
                if (!a) return;
                if (!r) _(a, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (n instanceof ur) return;
                    e.value = ze(ur, i, {
                        expression: n || ze(Nr, e).transform(t)
                    });
                });
                return P(a) ? a : ze(pn, i, {
                    body: [ a, ze(ln, i, {
                        body: ze(ur, i, {
                            expression: ze(jn, i, {
                                value: 0
                            })
                        })
                    }) ]
                });
                function o(e) {
                    if (!r) return e;
                    if (e.TYPE != "Call") return e;
                    var n = e.expression;
                    switch (n.CTOR) {
                      case xt:
                        n = ze(wt, n, n);
                        break;

                      case kt:
                        n = ze(St, n, n);
                        break;

                      case Et:
                        n = ze(Tt, n, n);
                        break;

                      default:
                        return e;
                    }
                    e = e.clone();
                    e.expression = n;
                    return e;
                }
            });
            e(Tn, function(n, e, t, r) {
                if (t === undefined) return;
                var i = this;
                var a = i.operator;
                if (!je[a]) return;
                var o = i.right.try_inline(n, e, t, r);
                if (!o) return;
                return ze(mn, i, {
                    condition: s(i.left),
                    body: o,
                    alternative: t ? null : ze(vn, i, {
                        value: null
                    })
                });
                function s(e) {
                    switch (a) {
                      case "&&":
                        return e;

                      case "||":
                        return e.negate(n);

                      case "??":
                        return ze(Tn, i, {
                            operator: "==",
                            left: ze(Pr, i),
                            right: e
                        });
                    }
                }
            });
            e(pn, function(e, n, t, r) {
                if (t) return;
                if (!this.variables) return;
                var i = this.body;
                var a = i.length - 1;
                if (a < 0) return;
                var o = i[a].try_inline(e, this, t, r);
                if (!o) return;
                i[a] = o;
                return this;
            });
            e(bn, function(r, i, e, a) {
                if (r.option("inline") < 4) return;
                var t = this;
                if (t.is_expr_pure(r)) return;
                var o = t.expression;
                if (!(o instanceof mt)) return;
                if (o.name) return;
                if (o.uses_arguments) return;
                if (o.pinned()) return;
                if (bt(o)) return;
                var s = _t(o);
                if (s && o.value) return;
                if (o.body[0] instanceof Zn) return;
                if (o.contains_this()) return;
                if (!i) i = qe(r);
                var f = new fn();
                f.set("NaN", true);
                while (!(i instanceof dn)) {
                    i.variables.each(function(e) {
                        f.set(e.name, true);
                    });
                    i = i.parent_scope;
                }
                if (!In(i, r.stack)) return;
                if (i.pinned() && o.variables.size() > (s ? 0 : 1)) return;
                if (i instanceof ht) {
                    if (o.variables.size() > (s ? 0 : 1)) {
                        if (!r.toplevel.vars) return;
                        if (o.functions.size() > 0 && !r.toplevel.funcs) return;
                    }
                    f.set("arguments", true);
                }
                var u = gt(o);
                if (u) {
                    if (!r.option("awaits")) return;
                    if (!gt(i)) return;
                    if (t.may_throw(r)) return;
                }
                var c = i.var_names();
                if (a) a = [];
                if (!o.variables.all(function(e, n) {
                    if (a) a.push(e);
                    if (!f.has(n) && !c.has(n)) return true;
                    return !s && n == "arguments" && e.orig.length == 1;
                })) return;
                if (a && a.length > 0 && Ke(o, a)) return;
                var l = true;
                if (!sn(o.argnames, function(e) {
                    var n = false;
                    var t = new Nn(function(e) {
                        if (n) return true;
                        if (e instanceof gn) {
                            if (me(o, e.value)) return n = true;
                            e.name.walk(t);
                            return true;
                        }
                        if (e instanceof pr) {
                            if (e.key instanceof un && me(o, e.key)) return n = true;
                            e.value.walk(t);
                            return true;
                        }
                        if (e instanceof Cn && !sn(e.definition().orig, function(e) {
                            return !(e instanceof Er);
                        })) return n = true;
                    });
                    e.walk(t);
                    if (n) return false;
                    if (!(e instanceof Cn)) l = false;
                    return true;
                })) return;
                if (o.rest) {
                    if (me(o, o.rest)) return;
                    l = false;
                }
                if (e && !sn(o.body, function(e) {
                    var n = false;
                    e.walk(new Nn(function(e) {
                        if (n) return true;
                        if (u && e instanceof ur || e instanceof vn) return n = true;
                        if (e instanceof dn && e !== o) return true;
                    }));
                    return !n;
                })) return;
                if (!Se(o, ve(i))) return;
                o.functions.each(function(e, n) {
                    i.functions.set(n, e);
                });
                var p = [];
                o.variables.each(function(n, e) {
                    if (e == "arguments") return;
                    c.set(e, true);
                    i.enclosed.push(n);
                    i.variables.set(e, n);
                    n.single_use = false;
                    if (!a) return;
                    if (n.references.length == n.replaced) return;
                    if (n.orig.length == n.eliminated) return;
                    if (n.orig.length == 1 && o.functions.has(e)) return;
                    if (!sn(n.orig, function(e) {
                        if (e instanceof yr) return false;
                        if (e instanceof Cn) return n.scope.resolve() !== o;
                        if (e instanceof xr) return false;
                        return true;
                    })) return;
                    var t = n.orig[0];
                    if (t instanceof Ar) return;
                    p.push(ze(ln, t, {
                        body: rn(r, tn(t))
                    }));
                });
                var d = Object.create(null), h = new fn();
                if (l && sn(t.args, function(e) {
                    return !(e instanceof kn);
                })) {
                    var v = t.args.slice();
                    o.argnames.forEach(function(e) {
                        var n = v.shift();
                        if (e.unused) {
                            if (n) p.push(ze(ln, t, {
                                body: n
                            }));
                            return;
                        }
                        p.push(ze(er, t, {
                            definitions: [ ze(_n, t, {
                                name: e.convert_symbol(kr, m),
                                value: n || ze(Nr, t).transform(r)
                            }) ]
                        }));
                    });
                    if (v.length) p.push(ze(ln, t, {
                        body: Ce(t, v)
                    }));
                } else {
                    p.push(ze(er, t, {
                        definitions: [ ze(_n, t, {
                            name: ze(lr, t, {
                                elements: o.argnames.map(function(e) {
                                    if (e.unused) return ze(Ir, e);
                                    return e.convert_symbol(kr, m);
                                }),
                                rest: o.rest && o.rest.convert_symbol(kr, m)
                            }),
                            value: ze(On, t, {
                                elements: t.args.slice()
                            })
                        }) ]
                    }));
                }
                h.each(function(e, n) {
                    var t = d[n];
                    [].unshift.apply(t.orig, e);
                    t.eliminated += e.length;
                });
                [].push.apply(p, a ? o.body.filter(function(e) {
                    if (!(e instanceof At)) return true;
                    var n = ze(kr, e.name, tn(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    p.push(ze(er, e, {
                        definitions: [ ze(_n, e, {
                            name: n,
                            value: we(e, true)
                        }) ]
                    }));
                    return false;
                }) : o.body);
                var n = ze(pn, t, {
                    body: p
                });
                if (!e) {
                    if (u) _(n, function(e) {
                        var n = e.value;
                        if (Pe(n)) return;
                        e.value = ze(ur, t, {
                            expression: n
                        });
                    });
                    p.push(ze(vn, t, {
                        value: null
                    }));
                }
                return n;
                function m(e, n) {
                    var t = n.definition();
                    d[t.id] = t;
                    h.add(t.id, e);
                }
            });
            e(An, function(e, n, t, r) {
                var i = this;
                var a = i.consequent.try_inline(e, n, t, r);
                var o = i.alternative.try_inline(e, n, t, r);
                if (!a && !o) return;
                return ze(mn, i, {
                    condition: i.condition,
                    body: a || s(i.consequent),
                    alternative: o || s(i.alternative)
                });
                function s(e) {
                    if (t) return ze(ln, e, {
                        body: e
                    });
                    return ze(vn, e, {
                        value: e
                    });
                }
            });
            e(ut, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.init;
                if (a) {
                    a = a.try_inline(e, n, true, r);
                    if (a) {
                        this.init = null;
                        if (a instanceof pn) {
                            a.body.push(this);
                            return a;
                        }
                        return ze(pn, a, {
                            body: [ a, this ]
                        });
                    }
                }
                return i && this;
            });
            e(ct, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.object;
                if (a instanceof yn) {
                    var o = f(e, n, true, r, a, 1);
                    if (o) {
                        this.object = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(mn, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.alternative;
                if (a) {
                    a = a.try_inline(e, n, t, r);
                    if (a) this.alternative = a;
                }
                var o = this.condition;
                if (o instanceof yn) {
                    var s = f(e, n, true, r, o, 1);
                    if (s) {
                        this.condition = o.tail_node();
                        s.body.push(this);
                        return s;
                    }
                }
                return (i || a) && this;
            });
            e(at, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (!i) return;
                this.body = i;
                return this;
            });
            e(it, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (!i) return;
                this.body = i;
                return this;
            });
            e(ar, Yn);
            e(vn, function(e, n, t, r) {
                var i = this.value;
                return i && i.try_inline(e, n, undefined, r === "try");
            });
            function f(e, n, t, r, i, a) {
                var o = [], s = i.expressions, f = t;
                for (var u = s.length - (a || 0), c = u; --u >= 0; f = true) {
                    var l = s[u].try_inline(e, n, f, r);
                    if (!l) continue;
                    p();
                    o.push(l);
                }
                if (o.length == 0) return;
                p();
                if (!t && o[0] instanceof ln) {
                    o[0] = ze(vn, i, {
                        value: o[0].body
                    });
                }
                return ze(pn, i, {
                    body: o.reverse()
                });
                function p() {
                    if (c > u + 1) o.push(ze(ln, i, {
                        body: Ce(i, s.slice(u + 1, c))
                    }));
                    c = u;
                }
            }
            e(yn, function(e, n, t, r) {
                return f(e, n, t, r, this);
            });
            e(ln, function(e, n, t, r) {
                var i = this.body;
                while (i instanceof Sn) {
                    var a = i.operator;
                    if (Qr[a]) break;
                    if (a == "void") break;
                    i = i.expression;
                }
                if (!t && !Pe(i)) i = ze(Sn, this, {
                    operator: "void",
                    expression: i
                });
                return i.try_inline(e, n, t || false, r);
            });
            e(Sn, function(t, e, n, r) {
                var i = this;
                var a = i.operator;
                if (Qr[a]) return;
                if (!n && a == "void") n = false;
                var o = i.expression.try_inline(t, e, n, r);
                if (!o) return;
                if (!n) _(o, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (a == "void" && Pe(n)) return;
                    e.value = ze(Sn, i, {
                        operator: a,
                        expression: n || ze(Nr, e).transform(t)
                    });
                });
                return o;
            });
            e(dt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.expression;
                if (a instanceof yn) {
                    var o = f(e, n, true, r, a, 1);
                    if (o) {
                        this.expression = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(cr, function(e, n, t, r) {
                if (!e.option("yields")) return;
                if (!this.nested) return;
                var i = this.expression;
                if (i.TYPE != "Call") return;
                var a = i.expression;
                switch (a.CTOR) {
                  case Et:
                    a = ze(kt, a, a);
                    break;

                  case Tt:
                    a = ze(St, a, a);
                    break;

                  default:
                    return;
                }
                i = i.clone();
                i.expression = a;
                return i.try_inline(e, n, t, r);
            });
        })(function(e, n) {
            e.DEFMETHOD("try_inline", n);
        });
        e(vn, function(e, n) {
            var t = e.value;
            if (t && n.option("side_effects") && Pe(t, n) && !k(n.find_parent(dn))) {
                e.value = null;
            }
            return e;
        });
    })(function(e, r) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = r(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ae(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function ni(f) {
        f = be(f, {
            annotations: false,
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = an;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var e = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, e - 1), f.comments.substr(e + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = ae;
            } else {
                u = Rn;
            }
        }
        function t(e) {
            if (typeof e == "number") return new Array(e + 1).join(" ");
            if (!e) return "";
            if (!/^\s*$/.test(e)) throw new Error("unsupported indentation: " + JSON.stringify("" + e));
            return e;
        }
        var c = 0;
        var l = 1;
        var r = t(f.indent_start);
        var i = t(f.indent_level);
        var P = i.length + 1 >> 1;
        var o;
        var s = 0;
        var p = true;
        var d = f.source_map && [];
        var h;
        var v;
        var m;
        var _;
        var g = false;
        var b = false;
        var y;
        var a;
        var w = "";
        function x() {
            o = "";
            m = false;
            _ = false;
            a = [];
            var e = y;
            y = "";
            return e;
        }
        x();
        var k = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, r = 0; t < e.length; t++) {
                var i = e.charCodeAt(t);
                if (te(i)) {
                    if (re(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!re(i)) {
                    continue;
                }
                n += e.slice(r, t) + "\\u" + i.toString(16);
                r = t + 1;
            }
            return r == 0 ? e : n + e.slice(r);
        };
        function E(e) {
            return "'" + e.replace(/\x27/g, "\\'") + "'";
        }
        function S(e) {
            return '"' + e.replace(/\x22/g, '\\"') + '"';
        }
        var j = [ null, E, S, function(e, n) {
            return n == "'" ? E(e) : S(e);
        } ][f.quote_style] || function(e, n, t, r) {
            return t > r ? E(e) : S(e);
        };
        function T(t, e) {
            var r = 0, i = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++r;
                    return '"';

                  case "'":
                    ++i;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            return j(k(t), e, r, i);
        }
        var N = d ? function(n, t) {
            d.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Yn;
        var A = d ? function() {
            d.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            d = [];
        } : Yn;
        function D(e) {
            w += y.slice(0, s);
            y = y.slice(s);
            var n = y.length;
            N(e, n - c);
            l += e;
            c = n;
            while (e--) w += "\n";
        }
        var O = f.max_line_len ? function(e) {
            if (p) {
                if (c > f.max_line_len) {
                    un.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (c > f.max_line_len) {
                D(1);
                p = true;
            }
            if (p || e) A();
        } : Yn;
        var I = on("( [ + * / - , .");
        var $ = f.beautify || f.comments || f.max_line_len || f.preserve_line || f.shebang || !f.semicolons || f.source_map || f.width ? function(e) {
            var n = e.charAt(0);
            if (g && n) {
                g = false;
                if (n != "\n") {
                    $("\n");
                    z();
                }
            }
            if (b && n) {
                b = false;
                if (!/[\s;})]/.test(n)) {
                    q();
                }
            }
            var t = o.slice(-1);
            if (_) {
                _ = false;
                if (t == ":" && n == "}" || t != ";" && (!n || ";}".indexOf(n) < 0)) {
                    var r = I[n];
                    if (r || f.semicolons) {
                        y += ";";
                        c++;
                        if (!p) {
                            O();
                            if (p && !r && y == ";") {
                                y = "";
                                c = 0;
                            }
                        }
                        if (s == y.length - 1) s++;
                    } else {
                        O();
                        y += "\n";
                        l++;
                        c = 0;
                        if (/^\s+$/.test(e)) _ = true;
                    }
                    if (!f.beautify) m = false;
                }
            }
            if (m) {
                if (ie(t) && (ie(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == o || e == "--" && o == "!" || e == "in" && t == "/" || o == "--" && n == ">") {
                    y += " ";
                    c++;
                }
                if (t != "<" || e != "!") m = false;
            }
            if (v) {
                d.push({
                    token: v,
                    name: h,
                    line: l,
                    col: c
                });
                v = false;
                if (p) A();
            }
            y += e;
            var i = e.split(/\r?\n/), a = i.length - 1;
            l += a;
            c += i[0].length;
            if (a > 0) {
                O();
                c = i[a].length;
            }
            o = e;
        } : function(e) {
            var n = e.charAt(0);
            var t = o.slice(-1);
            if (_) {
                _ = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    y += ";";
                    m = false;
                }
            }
            if (m) {
                if (ie(t) && (ie(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == o || e == "--" && o == "!" || e == "in" && t == "/" || o == "--" && n == ">") {
                    y += " ";
                }
                if (t != "<" || e != "!") m = false;
            }
            y += e;
            o = e;
        };
        var q = f.beautify ? function() {
            $(" ");
        } : function() {
            m = true;
        };
        var z = f.beautify ? function(e) {
            if (g) $("\n");
            $(e ? r.slice(0, -P) : r);
        } : Yn;
        var C = f.beautify ? function(e) {
            var n = r;
            r += i;
            e();
            r = n;
        } : function(e) {
            e();
        };
        var M = f.max_line_len || f.preserve_line ? function() {
            O();
            s = y.length;
            p = false;
        } : Yn;
        var H = f.beautify ? function() {
            $("\n");
            s = y.length;
        } : M;
        var Y = f.beautify ? function() {
            $(";");
        } : function() {
            _ = true;
        };
        function R() {
            if (_) $(";");
            $(";");
        }
        function L(e) {
            $("{");
            H();
            C(e);
            z();
            $("}");
        }
        function B(e) {
            $("(");
            M();
            e();
            M();
            $(")");
        }
        function U(e) {
            $("[");
            M();
            e();
            M();
            $("]");
        }
        function V() {
            M();
            $(",");
            M();
            q();
        }
        function W() {
            $(":");
            q();
        }
        var G = d ? function(e, n) {
            v = e;
            h = n;
        } : Yn;
        function J() {
            if (!p) O(true);
            return w + y;
        }
        function X() {
            return /(^|\n) *$/.test(y);
        }
        function F(e, n) {
            if (g) return;
            if (e.nlb && (n || !X())) {
                g = true;
            } else if (n) {
                b = true;
            }
        }
        function K(e) {
            var n = e.value.replace(/[@#]__PURE__/g, " ");
            if (/^\s*$/.test(n) && !/^\s*$/.test(e.value)) return false;
            if (/comment[134]/.test(e.type)) {
                $("//" + n);
                g = true;
            } else if (e.type == "comment2") {
                $("/*" + n + "*/");
            }
            return true;
        }
        function Q(e, n) {
            if (n instanceof Tn) return n.left === e;
            if (n.TYPE == "Call") return n.expression === e;
            if (n instanceof An) return n.condition === e;
            if (n instanceof xn) return n.expression === e;
            if (n instanceof It) return true;
            if (n instanceof yn) return n.expressions[0] === e;
            if (n instanceof sr) return n.expression === e;
            if (n instanceof fr) return true;
            if (n instanceof cr) return true;
        }
        function Z(e) {
            var r = this;
            var i;
            if (e instanceof It) {
                i = e.value;
            } else if (e instanceof cr) {
                i = e.expression;
            }
            var t = s(e);
            if (!t) t = [];
            if (i) {
                var a = new Nn(function(e) {
                    if (!Q(e, a.parent())) return true;
                    var n = s(e);
                    if (n) t = t.concat(n);
                });
                a.push(e);
                i.walk(a);
            }
            if (l == 1 && c == 0) {
                if (t.length > 0 && f.shebang && t[0].type == "comment5") {
                    $("#!" + t.shift().value + "\n");
                    z();
                }
                var n = f.preamble;
                if (n) $(n.replace(/\r\n?|\u2028|\u2029|(^|\S)\s*$/g, "$1\n"));
            }
            t = t.filter(u, e);
            var o = false;
            t.forEach(function(e, n) {
                F(e, n);
                if (K(e)) o = true;
            });
            if (o) F(e.start, true);
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!i) return;
                    e.start = n = new ne();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!i) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === r) return;
                t._dumped = r;
                return t;
            }
        }
        function ee(e, t) {
            var n = this;
            var r = e.end;
            if (!r) return;
            var i = r[t ? "comments_before" : "comments_after"];
            if (!i || i._dumped === n) return;
            if (!(e instanceof Kn || sn(i, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            i._dumped = n;
            i.filter(u, e).forEach(function(e, n) {
                F(e, n || !t);
                K(e);
            });
        }
        return {
            get: J,
            reset: x,
            indent: z,
            should_break: f.beautify && f.width ? function() {
                return c >= f.width;
            } : an,
            has_parens: function() {
                return o.slice(-1) == "(";
            },
            newline: H,
            print: $,
            space: q,
            comma: V,
            colon: W,
            last: function() {
                return o;
            },
            semicolon: Y,
            force_semicolon: R,
            to_utf8: k,
            print_name: function(e) {
                $(k(e.toString(), true));
            },
            print_string: f.inline_script ? function(e, n) {
                e = T(e, n).replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                $(e.replace(/\x3c!--/g, "\\x3c!--").replace(/--\x3e/g, "--\\x3e"));
            } : function(e, n) {
                $(T(e, n));
            },
            with_indent: C,
            with_block: L,
            with_parens: B,
            with_square: U,
            add_mapping: G,
            option: function(e) {
                return f[e];
            },
            prepend_comments: f.comments || f.shebang ? Z : Yn,
            append_comments: f.comments ? ee : Yn,
            push_node: function(e) {
                a.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = a.pop();
                if (e.start && e.start.line > l) {
                    D(e.start.line - l);
                }
            } : function() {
                a.pop();
            },
            parent: function(e) {
                return a[a.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        un.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(r);
            } else {
                r();
            }
            e.pop_node();
            function r() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        var t = ni({
            inline_script: false,
            shebang: false,
            width: false
        });
        un.DEFMETHOD("print_to_string", function(e) {
            if (e) {
                var n = ni(e);
                this.print(n);
                return n.get();
            }
            this.print(t);
            return t.reset();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(un, an);
        function r(e) {
            var n = e.parent();
            if (!e.has_parens() && Xn(e, false, true)) {
                return this.name || !(n instanceof tr);
            }
            if (e.option("webkit") && n instanceof wn && n.expression === this) return true;
            if (e.option("wrap_iife") && n instanceof bn && n.expression === this) return true;
        }
        n(kt, r);
        n(Et, r);
        n(Mt, r);
        n(St, r);
        n(Tt, r);
        function i(e) {
            return !e.has_parens() && Xn(e, true);
        }
        n(qn, i);
        function a(e) {
            var n = e.parent();
            if (n instanceof Tn) return n.operator == "**" && n.left === this;
            if (n instanceof bn) return n.expression === this;
            if (n instanceof zt) return true;
            if (n instanceof wn) return n.expression === this;
            if (n instanceof Cr) return n.tag === this;
        }
        n(ur, a);
        n(En, a);
        n(yn, function(e) {
            var n = e.parent();
            return n instanceof On || _t(n) && n.value === this || n instanceof ur || n instanceof Tn || n instanceof bn || n instanceof zt || n instanceof Ft || n instanceof An || n instanceof gn || n instanceof pr || n instanceof tr || n instanceof ye || n instanceof hr || n instanceof wn && n.expression === this || n instanceof kn || n instanceof Cr && n.tag === this || n instanceof En || n instanceof _n || n instanceof cr;
        });
        n(Tn, function(e) {
            var n = e.parent();
            if (n instanceof ur) return true;
            if (n instanceof Tn) {
                var t = n.operator, r = Jr[t];
                var i = this.operator, a = Jr[i];
                return r > a || t == "??" && (i == "&&" || i == "||") || r == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof bn) return n.expression === this;
            if (n instanceof zt) return true;
            if (n instanceof wn) return n.expression === this;
            if (n instanceof Cr) return n.tag === this;
            if (n instanceof En) return true;
        });
        function o(e, n) {
            if (!e.terminal) return false;
            if (!(n instanceof bn || n instanceof wn)) return false;
            return n.expression === e;
        }
        n(wn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof ar && t.expression === n && or(n).TYPE == "Call") return true;
            return o(n, t);
        });
        n(bn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof ar) return t.expression === n;
            if (e.option("webkit") && n.expression instanceof St && t instanceof wn && t.expression === n) {
                var r = e.parent(1);
                if (r instanceof Dn && r.left === t) return true;
            }
            return o(n, t);
        });
        n(ar, function(e) {
            if (z(this, e)) return false;
            var n = e.parent();
            if (n instanceof bn) return n.expression === this;
            if (n instanceof wn) return true;
            if (n instanceof Cr) return n.tag === this;
        });
        n(jn, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof wn && n.expression === this && /^0/.test(C(this.value));
        });
        function f(e, n) {
            var t = n.parent();
            if (t instanceof ur) return true;
            if (t instanceof Tn) return !(t instanceof Dn);
            if (t instanceof bn) return t.expression === e;
            if (t instanceof zt) return true;
            if (t instanceof An) return t.condition === e;
            if (t instanceof wn) return t.expression === e;
            if (t instanceof Cr) return t.tag === e;
            if (t instanceof En) return true;
        }
        n(wt, function(e) {
            return f(this, e);
        });
        n(Dn, function(e) {
            if (f(this, e)) return true;
            if (e.option("v8")) return this.left instanceof $n;
            if (this.left instanceof dr) return i(e);
        });
        n(xt, function(e) {
            return f(this, e);
        });
        n(An, function(e) {
            return f(this, e);
        });
        n(cr, function(e) {
            return f(this, e);
        });
        e(Zn, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(Qn, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function u(e, t, r, n) {
            var i = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof Zn) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof cn)) {
                        if (e instanceof ln && e.body instanceof Pn) {
                            r.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof cn) return;
                r.indent();
                e.print(r);
                if (n == i && t) return;
                r.newline();
                if (t) r.newline();
            });
            s = o;
        }
        e(ht, function(e) {
            u(this.body, true, e, true);
            e.print("");
        });
        e(it, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(ln, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function c(e, n) {
            n.print("{");
            n.with_indent(function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function l(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    u(e.body, false, n, t);
                });
            } else c(e, n);
        }
        e(pn, function(e) {
            l(this, e);
        });
        e(cn, function(e) {
            e.semicolon();
        });
        e(st, function(e) {
            var n = this;
            e.print("do");
            M(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(ft, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            q(n.body, e);
        });
        e(ut, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof Kt) {
                        n.init.print(e);
                    } else {
                        E(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            q(n.body, e);
        });
        function p(t, r) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                e.with_parens(function() {
                    n.init.print(e);
                    e.space();
                    e.print(r);
                    e.space();
                    n.object.print(e);
                });
                q(n.body, e);
            };
        }
        e(pt, p("for await", "of"));
        e(lt, p("for", "in"));
        e(ye, p("for", "of"));
        e(dt, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            q(n.body, e);
        });
        e(nr, function(e) {
            e.print("export");
            e.space();
            this.body.print(e);
        });
        e(tr, function(e) {
            e.print("export");
            e.space();
            e.print("default");
            e.space();
            var n = this.body;
            n.print(e);
            if (n instanceof Mt) {
                if (!n.name) return;
            }
            if (n instanceof Ct) return;
            if (n instanceof At) return;
            if (n instanceof mt) {
                if (!n.name && !_t(n)) return;
            }
            e.semicolon();
        });
        e(ke, function(r) {
            var i = this;
            r.print("export");
            r.space();
            var n = i.keys.length;
            if (n == 0) {
                c(i, r);
            } else if (i.keys[0] == "*") {
                t(0);
            } else r.with_block(function() {
                r.indent();
                t(0);
                for (var e = 1; e < n; e++) {
                    r.print(",");
                    r.newline();
                    r.indent();
                    t(e);
                }
                r.newline();
            });
            r.space();
            r.print("from");
            r.space();
            r.print_string(i.path, i.quote);
            r.semicolon();
            function t(e) {
                var n = i.aliases[e];
                var t = i.keys[e];
                r.print_name(t);
                if (n != t) {
                    r.space();
                    r.print("as");
                    r.space();
                    r.print_name(n);
                }
            }
        });
        e(rr, function(e) {
            var n = this;
            e.print("export");
            e.space();
            A(n, e);
            e.semicolon();
        });
        e(ir, function(e) {
            var n = this;
            e.print("import");
            e.space();
            if (n.default) n.default.print(e);
            if (n.all) {
                if (n.default) e.comma();
                n.all.print(e);
            }
            if (n.properties) {
                if (n.default) e.comma();
                A(n, e);
            }
            if (n.all || n.default || n.properties) {
                e.space();
                e.print("from");
                e.space();
            }
            e.print_string(n.path, n.quote);
            e.semicolon();
        });
        function d(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function h(e, n) {
            var t = e.argnames.length == 1 && !e.rest && e.argnames[0];
            if (t instanceof Cn && t.name != "yield") {
                t.print(n);
            } else {
                d(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                l(e, n, true);
            }
        }
        e(wt, function(e) {
            h(this, e);
        });
        e(xt, function(e) {
            e.print("async");
            e.space();
            h(this, e);
        });
        function v(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            d(e, n);
            n.space();
            l(e, n, true);
        }
        e(hn, function(e) {
            e.print("function");
            v(this, e);
        });
        function m(e) {
            e.print("async");
            e.space();
            e.print("function");
            v(this, e);
        }
        e(Dt, m);
        e(kt, m);
        function _(e) {
            e.print("async");
            e.space();
            e.print("function*");
            v(this, e);
        }
        e(Ot, _);
        e(Et, _);
        function g(e) {
            e.print("function*");
            v(this, e);
        }
        e(qt, g);
        e(Tt, g);
        e(zt, function(e) {
            var n = this;
            e.print("class");
            if (n.name) {
                e.space();
                n.name.print(e);
            }
            if (n.extends) {
                e.space();
                e.print("extends");
                e.space();
                n.extends.print(e);
            }
            e.space();
            A(n, e, true);
        });
        e(Pt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            D(n, e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                n.value.print(e);
            }
            e.semicolon();
        });
        e(we, O("get"));
        e(xe, O("set"));
        function b(e, n) {
            var t = e.value;
            if (gt(t)) {
                n.print("async");
                n.space();
            }
            if (bt(t)) n.print("*");
            D(e, n);
            v(e.value, n);
        }
        e(jt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            b(n, e);
        });
        function y(t, r) {
            return function(e) {
                e.print(t);
                var n = this[r];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(vn, y("return", "value"));
        e(Ht, y("throw", "value"));
        e(Rt, y("break", "label"));
        e(Lt, y("continue", "label"));
        function w(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof Qt || t instanceof Zt) || n.option("ie") && t instanceof st) return M(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof mn) {
                    if (!t.alternative) {
                        M(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof j) {
                    t = t.body;
                } else break;
            }
            q(e.body, n);
        }
        e(mn, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            if (n.alternative) {
                w(n, e);
                e.space();
                e.print("else");
                if (n.alternative instanceof mn) {
                    e.space();
                    n.alternative.print(e);
                } else {
                    q(n.alternative, e);
                }
            } else {
                q(n.body, e);
            }
        });
        e(Bt, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var r = e.body.length - 1;
            if (r < 0) c(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < r && e.body.length > 0) t.newline();
                });
            });
        });
        function x(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(Vt, function(e) {
            e.print("default:");
            x(this, e);
        });
        e(Wt, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            x(n, e);
        });
        e(Gt, function(e) {
            var n = this;
            e.print("try");
            e.space();
            l(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(Jt, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            l(n, e);
        });
        e(Xt, function(e) {
            e.print("finally");
            e.space();
            l(this, e);
        });
        function k(r) {
            return function(t) {
                var e = this;
                t.print(r);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (!(n instanceof at && n.init === e)) t.semicolon();
            };
        }
        e(Qt, k("const"));
        e(Zt, k("let"));
        e(er, k("var"));
        function E(e, n, t) {
            var r = false;
            if (t) e.walk(new Nn(function(e) {
                if (r) return true;
                if (e instanceof Tn && e.operator == "in") return r = true;
                if (e instanceof dn && !(_t(e) && e.value)) return true;
            }));
            e.print(n, r);
        }
        e(_n, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var r = t instanceof ut || t instanceof ct;
                E(n.value, e, r);
            }
        });
        e(gn, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function S(e, n) {
            if (!n.option("annotations")) return;
            if (!e.pure) return;
            var t = 0, r = e, i;
            do {
                i = r;
                r = n.parent(t++);
                if (r instanceof bn && r.expression === i) return;
            } while (r instanceof wn && r.expression === i);
            n.print("/*@__PURE__*/");
        }
        function T(e, t) {
            if (e.expression instanceof bn || e.expression instanceof hn) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(bn, function(e) {
            var n = this;
            S(n, e);
            n.expression.print(e);
            if (n.optional) e.print("?.");
            T(n, e);
        });
        e(ar, function(e) {
            var n = this;
            S(n, e);
            e.print("new");
            e.space();
            n.expression.print(e);
            if (z(n, e)) T(n, e);
        });
        e(yn, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(xn, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var r = n.property;
            if (e.option("ie") && N[r]) {
                e.print(n.optional ? "?.[" : "[");
                e.add_mapping(n.end);
                e.print_string(r);
                e.print("]");
            } else {
                if (t instanceof jn && !/[ex.)]/i.test(e.last())) e.print(".");
                e.print(n.optional ? "?." : ".");
                e.add_mapping(n.end);
                e.print_name(r);
            }
        });
        e(sr, function(e) {
            var n = this;
            n.expression.print(e);
            e.print(n.optional ? "?.[" : "[");
            n.property.print(e);
            e.print("]");
        });
        e(kn, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(Sn, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof Sn && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(fr, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(Tn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(An, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(ur, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(cr, function(e) {
            e.print(this.nested ? "yield*" : "yield");
            if (this.expression) {
                e.space();
                this.expression.print(e);
            }
        });
        e(On, function(t) {
            var e = this.elements, r = e.length;
            t.with_square(r > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === r - 1 && e instanceof Ir) t.comma();
                });
                t.space();
            } : Yn);
        });
        e(lr, function(t) {
            var e = this.elements, n = e.length, r = this.rest;
            t.with_square(n || r ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (r) {
                    if (n) t.comma();
                    t.print("...");
                    r.print(t);
                } else if (e[n - 1] instanceof Ir) {
                    t.comma();
                }
                t.space();
            } : Yn);
        });
        e(pr, function(e) {
            var n = this;
            var t = D(n, e);
            var r = n.value;
            if (t) {
                if (r instanceof gn) {
                    if (r.name instanceof br && t == $(r.name)) {
                        e.space();
                        e.print("=");
                        e.space();
                        r.value.print(e);
                        return;
                    }
                } else if (r instanceof br) {
                    if (t == $(r)) return;
                }
            }
            e.colon();
            r.print(e);
        });
        e(dr, function(t) {
            var e = this.properties, n = e.length, r = this.rest;
            if (n || r) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (r) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    r.print(t);
                }
                t.newline();
            }); else c(this, t);
        });
        function A(e, t, r) {
            var n = e.properties;
            if (n.length > 0) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        if (!r) t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else c(e, t);
        }
        e(qn, function(e) {
            A(this, e);
        });
        function D(e, n) {
            var t = e.key;
            if (t instanceof un) return n.with_square(function() {
                t.print(n);
            });
            var r = e.start && e.start.quote;
            if (n.option("quote_keys") || r && n.option("keep_quoted_props")) {
                n.print_string(t, r);
            } else if ("" + +t == t && t >= 0) {
                n.print(C(t));
            } else if (e.private) {
                n.print_name(t);
            } else if (N[t] ? !n.option("ie") : Ur(t)) {
                n.print_name(t);
                return t;
            } else {
                n.print_string(t, r);
            }
        }
        e(vr, function(e) {
            var n = this;
            D(n, e);
            e.colon();
            n.value.print(e);
        });
        e(mr, function(e) {
            b(this, e);
        });
        function O(t) {
            return function(e) {
                var n = this;
                if (n.static) {
                    e.print("static");
                    e.space();
                }
                e.print(t);
                e.space();
                D(n, e);
                v(n.value, e);
            };
        }
        e(gr, O("get"));
        e(_r, O("set"));
        function $(e) {
            var n = e.definition();
            return n && n.mangled_name || e.name;
        }
        e(br, function(e) {
            e.print_name($(this));
        });
        e(Dr, function(e) {
            var n = this;
            var t = $(n);
            e.print_name(t);
            var r = n.alias;
            if (r != t) {
                e.space();
                e.print("as");
                e.space();
                e.print_name(r);
            }
        });
        e(wr, function(e) {
            var n = this;
            var t = $(n);
            var r = n.key;
            if (r && r != t) {
                e.print_name(r);
                e.space();
                e.print("as");
                e.space();
            }
            e.print_name(t);
        });
        e(Ir, Yn);
        e(Cr, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e(Fn, function(e) {
            e.print("" + this.value);
        });
        e(Pn, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(jn, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(C(this.value));
            }
        });
        e(Fr, function(e) {
            var n = this.value;
            var t = n.toString();
            var r = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(r);
            } else if (r == 1) {
                t = "/(?:)" + t.slice(r);
            } else if (t.indexOf("/", 1) < r) {
                t = "/" + t.slice(1, r).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(r);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var i = e.parent();
            if (i instanceof Tn && /^in/.test(i.operator) && i.left === this) e.print(" ");
        });
        function q(e, n) {
            if (n.option("braces") && !(e instanceof Qt || e instanceof Zt)) {
                M(e, n);
            } else if (e instanceof cn) {
                n.force_semicolon();
            } else {
                n.space();
                e.print(n);
            }
        }
        function z(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function P(e) {
            var n = e[0], t = n.length;
            for (var r = 1; r < e.length; ++r) {
                if (e[r].length < t) {
                    n = e[r];
                    t = n.length;
                }
            }
            return n;
        }
        function C(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var r, i, a;
            if (r = /^\.0+/.exec(n)) {
                i = r[0].length;
                a = n.slice(i);
                t.push(a + "e-" + (a.length + i - 1));
            } else if (r = /[^0]0+$/.exec(n)) {
                i = r[0].length - 1;
                t.push(n.slice(0, -i) + "e" + i);
            } else if (r = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(r[1] + r[2] + "e" + (r[3] - r[2].length));
            }
            return P(t);
        }
        function M(e, n) {
            n.space();
            if (e instanceof cn) {
                c(e, n);
            } else if (e instanceof pn) {
                e.print(n);
            } else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function F(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        F([ un, it ], Yn);
        F([ On, pn, Jt, Fn, Qn, Kt, $n, Xt, Nt, hn, ar, qn, j, br, Bt, Ut, Gt ], function(e) {
            e.add_mapping(this.start);
        });
        F([ Ft, pr, hr ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var S = t("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var T = S.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function A(e, n) {
        var t = 0;
        var r = 0;
        for (var i = 0, a = 0; i < n.length; i++) {
            var o = T[n[i]];
            t += (o & 31) << r;
            if (o & 32) {
                r += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = r = 0;
            }
        }
        return a;
    }
    function D(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += S[t];
        } while (e);
        return n;
    }
    function O() {
        var t = new fn();
        var r = [];
        r.index = function(e) {
            var n = t.get(e);
            if (!(n >= 0)) {
                n = r.length;
                r.push(e);
                t.set(e, n);
            }
            return n;
        };
        return r;
    }
    function $(l) {
        var f = O();
        var a = l.includeSources && new fn();
        var u = O();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, A(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var r = 0; r < n.sources.length; r++) {
                var i = n.sourcesContent[r];
                if (i) a.set(n.sources[r], i);
            }
        });
        var p;
        var d = 1;
        var h = 0;
        var v = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, r, i, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[r - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (i >= c) f = s[u];
                        if (i <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        r = f[2];
                        i = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, r, i, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!a.has(e)) {
                    a.set(e, n);
                }
            } : Yn,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a.get(e) || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, r, i, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                h = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += D(t - h);
            h = t;
            if (e == null) return;
            var o = f.index(e);
            c += D(o - v);
            v = o;
            c += D(r - m);
            m = r;
            c += D(i - _);
            _ = i;
            if (l.names && a != null) {
                var s = u.index(a);
                c += D(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        var r = {
            Program: function(e) {
                return new ht({
                    start: s(e),
                    end: f(e),
                    body: a(e.body.map(l))
                });
            },
            ArrowFunctionExpression: function(e) {
                var n = [], t = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                var r = new (e.async ? xt : wt)({
                    start: s(e),
                    end: f(e),
                    argnames: n,
                    rest: t
                });
                var i = l(e.body);
                if (i instanceof pn) {
                    r.body = a(i.body);
                    r.value = null;
                } else {
                    r.body = [];
                    r.value = i;
                }
                return r;
            },
            FunctionDeclaration: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Ot : Dt;
                } else {
                    n = e.generator ? qt : $t;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: r,
                    body: a(l(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Et : kt;
                } else {
                    n = e.generator ? Tt : St;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: r,
                    body: a(l(e.body).body)
                });
            },
            ClassDeclaration: function(e) {
                return new Ct({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            ClassExpression: function(e) {
                return new Mt({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            MethodDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                var r = jt, i = l(e.value);
                switch (e.kind) {
                  case "get":
                    r = we;
                    i = new vt(i);
                    break;

                  case "set":
                    r = xe;
                    i = new vt(i);
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: i
                });
            },
            PropertyDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                return new Pt({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: l(e.value)
                });
            },
            ForOfStatement: function(e) {
                return new (e.await ? pt : ye)({
                    start: s(e),
                    end: f(e),
                    init: l(e.left),
                    object: l(e.right),
                    body: l(e.body)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new Gt({
                    start: s(e),
                    end: f(e),
                    body: l(e.block).body,
                    bcatch: l(n[0]),
                    bfinally: e.finalizer ? new Xt(l(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.computed ? l(e.key) : o(e.key);
                var t = {
                    start: s(e),
                    end: f(e),
                    key: n,
                    value: l(e.value)
                };
                if (e.kind == "init") return new (e.method ? mr : vr)(t);
                t.value = new vt(t.value);
                if (e.kind == "get") return new gr(t);
                if (e.kind == "set") return new _r(t);
            },
            ArrayExpression: function(e) {
                return new On({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Ir() : l(e);
                    })
                });
            },
            ArrayPattern: function(e) {
                var n = [], t = null;
                e.elements.forEach(function(e) {
                    if (e === null) {
                        n.push(new Ir());
                    } else if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                return new lr({
                    start: s(e),
                    end: f(e),
                    elements: n,
                    rest: t
                });
            },
            ObjectPattern: function(e) {
                var n = [], t = null;
                e.properties.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(new pr(l(e)));
                    }
                });
                return new dr({
                    start: s(e),
                    end: f(e),
                    properties: n,
                    rest: t
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? sr : xn)({
                    start: s(e),
                    end: f(e),
                    optional: e.optional,
                    expression: l(e.object),
                    property: e.computed ? l(e.property) : e.property.name
                });
            },
            MetaProperty: function(e) {
                var n = l(e.meta);
                var t = o(e.property);
                if (n.name == "new" && t == "target") return new zr({
                    start: s(e),
                    end: f(e),
                    name: "new.target"
                });
                return new xn({
                    start: s(e),
                    end: f(e),
                    expression: n,
                    property: t
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? Wt : Vt)({
                    start: s(e),
                    end: f(e),
                    expression: l(e.test),
                    body: e.consequent.map(l)
                });
            },
            ExportAllDeclaration: function(e) {
                var n = e.exported ? o(e.exported) : "*";
                return new ke({
                    start: s(e),
                    end: f(e),
                    aliases: [ n ],
                    keys: [ "*" ],
                    path: e.source.value
                });
            },
            ExportDefaultDeclaration: function(e) {
                var n = l(e.declaration);
                if (!n.name) switch (n.CTOR) {
                  case Dt:
                    n = new kt(n);
                    break;

                  case Ot:
                    n = new Et(n);
                    break;

                  case Ct:
                    n = new Mt(n);
                    break;

                  case $t:
                    n = new St(n);
                    break;

                  case qt:
                    n = new Tt(n);
                    break;
                }
                return new tr({
                    start: s(e),
                    end: f(e),
                    body: n
                });
            },
            ExportNamedDeclaration: function(e) {
                if (e.declaration) return new nr({
                    start: s(e),
                    end: f(e),
                    body: l(e.declaration)
                });
                if (e.source) {
                    var n = [], t = [];
                    e.specifiers.forEach(function(e) {
                        n.push(o(e.exported));
                        t.push(o(e.local));
                    });
                    return new ke({
                        start: s(e),
                        end: f(e),
                        aliases: n,
                        keys: t,
                        path: e.source.value
                    });
                }
                return new rr({
                    start: s(e),
                    end: f(e),
                    properties: e.specifiers.map(function(e) {
                        var n = new Dr(l(e.local));
                        n.alias = o(e.exported);
                        return n;
                    })
                });
            },
            ImportDeclaration: function(e) {
                var t = null, r = null, i = null;
                e.specifiers.forEach(function(e) {
                    var n = new wr(l(e.local));
                    switch (e.type) {
                      case "ImportDefaultSpecifier":
                        r = n;
                        r.key = "";
                        break;

                      case "ImportNamespaceSpecifier":
                        t = n;
                        t.key = "*";
                        break;

                      default:
                        n.key = e.imported.name || syn.name;
                        if (!i) i = [];
                        i.push(n);
                        break;
                    }
                });
                return new ir({
                    start: s(e),
                    end: f(e),
                    all: t,
                    default: r,
                    properties: i,
                    path: e.source.value
                });
            },
            ImportExpression: function(e) {
                var n = s(e);
                var t = l(e.source);
                return new bn({
                    start: n,
                    end: f(e),
                    expression: new Mn({
                        start: n,
                        end: t.start,
                        name: "import"
                    }),
                    args: [ t ]
                });
            },
            VariableDeclaration: function(e) {
                return new ({
                    const: Qt,
                    let: Zt
                }[e.kind] || er)({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(l)
                });
            },
            Literal: function(e) {
                var n = {
                    start: s(e),
                    end: f(e)
                };
                if (e.bigint) {
                    n.value = e.bigint.toLowerCase() + "n";
                    return new Mr(n);
                }
                var t = e.value;
                if (t === null) return new Pr(n);
                var r = e.regex;
                if (r && r.pattern) {
                    n.value = new RegExp(r.pattern, r.flags);
                    n.value.raw_source = r.pattern;
                    return new Fr(n);
                } else if (r) {
                    n.value = e.regex && e.raw ? e.raw : t;
                    return new Fr(n);
                }
                switch (typeof t) {
                  case "string":
                    n.value = t;
                    return new Pn(n);

                  case "number":
                    if (isNaN(t)) return new jr(n);
                    var i, a;
                    if (isFinite(t)) {
                        i = 1 / t < 0;
                        n.value = i ? -t : t;
                        a = new jn(n);
                    } else {
                        i = t < 0;
                        a = new Hr(n);
                    }
                    return i ? new Sn({
                        start: n.start,
                        end: n.end,
                        operator: "-",
                        expression: a
                    }) : a;

                  case "boolean":
                    return new (t ? Lr : Rr)(n);
                }
            },
            TemplateLiteral: function(e) {
                return new Cr({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(l),
                    strings: e.quasis.map(function(e) {
                        return e.value.raw;
                    })
                });
            },
            TaggedTemplateExpression: function(e) {
                var n = l(e.quasi);
                n.start = s(e);
                n.end = f(e);
                n.tag = l(e.tag);
                return n;
            },
            Identifier: function(e) {
                var n, t = c.length - 1;
                do {
                    n = c[--t];
                } while (n.type == "ArrayPattern" || n.type == "AssignmentPattern" && n.left === c[t + 1] || n.type == "ObjectPattern" || n.type == "Property" && n.value === c[t + 1] || n.type == "VariableDeclarator" && n.id === c[t + 1]);
                var r = Mn;
                switch (n.type) {
                  case "ArrowFunctionExpression":
                    if (n.body !== c[t + 1]) r = Cn;
                    break;

                  case "BreakStatement":
                  case "ContinueStatement":
                    r = Te;
                    break;

                  case "CatchClause":
                    r = Ar;
                    break;

                  case "ClassDeclaration":
                    if (n.id === c[t + 1]) r = Ee;
                    break;

                  case "ClassExpression":
                    if (n.id === c[t + 1]) r = Tr;
                    break;

                  case "FunctionDeclaration":
                    r = n.id === c[t + 1] ? Er : Cn;
                    break;

                  case "FunctionExpression":
                    r = n.id === c[t + 1] ? Sr : Cn;
                    break;

                  case "LabeledStatement":
                    r = Se;
                    break;

                  case "VariableDeclaration":
                    r = {
                        const: yr,
                        let: xr
                    }[n.kind] || kr;
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            Super: function(e) {
                return new $r({
                    start: s(e),
                    end: f(e),
                    name: "super"
                });
            },
            ThisExpression: function(e) {
                return new qr({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            },
            ParenthesizedExpression: function(e) {
                var n = l(e.expression);
                if (!n.start.parens) n.start.parens = [];
                n.start.parens.push(s(e));
                if (!n.end.parens) n.end.parens = [];
                n.end.parens.push(f(e));
                return n;
            },
            ChainExpression: function(e) {
                var n = l(e.expression);
                n.terminal = true;
                return n;
            }
        };
        r.UpdateExpression = r.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? Sn : fr)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: l(n.argument)
            });
        };
        u("EmptyStatement", cn);
        u("ExpressionStatement", ln, "expression>body");
        u("BlockStatement", pn, "body@body");
        u("IfStatement", mn, "test>condition, consequent>body, alternate>alternative");
        u("LabeledStatement", it, "label>label, body>body");
        u("BreakStatement", Rt, "label>label");
        u("ContinueStatement", Lt, "label>label");
        u("WithStatement", dt, "object>expression, body>body");
        u("SwitchStatement", Bt, "discriminant>expression, cases@body");
        u("ReturnStatement", vn, "argument>value");
        u("ThrowStatement", Ht, "argument>value");
        u("WhileStatement", ft, "test>condition, body>body");
        u("DoWhileStatement", st, "test>condition, body>body");
        u("ForStatement", ut, "init>init, test>condition, update>step, body>body");
        u("ForInStatement", lt, "left>init, right>object, body>body");
        u("DebuggerStatement", Qn);
        u("VariableDeclarator", _n, "id>name, init>value");
        u("CatchClause", Jt, "param>argname, body%body");
        u("BinaryExpression", Tn, "operator=operator, left>left, right>right");
        u("LogicalExpression", Tn, "operator=operator, left>left, right>right");
        u("AssignmentExpression", Dn, "operator=operator, left>left, right>right");
        u("AssignmentPattern", gn, "left>name, right>value");
        u("ConditionalExpression", An, "test>condition, consequent>consequent, alternate>alternative");
        u("NewExpression", ar, "callee>expression, arguments@args, pure=pure");
        u("CallExpression", bn, "callee>expression, arguments@args, optional=optional, pure=pure");
        u("SequenceExpression", yn, "expressions@expressions");
        u("SpreadElement", kn, "argument>expression");
        u("ObjectExpression", qn, "properties@properties");
        u("AwaitExpression", ur, "argument>expression");
        u("YieldExpression", cr, "argument>expression, delegate=nested");
        d(ht, function e(n) {
            return m("Program", n);
        });
        d(At, function e(n) {
            var t = n.argnames.map(h);
            if (n.rest) t.push({
                type: "RestElement",
                argument: h(n.rest)
            });
            return {
                type: "FunctionDeclaration",
                id: h(n.name),
                async: gt(n),
                generator: bt(n),
                params: t,
                body: m("BlockStatement", n)
            };
        });
        d(hn, function e(n) {
            var t = n.argnames.map(h);
            if (n.rest) t.push({
                type: "RestElement",
                argument: h(n.rest)
            });
            if (_t(n)) return {
                type: "ArrowFunctionExpression",
                async: gt(n),
                params: t,
                body: n.value ? h(n.value) : m("BlockStatement", n)
            };
            return {
                type: "FunctionExpression",
                id: h(n.name),
                async: gt(n),
                generator: bt(n),
                params: t,
                body: m("BlockStatement", n)
            };
        });
        d(Ct, function e(n) {
            return {
                type: "ClassDeclaration",
                id: h(n.name),
                superClass: h(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(h)
                }
            };
        });
        d(Mt, function e(n) {
            return {
                type: "ClassExpression",
                id: h(n.name),
                superClass: h(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(h)
                }
            };
        });
        function e(r) {
            return function(e) {
                var n = e.key instanceof un;
                var t = n ? h(e.key) : e.private ? {
                    type: "PrivateIdentifier",
                    name: e.key.slice(1)
                } : {
                    type: "Literal",
                    value: e.key
                };
                return {
                    type: "MethodDefinition",
                    kind: r,
                    computed: n,
                    key: t,
                    static: e.static,
                    value: h(e.value)
                };
            };
        }
        d(we, e("get"));
        d(xe, e("set"));
        d(jt, e("method"));
        d(Pt, function e(n) {
            var t = n.key instanceof un;
            var r = t ? h(n.key) : n.private ? {
                type: "PrivateIdentifier",
                name: n.key.slice(1)
            } : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "PropertyDefinition",
                computed: t,
                key: r,
                static: n.static,
                value: h(n.value)
            };
        });
        function n(n) {
            return function(e) {
                return {
                    type: "ForOfStatement",
                    await: n,
                    left: h(e.init),
                    right: h(e.object),
                    body: h(e.body)
                };
            };
        }
        d(pt, n(true));
        d(ye, n(false));
        d(Zn, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: p(n, {
                    type: "Literal",
                    value: n.value
                })
            };
        });
        d(Ut, function e(n) {
            return {
                type: "SwitchCase",
                test: h(n.expression),
                consequent: n.body.map(h)
            };
        });
        d(Gt, function e(n) {
            return {
                type: "TryStatement",
                block: v(n),
                handler: h(n.bcatch),
                guardedHandlers: [],
                finalizer: h(n.bfinally)
            };
        });
        d(Jt, function e(n) {
            return {
                type: "CatchClause",
                param: h(n.argname),
                guard: null,
                body: v(n)
            };
        });
        d(nr, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                declaration: h(n.body)
            };
        });
        d(tr, function e(n) {
            return {
                type: "ExportDefaultDeclaration",
                declaration: h(n.body)
            };
        });
        d(ke, function e(n) {
            if (n.keys[0] == "*") return {
                type: "ExportAllDeclaration",
                exported: n.aliases[0] == "*" ? null : {
                    type: "Identifier",
                    name: n.aliases[0]
                },
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
            var t = [];
            for (var r = 0; r < n.aliases.length; r++) {
                t.push({
                    type: "ExportSpecifier",
                    exported: {
                        type: "Identifier",
                        name: n.aliases[r]
                    },
                    local: {
                        type: "Identifier",
                        name: n.keys[r]
                    }
                });
            }
            return {
                type: "ExportNamedDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        d(rr, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                specifiers: n.properties.map(function(e) {
                    return {
                        type: "ExportSpecifier",
                        local: h(e),
                        exported: {
                            type: "Identifier",
                            name: e.alias
                        }
                    };
                })
            };
        });
        d(ir, function e(n) {
            var t = n.properties ? n.properties.map(function(e) {
                return {
                    type: "ImportSpecifier",
                    local: h(e),
                    imported: {
                        type: "Identifier",
                        name: e.key
                    }
                };
            }) : [];
            if (n.all) t.unshift({
                type: "ImportNamespaceSpecifier",
                local: h(n.all)
            });
            if (n.default) t.unshift({
                type: "ImportDefaultSpecifier",
                local: h(n.default)
            });
            return {
                type: "ImportDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        d(Kt, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: n.TYPE.toLowerCase(),
                declarations: n.definitions.map(h)
            };
        });
        d(wn, function e(n) {
            var t = n instanceof sr;
            var r = {
                type: "MemberExpression",
                object: h(n.expression),
                computed: t,
                optional: n.optional,
                property: t ? h(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
            return n.terminal ? {
                type: "ChainExpression",
                expression: r
            } : r;
        });
        d(En, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof Sn,
                argument: h(n.expression)
            };
        });
        d(Tn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: h(n.left),
                operator: n.operator,
                right: h(n.right)
            };
        });
        d(On, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(h)
            };
        });
        d(lr, function e(n) {
            var t = n.elements.map(h);
            if (n.rest) t.push({
                type: "RestElement",
                argument: h(n.rest)
            });
            return {
                type: "ArrayPattern",
                elements: t
            };
        });
        d(pr, function e(n) {
            var t = n.key instanceof un;
            var r = t ? h(n.key) : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "Property",
                kind: "init",
                computed: t,
                key: r,
                value: h(n.value)
            };
        });
        d(dr, function e(n) {
            var t = n.properties.map(h);
            if (n.rest) t.push({
                type: "RestElement",
                argument: h(n.rest)
            });
            return {
                type: "ObjectPattern",
                properties: t
            };
        });
        d(hr, function e(n) {
            var t = n.key instanceof un;
            var r = t ? h(n.key) : {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof vr) {
                i = "init";
            } else if (n instanceof gr) {
                i = "get";
            } else if (n instanceof _r) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                computed: t,
                method: n instanceof mr,
                key: r,
                value: h(n.value)
            };
        });
        d(br, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        d($r, function e() {
            return {
                type: "Super"
            };
        });
        d(qr, function e() {
            return {
                type: "ThisExpression"
            };
        });
        d(zr, function e() {
            return {
                type: "MetaProperty",
                meta: {
                    type: "Identifier",
                    name: "new"
                },
                property: {
                    type: "Identifier",
                    name: "target"
                }
            };
        });
        d(Fr, function e(n) {
            var t = n.value.toString().match(/\/([gimuy]*)$/)[1];
            var r = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: r,
                raw: r,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        d(Mr, function e(n) {
            var t = n.value;
            return {
                type: "Literal",
                bigint: t.slice(0, -1),
                raw: t
            };
        });
        function t(e) {
            var n = e.value;
            if (typeof n === "number" && (n < 0 || n === 0 && 1 / n < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -n,
                        raw: e.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: n,
                raw: e.start.raw
            };
        }
        d(Yr, t);
        d(Fn, t);
        d(Pr, t);
        d(g, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        d(Cr, function e(n) {
            var t = n.strings.length - 1;
            var r = {
                type: "TemplateLiteral",
                expressions: n.expressions.map(h),
                quasis: n.strings.map(function(e, n) {
                    return {
                        type: "TemplateElement",
                        tail: n == t,
                        value: {
                            raw: e
                        }
                    };
                })
            };
            if (!n.tag) return r;
            return {
                type: "TaggedTemplateExpression",
                tag: h(n.tag),
                quasi: r
            };
        });
        rt.DEFMETHOD("to_mozilla_ast", pn.prototype.to_mozilla_ast);
        Ir.DEFMETHOD("to_mozilla_ast", Bn);
        un.DEFMETHOD("to_mozilla_ast", function() {
            throw new Error("Cannot convert AST_" + this.TYPE);
        });
        function a(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof ln)) break;
                var r = t.body;
                if (!(r instanceof Pn)) break;
                if (t.start.pos !== r.start.pos) break;
                e[n] = new Zn(r);
            }
            return e;
        }
        function i(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var r = e.range;
            return new ne({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[0] : e.start,
                raw: i(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var r = e.range;
            return new ne({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[1] : e.end,
                raw: i(e)
            });
        }
        function o(e) {
            return "" + e[e.type == "Identifier" ? "name" : "value"];
        }
        function u(e, n, t) {
            var a = [ "start: my_start_token(M)", "end: my_end_token(M)" ];
            var o = [ "type: " + JSON.stringify(e) ];
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], r = n[2], i = n[3];
                switch (r) {
                  case "@":
                    a.push(i + ": M." + t + ".map(from_moz)");
                    o.push(t + ": M." + i + ".map(to_moz)");
                    break;

                  case ">":
                    a.push(i + ": from_moz(M." + t + ")");
                    o.push(t + ": to_moz(M." + i + ")");
                    break;

                  case "=":
                    a.push(i + ": M." + t);
                    o.push(t + ": M." + i);
                    break;

                  case "%":
                    a.push(i + ": from_moz(M." + t + ").body");
                    o.push(t + ": to_moz_block(M)");
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            r[e] = new Function("U2", "my_start_token", "my_end_token", "from_moz", [ "return function From_Moz_" + e + "(M) {", "    return new U2.AST_" + n.TYPE + "({", a.join(",\n"), "    });", "};" ].join("\n"))(_, s, f, l);
            d(n, new Function("to_moz", "to_moz_block", "to_moz_scope", [ "return function To_Moz_" + e + "(M) {", "    return {", o.join(",\n"), "    };", "};" ].join("\n"))(h, v, m));
        }
        var c = null;
        function l(e) {
            c.push(e);
            var n = null;
            if (e) {
                if (!Jn(r, e.type)) throw new Error("Unsupported type: " + e.type);
                n = r[e.type](e);
            }
            c.pop();
            return n;
        }
        un.from_mozilla_ast = function(e) {
            var n = c;
            c = [];
            var t = l(e);
            c = n;
            t.walk(new Nn(function(e) {
                if (e instanceof Te) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof dn) break;
                        if (t instanceof it && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var r = e.start;
                        Oe("Undefined label " + e.name, r.file, r.line, r.col, r.pos);
                    }
                }
            }));
            return t;
        };
        function p(e, n) {
            var t = e.start;
            var r = e.end;
            if (t.pos != null && r.endpos != null) {
                n.range = [ t.pos, r.endpos ];
            }
            if (t.line) {
                n.loc = {
                    start: {
                        line: t.line,
                        column: t.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (t.file) {
                    n.loc.source = t.file;
                }
            }
            return n;
        }
        function d(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return p(this, n(this));
            });
        }
        function h(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function v(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(h)
            };
        }
        function m(e, n) {
            var t = n.body.map(h);
            if (n.body[0] instanceof ln && n.body[0].body instanceof Pn) {
                t.unshift(h(new cn(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var q = function() {
        var n = new fn();
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return n;
        function t(e) {
            n.set(e, true);
        }
    }();
    function z(e, n) {
        e.walk(new Nn(function(e) {
            if (e instanceof Ft) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof hr) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof sr) {
                W(e.property, t);
            }
        }));
        function t(e) {
            Vn(n, e);
        }
    }
    function W(e, n) {
        if (e instanceof An) {
            W(e.consequent, n);
            W(e.alternative, n);
        } else if (e instanceof yn) {
            W(e.tail_node(), n);
        } else if (e instanceof Pn) {
            n(e.value);
        }
    }
    function G(e, t) {
        t = be(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = t.builtins ? new fn() : q.clone();
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n.set(e, true);
        });
        var r = -1;
        var i;
        if (t.cache) {
            i = t.cache.props;
            i.each(function(e) {
                n.set(e, true);
            });
        } else {
            i = new fn();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = new fn();
        var u = n.clone();
        e.walk(new Nn(function(e) {
            if (e instanceof Tn) {
                if (e.operator == "in") W(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof xn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Mn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    W(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    W(e.args[0], p);
                    break;
                }
            } else if (e instanceof Ft) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof xn) {
                p(e.property);
            } else if (e instanceof hr) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof sr) {
                W(e.property, p);
            }
        }));
        e.walk(new Nn(function(e) {
            if (e instanceof Tn) {
                if (e.operator == "in") h(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof xn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Mn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    h(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    h(e.args[0]);
                    break;
                }
            } else if (e instanceof Ft) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof xn) {
                e.property = d(e.property);
            } else if (e instanceof hr) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof sr) {
                if (!t.keep_quoted) h(e.property);
            }
        }));
        function c(e) {
            if (u.has(e)) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n.has(e)) return false;
            if (a && !a.test(e)) return false;
            return i.has(e) || f.has(e);
        }
        function p(e) {
            if (c(e)) f.set(e, true);
            if (!l(e)) u.set(e, true);
        }
        function d(e) {
            if (!l(e)) return e;
            var n = i.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = E(++r);
                } while (!c(n));
                if (/^#/.test(e)) n = "#" + n;
                i.set(e, n);
            }
            return n;
        }
        function h(e) {
            if (e instanceof yn) {
                h(e.expressions.tail_node());
            } else if (e instanceof Pn) {
                e.value = d(e.value);
            } else if (e instanceof An) {
                h(e.consequent);
                h(e.alternative);
            }
        }
    }
    "use strict";
    var J, X;
    if (typeof Buffer == "undefined") {
        J = atob;
        X = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        J = function(e) {
            return new Buffer(e, "base64").toString();
        };
        X = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        J = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        X = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function K(e, n) {
        var t = n.end.comments_after;
        for (var r = t.length; --r >= 0; ) {
            var i = t[r];
            if (i.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(i.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,([^,]+)$/.exec(a[2]);
                if (!a) break;
                return J(a[2]);
            }
        }
        un.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function Q(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function Z(n, t, e) {
        e.forEach(function(e) {
            if (t[e]) {
                if (typeof t[e] != "object") t[e] = {};
                if (!(n in t[e])) t[e][n] = t[n];
            }
        });
    }
    function ee(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new fn();
        } else if (!(e.props instanceof fn)) {
            e.props = fn.fromObject(e.props);
        }
    }
    function oe(e) {
        return {
            props: e.props.toObject()
        };
    }
    function se(r, i) {
        try {
            i = be(i, {
                annotations: undefined,
                compress: {},
                enclose: false,
                ie: false,
                ie8: false,
                keep_fargs: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (i.validate) un.enable_validation();
            var e = i.timings && {
                start: Date.now()
            };
            if (i.rename === undefined) i.rename = i.compress && i.mangle;
            if (i.annotations !== undefined) Z("annotations", i, [ "compress", "output" ]);
            if (i.ie8) i.ie = i.ie || i.ie8;
            if (i.ie) Z("ie", i, [ "compress", "mangle", "output" ]);
            if (i.keep_fargs) Z("keep_fargs", i, [ "compress", "mangle" ]);
            if (i.keep_fnames) Z("keep_fnames", i, [ "compress", "mangle" ]);
            if (i.toplevel) Z("toplevel", i, [ "compress", "mangle" ]);
            if (i.v8) Z("v8", i, [ "mangle", "output" ]);
            if (i.webkit) Z("webkit", i, [ "compress", "mangle", "output" ]);
            var n;
            if (i.mangle) {
                i.mangle = be(i.mangle, {
                    cache: i.nameCache && (i.nameCache.vars || {}),
                    eval: false,
                    ie: false,
                    keep_fargs: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (i.mangle.properties) {
                    if (typeof i.mangle.properties != "object") {
                        i.mangle.properties = {};
                    }
                    if (i.mangle.properties.keep_quoted) {
                        n = i.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        i.mangle.properties.reserved = n;
                    }
                    if (i.nameCache && !("cache" in i.mangle.properties)) {
                        i.mangle.properties.cache = i.nameCache.props || {};
                    }
                }
                ee(i.mangle.cache);
                ee(i.mangle.properties.cache);
            }
            if (i.sourceMap) {
                i.sourceMap = be(i.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (i.warnings) un.log_function(function(e) {
                t.push(e);
            }, i.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (r instanceof ht) {
                a = r;
            } else {
                if (typeof r == "string") {
                    r = [ r ];
                }
                i.parse = i.parse || {};
                i.parse.toplevel = null;
                var o = i.sourceMap && i.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = Q(o);
                }
                if (o) i.sourceMap.orig = Object.create(null);
                for (var s in r) if (Jn(r, s)) {
                    i.parse.filename = s;
                    i.parse.toplevel = a = Xr(r[s], i.parse);
                    if (o == "inline") {
                        var f = K(s, a);
                        if (f) {
                            i.sourceMap.orig[s] = Q(f);
                        }
                    } else if (o) {
                        i.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                z(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = i[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                r[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (i.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (i.rename) {
                a.figure_out_scope(i.mangle);
                a.expand_names(i.mangle);
            }
            if (e) e.compress = Date.now();
            if (i.compress) {
                a = new ei(i.compress).compress(a);
                if (i.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (i.mangle) a.figure_out_scope(i.mangle);
            if (e) e.mangle = Date.now();
            if (i.mangle) {
                a.compute_char_frequency(i.mangle);
                a.mangle_names(i.mangle);
            }
            if (e) e.properties = Date.now();
            if (i.mangle && i.mangle.properties) G(a, i.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            var c = be(i.output, {
                ast: false,
                code: true
            });
            if (c.ast) u.ast = a;
            if (c.code) {
                if (i.sourceMap) {
                    c.source_map = $(i.sourceMap);
                    if (i.sourceMap.includeSources) {
                        if (r instanceof ht) {
                            throw new Error("original source content unavailable");
                        } else for (var s in r) if (Jn(r, s)) {
                            c.source_map.setSourceContent(s, r[s]);
                        }
                    }
                }
                delete c.ast;
                delete c.code;
                var l = ni(c);
                a.print(l);
                u.code = l.get();
                if (i.sourceMap) {
                    u.map = c.source_map.toString();
                    var p = i.sourceMap.url;
                    if (p) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + X(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (i.nameCache && i.mangle) {
                if (i.mangle.cache) i.nameCache.vars = oe(i.mangle.cache);
                if (i.mangle.properties && i.mangle.properties.cache) {
                    i.nameCache.props = oe(i.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            un.log_function();
            un.disable_validation();
        }
    }
    _["Dictionary"] = fn;
    _["is_statement"] = et;
    _["List"] = Un;
    _["minify"] = se;
    _["parse"] = Xr;
    _["push_uniq"] = Vn;
    _["TreeTransformer"] = Br;
    _["TreeWalker"] = Nn;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
